package Counter;
require CMONOS::CGI_Lib::UrlDecode;
@ISA = qw(UrlDecode);
use strict;
use utf8;
######################################################################
# アクセスカウントモジュール
# Counter.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-01-19
######################################################################
# オブジェクトを作る。
sub new ($) {
    my $pkg  = shift;
    my $this = {};
    bless $this;
    $this->fix_env;
    $this;
}

######################################################################
# メイン
sub run ($) {
    my $this = shift;
    my ( $location, $date, $time, $month, $date2, $nocheck, $host );
    $host = $ENV{'REMOTE_HOST'} || $this->to_host( $ENV{'REMOTE_ADDR'} );
    if ( $host && $host =~ /(?:crawl|spider|\w+bot|nemui\.org|arege\.jp)/i ) {
        $this->invisible_gif;
    }
    elsif ($ENV{'HTTP_USER_AGENT'}
        && $ENV{'HTTP_USER_AGENT'}
        =~ /(?:crawl|spider|\w+bot|https?:\/\/| Qt\/|ScreenShot|FC2BS|archive\.org|ia_archiver)/i
        )
    {
        $this->invisible_gif;
    }

    # デモ
    if ( defined $main::demo && $main::demo eq 'true' ) {
        $this->number_gif( 12345, 678, 90, 88, 1 );

        # リンク先指定がある場合
    }
    elsif ( defined $main::location && $main::location ne '' ) {
        $location = $main::location;

    }
    elsif ( defined $main::url && $main::url ne '' ) {
        $location = $main::url;

        # その他
    }
    elsif ( defined $ENV{'HTTP_REFERER'}
        && $ENV{'HTTP_REFERER'} =~ /\/counter\.cgi/ )
    {
        $this->invisible_gif;

    }
    else {
        $location
            = ( defined $ENV{'HTTP_REFERER'} ) ? $ENV{'HTTP_REFERER'} : '';

    }

    # 翻訳サイト対策
    if ( $location =~ /\?(.+)$/ || $location =~ /^.+(http.*?)$/ ) {
        my $query = $1;
        utf8::encode($query);
        $query =~ s/\+/ /g;
        $query
            =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/(($1 eq '26' || uc $1 eq '3D') ? '%' . $1 : pack("C",hex($1)))/ge;
        foreach my $t (@default::target) {
            if ( $query =~ s/^.*\Q$t\E/http:\/\/$t/ ) {
                $query =~ s/[\&\^][^\/\.]*$//;
                $query =~ s/%26/\&/gi;
                $query =~ s/%3D/=/gi;
                $location = $query;
                last;
            }
        }
    }

# パスワードの埋め込まれたURL→安全のため、パスワード部分を削除
    $location =~ s!^(http[s]?://)[0-9a-zA-Z_:]+\@!$1!si;

    # CGIの条件部分アンカーを無視
    $location =~ s/\#.*$//s;
    if ($location =~ /\/start.cgi\?(?:|.+?\&)m=DetailViewer(?![a-zA-Z0-9])/s )
    {
        my $c = ( $location =~ /\&?c=([^\&=])+/ ) ? $1 : '';
        my $n = ( $location =~ /\&?n=([^\&=])+/ ) ? $1 : '';
        my $q
            = ( $c ne '' && $n ne '' )
            ? '?m=DetailViewer&c=' . $c . '&n=' . $n
            : '';
        $location =~ s/\?.*$/$q/s;
    }
    else {
        $location =~ s/\?.*$//s;
        $location =~ s/(\.[s]?htm[l]?)(?=[^0-9a-zA-Z_]).*?$/$1/s;
    }

    # index.htmlを統一
    $location =~ s!/index\.[s]?htm[l]?$!/!si;
    $location =~ s/%7e/~/sgi;

    # スラッシュの補完
    $location .= '/' if $location =~ m!^http[s]?://[^/]+$!;

    # ターゲットサイト以外の場合
    if ( !@default::target ) {
        my $home_location = $this->home_location;
        if ( defined $env::doublename && $env::doublename ) {
            $home_location =~ s!^http[s]?://www\.!!si;
            $location
                =~ s!^(http[s]?://)www\.$home_location!$1$home_location!si
                if defined $env::doublename && $env::doublename;
        }
        push( @default::target, $home_location );
    }
    ( defined $main::location && $main::location ne '' )
        ? $this->location($main::location)
        : $this->invisible_gif
        unless $location
        && grep( eval { $location =~ /\Q$_\E/ }, @default::target );

    #Cookieチェック
    my $target_id;
    if ($default::idle_time) {
        if ( eval 'use Digest::MD5;1;' ) {
            $target_id = Digest::MD5->new->add($location)->hexdigest;
        }
        else {
            $target_id = $location;
            $target_id =~ s/[^0-9a-zA-Z]//sg;
        }
        if ( $this->read_cookie_direct($target_id) ) {
            $main::nocount = 'true';
            $nocheck       = 1;
        }
    }

    # 管理人等記録対象外者
    if (   defined $default::nocheck_pswd
        && $default::nocheck_pswd ne ''
        && $this->read_cookie_direct( 'NOCHECK' . $default::id ) eq
        $default::nocheck_pswd
        && ( !defined $main::nocount || $main::nocount ne 'true' ) )
    {
        $main::nocount = 'true';
        $nocheck       = 1;
    }

    # アクセス日時
    ( $date, $time ) = $this->date_id;
    $month = $1 if $date =~ /^([0-9]{6})/;
    ($date2) = $this->date_id( time - 86400 );

    # アクセスカウント情報読み書き
    my ( %counter, $total, $thismonth, $today, $yesterday, $flags );
    $total = 0;
    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';
    if ( defined $main::nocount && $main::nocount eq 'true' ) {
        $flags = O_RDONLY;
    }
    else {
        $flags = O_RDWR | O_RDONLY | O_CREAT;
    }
    tie( %counter, $env::dbm_file,
        $default::access_counter . '/access_counter',
        $flags, $env::dbm_mode );
    if ( ref tied %counter ) {
        my @data = split( /\x09/,
            $this->decode_utf8( $counter{ $this->encode_utf8($location) } ) );
        if ( !defined $main::nocount || $main::nocount ne 'true' ) {
            $data[0]++;

            #今月
            if ( $data[1] eq $month ) {
                $data[2]++;
            }
            else {
                $data[1] = $month;
                $data[2] = 1;
            }

            #今日
            if ( $data[3] eq $date ) {
                $data[4]++;
            }
            else {
                if ( $data[3] eq $date2 ) {
                    $data[5] = $date2;
                    $data[6] = $data[4];
                }
                $data[3] = $date;
                $data[4] = 1;
            }

            #昨日
            $data[6] = 0 if $data[5] ne $date2;

            my $loc_data = $this->encode_utf8( join( "\x09", @data ) );
            my $loc = $this->encode_utf8($location);
            eval '$counter{$loc} = $loc_data';
        }
        $total     = $data[0];
        $thismonth = $data[2];
        $today     = $data[4];
        $yesterday = $data[6];

        # 読み書き失敗
    }
    else {
        ( defined $main::location && $main::location ne '' )
            ? $this->location($main::location)
            : $this->invisible_gif;
    }
    untie %counter;

    # リンク先カウントタイプ
    $this->location($main::location)
        if defined $main::location
        && $main::location ne ''
        && ( !defined $main::nocount
        || $main::nocount ne 'true'
        || $nocheck );

    # 隠しカウンタータイプ
    $this->invisible_gif
        if defined $main::invisible && $main::invisible eq 'true';

    # キリバンゲッター
    my ($kiri_flag);
    if (   ( !defined $main::kirilevel || $main::kirilevel ne 'no' )
        && ( !defined $main::nocount || $main::nocount ne 'true' ) )
    {
        my (@kiriban);
        @kiriban = grep( $_ ne '', split( /,/, $main::kiriban ) )
            if defined $main::kiriban && $main::kiriban;
        if ($total =~ /^1[0]{2,}$/
            || (   defined $main::kirilevel
                && $main::kirilevel >= 2
                && $total =~ /^[1-9][0]{2,}$/ )
            || ( @kiriban && grep( $total == $_, @kiriban ) )
            )
        {
            $kiri_flag = 1;
            my ( %setting, $mastername, $master, $mailto );
            tie( %setting, $env::dbm_file,
                $default::preference_dir . '/general',
                O_RDONLY, $env::dbm_mode );
            $mastername = $setting{'mastername'};
            $master     = $setting{'master'};
            $mailto     = $setting{'mailto'};
            untie %setting;

            # キリバン通知
            if ( defined $mailto && $mailto ) {
                my ( $msg, $kiritime );
                $kiritime
                    = $1 . '年' . ( $2 + 0 ) . '月' . ( $3 + 0 ) . '日 '
                    if $date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})/;
                $kiritime .= $1 . ':' . $2 . ':' . $3
                    if $time =~ /^([0-9]{2})([0-9]{2})([0-9]{2})/;

                $msg = 'おめでとうございます！' . "\x0A";
                $msg .= 'キリバンヒットです！' . "\x0A";
                $msg .= "\x0A";
                $msg .= '対象ページ：' . $location . "\x0A";
                $msg .= '総アクセス数：' . $total . '件' . "\x0A";
                $msg .= "\x0A";
                $msg .= 'キリバンヒット日時：' . $kiritime . "\x0A";
                $msg .= 'キリバンゲッターIP：'
                    . $this->to_host( $ENV{'REMOTE_ADDR'} ) . "\x0A";

                unless ( ref $cgi::SendMail ) {
                    require CMONOS::CGI_Lib::SendMail;
                    $cgi::SendMail
                        = SendMail->new( $env::sendmail, $env::master_email,
                        '', '', 1 );
                }

                $cgi::SendMail->send_mail(
                    'Bcc'  => $mailto,
                    'From' => (
                        ($mastername)
                        ? $mastername . ' <' . $master . '>'
                        : $master
                    ),
                    'Subject' => 'キリバンヒット！ ('
                        . $location . ')',
                    'message' => $msg,
                    'info'    => 0
                );
            }
        }
    }

    $this->number_gif( $total, $thismonth, $today, $yesterday, $kiri_flag,
        $target_id );
}

# カウントデータGIF
sub number_gif ($$$$$;$$) {
    my ($this,      $total,     $thismonth, $today,
        $yesterday, $kiri_flag, $target_id
    ) = @_;
    my ( $gif, @images, $vector, @color, $no_word_flag, $count_flag );
    $no_word_flag = $count_flag = 0;

    # 数字GIFディレクトリ
    $main::image = 1 if !defined $main::image || !$main::image;
    $gif = $default::number . '/' . $main::image;
    ( defined $main::location && $main::location ne '' )
        ? $this->location($main::location)
        : $this->invisible_gif
        unless -d $gif;

    # 開始画像
    push( @images, $gif . '/start.gif' )
        if ( !defined $main::start || $main::start ne 'false' )
        && -f $gif . '/start.gif';

    # 数字
    $no_word_flag = 1 if defined $main::word && $main::word eq 'false';
    $main::total = ''
        if defined $main::total
        && $main::total eq 'false'
        && defined $main::thismonth
        && $main::thismonth eq 'false'
        && defined $main::today
        && $main::today eq 'false'
        && defined $main::yesterday
        && $main::yesterday eq 'false';
    push( @images,
        $this->num_images( $total, $gif, 'total', $no_word_flag, $kiri_flag )
        )
        && ++$count_flag
        if !defined $main::total || $main::total ne 'false';
    push( @images, $gif . '/spacer.gif' ) if $count_flag;
    push( @images,
        $this->num_images( $thismonth, $gif, 'thismonth', $no_word_flag ) )
        && ++$count_flag
        if !defined $main::thismonth || $main::thismonth ne 'false';
    push( @images, $gif . '/spacer.gif' ) if $count_flag;
    push( @images, $this->num_images( $today, $gif, 'today', $no_word_flag ) )
        && ++$count_flag
        if !defined $main::today || $main::today ne 'false';
    push( @images, $gif . '/spacer.gif' ) if $count_flag;
    push( @images,
        $this->num_images( $yesterday, $gif, 'yesterday', $no_word_flag ) )
        && ++$count_flag
        if !defined $main::yesterday || $main::yesterday ne 'false';

    # 終了画像
    push( @images, $gif . '/end.gif' )
        if ( !defined $main::end || $main::end ne 'false' )
        && -f $gif . '/end.gif';

    # 色変換
    # 配色表変換
    if ( defined $main::colortable && $main::colortable ne '' ) {
        push( @color, 'change' );
        push( @color, grep( $_ ne '', split( /,/, $main::colortable ) ) );

        # 配色表スライド
    }
    elsif ( defined $main::color && $main::color ne '' ) {
        push( @color, 'slide' );
        push( @color, $main::color );
        push( @color,
            ( ( defined $main::abs && $main::abs eq 'true' ) ? 1 : 0 ) );
        push( @color, $main::revcolor );
    }

    # 縦書き｜横書き
    $main::vector = ( -f $gif . '/v.gif' ) ? 'v' : 'h'
        if !defined $main::vector || !$main::vector;

    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }

    # 数字書き出し
    if ($target_id) {
        $cgi::Image->set_cookie( $default::idle_time, $target_id, 1,
            $env::cgi_server, $ENV{'SCRIPT_NAME'} );
    }
    $cgi::Image->gif_cat( \@images, '', $main::vector, @color );
    exit;
}

sub num_images ($$$$$;$) {
    my ( $this, $num, $gif, $type, $no_word_flag, $kiri_flag ) = @_;
    my (@images);

    $num = '0' if !defined $num || !$num;
    push( @images, $type )
        if !$no_word_flag && -f $gif . '/' . $type . '.gif';
    push( @images, split( //, $num ) );
    push( @images, $type . '_end' )
        if !$no_word_flag && -f $gif . '/' . $type . '_end.gif';
    push( @images, 'kiriban' ) if $kiri_flag && -f $gif . '/' . 'kiriban.gif';

    map( $_ = $gif . '/' . $_ . '.gif', @images );
    return @images;
}

1;
