package Tools;
use strict;
use utf8;
######################################################################
# メンテナンスモジュール
# Tools.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::table    = 1;    #テーブル設定読み込み
    $setting::page     = 0;    #ページ設定読み込み

    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    #フィールド読み込み設定
    $setting::field = 0
        ; #フィールド設定読み込み（2=オリジナルも読み込む）

#	$setting::field_style_disabled = 2;			#2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
#	$setting::field_tag_enabled = 'no';			#tag=タグのみ/all=全ての設定/no=タグをつけない

    #各種キー設定
    $setting::security_key = 'tools'; #デフォルトセキュリティキー
    $setting::key          = 'tools'; #ページ設定キー

    #	$setting::subkey = '';									#ページ詳細設定キー

    #アクセス権設定名
    $setting::security_name{'tools'}   = '環境設定';
    $setting::security_name{'ranking'} = 'アクセスランキング';

    #バックアップ対象DB
    $backup::db_name{'ranking'} = 'アクセスランキング設定'; #名前
    $backup::db_path{'ranking'}
        = $default::preference_dir . '/ranking';                       #位置
    $backup::find{'ranking'} = 0;    #1=ディレクトリの階層を下る
    $backup::db_name{'rankingdata'} = 'カウントデータ';    #名前
    $backup::db_path{'rankingdata'} = $default::access_counter
        . '/access_counter';    #データベースの位置
    $backup::find{'rankingdata'} = 0;  #1=ディレクトリの階層を下る

    #ツールページ設定
    $setting::page{'tools'}{'title'} = '環境設定';

    #	$setting::page{'tools'}{'text'} = '#000000';
    #	$setting::page{'tools'}{'link'} = '#0000ff';
    #	$setting::page{'tools'}{'alink'} = '#99ffff';
    #	$setting::page{'tools'}{'vlink'} = '#000099';
    #	$setting::page{'tools'}{'hover'} = '#00ffff';
    #	$setting::page{'tools'}{'nodeco'} = 'no';
    #	$setting::page{'tools'}{'bgcolor'} = '#ffffff';
    $setting::page{'tools'}{'bodyId'}                   = 'tools';
    $setting::page{'tools'}{'commonHtmlHeaderDisabled'} = 1;
    $setting::page{'tools'}{'cssFileName'}              = 'tools.css';

# 	$setting::page{'tools'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'tools'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'tools'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'tools'}{'background'} = '';
# 	$setting::page{'tools'}{'bgproperties'} = '';
# 	$setting::page{'tools'}{'topmargin'} = '';
# 	$setting::page{'tools'}{'leftmargin'} = '';
# 	$setting::page{'tools'}{'javascript'} = '';
# 	$setting::page{'tools'}{'header'} = '';
# 	$setting::page{'tools'}{'headerFileName'} = '';
# 	$setting::page{'tools'}{'titleImageAlign'} = '';
# 	$setting::page{'tools'}{'titleImage'} = '';
# 	$setting::page{'tools'}{'align'} = '';
# 	$setting::page{'tools'}{'width'} = '';
# 	$setting::page{'tools'}{'deco'} = '';
# 	$setting::page{'tools'}{'titleText'} = '';

    #必須フォーム
    @setting::form = ( 'm', 'k' );
    $cgi::input->query_filter( $cgi::input->secure_query_for_tools_ref )
        if ref $cgi::input;

    #メンテナンスモジュール読み込み
    Common::use_modules( 'CGI_Lib/Tools', '', ['ImageMenuEditor'] );
    Common::use_modules( $default::lib . '/Tools' );

    #デフォルトキー
    $main::k = '0000'
        if !defined $main::k || $main::k eq '' || $main::k eq 'general';

}

1;
