package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# 一般設定モジュール
# GeneralSetting.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #複数メール書式チェック
    $check::emails{'mailto'} = 'キリバン通知送付先';

    return;
}

sub ogtype_disabled ($) {
    my $this = shift;
    return 1;
}

######################################################################
# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;

    if ( defined $master && $master ) {
        print
            '<fieldset><legend><label for="data:mailto">キリバン通知送付先メールアドレス</label></legend>';
        print
            '<textarea name="data:mailto" id="data:mailto" cols="56" rows="4" wrap="off" title="アクセスログ容量が制限値を超えたときに削除されるファイルは、ここで設定されたアドレスに添付メールで送信されます。">'
            . $this->escape( $main::data{'mailto'} )
            . '</textarea>';
        print
            '<div class="note">送付先が複数の時はカンマ（+改行）で区切ります。</div></fieldset>';
        print
            '<fieldset><legend><label for="idle_time">カウント間隔</label></legend>';
        print
            '<input type="text" name="idle_time" id="idle_time" size="4" value="'
            . ( $main::idle_time || $default::idle_time || '' )
            . '">時間以内の再アクセスをカウントしない';
        print
            '<div class="note">連続カウントを防ぎます。小数で指定できます。</div></fieldset>';
    }
    else {
        print '<fieldset><legend>キリバン通知送付先</legend>';
        my $mailto = $this->escape( $main::data{'mailto'} );
        $mailto
            =~ s/[\x09\x0A\x0C\x0D\x20]*,[\x09\x0A\x0C\x0D\x20]*/<br \/>/g;
        print $mailto;
        print '</fieldset>';
        print '<fieldset><legend>カウント間隔</legend>'
            . ( $default::idle_time || 0 )
            . '時間以内のアクセスをカウントしない</fieldset>';
    }
    return;
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    if (   defined $main::idle_time
        && $main::idle_time ne ''
        && $this->is_nan($main::idle_time) )
    {
        push(
            @{ $this->{'dialog'} },
            '１ページ表示件数最大値を更新できませんでした。半角数字にしてください。'
        );
        undef $main::idle_time;
    }
    $main::idle_time =~ s/^\-// if defined $main::idle_time;
    if (defined $main::idle_time
        && (( $main::idle_time && !defined $default::idle_time )
            || ( defined $default::idle_time
                && $main::idle_time != $default::idle_time )
        )
        )
    {
        my ( $data, $default_path );
        $main::idle_time = 0 if $main::idle_time eq '';
        $default_path    = './default.pl';
        $data            = $this->read_file( $default_path, 1 );
        unless ( $data
            =~ s/^[\x20\x09]*\$idle_time[\x20\x09]*=[^;]*;/\$idle_time = $main::idle_time;/gm
            )
        {
            $data =~ s/^1;/\$idle_time = $main::idle_time;\x0A\x0A1;/m;
        }
        if ( $this->write_file( $default_path, \$data, 1 ) ) {
            push(
                @{ $this->{'dialog'} },
                'カウント間隔を更新しました。'
            );
            $default::idle_time = $main::idle_time;
        }
        else {
            push(
                @{ $this->{'dialog'} },
                'カウント間隔の更新に失敗しました。'
            );
        }
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定';
}

1;
