package TagSample;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# タグ見本モジュール
# TagSample.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this  = shift;
    my $myurl = $this->my_url;
    $myurl =~ s/start\.cgi$/stat.cgi/;

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print
        '<h1 title="テキストボックスの中身をコピーしてください。">タグ見本</h1>';

    my $time_stamp = time;
    print <<SMPL;
<form action="#">
<fieldset><legend>透過GIF埋め込み（タグが貼り付けられたファイルのアクセスログを記録します）</legend>
<textarea rows="18" cols="96" wrap="off" title="テキストボックスの中身をコピーして、アクセスログを取るファイルに貼り付けてください。">
&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot;&gt;
&lt;!--
document.write(
	'&lt;img src=&quot;$myurl?'
	+'referer='+escape(top.document.referrer)	//リンク元
	+'&amp;amp;innerWidth='+((top.innerWidth) ? top.innerWidth : ((document.compatMode != null && document.compatMode != "BackCompat") ? document.documentElement.clientWidth : document.body.clientWidth))		//ウィンドウ幅
	+'&amp;amp;innerHeight='+((top.innerHeight) ? top.innerHeight : ((document.compatMode != null && document.compatMode != "BackCompat") ? document.documentElement.clientHeight : document.body.clientHeight))	//ウィンドウ高さ
	+'&amp;amp;screenWidth='+screen.width	//スクリーン幅
	+'&amp;amp;screenHeight='+screen.height	//スクリーン高さ
	+'&amp;amp;id='+(new Date()).getTime	//ファイルID
	+'&quot; height=&quot;1&quot; width=&quot;1&quot; /&gt;'
);
//--&gt;
&lt;/script&gt;
&lt;noscript&gt;
&lt;img src=&quot;$myurl&amp;amp;id=$time_stamp&quot; height=&quot;1&quot; width=&quot;1&quot; alt=&quot;&quot; /&gt;
&lt;/noscript&gt;
</textarea>
<div class="hints">id は、キャッシュを読み込ませないためにつけます。ファイルごとにユニークな id を割り当てて下さい。</div>
</fieldset>
<fieldset><legend>リンク先を記録（location で指定されたリンク先のアクセスログを記録します）</legend>
<textarea rows="18" cols="96" wrap="off" title="テキストボックスの中身をコピーして、アクセスログを取るファイルに貼り付けてください。">
&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot;&gt;
&lt;!--
document.write(
	'&lt;a href=&quot;$myurl?'
	+'location='+escape('http://ww.../download.zip')	//リンク先（変更してください）
	+'&amp;amp;innerWidth='+((top.innerWidth) ? top.innerWidth : ((document.compatMode != null && document.compatMode != "BackCompat") ? document.documentElement.clientWidth : document.body.clientWidth))		//ウィンドウ幅
	+'&amp;amp;innerHeight='+((top.innerHeight) ? top.innerHeight : ((document.compatMode != null && document.compatMode != "BackCompat") ? document.documentElement.clientHeight : document.body.clientHeight))	//ウィンドウ高さ
	+'&amp;amp;screenWidth='+screen.width	//スクリーン幅
	+'&amp;amp;screenHeight='+screen.height	//スクリーン高さ
	+'&quot;&gt;Download&lt;/a&gt;'
);
//--&gt;
&lt;/script&gt;
&lt;noscript&gt;
&lt;a href=&quot;$myurl?location=http://ww.../download.zip&quot;&gt;Download&lt;/a&gt;
&lt;!--リンク先部分は変更してください↑--&gt;
&lt;/noscript&gt;
</textarea>
</fieldset>
</form>
SMPL

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'a210', 'TagSample' );

    #メニュー登録
    $setting::jump_menu{'a210'} = 'タグ見本';

}

1;
