package TitleSweeper;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# タイトルの整理モジュール
# TitleSweeper.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my (%title);
    use Fcntl qw(:DEFAULT);

    # タイトルデータベース更新
    if ($main::reset) {
        eval 'use ' . $env::dbm_file . ';';
        tie( %title, $env::dbm_file,
            $default::preference_dir . '/url_to_title',
            O_RDWR, $env::dbm_mode );
        %title = () if ref tied %title;
        untie %title;
        push(
            @{ $this->{'dialog'} },
            'ページタイトルを全て削除しました。'
        );
    }
    elsif ( $main::url && $main::url =~ /^https?:\/\//i ) {
        require CMONOS::Accestat::Accestat;
        my $stat = {};
        bless $stat, 'Accestat';
        my $target_url = $stat->url_filter($main::url);
        undef $stat;
        eval 'use ' . $env::dbm_file . ';';
        tie(%title, $env::dbm_file,
            $default::preference_dir . '/url_to_title',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        utf8::encode($target_url) if utf8::is_utf8($target_url);

        if ( ref tied %title && $title{$target_url} ) {
            if ($main::title) {
                $title{$target_url} = $this->encode_utf8($main::title);
                push(
                    @{ $this->{'dialog'} },
                    '「'
                        . $main::url
                        . '」のタイトルを「'
                        . $main::title
                        . '」に設定しました。'
                );
            }
            else {
                push(
                    @{ $this->{'dialog'} },
                    '「'
                        . $main::url
                        . '」のタイトル「'
                        . $this->decode_utf8( $title{$target_url} )
                        . '」を削除しました。次回表示時にタイトルを再取得します。'
                );
                delete $title{$target_url};
            }
        }
        else {
            push(
                @{ $this->{'dialog'} },
                '指定された URL は、ページタイトルデータベースに存在しません。'
            );
        }
        untie %title;
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>ページタイトルデータベースの整理</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );

    print '<fieldset><legend>対象 URL</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr><td class="field-name"><label for="url">URL</label></td>';
    print
        '<td class="field"><input type="text" name="url" id="url" size="56" value="'
        . $this->escape($main::url)
        . '" /></td></tr>';
    print
        '<tr><td class="field-name"><label for="title">新しいタイトル</label></td>';
    print
        '<td class="field"><input type="text" name="title" id="title" size="56" value="'
        . $this->escape($main::title)
        . '" /><div class="note">空欄にするとページタイトルを削除し、次回表示時に再取得します。</div></td></tr>';
    print '</tbody></table></fieldset>';

    print '<fieldset class="submit">';
    print
        '<input type="submit" value="ページタイトルを更新する" />';
    print '</fieldset></form>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );
    print '<fieldset class="delete">';
    print
        '<input name="reset=1" type="submit" value="ページタイトルを全て削除する" onclick="return confirm(\'この操作は取り消せません。本当に削除しますか？\');" />';
    print '</fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

sub query_decode ($$;$) {
    my ( $this, $query, $icode ) = @_;
    utf8::encode($query);
    $query =~ s/\+/ /g;
    $query =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
    $query
        =~ s/\%u([A-Fa-f0-9][A-Fa-f0-9])([A-Fa-f0-9][A-Fa-f0-9])/$this->jcode_convert(pack("C",hex($1)) . pack("C",hex($2)),'utf8','ucs2')/ge;
    return $this->jcode_convert( \$query, 'utf8',
        ( ($icode) ? $icode : ( $query =~ /=utf-8/i ) ? 'utf8' : '' ) );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'a205', 'TitleSweeper' );

    #メニュー登録
    $setting::jump_menu{'a205'} = 'タイトルの整理';

}

1;
