package BbTrunk;
require CMONOS::Baobab::BbCommon;
@ISA = qw(BbCommon);
use strict;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
use utf8;
######################################################################
# バオバブ記事表示基本モジュール
# BbTrunk.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
sub is_list ($) {
    my $this = shift;
    return 0;
}

######################################################################
# ページセッティング
sub css ($) {
    my $this = shift;
    return '';
}

######################################################################
# 前後ページへのリンク
sub print_page_jump_form ($$$;$$$$$) {
    my ( $this, $handle, $output, $p, $u, $count, $name, $is_list ) = @_;
    return if $u > $count;
    $name = '' if !defined $name;
    my ( @form, $url, $prev, $next, $to, $button, $post_flag );
    $p    = 0 if !$p;
    $prev = $p - 1;
    $next = $p + 1;

    if ( defined $output && $output ) {
        push( @form, @setting::form0, 'v' );
    }
    elsif ($is_list) {
        push( @form, @setting::form, 'v' );
    }
    else {
        push( @form, @setting::form, 'v', 't' );
    }

    if ( !$output && $setting::general{'postMethod'} ) {
        print $handle $this->form_start(
            'key'      => $setting::security_key,
            'name'     => 'jump' . $name,
            'required' => \@form
        );
        $post_flag = 1;
    }
    else {
        $this->use_deco($output);
        $url = $cgi::path
            . $this->amp_escape( $this->set_query( 'url', \@form ) );
    }

    print $handle '<ul class="pager">';

    if ( $prev >= 0 ) {
        print $handle '<li class="prev">';
        if ( defined $post_flag && $post_flag ) {
            print $handle $cgi::Deco->submit_button(
                'prev',
                $setting::page{'prevButton'},
                ( ($default::english) ? 'Prev' : '前のページ' ),
                '',
                ( ($prev) ? { 'p' => $prev } : {} )
            );
        }
        else {
            print $handle $cgi::Deco->button(
                'prev',
                $setting::page{'prevButton'},
                $url
                    . (
                    ($prev) ? $this->amp_escape(
                        $this->add_query( 'url', { 'p' => $prev } )
                    ) : ''
                    ),
                ( ($default::english) ? 'Prev' : '前のページ' )
            );
        }
        print $handle '</li>';
    }

    $count = 0 if !$count;

    $to = $u * $next;
    $to = $count if $to > $count;

    if ( $post_flag || $setting::page{'pageinfo'} || $count < $u ) {
        my $from = $u * $p;
        $from += 1 if defined $count && $count;
        print $handle '<li class="info">'
            . $from . ' - '
            . $to . ' / '
            . $count . '</li>';
    }
    else {
        my $pnum = $p + 1;
        my $max
            = ( $setting::page{'pagelistmax'} )
            ? $setting::page{'pagelistmax'}
            : 12;
        my $margin
            = ( $setting::page{'pagelistmargin'} )
            ? $setting::page{'pagelistmargin'}
            : 2;
        my $total = int( $count / $u + 0.9999 );
        $max = 7 if $max && $max < 7;
        $margin = int( ( $max - 5 ) / 2 ) if $max - $margin * 2 - 5 < 0;
        $margin = 1 if $margin < 1;
        my $start_page
            = ( $pnum - $margin <= $total - $max + 3 )
            ? ( $pnum - $margin > 3 )
                ? $pnum - $margin
                : 3
            : $total - $max + 3;
        my $end_page = $start_page + $max - 5;
        my $omission = 0;

        foreach my $page ( 1 .. $total ) {
            if (( $max && $max < $total && $page > 1 && $page < $total )
                && (   ( $pnum > $margin + 3 && $page < $start_page )
                    || ( $end_page < $page && $end_page < $total - 2 ) )
                )
            {
                $omission = 1;
                next;
            }
            if ($omission) {
                print $handle '<li class="omission">...</li>';
                $omission = 0;
            }
            if ( $page == $pnum ) {
                print $handle '<li class="here">' . $page . '</li>';
            }
            else {
                print $handle '<li><a href="'
                    . $url
                    . (
                    ( $page && $page > 1 )
                    ? $this->amp_escape(
                        $this->add_query( 'url', { 'p' => ( $page - 1 ) } )
                        )
                    : ''
                    )
                    . '">'
                    . $page
                    . '</a></li>';
            }
        }
        print $handle '<li class="manual">';
        print $handle $this->form_start(
            'key'      => $setting::security_key,
            'name'     => 'jump' . $name,
            'required' => \@form
        );
        print $handle '<input type="text" size="2" name="pnum" title="'
            . ( ($default::english)
            ? 'Type return key'
            : 'ページ番号を入力しリターンキーで移動します。'
            ) . '" />';
        print $handle '</form></li>';
    }

    unless ( $count < 1 || $count <= $to ) {
        print $handle '<li class="next">';
        if ( defined $post_flag && $post_flag ) {
            print $handle $cgi::Deco->submit_button(
                'next',
                $setting::page{'nextButton'},
                ( ($default::english) ? 'Next' : '次のページ' ),
                '', { 'p' => $next }
            );
        }
        else {
            print $handle $cgi::Deco->button(
                'next',
                $setting::page{'nextButton'},
                $url
                    . $this->amp_escape(
                    $this->add_query( 'url', { 'p' => $next } )
                    ),
                ( ($default::english) ? 'Next' : '次のページ' )
            );
        }
        print $handle '</li>';
    }

    print $handle '</ul>';
    print $handle '</form>' if defined $post_flag && $post_flag;
}

######################################################################
#入力欄
sub print_input_form ($$$$$$$$) {
    my ( $this, $handle, $output, $database, $t, $n, $v ) = @_;
    my $parent
        = ( $v && $v eq 'listarticle' && $n ) ? $n
        : ( $v && $v eq 'listthread' && $t ) ? $t
        :                                      '';
    return if $parent && !$cgi::action->is_secure('inputchild');
    local %main::data   = ();
    local $main::m      = 'Editor';
    local $main::k      = 'editor';
    local $main::n      = '';
    local $main::t      = $t;
    local $main::parent = $parent;
    local $main::v      = $v;

    local $thread::id;
    local $thread::root;
    local $thread::category_name;
    local $thread::status;
    if ($parent) {
        my ( %tree, @info );
        tie( %tree, $env::dbm_file, $default::db . '/tree',
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %tree ) {
            @info = split( /,/,
                $this->decode_utf8( $tree{ $this->encode_utf8($parent) } ) );
        }
        untie(%tree);
        if ( defined $info[0] && $info[0] ) {
            return if $info[0] =~ /^d/;
            $thread::id
                = ( defined $info[1] && $info[1] ne '' ) ? $info[1] : $parent;
        }
        else {
            return;
        }
        if ( $field::for{'category'} ) {
            my ( %thread_category, $category_id );
            tie( %thread_category, $env::dbm_file,
                $default::db . '/thread_category',
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %thread_category ) {
                $category_id = $this->decode_utf8(
                    $thread_category{ $this->encode_utf8($thread::id) } );
            }
            untie(%thread_category);
            if (   defined $category_id
                && ref $thread::category{$category_id}
                && $thread::category{$category_id}{'closed'}
                && !$this->is_secure('closed') )
            {
                return;
            }
            elsif (defined $category_id
                && ref $thread::category{$category_id}
                && $thread::category{$category_id}{'name'} )
            {
                $thread::category_name
                    = $thread::category{$category_id}{'name'};
            }
        }
        if ( $field::for{'status'} ) {
            my (%thread_status);
            tie( %thread_status, $env::dbm_file,
                $default::db . '/thread_status',
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %thread_status ) {
                $thread::status = $this->decode_utf8(
                    $thread_status{ $this->encode_utf8($thread::id) } );
            }
            untie(%thread_status);
        }
        if ( $field::for{'name'} ) {
            my (%name);
            tie( %name, $env::dbm_file,
                $default::db . '/' . $field::obj{ $field::for{'name'} }->db,
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %name ) {
                $thread::root = $this->decode_utf8(
                    $name{ $this->encode_utf8($thread::id) } );
            }
            untie(%name);
        }
    }

    my $cookie_name
        = ( $default::subdivided && defined $main::c && $main::c ne '' )
        ? 'INPUT_' . ( uc $main::c )
        : 'INPUT';
    $this->read_cookie($cookie_name);

    #フォーム
    print $handle '<div class="section baobab-form">';
    print $handle $this->form_start(
        'key'      => $setting::security_key,
        'id'       => 'bb-input-form',
        'name'     => 'bb-input-form',
        'multi'    => $cgi::enctype_multipart,
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => [ 'n', 't', 'v', 'p', @setting::form ]
    );
    print $handle '<input type="hidden" name="a" value="w" />';
    print $handle '<input type="hidden" name="opener" value="self" />';
    print $handle '<input type="hidden" name="parent" value="'
        . $this->escape($parent) . '" />'
        if $parent;

    print $handle '<table class="field-table"><tbody>';
    my $cookie_enabled = 0;
    foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$o};
        if (ref $field::obj{$id}
            && (  !$field::obj{$id}->{'protected'}
                || $this->is_secure( 'inputProtectedFields', 0, 'input' ) )
            && $field::obj{$id}->{'class'} ne 'user_xtime'
            )
        {
            $cookie_enabled = 1
                if $field::obj{$id}->cookie_enabled
                && $field::obj{$id}->{'cookie'};
            my %data
                = ( $parent && $field::obj{$id}->db )
                ? $field::obj{$id}->elements(
                $this->decode_utf8(
                    $database->{ $field::obj{$id}->db }
                        ->{ $this->encode_utf8($parent) }
                )
                )
                : ();
            print $handle $field::obj{$id}->form(
                '', \%data,
                $default::file . '/',
                ( ($parent) ? $default::file . '/' . $parent : '' )
            );
        }
    }

    print $handle '</tbody><tbody>';
    print $handle '<tr class="tbody-start">';
    print $handle '<td class="submit-box" colspan="2">';
    if (   $setting::general{'resmail'}
        && $this->is_secure('mail')
        && $field::for{'mail'}
        && ref $field::obj{ $field::for{'mail'} }
        && $field::obj{ $field::for{'mail'} }->{'e-mail'}
        && $field::obj{ $field::for{'mail'} }->{'class'} =~ /email/ )
    {
        print $handle '<label><input type="checkbox" name="mailing" value="1"'
            . ( ($main::mailing) ? ' checked="checked"' : '' )
            . ' />返信通知</label> ';
    }
    if ( defined $cookie_enabled && $cookie_enabled ) {
        print $handle
            '<label title="同じ内容を入力することが多いいくつかの項目を記憶します。"><input type="checkbox" name="set_cookie" value="1"'
            . ( ( $cookie::read{$cookie_name} || $main::set_cookie )
            ? ' checked="checked"'
            : '' )
            . ' />情報を記憶する</label> ';
    }
    print $handle
        '<input type="submit" name="submit_button" value="送信" class="save" />';
    print $handle '</td></tr></tbody></table></form>';
    print $handle '</div>';
}

######################################################################
# 新着アイコン取得
sub new_item_icon ($$$;$) {
    my ( $this, $database, $n, $is_thread ) = @_;
    $n = $this->encode_utf8($n);
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    if ( $setting::page{'newIconLimit'} ) {
        my $ctime;
        if ($is_thread) {
            tie( %{ $database->{'thread_ctime'} },
                $env::dbm_file, "$default::db/thread_ctime", O_RDONLY,
                $env::dbm_mode )
                if !ref tied %{ $database->{'thread_ctime'} };
            $ctime = $database->{'thread_ctime'}{$n};
        }
        else {
            tie( %{ $database->{'ctime'} },
                $env::dbm_file, "$default::db/ctime", O_RDONLY,
                $env::dbm_mode )
                if !ref tied %{ $database->{'ctime'} };
            $ctime = $database->{'ctime'}{$n};
        }
        if ( $ctime
            && time - $ctime < 86400 * $setting::page{'newIconLimit'} )
        {
            my $title
                = ( $setting::page{'newIconAlt'} )
                ? $setting::page{'newIconAlt'}
                : (
                $setting::deco{'new'}{ $setting::page{'newIcon'} }{'alt'} )
                ? $setting::deco{'new'}{ $setting::page{'newIcon'} }{'alt'}
                : 'NEW!';
            if (   $setting::page{'newIcon'}
                && $setting::deco{'new'}{ $setting::page{'newIcon'} }{'width'}
                )
            {
                return ' '
                    . $cgi::Image->image_tag(
                    $env::image_dir . '/new/'
                        . $setting::deco{'new'}{ $setting::page{'newIcon'} }
                        {'name'},
                    $setting::deco{'new'}{ $setting::page{'newIcon'} }
                        {'width'},
                    $setting::deco{'new'}{ $setting::page{'newIcon'} }
                        {'height'},
                    0,
                    $title,
                    'class="new-item-icon"',
                    '',
                    '',
                    $cgi::output,
                    $cgi::output_option
                    );
            }
            else {
                return ' <span class="new-item-icon">' . $title . '</span>';
            }
        }
    }
    if ( $setting::page{'upIconLimit'} ) {
        my $mtime;
        if ($is_thread) {
            tie( %{ $database->{'thread_mtime'} },
                $env::dbm_file, "$default::db/thread_mtime", O_RDONLY,
                $env::dbm_mode )
                if !ref tied %{ $database->{'thread_mtime'} };
            $mtime = $database->{'thread_mtime'}{$n};
        }
        else {
            tie( %{ $database->{'mtime'} },
                $env::dbm_file, "$default::db/mtime", O_RDONLY,
                $env::dbm_mode )
                if !ref tied %{ $database->{'mtime'} };
            $mtime = $database->{'mtime'}{$n};
        }
        if ( $mtime && time - $mtime < 86400 * $setting::page{'upIconLimit'} )
        {
            my $title
                = ( $setting::page{'upIconAlt'} )
                ? $setting::page{'upIconAlt'}
                : ( $setting::deco{'new'}{ $setting::page{'upIcon'} }{'alt'} )
                ? $setting::deco{'new'}{ $setting::page{'upIcon'} }{'alt'}
                : 'UP!';
            if (   $setting::page{'upIcon'}
                && $setting::deco{'new'}{ $setting::page{'upIcon'} }{'width'}
                )
            {
                return ' '
                    . $cgi::Image->image_tag(
                    $env::image_dir . '/new/'
                        . $setting::deco{'new'}{ $setting::page{'upIcon'} }
                        {'name'},
                    $setting::deco{'new'}{ $setting::page{'upIcon'} }
                        {'width'},
                    $setting::deco{'new'}{ $setting::page{'upIcon'} }
                        {'height'},
                    0,
                    $title,
                    'class="up-item-icon"',
                    '',
                    '',
                    $cgi::output,
                    $cgi::output_option
                    );
            }
            else {
                return ' <span class="up-item-icon">' . $title . '</span>';
            }
        }
    }
    return '';
}

1;
