package ViewSelector;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールドモジュール（表示切り替えボタン）
# ViewSelector.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-06-14
######################################################################
sub set_my_type ($;$) {
    my ( $v, $n ) = @_;
    if ($v) {
        if ( $v =~ /tree/ ) {
            $ViewSelector::type = 'tree';
        }
        elsif ( $v =~ /thread/ ) {
            $ViewSelector::type = 'articlelist';
        }
        elsif ( $v =~ /article/ ) {
            if ( defined $n && $n ne '' ) {
                $ViewSelector::type = 'article';
            }
            else {
                $ViewSelector::type = 'articlelist';
            }
        }
        else {
            $ViewSelector::type = 'list';
        }
    }
    else {
        $ViewSelector::type = 'list';
    }
}

sub _set ($$) {
    my ( $this, $setting ) = @_;
    return if defined $ViewSelector::type && $ViewSelector::type;
    if ( $main::k eq 'viewer' ) {
        set_my_type( $main::v, $main::n );
    }
    elsif ( $main::k =~ /tree/ ) {
        $ViewSelector::type = 'tree';
    }
    else {
        $ViewSelector::type = 'list';
    }
    return;
}

######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return '';
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my ( $this, $status, $original ) = @_;
    return '';
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $main::data{ $this->{'id'} }{'str'};
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n, $db ) = @_;
    return $this->field_tag( $this->get_tool_icon( $n, $db ) );
}

sub has_content {
    my $this = shift;
    return 1;
}

sub get_tool_icon ($$$) {
    my ( $this, $n, $db ) = @_;
    my ($form,        $info,      $is_deleted, $top,
        $base_url,    $settarget, $onclick,    $dummy_window,
        $inline_flag, $word_flag, $form_flag
    );

    if ( $ViewSelector::type eq 'tree' ) {
        if ( defined $this->{'icon'} && $this->{'icon'} ) {
            $form .= '<div class="inline-toolbox">';
            $inline_flag = 1;
        }
        else {
            $word_flag = 1;
        }
    }
    $info = $this->decode_utf8( $db->{'tree'}->{ $this->encode_utf8($n) } );
    $is_deleted = 1 if $info && $info =~ /^d/;
    $top = $cgi::action->get_top( $n, $info );

    if ( !$word_flag && $setting::general{'postMethod'} ) {
        $form_flag = 1;
        if ( defined $cgi::output && $cgi::output ) {
            $form .= $this->form_start(
                'key'           => 'browse',
                'authorization' => 'disabled',
                'name'          => 'tool_' . $n
            );
            $form
                .= '<input type="hidden" name="c" value="'
                . $this->escape($main::c) . '" />'
                if defined $main::c && $main::c ne '';
        }
        else {
            $settarget = 'cmonos.element.item(this.form).fixTarget();"'
                if $main::k ne 'viewer';
            $form .= $this->form_start(
                'key'      => 'browse',
                'name'     => 'tool_' . $n,
                'required' => \@setting::form1
            );
        }
    }
    else {
        $base_url = $cgi::path;
        if ( defined $cgi::output && $cgi::output ) {
            $base_url
                .= ( defined $main::c && $main::c ne '' )
                ? '?c=' . $main::c . '&amp;'
                : '?';
        }
        else {
            $settarget = 'cmonos.element.item(this).fixTarget();'
                if $main::k ne 'viewer';
            my $query = $cgi::action->amp_escape(
                $this->set_query( 'url', \@setting::form1 ) );
            $base_url .= ($query) ? $query . '&amp;' : '?';
        }
    }
    if ( !defined $word_flag || !$word_flag ) {
        if ( defined $inline_flag && $inline_flag ) {
            $form .= '<ul class="tools">';
        }
        else {
            my $style = '';
            $style .= 'text-align: ' . $this->{'align'} . ';'
                if defined $this->{'align'} && $this->{'align'};
            $style
                .= ( ($style) ? ' ' : '' )
                . 'float: '
                . $this->{'float'} . ';'
                if defined $this->{'float'} && $this->{'float'};
            $form .= '<ul class="tools"'
                . ( ( $style ne '' ) ? ' style="' . $style . '"' : '' ) . '>';
        }
    }

    # 表示切り替えボタン
    if ((      $this->{ $ViewSelector::type . 'view' }
            || $this->{ $ViewSelector::type . 'view' } eq ''
        )
        && (   $this->{'treeres'}
            || $this->{'listres'}
            || $this->{'articlelistres'}
            || $this->{'articleres'}
            || $this->{'treeres'} eq ''
            || $this->{'listres'} eq ''
            || $this->{'articlelistres'} eq ''
            || $this->{'articleres'} eq '' )
        )
    {

        if ( defined $word_flag && $word_flag ) {

            # 単記事表示
            $form
                .= '<a href="'
                . $base_url . 'n='
                . $n
                . '&amp;v=listarticle"'
                . ( ($settarget) ? ' onclick="' . $settarget . '"' : '' )
                . '>[記事]</a>';

            # 記事スレッド表示
            $form
                .= '<a href="'
                . $base_url . 'n='
                . $n
                . '&amp;t='
                . $top
                . '&amp;v=listthread"'
                . ( ($settarget) ? ' onclick="' . $settarget . '"' : '' )
                . '>[スレッド]</a>';

            # ツリー表示
            $form
                .= '<a href="'
                . $base_url
                . 'k=tree&amp;m=TreeView&amp;n='
                . $n
                . '&amp;t='
                . $top
                . '" target="treeViewer"'
                . ( ( $main::k eq 'viewer' )
                ? 'onclick="cmonos.window.open(\'treeViewer\',800,300);"'
                : '' )
                . '>[ツリー]</a>';

        }
        else {

            # 単記事表示
            $form
                .= $cgi::action->view_switch_button( 'viewarticle',
                '単記事表示', $base_url,
                { 'n' => $n, 'v' => 'listarticle' },
                '', $settarget );

            # 記事スレッド表示
            $form
                .= $cgi::action->view_switch_button( 'viewthread',
                '記事スレッド表示', $base_url,
                { 'n' => $n, 't' => $top, 'v' => 'listthread' },
                '', $settarget );

            # ツリー表示
            $form .= $cgi::action->view_switch_button(
                'viewtree',
                'ツリー表示',
                $base_url,
                { 'n' => $n, 't' => $top, 'm' => 'TreeView', 'k' => 'tree' },
                'group-end',
                'cmonos.window.open(\'treeViewer\',800,300);',
                'treeViewer',
            );
        }
    }
    return $form
        . ( ($word_flag)
        ? ''
        : '</ul>'
            . ( ($form_flag)   ? '</form>' : '' )
            . ( ($inline_flag) ? '</div>'  : '' ) )
        if $this->{ $ViewSelector::type . 'edit' } eq '0'
        && $this->{ $ViewSelector::type . 'res' } eq '0';

    $onclick = 'cmonos.window.open(\'articleEditor\',640,480);';

    # 修正ボタン
    if (   $this->{ $ViewSelector::type . 'edit' }
        || $this->{ $ViewSelector::type . 'edit' } eq '' )
    {

        if ( defined $word_flag && $word_flag ) {
            my $url
                = $base_url
                . 'k=editor&amp;m=Editor&amp;n='
                . $n
                . ( ( $main::k eq 'tree' ) ? '&amp;opener=tree' : '' )
                . '&amp;t='
                . $top
                . '&amp;v='
                . $main::v;
            $form .= ' ' if defined $form && $form ne '';

            # 削除
            if ( !$cgi::output && $this->is_secure('remove') ) {
                $form
                    .= '<a href="'
                    . $url
                    . '&amp;rmthread=1" target="articleEditor" onclick="return confirm(\'この操作は取り消せません。このスレッドを本当に削除しますか？\') &amp;&amp; '
                    . $onclick
                    . '">[スレッド削除]</a>';
            }

            # 削除
            if ( !$cgi::output
                && ( !$is_deleted && $this->is_secure('revise') ) )
            {
                $form
                    .= '<a href="'
                    . $url
                    . '&amp;delete=1" target="articleEditor" onclick="return confirm(\'この操作は取り消せません。この記事を本当に削除しますか？\') &amp;&amp; '
                    . $onclick
                    . '">[削除]</a>'
                    if !$cgi::output
                    && $this->is_secure( 'delete', 0, 'revise' );

                # 修正
                $form
                    .= '<a href="'
                    . $url
                    . '" target="articleEditor" onclick="'
                    . $onclick
                    . '">[修正]</a>';
            }

        }
        else {
            my %query = (
                'k' => 'editor',
                'm' => 'Editor',
                'n' => $n,
                't' => $top,
                'v' => $main::v
            );
            $query{'opener'} = 'tree' if $main::k eq 'tree';

            # 削除
            if ( !$cgi::output && $this->is_secure('remove') ) {
                $form .= $cgi::action->view_switch_button(
                    'inputrmthread',
                    'スレッド削除',
                    $base_url,
                    { 'rmthread' => '1', %query },
                    'group-end',
                    'return confirm(\'この操作は取り消せません。このスレッドを本当に削除しますか？\') &amp;&amp; '
                        . $onclick,
                    'articleEditor'
                );
            }

            # 削除
            if ( !$cgi::output
                && ( !$is_deleted && $this->is_secure('revise') ) )
            {
                $form .= $cgi::action->view_switch_button(
                    'inputdelete',
                    '削除',
                    $base_url,
                    { 'delete' => '1', %query },
                    '',
                    'return confirm(\'この操作は取り消せません。この記事を本当に削除しますか？\') &amp;&amp; '
                        . $onclick,
                    'articleEditor'
                    )
                    if !$cgi::output
                    && $this->is_secure( 'delete', 0, 'revise' );

                # 修正
                $form .= $cgi::action->view_switch_button(
                    'inputedit', '修正', $base_url, \%query,
                    'group-end', $onclick, 'articleEditor'
                );
            }
        }
    }

    # レスボタン
    if (!$is_deleted
        && (   $this->{ $ViewSelector::type . 'res' }
            || !defined $this->{ $ViewSelector::type . 'res' }
            || $this->{ $ViewSelector::type . 'res' } eq '' )
        && ((   defined $setting::security{'inputchild'}{'passwordCheck'}
                && $setting::security{'inputchild'}{'passwordCheck'} eq
                'nocheck'
            )
            || ( !$cgi::output && $this->is_secure('inputchild') )
        )
        )
    {

        if ( defined $word_flag && $word_flag ) {
            my $url
                = $base_url
                . 'k=editor&amp;m=Editor&amp;'
                . ( ( $main::k eq 'tree' ) ? '&amp;opener=tree' : '' )
                . 'parent='
                . $n
                . ( ($main::p) ? '&amp;p=' . $main::p : '' )
                . '&amp;t='
                . $top
                . '&amp;v='
                . $main::v;
            $form .= ' ' if defined $form && $form ne '';

            # レス
            $form
                .= '<a href="'
                . $url
                . '" target="articleEditor" onclick="'
                . $onclick
                . '">[返信]</a>';

        }
        else {
            my (%query);
            %query = (
                'm'      => 'Editor',
                'k'      => 'editor',
                'v'      => $main::v,
                'parent' => $n,
                't'      => $top
            );
            $query{'p'}      = $main::p if $main::p;
            $query{'opener'} = 'tree'   if $main::k eq 'tree';

            # レス
            $form
                .= $cgi::action->view_switch_button( 'inputres', '返信',
                ( ($form_flag) ? '' : $base_url ),
                \%query, '', $onclick, 'articleEditor' );
        }
    }

    if ( !defined $word_flag || !$word_flag ) {
        $form .= '</ul>';
        $form .= '</form>' if defined $form_flag && $form_flag;
        $form .= '</div>' if defined $inline_flag && $inline_flag;
    }
    return $form;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_mail {
    my ( $this, $str, $path, $c, $n, $db ) = @_;
    return '';
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
    my ( $this, $str, $path, $c, $n, $db ) = @_;
    return $this->field_tag( $this->get_tool_icon( $n, $db ) );
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_text {
    my ( $this, $str, $path, $c, $n, $db ) = @_;
    return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ( $name, $searchOption_checked, $comma_checked, $note );

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form( $name, 1 );

    print '<fieldset>';
    print '<legend>表示設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">表示の制御</span></td>';
    print '<td class="field">';

    #テーブル設定
    require CMONOS::CGI_Lib::Table;
    my $table = Table->new;
    $table->set(
        'tableclass' => 'tooltable',
        'thenabled'  => 'true',
        'trclass'    => 'odd,even',
        'class0'     => 'odd,even',
        'classF'     => 'name',
        'style0'     => 'text-align: center; width: 100px;'
    );

    #表
    print $table->table;
    print $table->tr;
    print $table->td('');
    print $table->td('表示切り替え<br />ボタン');
    print $table->td('削除・修正<br />ボタン');
    print $table->td('返信<br />ボタン');
    print $table->_tr;
    my %type_name = (
        'tree'        => 'ツリー表示時',
        'list'        => '一覧表示時',
        'articlelist' => '記事一覧表示時',
        'article'     => '単記事表示時'
    );
    my ($type);

    foreach $type ( 'tree', 'list', 'articlelist', 'article' ) {
        print $table->tr;
        print $table->td( $type_name{$type} );
        my ($icon);
        foreach $icon ( 'view', 'edit', 'res' ) {
            print $table->td(
                      '<input type="checkbox" name="data:'
                    . $this->{'id'} . '_'
                    . $type
                    . $icon
                    . '" value="1"'
                    . (
                    (          $this->{ $type . $icon }
                            || $this->{ $type . $icon } eq ''
                    ) ? ' checked="checked"' : ''
                    )
                    . ' />'
            );
        }
        print $table->_tr;
    }
    print $table->_table;
    undef %type_name;
    undef %{$table};
    undef $table;

    print
        '<div class="hints">どの表示形式でも返信ボタンが表示されない場合、表示切り替えボタンは表示されません。</div>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_align">配置</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_align', '', '', $this->{'align'},
        ''       => '',
        'left'   => '左寄せ',
        'center' => '中央揃え',
        'right'  => '右寄せ'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_float">回り込み</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_float', '', '', $this->{'float'},
        ''      => '',
        'left'  => '左',
        'right' => '右'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">オプション</span></td>';
    print '<td class="field"><label><input type="checkbox" name="'
        . $name
        . '_icon" value="1"'
        . ( ( $this->{'icon'} ) ? ' checked="checked"' : '' )
        . ' /> ツリー表示時も[文字]ではなくアイコンで表示する</label>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    $this->print_setting_save_button;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    my ($type);
    foreach $type ( 'tree', 'list', 'articlelist', 'article' ) {
        my ($icon);
        foreach $icon ( 'view', 'edit', 'res' ) {
            $main::data{ $this->{'id'} . '_' . $type . $icon } = '0'
                if !defined $main::data{ $this->{'id'} . '_' . $type . $icon }
                || !$main::data{ $this->{'id'} . '_' . $type . $icon };
        }
    }
    $main::data{ $this->{'id'} . '_icon' } = ''
        if !defined $main::data{ $this->{'id'} . '_icon' }
        || !$main::data{ $this->{'id'} . '_icon' };
    return 1;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'xbb_viewselector', 'ViewSelector',
        '表示切り替えボタン' );
}

1;
