package IconEditor;
require CMONOS::CGI_Lib::Tools::ImageEditor;
@ISA = qw(ImageEditor);
use strict;
use utf8;
######################################################################
# Baobabアイコンライブラリ編集モジュール
# IconEditor.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 画像情報
sub get_image_info ($) {
    my $this = shift;
    undef %setting::deco_type;
    undef %setting::deco_dir;

    %setting::deco_type = (
        'list'              => 'button',
        'listtree'          => 'button',
        'listarticle'       => 'button',
        'listthread'        => 'button',
        'listsearch'        => 'button',
        'input'             => 'button',
        'inputedit'         => 'button',
        'inputres'          => 'button',
        'inputdelete'       => 'button',
        'inputrmthread'     => 'button',
        'viewtree'          => 'button',
        'viewarticle'       => 'button',
        'viewthread'        => 'button',
        'tool'              => 'button',
        'toolpassword'      => 'button',
        'statusnew'         => 'image',
        'statusoperational' => 'image',
        'statussolved'      => 'image',
        'threadcategory'    => 'image'
    );
    %setting::deco_option = ( 'threadcategory' => 'noalt' );
    %setting::deco_dir = (
        'list'         => '001:テーブル表示インデックスボタン',
        'listtree'     => '002:ツリー表示インデックスボタン',
        'listthread'   => '003:ソート順ツリー表示ボタン',
        'listarticle'  => '004:ソート順記事表示ボタン',
        'listreset'    => '005:記事検索ボタン',
        'listsearch'   => '006:記事検索ボタン',
        'tool'         => '101:環境設定を開く ボタン',
        'toolpassword' => '102:ログインボタン',
        'input'        => '103:新規投稿ボタン',
        'viewarticle'  => '201:単記事表示ボタン',
        'viewthread'   => '202:記事スレッド表示ボタン',
        'viewtree'     => '203:ツリー表示ボタン',
        'inputrmthread'     => '301:スレッド削除ボタン',
        'inputdelete'       => '302:削除ボタン',
        'inputedit'         => '303:記事修正ボタン',
        'inputres'          => '304:返信ボタン',
        'statusnew'         => '401:新規投稿アイコン',
        'statusoperational' => '402:進行中スレッドアイコン',
        'statussolved'      => '403:解決済みスレッドアイコン',
        'threadcategory'    => '501:スレッドカテゴリーアイコン'
    );

    my $icon_pref = $env::preference_dir . '/bb_icon';
    $this->import_db( $icon_pref, \%setting::icon, 1 );
    $main::dir = 'list' if !defined $main::dir || $main::dir eq '';
    return (
        $env::image_dir . '/baobab',
        $env::image_lib . '/baobab',
        \%setting::icon, $icon_pref, $env::css . '/' . $setting::image_css
    );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    unless ( $default::subdivided && defined $main::c && $main::c ne '' ) {

        #クラス登録
        Common::class_register( '0102', 'IconEditor' );

        #メニュー登録
        $setting::jump_menu{'0102'}
            = 'アイコンライブラリ編集(Baobab共通)';
        $setting::master_check_option{'0102'} = 1;

        #イメージCSS
        $setting::image_css = 'baobab-image.css';
    }
}

1;
