package PageIconObj;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
use utf8;
######################################################################
# 共通アイコンモジュール
# PageIconObj.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定環境
sub set_preferences ($) {
    my $this = shift;
    $preference::db         = 'page';    # 記録用データベース名
    $preference::submenukey = 'page';    # サブメニューキー

    $preference::id   = '';                            # データキー
    $preference::name = '共通アイコン設定';    # 設定パネル名
    $preference::title
        = '各ページが共通して利用するアイコンについて設定します。';

    $this->use_icon( 'baobab', 'bb_icon' );
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;

    print '<input type="hidden" name="id" value="" />';

    print
        '<fieldset><legend>インデックス表示ボタン設定</legend>';
    $this->print_button_menu( 'テーブル表示インデックスボタン',
        'list' );
    $this->print_button_menu( 'ツリー表示インデックスボタン',
        'listtree' );
    $this->print_button_menu( 'ソート順記事表示ボタン',
        'listarticle' );
    $this->print_button_menu( 'ソート順ツリー表示ボタン',
        'listthread' );
    $this->print_button_menu( '検索条件リセットボタン',
        'listreset' );
    $this->print_button_menu( '記事検索ボタン', 'listsearch' );
    print '</fieldset>';

    print '<fieldset><legend>ツールボタン設定</legend>';
    $this->print_button_menu( '環境設定を開く ボタン', 'tool' );
    $this->print_button_menu( 'ログインボタン', 'toolpassword' );
    $this->print_button_menu( '新規投稿ボタン', 'input' );
    print '</fieldset>';

    print '<fieldset><legend>記事表示ボタン設定</legend>';
    $this->print_button_menu( '単記事表示ボタン', 'viewarticle' );
    $this->print_button_menu( '記事スレッド表示ボタン',
        'viewthread' );
    $this->print_button_menu( 'ツリー表示ボタン', 'viewtree' );
    print '</fieldset>';

    print '<fieldset><legend>記事編集ボタン設定</legend>';
    $this->print_button_menu( 'スレッド削除ボタン',
        'inputrmthread' );
    $this->print_button_menu( '削除ボタン',       'inputdelete' );
    $this->print_button_menu( '記事修正ボタン', 'inputedit' );
    $this->print_button_menu( '返信ボタン',       'inputres' );
    print '</fieldset>';

    print '<fieldset><legend>スレッド状況アイコン設定</legend>';
    $this->print_image_menu( '新規投稿アイコン', 'statusnew' );
    $this->print_image_menu( '進行中スレッドアイコン',
        'statusoperational' );
    $this->print_image_menu( '解決済みスレッドアイコン',
        'statussolved' );
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

sub print_button_menu ($$$) {
    my ( $this, $title, $name ) = @_;
    print '<fieldset><legend>' . $title . '</legend>';
    print $cgi::icon->button_menu( 'data:' . $name,
        $name, 120, $main::data{$name} );
    print '</fieldset>';
}

sub print_image_menu ($$$) {
    my ( $this, $title, $name ) = @_;
    print '<fieldset><legend>' . $title . '</legend>';
    print $cgi::icon->image_menu( 'data:' . $name,
        $name, 120, $main::data{$name} );
    print '</fieldset>';
}

######################################################################
# 登録
#sub import {
BEGIN {
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {
        #クラス登録
        Common::class_register( 'b0zy', 'PageIconObj' );

        #ツール登録
        $setting::sub_jump_menu{'page'}{'b0zy'} = '共通アイコン設定';
        $setting::selected_jump_menu{'b0zy'} = 'b010'
            ; #サブメニューがあるときメインメニューのデフォルトキー
    }
}

1;
