package TreePage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
no warnings qw(once);
######################################################################
# ツリーウィンドウ ページ設定モジュール
# TreePage.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    $check::num{'treeLimit'} = '表示件数';
    push( @check::checkbox, 'treeNoLine' );
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'tree';    # データキー
    $preference::name = 'ツリーウィンドウ ページレイアウト'
        ;                        # 設定パネル名
    $preference::title
        = 'ツリーウィンドウのレイアウトについて設定します。';
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($;$$) {
    my ( $this, $id, $key ) = @_;
    print '<fieldset><legend>ツリー表示設定</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">表示方法</span></td>';
    print
        '<td class="field"><label><input type="checkbox" name="data:tree_treeNoLine" id="data:tree_NoLine" value="1"'
        . ( ( $main::data{'tree_treeNoLine'} ) ? ' checked="checked"' : '' )
        . ' /> 記事階層ガイド罫線を表示しない</label></td>';
    print '</tr><tr>';
    print
        '<td class="field-name"><label for="data:tree_treeLimit">表示件数</label></td>';
    print
        '<td class="field"><input type="text" name="data:tree_treeLimit" id="data:tree_treeLimit" value="'
        . $this->escape( $main::data{'tree_treeLimit'} )
        . '" size="7" maxlength="7" /> 件/1ページ</td>';
    print '</tr></tbody>';
    print '<tbody class="foldable"><tr>';
    print
        '<td class="field-name"><label for="data:tree_treeStyle">表示スタイル</label></td>';
    print
        '<td class="field"><input type="text" name="data:tree_treeStyle" id="data:tree_treeStyle" value="'
        . $this->escape( $main::data{ $key . 'treeStyle' } )
        . '" size="64" />';
    print
        '<div class="hints">「:」を含まない場合はクラス指定と解釈されます。</div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table></fieldset>';
}

######################################################################
#sub import {
BEGIN {
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #クラス登録
        Common::class_register( 'b011', 'TreePage' );

        #ツール登録
        $setting::sub_jump_menu{'page'}{'b011'} = 'ツリーウィンドウ';
        $setting::selected_jump_menu{'b011'} = 'b010'
            ; #サブメニューがあるときメインメニューのデフォルトキー

        $preference::page{'b011'} = 'tree';

    }
}

1;
