package Podcast;
require CMONOS::CGI_Lib::Feed::RSS2_0;
@ISA = qw(RSS2_0);
use strict;
use utf8;
######################################################################
# Podcast更新
# CMONOS::CGI_Lib::Feed::Podcast.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
sub _init ($) {
    my $this = shift;
    $this->{'xmlns'}{'itunes'} = 'http://www.itunes.com/DTDs/Podcast-1.0.dtd';
    $this->{'channel_element'}{'itunes:subtitle'}
        = $this->{'channel_element'}{'title'}
        if !defined $this->{'channel_element'}{'itunes:subtitle'}
        || $this->{'channel_element'}{'itunes:subtitle'} eq '';
    $this->{'channel_element'}{'itunes:summary'}
        = $this->{'channel_element'}{'description'}
        if !defined $this->{'channel_element'}{'itunes:summary'}
        || $this->{'channel_element'}{'itunes:summary'} eq '';
    $this->{'channel_element'}{'itunes:image'}{'href'}
        = $this->{'channel_element'}{'image'}{'value'}{'url'}
        if !ref $this->{'channel_element'}{'itunes:image'}
        && ref $this->{'channel_element'}{'image'}
        && ref $this->{'channel_element'}{'image'}{'value'}
        && $this->{'channel_element'}{'image'}{'value'}{'url'};
    $this->{'channel_element'}{'itunes:image'}{'href'}
        = $this->{'channel_element'}{'image'}{'url'}
        if !ref $this->{'channel_element'}{'itunes:image'}
        && ref $this->{'channel_element'}{'image'}
        && $this->{'channel_element'}{'image'}{'url'};
}

sub _item_init ($$) {
    my ( $this, $item ) = @_;
    $item->{'itunes:subtitle'} = $item->{'title'}
        if !defined $item->{'itunes:subtitle'}
        || $item->{'itunes:subtitle'} eq '';
    $item->{'itunes:summary'} = $item->{'description'}
        if !defined $item->{'itunes:summary'}
        || $item->{'itunes:summary'} eq '';
    $item->{'itunes:author'} = $item->{'author'}
        if ( !defined $item->{'itunes:author'}
        || $item->{'itunes:author'} eq '' )
        && $item->{'author'};
    if ( ref $item->{'enclosure'} && $item->{'enclosure'}{'url'} ) {
        my $ext
            = ( $item->{'enclosure'}{'url'} =~ /\.([0-9a-zA-Z_]+)$/ )
            ? lc $1
            : '';
        if ( $ext eq 'mp3' ) {
            $item->{'enclosure'}{'type'} = 'audio/mpeg';
        }
        elsif ( $ext eq 'm4a' ) {
            $item->{'enclosure'}{'type'} = 'audio/x-m4a';
        }
        elsif ( $ext eq 'mp4' ) {
            $item->{'enclosure'}{'type'} = 'video/mp4';
        }
        elsif ( $ext eq 'm4v' ) {
            $item->{'enclosure'}{'type'} = 'video/x-m4v';
        }
        elsif ( $ext eq 'mov' ) {
            $item->{'enclosure'}{'type'} = 'video/quicktime';
        }
        elsif ( $ext eq 'pdf' ) {
            $item->{'enclosure'}{'type'} = 'application/pdf';
        }
        elsif ( $ext eq 'epub' ) {
            $item->{'enclosure'}{'type'} = 'document/x-epub';
        }
    }
}

1;
