package EmailSelector;
require CMONOS::CGI_Lib::Field::Email;
@ISA = qw(Email);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（メールアドレスセレクタ）
# EmailSelector.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-01-28
######################################################################
sub __set ($$) {
    my ( $this, $setting ) = @_;
    if (   $this->{'field_for'}{'mail'}
        && $this->{'field_for'}{'mail'} eq $this->{'id'} )
    {
        if ( $this->{'selectorType'} ) {
            if ( $this->{'selectorType'} eq 'checkbox' ) {
                $this->{'selectorType'} = 'radio';
            }
            elsif ( $this->{'selectorType'} eq 'multipleselector' ) {
                $this->{'selectorType'} = 'selector';
            }
        }
    }
    return;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ( $name, $form, %user_name, %done, @selected );

    #名前にデータIDを埋め込む
    $name = 'data:' . $this->{'id'} . ':str';

    %user_name = $cgi::Register->get_name_hash_from_emails(
        $this->get_address(
            $setting::general{'owners'}, $setting::general{'staff'},
            $this->{'default'}
        )
    ) if ref $cgi::Register;
    %done     = ();
    @selected = $this->get_address(
        (          ref $main::data{ $this->{'id'} }{'str'}
                && ref $main::data{ $this->{'id'} }{'str'} == 'ARRAY'
        ) ? @{ $main::data{ $this->{'id'} }{'str'} }
        : (        $main::data{ $this->{'id'} }{'str'}
                && $main::data{ $this->{'id'} }{'str'} =~ /\x0A/s ) ?
            split( /\x0A/, $main::data{ $this->{'id'} }{'str'} )
        : $main::data{ $this->{'id'} }{'str'}
    );

    if ( $this->{'default'} ) {
        while ( $this->{'default'} =~ /^(.*?)$/gm ) {
            $form .= $this->email_option( $name, $1, \@selected, \%user_name,
                \%done );
        }
    }
    $form .= $this->email_option(
        $name,
        (   (   defined $setting::general{'mastername'}
                    && $setting::general{'mastername'} ne ''
            ) ? $setting::general{'mastername'} : '管理人'
            )
            . ' <'
            . $setting::general{'master'} . '>',
        \@selected,
        {},
        \%done
    ) if $this->{'addMaster'};
    if ( $this->{'addOwners'} && $setting::general{'owners'} ) {
        while ( $setting::general{'owners'} =~ /^(.*?),?$/gm ) {
            $form .= $this->email_option( $name, $1, \@selected, \%user_name,
                \%done );
        }
    }
    if ( $this->{'addStaff'} && $setting::general{'staff'} ) {
        while ( $setting::general{'staff'} =~ /^(.*?),?$/gm ) {
            $form .= $this->email_option( $name, $1, \@selected, \%user_name,
                \%done );
        }
    }

    return '' if !$form;
    if ($this->{'selectorType'}
        && (   $this->{'selectorType'} eq 'checkbox'
            || $this->{'selectorType'} eq 'radio' )
        )
    {
        $form = '<ol class="checkbox">'
            . (
            (          $this->{'selectorType'}
                    && $this->{'selectorType'} eq 'radio'
                    && !$this->{'required'}
            )
            ? '<li><label><input type="radio" name="'
                . $name
                . '" value=""'
                . ( ( !@selected ) ? ' checked="checked"' : '' )
                . ' /> なし</label></li>'
            : ''
            ) . $form . '</ol>';
    }
    else {
        $form
            = '<select id="'
            . $name
            . '" name="'
            . $name . '"'
            . (
            (          $this->{'selectorType'}
                    && $this->{'selectorType'} eq 'multipleselector'
            ) ? ' multiple="multiple"' : ''
            )
            . ( ( $this->{'required'} ) ? ' required="required"' : '' ) . '>'
            . (
            (         !$this->{'selectorType'}
                    || $this->{'selectorType'} eq 'selector'
            )
            ? '<option value="">'
                . (
                ( $this->{'required'} ) ? '▼選択してください' : ''
                )
                . '</option>'
            : ''
            )
            . $form
            . '</select>';
    }

    return $this->field_header(
        50,
        (   (         !$this->{'selectorType'}
                    || $this->{'selectorType'} =~ /selector/
            ) ? $name : ''
        )
        )
        . $form
        . $this->field_footer;
}

sub email_option ($$$$$$) {
    my ( $this, $input_name, $str, $value, $user_name, $done ) = @_;
    return '' if !$str;
    my $email = $str;
    my $name  = '';
    if ( $str =~ /^\s*(.*?)\s*<(.*?)>/s ) {
        $name  = $1;
        $email = $2;
    }
    elsif ( ref $user_name && $user_name->{$str} ) {
        $name = $user_name->{$str};
    }
    return '' if $done->{$email} || $this->is_invalid_email_address($email);
    $done->{$email} = 1;
    my $is_selected = ( ref $value && grep( $_ eq $email, @$value ) ) ? 1 : 0;
    $name =~ s/[()<>]/ /sg;
    $str = $this->escape(
        ( $name ne '' ) ? $name . ' <' . $email . '>' : $email );
    if ($this->{'selectorType'}
        && (   $this->{'selectorType'} eq 'checkbox'
            || $this->{'selectorType'} eq 'radio' )
        )
    {
        return
              '<li><label><input type="'
            . $this->{'selectorType'}
            . '" name="'
            . $input_name
            . '" value="'
            . $this->escape($email) . '"'
            . ( ($is_selected) ? ' checked="checked"' : '' ) . ' />'
            . $str
            . '</label></li>';
    }
    else {
        return
              '<option value="'
            . $this->escape($email) . '"'
            . ( ($is_selected) ? ' selected="selected"' : '' ) . '>'
            . $str
            . '</option>';
    }
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this     = shift;
    my $is_valid = 1;
    if ($this->{'selectorType'}
        && (   $this->{'selectorType'} eq 'checkbox'
            || $this->{'selectorType'} eq 'multipleselector' )
        && ref $main::data{ $this->{'id'} }{'str'}
        )
    {
        if ( ref $main::data{ $this->{'id'} }{'str'} ne 'ARRAY' ) {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'を確認してください。'
            ) if ref $cgi::action;
            $main::data{ $this->{'id'} }{'str'} = '';
            $is_valid = 0;
        }
        else {
            for (
                my $i = 0;
                $i < @{ $main::data{ $this->{'id'} }{'str'} };
                $i++
                )
            {
                $main::data{ $this->{'id'} }{'str'}[$i]
                    = $this->is_available_email(
                    $main::data{ $this->{'id'} }{'str'}[$i] );
            }
            @{ $main::data{ $this->{'id'} }{'str'} }
                = grep( defined $_ && $_ ne '',
                @{ $main::data{ $this->{'id'} }{'str'} } );
            if ( @{ $main::data{ $this->{'id'} }{'str'} } ) {
                $main::data{ $this->{'id'} }{'str'} = join( "\x0A",
                    @{ $main::data{ $this->{'id'} }{'str'} } );
            }
            else {
                $main::data{ $this->{'id'} }{'str'} = '';
            }
        }
    }
    else {
        if ( ref $main::data{ $this->{'id'} }{'str'} ) {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'を確認してください。'
            ) if ref $cgi::action;
            $main::data{ $this->{'id'} }{'str'} = '';
            $is_valid = 0;
        }
        else {
            $main::data{ $this->{'id'} }{'str'} = $this->is_available_email(
                $main::data{ $this->{'id'} }{'str'} );
        }
    }
    if ( $this->{'required'} && !$main::data{ $this->{'id'} }{'str'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                . 'を確認してください。選択されていません。'
        ) if ref $cgi::action;
        $is_valid = 0;
    }

    if ($is_valid) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if $this->{'cookie'} && $main::set_cookie;
    }
    else {
        $this->{'is_invalid_field'}{'str'} = 1;
    }
    return $is_valid;
}

sub is_available_email ($$$) {
    my ( $this, $email ) = @_;
    if ( $this->{'default'} ) {
        while ( $this->{'default'} =~ /^(.*?)$/gm ) {
            my $line = $1;
            if ( $line eq $email || $line =~ /<$email>$/ ) {
                pos( $this->{'default'} ) = 0;
                return $line;
            }
        }
    }
    return $email
        if $this->{'addMaster'} && $setting::general{'master'} eq $email;
    if ( $this->{'addOwners'} && $setting::general{'owners'} ) {
        while ( $setting::general{'owners'} =~ /^(.*?),?$/gm ) {
            my $line = $1;
            if ( $line eq $email || $line =~ /<$email>$/ ) {
                pos( $setting::general{'owners'} ) = 0;
                return $line;
            }
        }
    }
    if ( $this->{'addStaff'} && $setting::general{'staff'} ) {
        while ( $setting::general{'staff'} =~ /^(.*?),?$/gm ) {
            my $line = $1;
            if ( $line eq $email || $line =~ /<$email>$/ ) {
                pos( $setting::general{'staff'} ) = 0;
                return $line;
            }
        }
    }
    return '';
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag('') if !defined $str || $str eq '';

    if ( $this->{'button'} ) {
        $this->use_deco($cgi::output);
        my ( @email, $email, $email_title );
        @email = $this->get_address($str);
        $email = join( ',', @email );
        if ( $this->{'addressProtector'} ) {
            $email_title
                = ($default::english)
                ? 'E-Mail'
                : 'メールソフトを開きます。';
        }
        else {
            $email_title = $str;
            $email_title =~ s/\x0A/,/sg;
            $email_title = $this->address_camouflage($email_title);
        }
        $email
            = $this->address_protector( $email, $this->{'addressProtector'} );
        return $this->field_tag(
            $this->data_tag_from_hash(
                'str',
                $this->address_camouflage(
                    $str, $this->{'addressProtector'}
                )
                )
                . $cgi::Deco->button(
                'email', $this->{'button'}, $email,
                $email_title, '', '', '', 0, 1
                )
        );

    }
    else {
        return $this->field_tag(
            $this->data_tag_from_hash(
                'str',
                $this->address_camouflage(
                    $str, $this->{'addressProtector'}
                )
                )
                . $this->confirmation($str)
        );
    }
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( !defined $str || $str eq '' )
        ? ''
        : '[' . $this->name . "]\x0A" . $str . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    if ( !defined $str || $str eq '' ) {
        return '';
    }
    elsif ( $this->{'listEnabled'} ) {
        my @str = split( /\x0A+/, $str );
        my $html = '';
        foreach my $email (@str) {
            $this->escape( \$email );
            $this->autolink( \$email, 0, $this->{'addressProtector'} );
            $html .= '<li>'
                . $this->style( $email, $this->{'style'},
                $this->{'fontsize'}, $this->{'fontcolor'},
                $this->{'fontface'} )
                . '</li>';
        }
        return '<ul class="email-list">' . $html . '</ul>';
    }
    else {
        $str =~ s/\x0A/, /sg;
        $this->escape( \$str );
        $this->autolink( \$str, 0, $this->{'addressProtector'} );
        return $str;
    }
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">入力形式</span></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_selectorType',
        '', '',
        $this->{'selectorType'},
        'selector' => '選択メニュー',
        (   (          $this->{'field_for'}{'mail'}
                    && $this->{'field_for'}{'mail'} eq $this->{'id'}
            ) ? () : ( 'multipleselector' => '複数選択メニュー' )
        ),
        'radio' => 'ラジオボタン',
        (   (          $this->{'field_for'}{'mail'}
                    && $this->{'field_for'}{'mail'} eq $this->{'id'}
            ) ? () : ( 'checkbox' => 'チェックボックス' )
        ),
    );
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_default">メールアドレス選択肢</label></td>';
    print '<td class="field"><textarea name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" cols="56" rows="6" wrap="off" title="メールアドレス選択肢を設定します。">'
        . $this->escape( $this->{'default'} )
        . '</textarea>';
    print
        '<div class="note">書式：名前 &lt;somebody@on.the.net&gt;[メールアドレスごとに改行]</div></fieldset>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_default">メールアドレス選択肢追加項目</label></td>';
    print '<td class="field"><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_addMaster" value="1"'
        . ( ( defined $this->{'addMaster'} ) ? ' checked="checked"' : '' )
        . ' /> 管理人 メールアドレス</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_addOwners" value="1"'
        . ( ( defined $this->{'addOwners'} ) ? ' checked="checked"' : '' )
        . ' /> 共同オーナー メールアドレス</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_addStaff" value="1"'
        . ( ( defined $this->{'addStaff'} ) ? ' checked="checked"' : '' )
        . ' /> スタッフ メールアドレス</label></li>';
    print '</ol></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    if ( !defined $html_disabled || !$html_disabled ) {
        print '<fieldset><legend>メールアドレス表示設定</legend>';
        print '<fieldset><legend>ボタン</legend>';

        #ボタンメニュー
        print $cgi::Deco->button_menu( $name . '_button',
            'email', 120, $this->{'button'} );
        print
            '<div class="note">設定がない場合、E-Mailアドレスが表示されます。(<label><input type="checkbox" name="'
            . $name
            . '_listEnabled" value="1"'
            . ( ( defined $this->{'listEnabled'} && $this->{'listEnabled'} )
            ? ' checked="checked"'
            : '' )
            . ' /> リストで表示する。</label>)</div></fieldset>';
        print
            '<fieldset><legend>メールアドレスの保護</legend><label><input type="checkbox" name="'
            . $name
            . '_addressProtector" value="1"'
            . (
            (   defined $this->{'addressProtector'}
                    && $this->{'addressProtector'}
            ) ? ' checked="checked"' : ''
            )
            . ' /> メールアドレスを JavaScript + CSS + HTML エンティティで保護する。</label></fieldset>';
        print '</fieldset>';
        $this->print_font_setting_form($name);
    }

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;

    #文字色チェック
    my $is_valid = $this->is_valid_font_setting;
    if (   $this->{'field_for'}{'mail'}
        && $this->{'field_for'}{'mail'} eq $this->{'id'}
        && $main::data{ $this->{'id'} . '_selectorType' }
        && (   $main::data{ $this->{'id'} . '_selectorType' } eq 'checkbox'
            || $main::data{ $this->{'id'} . '_selectorType' } eq
            'multipleselector' )
        )
    {
        if ( $main::data{ $this->{'id'} . '_selectorType' } eq 'checkbox' ) {
            $main::data{ $this->{'id'} . '_selectorType' } = 'radio';
        }
        elsif ( $main::data{ $this->{'id'} . '_selectorType' } eq
            'multipleselector' )
        {
            $main::data{ $this->{'id'} . '_selectorType' } = 'selector';
        }
        push(
            @{ $cgi::action->{'dialog'} },
            '「代表メールフィールド」に指定されているのでメールアドレスは複数選択できません。'
        ) if ref $cgi::action;
    }

    if ( defined $main::data{ $this->{'id'} . '_default' }
        && $main::data{ $this->{'id'} . '_default' } ne '' )
    {
        my $temp             = '';
        my $is_invalid_email = 0;
        my %done             = ();
        while ( $main::data{ $this->{'id'} . '_default' } =~ /^(.*?)$/gm ) {
            my $line = $1;
            $line =~ s/\s*,\s*$//;
            $line =~ s/\s+$//;
            $line =~ s/^\s+//;
            my $email = $line;
            my $name  = '';
            if ( $line =~ /^(.*?)\s*<\s*(.*?)\s*>/s ) {
                $name  = $1;
                $email = $2;
            }
            if ($email) {
                if (   !$done{$email}
                    && !$this->is_invalid_email_address($email) )
                {
                    $temp
                        .= ( ( $name ne '' )
                        ? $name . ' <' . $email . '>'
                        : $email )
                        . "\x0A";
                    $done{$email}++;
                }
                else {
                    $is_invalid_email = 1;
                }
            }
        }
        $main::data{ $this->{'id'} . '_default' } = $temp;
        if ($is_invalid_email) {
            push(
                @{ $cgi::action->{'dialog'} },
                'メールアドレス選択肢を確認してください。'
            ) if ref $cgi::action;
        }
    }

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_addMaster' } = ''
        if !defined $main::data{ $this->{'id'} . '_addMaster' }
        || !$main::data{ $this->{'id'} . '_addMaster' };
    $main::data{ $this->{'id'} . '_addOwners' } = ''
        if !defined $main::data{ $this->{'id'} . '_addOwners' }
        || !$main::data{ $this->{'id'} . '_addOwners' };
    $main::data{ $this->{'id'} . '_addStaff' } = ''
        if !defined $main::data{ $this->{'id'} . '_addStaff' }
        || !$main::data{ $this->{'id'} . '_addStaff' };
    $main::data{ $this->{'id'} . '_addressProtector' } = ''
        if !defined $main::data{ $this->{'id'} . '_addressProtector' }
        || !$main::data{ $this->{'id'} . '_addressProtector' };
    $main::data{ $this->{'id'} . '_listEnabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_listEnabled' }
        || !$main::data{ $this->{'id'} . '_listEnabled' };
    return $is_valid;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'text_emailselector', 'EmailSelector',
        'メールアドレスセレクター' );
    $setting::deco_dir{'email'}  = 'Eメールボタン';
    $setting::deco_type{'email'} = 'button';
}

1;
