package FormattedText;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（書式付きテキスト）
# Num.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-10-17
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'format'} = '4'
        if !defined $this->{'format'} || $this->{'format'} eq '';
    $this->scalar_to_array( \$this->{'placeholder'} )
        if defined $this->{'placeholder'};
    return;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ($form);

    #デフォルト作成
    $main::data{ $this->{'id'} }{'str'} = (
        ( !defined $status || $status eq '' )
            && ( !defined $main::data{ $this->{'id'} }{'str'}
            || $main::data{ $this->{'id'} }{'str'} eq '' )
            && defined $this->{'default'}
        ) ? $this->{'default'}
        : ( defined $main::data{ $this->{'id'} }{'str'} )
        ? $main::data{ $this->{'id'} }{'str'}
        : '';
    my $format = $this->{'format'};
    $format = quotemeta $format;
    $format =~ s/[0-9]+/(.*?)/gs;
    my @strings = ( $main::data{ $this->{'id'} }{'str'} =~ /^$format$/s );
    my $count   = 0;
    my $prefix  = 'data:' . $this->{'id'} . ':';
    $form = $this->escape( $this->{'format'} );
    $form
        =~ s/([0-9]+)/$this->formatted_text_field($prefix,\@strings,$1,\$count)/eg;

    return $this->field_header . $form . $this->field_footer;
}

sub formatted_text_field ($$$$$;$) {
    my ( $this, $prefix, $strings, $size, $count, $not_form ) = @_;
    my $str = shift(@$strings);
    $size = 4 if !defined $size || !$size;
    my $form
        = '<input type="text" name="'
        . $prefix
        . $$count
        . '" size="'
        . $size
        . '" value="'
        . $this->escape($str) . '"'
        . (
        (          !$not_form
                && defined $this->{'placeholder'}[$$count]
                && $this->{'placeholder'}[$$count] ne ''
        ) ? ' placeholder="'
            . $this->lf_to_space(
            $this->escape( $this->{'placeholder'}[$$count] )
            )
            . '"' : ''
        )
        . (
        (   !$not_form
                && ( $this->{'is_invalid_field'}{'str'}
                || $this->{'is_invalid_field'}{$$count} )
        ) ? $this->set_invalid_class : ''
        )
        . (
        (         !$not_form
                && $this->{'required'}
                && ( $this->{'requiredAll'} || $this->{'justsize'} )
        ) ? ' required="required"' : ''
        ) . ' />';
    $$count++;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this     = shift;
    my $is_valid = 1;
    my $count    = 0;
    my $exist    = 0;
    my @dialogs  = ();
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( !defined $main::data{ $this->{'id'} }{'0'}
        && $main::data{ $this->{'id'} }{'str'} )
    {
        my $format = $this->{'format'};
        $format = quotemeta $format;
        $format =~ s/[0-9]+/(.*?)/gs;
        my @strings = ( $main::data{ $this->{'id'} }{'str'} =~ /^$format$/s );
        my $c       = 0;
        foreach my $str (@strings) {
            $main::data{ $this->{'id'} }{$c} = $str;
            $c++;
        }
    }
    ( $main::data{ $this->{'id'} }{'str'} = $this->{'format'} )
        =~ s/([0-9]+)/$this->format_to_text($1,\$count,\$is_valid,\@dialogs,\$exist)/eg;
    if ($exist) {
        push( @{ $cgi::action->{'dialog'} }, @dialogs );
    }
    else {
        undef %{ $this->{'is_invalid_field'} };
        undef @dialogs;
        $is_valid = 1;
        $main::data{ $this->{'id'} }{'str'} = '';
    }
    $is_valid = 0 unless $this->is_not_empty('str');
    $cookie::data{ 'data:' . $this->{'id'} . ':str' }
        = $main::data{ $this->{'id'} }{'str'}
        if $is_valid && $this->{'cookie'} && $main::set_cookie;
    return $is_valid;
}

sub format_to_text ($$$$$$) {
    my ( $this, $size, $count, $is_valid, $dialogs, $exist ) = @_;
    my $str = '';
    $main::data{ $this->{'id'} }{$$count} = ''
        if !defined $main::data{ $this->{'id'} }{$$count};
    foreach
        my $char ( grep( $_ ne '', split( /[0-9]+/, $this->{'format'} ) ) )
    {
        $char = quotemeta $char;
        $main::data{ $this->{'id'} }{$$count} =~ s/$char//g;
    }

    #入力強制
    if (   $this->{'justsize'}
        && $main::data{ $this->{'id'} }{$$count} !~ /^.{$size}$/ )
    {
        push( @$dialogs,
                  ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                . ( $$count + 1 )
                . ')を確認してください。'
                . $size
                . ' 文字の文字列にしてください。' )
            if ref $cgi::action;
        $this->{'is_invalid_field'}{$$count} = 1;
        $$is_valid = 0;
    }
    elsif ($this->{'requiredAll'}
        && $main::data{ $this->{'id'} }{$$count} eq '' )
    {
        push( @$dialogs,
                  ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                . ( $$count + 1 )
                . ')を入力してください。' )
            if ref $cgi::action;
        $this->{'is_invalid_field'}{$$count} = 1;
        $$is_valid = 0;
    }
    if (   defined $this->{'type'}
        && $this->{'type'} ne ''
        && defined $main::data{ $this->{'id'} }{$$count}
        && $main::data{ $this->{'id'} }{$$count} ne '' )
    {
        if ( $this->{'type'} eq 'h' ) {
            if ($this->is_not_hiragana(
                    $main::data{ $this->{'id'} }{$$count}
                )
                )
            {
                push( @$dialogs,
                    ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                        . ( $$count + 1 )
                        . ')を確認してください。ひらがなで入力して下さい。'
                ) if ref $cgi::action;
                $this->{'is_invalid_field'}{$$count} = 1;
                $$is_valid = 0;
            }
        }
        elsif ( $this->{'type'} eq 'k' ) {
            if ($this->is_not_katakana(
                    $main::data{ $this->{'id'} }{$$count}
                )
                )
            {
                push( @$dialogs,
                    ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                        . ( $$count + 1 )
                        . ')を確認してください。カタカナで入力して下さい。'
                ) if ref $cgi::action;
                $this->{'is_invalid_field'}{$$count} = 1;
                $$is_valid = 0;
            }
        }
        elsif ( $this->{'type'} eq 'a' ) {
            if ($this->is_not_word(
                    $main::data{ $this->{'id'} }{$$count}, 1
                )
                )
            {
                push( @$dialogs,
                    ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                        . ( $$count + 1 )
                        . ')を確認してください。半角英数字で入力して下さい。'
                ) if ref $cgi::action;
                $this->{'is_invalid_field'}{$$count} = 1;
                $$is_valid = 0;
            }
        }
        elsif ( $this->{'type'} eq '1' ) {
            if ( $this->is_nan( $main::data{ $this->{'id'} }{$$count}, 1 ) ) {
                push( @$dialogs,
                    ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                        . ( $$count + 1 )
                        . ')を確認してください。数字で入力して下さい。'
                ) if ref $cgi::action;
                $this->{'is_invalid_field'}{$$count} = 1;
                $$is_valid = 0;
            }
        }
        elsif ( $this->{'type'} eq 'j' ) {
            if ($this->is_not_japanese(
                    $main::data{ $this->{'id'} }{$$count}
                )
                )
            {
                push( @$dialogs,
                    ( ( $this->{'name'} ) ? $this->{'name'} : '入力' ) . '('
                        . ( $$count + 1 )
                        . ')を確認してください。日本語文字列がみつかりません。'
                ) if ref $cgi::action;
                $this->{'is_invalid_field'}{$$count} = 1;
                $$is_valid = 0;
            }
        }
    }
    if ( defined $main::data{ $this->{'id'} }{$$count}
        && $main::data{ $this->{'id'} }{$$count} ne '' )
    {
        $$exist = 1;
        $str    = $main::data{ $this->{'id'} }{$$count};
    }
    else {
        $str = '';
    }

    delete $main::data{ $this->{'id'} }{$$count};
    $$count++;
    return $str;
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag('') if !defined $str || $str eq '';
    return $this->field_tag(
        $this->style(
            $this->data_tag( 'str', $this->escape( $this->tag_to_lf($str) ) ),
            $this->{'style'},     $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
        )
    );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_format">入力フォーマット</label></td>';
    print '<td class="field">';
    print '<input type="text" name="'
        . $name
        . '_format" id="'
        . $name
        . '_format" value="'
        . $this->escape( $this->{'format'} )
        . '" size="56" title="入力フォーマットを設定します。" />';
    print '<div class="example">設定例）姓 名=8 8</div>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_requiredAll" id="'
        . $name
        . '_requiredAll" value="1"'
        . ( ( defined $this->{'requiredAll'} && $this->{'requiredAll'} )
        ? ' checked="checked"'
        : '' )
        . ' /> すべての入力欄の入力を強制する</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_justsize" id="'
        . $name
        . '_justsize" value="1"'
        . ( ( defined $this->{'justsize'} && $this->{'justsize'} )
        ? ' checked="checked"'
        : '' )
        . ' /> フォーマット通りの入力を強制する</label></li>';
    print '</ol>';
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_type">入力チェック</label></td>';
    print '<td class="field">';
    print '<select name="' . $name . '_type" id="' . $name . '_type">';
    print '<option value=""></option>';
    print '<option value="h"'
        . ( ( $this->{'type'} && $this->{'type'} eq 'h' )
        ? ' selected="selected"'
        : '' )
        . '>ひらがな</option>';
    print '<option value="k"'
        . ( ( $this->{'type'} && $this->{'type'} eq 'k' )
        ? ' selected="selected"'
        : '' )
        . '>カタカナ</option>';
    print '<option value="a"'
        . ( ( $this->{'type'} && $this->{'type'} eq 'a' )
        ? ' selected="selected"'
        : '' )
        . '>英数字</option>';
    print '<option value="1"'
        . ( ( $this->{'type'} && $this->{'type'} eq '1' )
        ? ' selected="selected"'
        : '' )
        . '>数字</option>';
    print '<option value="j"'
        . ( ( $this->{'type'} && $this->{'type'} eq 'j' )
        ? ' selected="selected"'
        : '' )
        . '>日本語文字列必須</option>';
    print '</select></td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_default">デフォルト</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" value="'
        . $this->escape( $this->{'default'} )
        . '" size="56" title="入力欄のデフォルトの値を設定します。" /></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">プレースホルダ</span></td>';
    print '<td class="field" colspan="3">';
    my $format           = $this->escape( $this->{'format'} );
    my $placeholder_name = $name . '_placeholder^';
    my $count            = 0;
    $format
        =~ s/([0-9]+)/$this->formatted_text_field($placeholder_name,$this->{'placeholder'},$1,\$count,1)/eg;
    print $format;
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    #文字設定
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;

    #空白の除去
    $main::data{ $this->{'id'} . '_default' } =~ s/[\x0A\x0D\x09]+/ /sg;
    $main::data{ $this->{'id'} . '_format' } =~ s/[\x0A\x0D\x09]+/ /sg;

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_justsize' } = 0
        if !$main::data{ $this->{'id'} . '_justsize' };
    $main::data{ $this->{'id'} . '_requiredAll' } = 0
        if !$main::data{ $this->{'id'} . '_requiredAll' };

    #フォントチェック
    return $this->is_valid_font_setting;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'text_0_formatted', 'FormattedText',
        '書式付文字列' );
}

1;
