package LinkToQuestionnaire;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールド定義モジュール（メールフォームを開く）
# Email.pm 1.1.6
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-10-30
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    $this->{'elements'} = 1;
    return;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;

    #名前にデータIDを埋め込む
    my $name = 'data:' . $this->{'id'} . ':dir';

    #デフォルト作成
    if (( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'dir'}
            || $main::data{ $this->{'id'} }{'dir'} eq '' )
        )
    {
        $main::data{ $this->{'id'} }{'dir'} = $this->{'default'};
    }

    return $this->field_header( 40, $name )
        . $this->questionnaire_selector( $name,
        $main::data{ $this->{'id'} }{'dir'} )
        . $this->field_footer;
}

sub questionnaire_selector ($;$$) {
    my ( $this, $name, $selected ) = @_;
    my %questionnaires = $this->questionnaire_data;
    my $selector       = '';
    if (%questionnaires) {
        no warnings qw(numeric);
        $selector
            = '<select id="'
            . $name
            . '" name="'
            . $name
            . '" onchange="var c=document.getElementById(\''
            . $name
            . '-url\');if(this.options[this.selectedIndex].value==\'\'){c.style.display=\'none\';c.href=\'#\';}else{c.style.display=\'inline\';c.href=\'../\'+this.options[this.selectedIndex].value+\'/start.cgi\';}">';
        $selector .= '<option value="">&lt;使用しない&gt;</option>';
        foreach my $d (
            sort {
                $questionnaires{$a} cmp $questionnaires{$b}
                    || $a <=> $b
                    || $a cmp $b
            } keys %questionnaires
            )
        {
            $selector
                .= '<option value="'
                . $d . '"'
                . ( ( $selected && $d eq $selected )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $this->escape( $questionnaires{$d} )
                . '</option>';
        }
        $selector
            .= '</select> <a href="'
            . ( ( defined $selected && $selected ne '' )
            ? '../' . $selected . '/start.cgi'
            : '#' )
            . '" id="'
            . $name
            . '-url" target="_blank"'
            . ( ( !defined $selected || $selected eq '' )
            ? ' style="display:none"'
            : '' )
            . '>[確認]</a>';
    }
    return $selector;
}

sub questionnaire_data ($) {
    my $this = shift;
    my %hash = ();
    local (*DIR);
    if ( opendir( DIR, "../" ) ) {
        my @dir = grep( $_ !~ /^\./ && -d "../$_" && -f "../$_/default.pl",
            readdir(DIR) );
        closedir(DIR);
        if (@dir) {
            foreach my $d (@dir) {
                my $name = $this->questionnaire_name($d);
                $hash{$d} = $name if defined $name && $name ne '';
            }
        }
    }
    return %hash;
}

sub questionnaire_name ($$) {
    my ( $this, $dir ) = @_;
    my $name;
    my $path = "../$dir/default.pl";
    my $data = $this->read_file($path);
    if ( $data =~ /\$lib\s*=\s*['"]Questionnaire['"]/s ) {
        $name = $dir;
        my $preference_dir
            = ( $data =~ /\$preference_dir\s*=\s*(.*?);/s )
            ? $this->un_base_change( eval $1, $path, 'rel', 1 )
            : '';
        my (%db);
        tie( %db, $env::dbm_file, $preference_dir . '/general',
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %db && defined $db{'cginame'} ) {
            $name = $this->decode_utf8( $db{'cginame'} );
        }
        untie %db;
    }
    return $name;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    if ( defined $main::data{ $this->{'id'} }{'dir'}
        && $main::data{ $this->{'id'} }{'dir'} ne '' )
    {
        my %questionnaires = $this->questionnaire_data;
        if (   !%questionnaires
            || !$questionnaires{ $main::data{ $this->{'id'} }{'dir'} } )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'を確認してください。'
            ) if ref $cgi::action;
            return 0;
        }
    }
    my $dir = $main::data{ $this->{'id'} }{'dir'};
    $main::data{ $this->{'id'} } = {};
    if ( defined $dir && $dir ne '' ) {
        while ( my ( $k, $v ) = each %{ $this->{'field_for'} } ) {
            if (   $v
                && ref $this->{'field_obj'}{$v}
                && $this->{'field_obj'}{$v}{'class'}
                && $this->{'field_obj'}{$v}{'class'} =~ /^text/
                && $this->{'field_obj'}{$v}->sort_enabled )
            {
                my $data = $this->{'field_obj'}{$v}
                    ->format_for_text( $main::data{$v}{'str'} );
                $data =~ s/<.*?>//igs;
                $data =~ s/\s+/ /gs;
                $main::data{ $this->{'id'} }{$k} = $data;
            }
        }
        $main::data{ $this->{'id'} }{'dir'} = $dir;
        $cookie::data{ 'data:' . $this->{'id'} . ':dir' }
            = $main::data{ $this->{'id'} }{'dir'}
            if $this->{'cookie'} && $main::set_cookie;
        $this->data;
    }
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return $this->field_tag('')
        if !%data || !defined $data{'dir'} || $data{'dir'} eq '';

    my $url   = $this->questionnaire_path( \%data, $c, $n );
    my $name  = $this->questionnaire_name( $data{'dir'} );
    my $title = $this->{'label'} || '<cginame> を開く';
    $title =~ s/<cginame>/$name/sgi;

    if ( $this->{'button'} ) {
        $this->use_deco($cgi::output);
        return $this->field_tag(
            $this->data_tag_from_ref( \%data )
                . $cgi::Deco->button(
                'email', $this->{'button'}, $url, $title,
                ( ( $this->{'newWindow'} ) ? '_blank' : '' ),
                '', $cgi::output_option
                )
        );

    }
    else {
        return $this->field_tag(
            $this->data_tag_from_ref( \%data )
                . $this->style(
                '<a href="'
                    . $this->escape_except_html_entity(
                    ( $cgi::output || $cgi::output_option )
                    ? $this->base_change( $url, $cgi::output,
                        $cgi::output_option )
                    : $url
                    )
                    . '" title="'
                    . $this->escape_except_html_entity($title) . '"'
                    . ( ( $this->{'newWindow'} ) ? ' target="_blank"' : '' )
                    . '>'
                    . $this->escape_except_html_entity($title) . '</a>',
                $this->{'style'},
                $this->{'fontsize'},
                $this->{'fontcolor'},
                $this->{'fontface'}
                )
        );
    }
}

sub questionnaire_path ($;$$) {
    my ( $this, $data, $c, $n ) = @_;
    my $url = $this->full_path( $this->article_path( $c, $n, 1 ) );
    return
          '../'
        . $data->{'dir'}
        . '/start.cgi?url='
        . $this->url_encode($url)
        . '&subject='
        . $this->url_encode(
        $this->template_replace( $this->{'subjectTemplate'}, $data, $url ) )
        . '&message='
        . $this->url_encode(
        $this->template_replace( $this->{'messageTemplate'}, $data, $url ) );
}

sub template_replace ($$;$$) {
    my ( $this, $template, $data, $url ) = @_;
    $template =~ s/<url>/$url/gs;
    $template =~ s/<cginame>/$setting::general{'cginame'}/gs;
    while ( my ( $k, $v ) = each %$data ) {
        $template =~ s/<$k>/$v/gs if $k && $k ne 'dir' && defined $v;
    }
    $template =~ s/<\w+>//gs;
    return $template;
}

sub format_for_mail {
    my ( $this, $str, $path, $c, $n ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return '' if !%data || !defined $data{'dir'} || $data{'dir'} eq '';

    my $name = $this->questionnaire_name( $data{'dir'} );
    my $title = $this->{'label'} || '<cginame> を開く';
    $title =~ s/<cginame>/$name/sgi;

    return
          '['
        . $this->name . "]\x0A"
        . $title . "\x0A"
        . $this->full_path( $this->questionnaire_path( \%data, $c, $n ) )
        . "\x0A\x0A";
}

sub format_for_text {
    my ( $this, $str, $path, $c, $n ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( !%data || !defined $data{'dir'} || $data{'dir'} eq '' )
        ? ''
        : $this->full_path( $this->questionnaire_path( \%data, $c, $n ) );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled, $tips ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    my $helpmenu = '';
    $helpmenu
        .= '<option value="&lt;cginame&gt;">&lt;cginame&gt; '
        . $this->escape( $setting::general{'cginame'} )
        . '</option>';
    $helpmenu
        .= '<option value="&lt;url&gt;">&lt;url&gt; [記事の URL]</option>';
    foreach my $k ( sort keys %{ $this->{'field_for'} } ) {
        my $v = $this->{'field_for'}{$k};
        if (   $v
            && ref $this->{'field_obj'}{$v}
            && $this->{'field_obj'}{$v}{'class'}
            && $this->{'field_obj'}{$v}{'class'} =~ /^text/
            && $this->{'field_obj'}{$v}->sort_enabled )
        {
            $helpmenu
                .= '<option value="&lt;'
                . $k
                . '&gt;">&lt;'
                . $k
                . '&gt; ['
                . $this->escape( $this->{'field_obj'}{$v}->name )
                . ' の値]</option>';
        }
    }

    print '<fieldset>';
    print '<legend>テンプレート</legend>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_subjectTemplate">メールの表題</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_subjectTemplate" id="'
        . $name
        . '_subjectTemplate" size="72" value="'
        . $this->escape( $this->{'subjectTemplate'} ) . '" />';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_subjectTemplate\').quotationByMenu(this)" title="これらのタグはメールフォームCGI「アンケート」に送信する際、対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print $helpmenu;
    print '</select>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_messageTemplate">メールの本文</label></legend>';
    print '<textarea name="'
        . $name
        . '_messageTemplate" id="'
        . $name
        . '_messageTemplate" cols="72" rows="10">'
        . $this->escape( $this->{'messageTemplate'} )
        . '</textarea>';
    print
        '<div class="toolbox"><select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_messageTemplate\').quotationByMenu(this)" title="これらのタグはメールフォームCGI「アンケート」に送信する際、対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print $helpmenu;
    print '</select></div>';
    print '</fieldset>';

    print '</fieldset>';

    print
        '<fieldset><legend>メールフォームを開くリンク</legend>';
    print '<fieldset><legend><label for="' . $name
        . '_default">デフォルト</label></legend>';
    my $selector = $this->questionnaire_selector( $name . '_default',
        $this->{'default'} );
    print( ($selector)
        ? $selector
        : '<p>メールフォームCGI「アンケート」がインストールされていません。「セットアップアシスタント」の「CGI インストーラー」からインストールしてください。</p>'
    );
    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_label">ラベル</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_label" id="'
        . $name
        . '_label" size="40" value="'
        . $this->escape( $this->{'label'} ) . '" />';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_label\').quotationByMenu(this)" title="これらのタグはメールフォームCGI「アンケート」に送信する際、対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print
        '<option value="&lt;cginame&gt;">&lt;cginame&gt; [メールフォームCGIのタイトル]</option>';
    print '</select>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>リンク設定</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_newWindow" value="1"'
        . ( ( defined $this->{'newWindow'} && $this->{'newWindow'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 新しいウィンドウで開く</label>';
    print '</fieldset>';

    print '<fieldset><legend>ボタン</legend>';

    #ボタンメニュー
    print $cgi::Deco->button_menu( $name . '_button',
        'email', 120, $this->{'button'} );
    print '</fieldset>';
    print '</fieldset>';

    $this->print_font_setting_form($name);

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;

    #文字色チェック
    my $is_valid = $this->is_valid_font_setting;

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_newWindow' } = ''
        if !defined $main::data{ $this->{'id'} . '_newWindow' }
        || !$main::data{ $this->{'id'} . '_newWindow' };

    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail ) {
        Field::class_register( 'z_qlink', 'LinkToQuestionnaire',
            'メールフォームを開く' );
        $setting::deco_dir{'email'}  = 'Eメールボタン';
        $setting::deco_type{'email'} = 'button';
    }
}

1;
