package MediaFile;
require CMONOS::CGI_Lib::Field::FileUL;
@ISA = qw(FileUL);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（メディアファイル選択）
# MediaFile.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-04-07
######################################################################
sub ___set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'anyfile'} = 1 if !ref $this->{'mimename'};
    return;
}

sub get_media_directory_ftp_url ($) {
    my $this = shift;
    return
          ( ( $this->{'ftpurl'} =~ m!://! ) ? '' : 'ftp://' )
        . $this->{'ftpurl'}
        . $this->ftp_url_fix
        if $this->{'ftpurl'};
    my $media_directory = $this->get_media_directory_path;
    my $uid = ( stat( $this->path_conv( $ENV{'SCRIPT_NAME'}, 'path' ) ) )[4];
    my $document_root  = $this->document_root;
    my $user_directory = $this->user_directory(1);
    my $htdocs_dir     = '';
    $media_directory
        = $this->path_change( $media_directory, $ENV{'SCRIPT_NAME'}, 'abs' );

    while ( $document_root =~ s!(/[^/]+)$!! ) {
        if ($document_root) {
            my $duid = ( stat($document_root) )[4];
            if ( !$duid || $duid ne $uid ) {
                $htdocs_dir = $1 . $htdocs_dir if !$htdocs_dir;
                last;
            }
        }
        $htdocs_dir = $1 . $htdocs_dir;
    }
    $media_directory =~ s/^$user_directory// if $user_directory;
    return 'ftp://' . $env::server_name . $htdocs_dir . $media_directory;
}

sub ftp_url_fix ($) {
    my $this = shift;
    return ( ( $default::lib eq 'TableMaker' )
        ? '/' . ( ( defined $main::c ) ? $main::c : '[category]' ) . '/media'
        : '' );
}

sub get_media_directory_path ($) {
    my $this = shift;
    return
          ( $default::lib eq 'TableMaker' )
        ? ( $main::m eq 'Tools' )
            ? $default::file
            : $default::file . '/' . $main::c . '/media'
        : ( ($default::home)
        ? ($default::file)
                ? $default::file
                : $default::home
        : $default::file )
        . '/media';
}

######################################################################
# obj->image(path[,[0-9]ata,option])
#		ファイルに対応したアイコンを表示するためのタグを返します。アイコン画像の
#		サイズは32×32で、env::iconDirで設定したディレクトリになければなりません。
sub image ($;$$$$) {
    my ( $this, $path, $data, $embed_option, $align, $valign ) = @_;
    return (   ref $data
            && $data->{'type'}
            && defined $data->{'name'}
            && $data->{'name'} ne '' )
        ? $this->_image( $this->get_media_directory_path,
        $data, $embed_option, $align, $valign )
        : '';
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my ( $name, $form, @menu, $v, $media_directory, $ftp_url );
    $media_directory = $this->get_media_directory_path;
    $ftp_url         = $this->get_media_directory_ftp_url;

    #名前にデータIDを埋め込む
    $name = 'data:' . $this->{'id'};

    #デフォルト作成
    $main::data{ $this->{'id'} }{'comment'} = $this->{'default'}
        if ( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'comment'}
        || $main::data{ $this->{'id'} }{'comment'} eq '' );

    #テーブル復元
    if (   ( !$this->{'nostyle'} || $this->{'nostyle'} <= 2 )
        && defined $main::data{ $this->{'id'} }{'comment'}
        && $main::data{ $this->{'id'} }{'comment'}
        =~ /<!--_[ct]sv(?![0-9a-zA-Z_])[^>]*-->/ )
    {
        my $tag = ( $this->{'csv'} ) ? 'no' : 'tag';
        $main::data{ $this->{'id'} }{'comment'}
            = $this->{'Table'}
            ->text_to_sv( $main::data{ $this->{'id'} }{'comment'},
            $tag, 'csv' );
    }

    #ファイルの存在をチェック
    if (   !$main::data{ $this->{'id'} }{'type'}
        || !defined $main::data{ $this->{'id'} }{'name'}
        || $main::data{ $this->{'id'} }{'name'} eq ''
        || !-f $media_directory . '/'
        . $main::data{ $this->{'id'} }{'name'} . '.'
        . $main::data{ $this->{'id'} }{'type'} )
    {
        (   $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $main::data{ $this->{'id'} }{'type'},
            $main::data{ $this->{'id'} }{'name'}
        ) = ( '', '', '', '' );
    }

    #フィールドネーム+ヘッダ
    $form = $this->field_header('50');

    #ファイル選択メニュー
    $form .= '<table class="sub-field-table"><tbody>';
    $form
        .= '<tr><td class="sub-field-name"><span class="datatitle">FTP</span></td><td class="sub-field"><a href="'
        . $ftp_url . '">'
        . $ftp_url
        . '</a></td></tr>'
        if $this->is_secure('tools');
    $form
        .= '<tr><td class="sub-field-name"><label for="'
        . $name
        . ':file">ファイル</label></td><td class="sub-field">';
    local (*DIR);
    if ( $this->set_dir($media_directory)
        && opendir( DIR, $media_directory ) )
    {
        my $media_file
            = (    $main::data{ $this->{'id'} }{'type'}
                && defined $main::data{ $this->{'id'} }{'name'}
                && $main::data{ $this->{'id'} }{'name'} ne '' )
            ? $main::data{ $this->{'id'} }{'name'} . '.'
            . $main::data{ $this->{'id'} }{'type'}
            : '';
        my %media = ();
        my $count = 0;
        my $done  = 0;
        my @files
            = grep( $_ !~ /^\./
                && $_ =~ /\.[0-9a-zA-Z_]+$/
                && -f "$media_directory/$_",
            readdir(DIR) );
        closedir(DIR);
        foreach my $f (@files) {
            $media{$f} = ( stat("$media_directory/$f") )[9]
                if !ref $this->{'ext_type'}
                || ( $f =~ /\.([0-9a-zA-Z_]+)$/ && $this->{'ext_type'}{$1} );
        }
        return '' if !%media;
        $form .= '<select name="' . $name . ':file" id="' . $name . ':file">';
        $form .= '<option value=""></option>';
        foreach my $f ( sort { $media{$b} <=> $media{$a} } keys %media ) {
            $form
                .= '<option value="'
                . $this->escape($f) . '"'
                . ( ( $f eq $media_file && !$done++ )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $this->escape($f)
                . '</option>';
            last if $this->{'maxitem'} && ++$count >= $this->{'maxitem'};
        }
        $form
            .= '<option value="'
            . $this->escape($media_file)
            . '" selected="selected">'
            . $this->escape($media_file)
            . '</option>'
            if $media_file && !$done;
    }
    else {
        return '';
    }

    #画像サイズ
    if ( defined $this->{'imagesize'} && $this->{'imagesize'} ) {
        $form
            .= '</td></tr><tr><td class="sub-field-name"><span class="datatitle">サイズ</span></td><td class="sub-field">';
        $form
            .= '<label>幅<input type="number" name="'
            . $name
            . ':width" id="'
            . $name
            . ':width" size="4"';
        $form
            .= ' value="'
            . $this->escape( $main::data{ $this->{'id'} }{'width'} ) . '"'
            if defined $main::data{ $this->{'id'} }{'width'}
            && $main::data{ $this->{'id'} }{'width'};
        $form .= $this->set_invalid_class
            if $this->{'is_invalid_field'}{'width'};
        $form .= ' /></label>';
        $form
            .= '×<label>高<input type="number" name="'
            . $name
            . ':height" size="4"';
        $form
            .= ' value="'
            . $this->escape( $main::data{ $this->{'id'} }{'height'} ) . '"'
            if defined $main::data{ $this->{'id'} }{'height'}
            && $main::data{ $this->{'id'} }{'height'};
        $form .= $this->set_invalid_class
            if $this->{'is_invalid_field'}{'height'};
        $form .= ' /></label>';
        $form .= '<span class="unit">ピクセル</span>';
    }
    else {
        $form
            .= '<input type="hidden" name="'
            . $name
            . ':width" value="'
            . $this->escape( $main::data{ $this->{'id'} }{'width'} ) . '" />';
        $form
            .= '<input type="hidden" name="'
            . $name
            . ':height" value="'
            . $this->escape( $main::data{ $this->{'id'} }{'height'} )
            . '" />';
    }
    $form .= '</td></tr>';
    if ( !$this->{'titlefrom'} || !$this->{'usertitledisabled'} ) {
        $form
            .= '<tr><td class="sub-field-name"><label for="'
            . $name
            . ':title">タイトル</label></td><td class="sub-field"><input type="text" name="'
            . $name
            . ':title" id="'
            . $name
            . ':title" size="36"';
        $form
            .= ' value="'
            . $this->escape( $main::data{ $this->{'id'} }{'title'} ) . '"'
            if defined $main::data{ $this->{'id'} }{'title'};
        $form .= ' /></td></tr>';
    }
    $form .= '</tbody></table>';

    #既存ファイルの表示
    if (   !$this->{'titlefrom'}
        || !$this->{'usertitledisabled'}
        || !ref $this->{'field_obj'}->{ $this->{'titlefrom'} }
        || $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'class'}
        !~ /^text/
        || (   $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'}
            && $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'} > 1 )
        )
    {
        $form .= '<div class="sample-image">';
        $form .= $this->image( $path, $main::data{ $this->{'id'} },
            $this->{'option'} );
        $form .= '</div>';
    }

    #コメント
    $form .= $this->comment_form( $name, $original ) if $this->{'comment'};

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    my $is_valid        = 1;
    my $media_directory = $this->get_media_directory_path;

    #シンボリックネーム
    $this->fill(
        \$main::data{ $this->{'id'} }{'width'},
        \$main::data{ $this->{'id'} }{'height'},
        \$main::data{ $this->{'id'} }{'type'},
        \$main::data{ $this->{'id'} }{'name'}
    );

    #タイトル
    if (   $this->{'titlefrom'}
        && ref $this->{'field_obj'}->{ $this->{'titlefrom'} }
        && $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'class'}
        =~ /^text/
        && (  !$this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'}
            || $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'} == 1 )
        && (   !defined $main::data{ $this->{'id'} }{'title'}
            || $main::data{ $this->{'id'} }{'title'} eq ''
            || $this->{'usertitledisabled'} )
        )
    {
        $main::data{ $this->{'id'} }{'title'}
            = ( defined $main::data{ $this->{'titlefrom'} }{'str'} )
            ? $main::data{ $this->{'titlefrom'} }{'str'}
            : '';
        $this->detag( \$main::data{ $this->{'id'} }{'title'} );
    }
    $main::data{ $this->{'id'} }{'title'} =~ s/[\x0A\x0D]//gs;

    #メディアファイルの処理
    if (   defined $main::data{ $this->{'id'} }{'file'}
        && $main::data{ $this->{'id'} }{'file'} ne ''
        && $main::data{ $this->{'id'} }{'file'} !~ /^\./
        && -f $media_directory . '/' . $main::data{ $this->{'id'} }{'file'}
        && $main::data{ $this->{'id'} }{'file'} =~ /^(.*)\.([0-9a-zA-Z_]+)$/ )
    {
        (   $main::data{ $this->{'id'} }{'name'},
            $main::data{ $this->{'id'} }{'type'}
        ) = ( $1, $2 );
        if ( $main::data{ $this->{'id'} }{'type'} =~ /^(jpg|jpeg|png|gif)$/i )
        {
            my @stat = $cgi::Image->info( $media_directory . '/'
                    . $main::data{ $this->{'id'} }{'file'} );
            (   $main::data{ $this->{'id'} }{'width'},
                $main::data{ $this->{'id'} }{'height'}
                )
                = @stat
                if @stat > 2;
        }
    }
    else {
        delete $main::data{ $this->{'id'} }{'width'};
        delete $main::data{ $this->{'id'} }{'height'};
        delete $main::data{ $this->{'id'} }{'type'};
        delete $main::data{ $this->{'id'} }{'name'};
        delete $main::data{ $this->{'id'} }{'file'};

        #必須項目
        if ( $this->{'required'} ) {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( $this->{'name'} )
                    ? $this->{'name'}
                    : 'メディアファイル'
                    )
                    . 'を指定してください。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'file'} = 1;
            $is_valid = 0;
        }
    }

    #コメントに禁止文字列あり
    $is_valid = 0 if $this->{'comment'} && !$this->is_not_taboo('comment');

    return 0 if !$is_valid;

    #データ整形
    $this->data('file');

#入力のチェック(データの大きさはDataにまとめた後にしかわからない)
    if (  !$this->is_not_too_long( 'str', 'コメント' )
        && $this->is_not_empty('name') )
    {
        $this->{'is_invalid_field'}{'comment'} = 1;
        return 0;
    }

    return 1;
}

######################################################################
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
    my ( $this, $str, @data ) = @_;
    $this->{'thumbnail'} = 'no';
    return $this->usual_format( $str, @data );
}

sub image_file_url ($$$$) {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '' if !$str;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    my $url = '';
    if ( $data{'type'} && grep( $_ eq $data{'type'}, 'gif', 'jpg', 'png' ) ) {
        $url
            = $this->get_media_directory_path . '/'
            . $this->{'id'}
            . (
            (          defined $data{'name'}
                    && $data{'name'} ne ''
                    && $data{'name'} !~ m!/!
            ) ? $data{'name'} . '.' : ''
            ) . $data{'type'};
    }
    return ($url) ? $this->full_path($url) : '';
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    $str
        = '['
        . $this->name . "]\x0A"
        . ( ( $data{'type'} )
        ? '(メディアファイル'
            . ( ( $data{'title'} ) ? ':' . $data{'title'} : '' ) . ')'
        : '' )
        . ( ( defined $data{'comment'} )
        ? "\x0A" . $this->blockquote_to_quotation( $data{'comment'}, 70 )
        : '' );
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return $this->blockquote_to_quotation( $data{'comment'},
        ( ( $this->{'cols'} ) ? $this->{'cols'} : 40 ) )
        . ( ( $data{'type'} )
        ? ' (メディアファイル有り'
            . ( ( $data{'title'} ) ? ':' . $data{'title'} : '' ) . ')'
        : '' );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled, $tips ) = @_;
    my ( $name, $media_directory, $ftp_url );
    $media_directory = $this->get_media_directory_path;
    $ftp_url         = $this->get_media_directory_ftp_url;

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);
    print '<fieldset>';
    print '<legend>メディアファイル表示設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    if ( !defined $html_disabled || !$html_disabled ) {
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_maxwidth">最大横幅（画像）</label></td>';
        print '<td class="q-field"><input type="number" name="'
            . $name
            . '_maxwidth" id="'
            . $name
            . '_maxwidth" value="'
            . $this->escape( $this->{'maxwidth'} )
            . '" size="4" /> <span class="unit">ピクセル</span></td>';
        print '<td class="field-name"><label for="' . $name
            . '_maxheight">最大高さ（画像）</label></td>';
        print '<td class="q-field"><input type="number" name="'
            . $name
            . '_maxheight" id="'
            . $name
            . '_maxheight" value="'
            . $this->escape( $this->{'maxheight'} )
            . '" size="4" /> <span class="unit">ピクセル</span></td>';
        print '</tr>';
    }
    print '<tr>';
    print '<td class="field-name"><input type="checkbox" name="'
        . $name
        . '_imagesize" id="'
        . $name
        . '_imagesize" value="1"'
        . ( ( defined $this->{'imagesize'} && $this->{'imagesize'} )
        ? ' checked="checked"'
        : '' )
        . ' /></td>';
    print '<td class="field" colspan="3"><label for="' . $name
        . '_imagesize">サイズ欄を表示</label>';
    print
        '<div class="hints">ブラウザが表示できるファイルにのみ適用されます。</div>';
    print
        '<div class="hints">画像が最大幅を超える場合、表示サイズが最大幅に縮小されます。</div>'
        if !defined $html_disabled || !$html_disabled;
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><input type="checkbox" name="'
        . $name
        . '_dlDisabled" id="'
        . $name
        . '_dlDisabled" value="1"'
        . ( ( defined $this->{'dlDisabled'} && $this->{'dlDisabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /></td>';
    print '<td class="field" colspan="3"><label for="' . $name
        . '_dlDisabled">ダウンロードリンクを表示しない</label></td>';
    print '</tr>';
    print '</tbody>';

    if ( !$html_disabled ) {
        print '<tbody>';
        print '<tr class="tbody-end">';
        print '<td class="field-name"><label for="' . $name
            . '_option">タグオプション</label></td>';
        print '<td class="field" colspan="3"><input type="text" name="'
            . $name
            . '_option" id="'
            . $name
            . '_option" value="'
            . $this->escape( $this->{'option'} )
            . '" size="50" title="メディアファイルを埋め込む際のオプションを設定します。" /></td>';
        print '</tr>';
        print '</tbody>';
        print '<tbody>';
        print '<tr class="tbody-end">';
        print
            '<td class="field-name"><span class="datatitle">MP3/MP4</span></td>';
        print '<td class="field" colspan="3">';
        print '<label><input type="checkbox" name="'
            . $name
            . '_useFlash" value="1"'
            . ( ( $this->{'useFlash'} ) ? ' checked="checked"' : '' )
            . ' /> <a href="http://sourceforge.net/projects/gsplayer/" target="_blank">GS Player</a> で MP3 と MP4 ファイルを表示する。</label></li>';
        print '</td>';
        print '</tr>';
        print '</tbody>';
        print '<tbody>';
        print '<tr class="tbody-end">';
        print
            '<td class="field-name"><label title="HTML5 の &lt;video&gt;/&lt;audio&gt; を使用するかどうか設定します。ブラウザによって再生できるファイル形式が異なりますので注意してください。"><input type="checkbox" name="'
            . $name
            . '_html5Enabled" value="1"'
            . ( ( defined $this->{'html5Enabled'} && $this->{'html5Enabled'} )
            ? ' checked="checked"'
            : '' )
            . ' />&lt;video&gt;/&lt;audio&gt;</label></td>';
        print '<td class="field" colspan="3"><ol class="checkbox">';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_preloadDisabled" value="1"'
            . ( ( $this->{'preloadDisabled'} ) ? ' checked="checked"' : '' )
            . ' /> 動画・音声をあらかじめ読み込ま<strong>ない</strong>。</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_autoplayEnabled" value="1"'
            . ( ( $this->{'autoplayEnabled'} ) ? ' checked="checked"' : '' )
            . ' /> 動画・音声を自動再生する。</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_loopEnabled" value="1"'
            . ( ( $this->{'loopEnabled'} ) ? ' checked="checked"' : '' )
            . ' /> 動画・音声をループ再生する。</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_controlsDisabled" value="1"'
            . ( ( $this->{'controlsDisabled'} ) ? ' checked="checked"' : '' )
            . ' /> コントローラーを表示し<strong>ない</strong>。</label></li>';
        print '</ol></td>';
        print '</tr>';
        print '</tbody>';
    }
    print '</table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>メディアファイル選択メニュー設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    if ( $this->set_dir($media_directory) ) {
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">メディアディレクトリ(自動取得)</label></td>';
        print '<td class="field"><a href="'
            . $ftp_url . '">'
            . $ftp_url . '</a>'
            . $this->ftp_url_fix . '</td>';
        print '</tr>';
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_ftpurl">メディアディレクトリ(補正)</label></td>';
        print '<td class="field">ftp://<input type="text" name="'
            . $name
            . '_ftpurl" id="'
            . $name
            . '_ftpurl" value="'
            . $this->escape( $this->{'ftpurl'} )
            . '" size="30" title="自動取得 URL が間違っている場合、メディアファイルを保存しているディレクトリのURLを設定します。" />'
            . $this->ftp_url_fix . '</td>';
        print '</tr>';
    }
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_maxitem">表示ファイル数</label></td>';
    print '<td class="field">新しい順に <input type="number" name="'
        . $name
        . '_maxitem" id="'
        . $name
        . '_maxitem" value="'
        . $this->escape( $this->{'maxitem'} )
        . '" size="3" title="メディアファイル選択メニューの表示ファイル数の上限を設定します。" /> 個のファイルをメニューに含める。</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_mimetype">表示するファイルの MIME-TYPE</label></td>';
    print '<td class="field">';
    print '<textarea name="'
        . $name
        . '_mimetype" id="'
        . $name
        . '_mimetype" cols="50" rows="6">'
        . $this->escape( $this->{'mimetype'} )
        . '</textarea>';
    $this->print_mimetype_menu( $name . '_mimetype' );
    print
        '<div class="hints">設定がない場合ディレクトリ内のファイルが全てメニューに登録されます。</div>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_titlefrom">タイトル</label></td>';
    print '<td class="field">タイトルがないとき、';
    print '<select name="'
        . $name
        . '_titlefrom" id="'
        . $name
        . '_titlefrom">';
    print '<option value=""></option>';

    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        next
            unless ref $this->{'field_obj'}->{$id}
            && $this->{'field_obj'}->{$id}->{'class'} =~ /^text/
            && ( !$this->{'field_obj'}->{$id}->{'rows'}
            || $this->{'field_obj'}->{$id}->{'rows'} == 1 );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $this->{'titlefrom'} && $this->{'titlefrom'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $this->{'field_obj'}->{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>からタイトルを作成する';
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_usertitledisabled" value="1"'
        . ( ( $this->{'usertitledisabled'} ) ? ' checked="checked"' : '' )
        . ' /> 常にこのフィールドの値をタイトルにする。</label></div>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>コメント欄設定</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_comment" value="1"'
        . ( ( defined $this->{'comment'} && $this->{'comment'} )
        ? ' checked="checked"'
        : '' )
        . ' onclick="cmonos.element.tagClass(\'div\',\'cmtsetting\',\'fieldset\',\'cmtsetting\').disappear(!this.checked);" /> コメント欄を追加する</label>';
    print '<div class="cmtsetting">';

    if ( !defined $default::static || !$default::static ) {
        print '<label><input type="checkbox" name="'
            . $name
            . '_noFileSearchForm" value="1"'
            . ( ( $this->{'noFileSearchForm'} ) ? ' checked="checked"' : '' )
            . ' /> 詳細条件でコメント検索欄のみ表示する</label>';
    }
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_cols">入力欄横幅</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_cols" id="'
        . $name
        . '_cols" value="'
        . $this->escape( $this->{'cols'} )
        . '" size="3" title="入力欄の横幅を設定します。" /> <span class="unit">文字(半角)</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_rows">入力欄高さ</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_rows" id="'
        . $name
        . '_rows" value="'
        . $this->escape( $this->{'rows'} )
        . '" size="3" title="入力欄の高さを設定します。" /> <span class="unit">文字</span></td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_maxlength">最大文字数</label></td>';
    print '<td class="field" colspan="3"><input type="number" name="'
        . $name
        . '_maxlength" id="'
        . $name
        . '_maxlength" value="'
        . $this->escape( $this->{'maxlength'} )
        . '" size="3" title="入力欄の文字数を制限します。" /> <span class="unit">文字(半角)</span></td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_default">デフォルト</label></td>';
    print '<td class="field" colspan="3"><textarea name="'
        . $name
        . '_default" cols="56" rows="4" wrap="soft">'
        . $this->escape( $this->{'default'} )
        . '</textarea>'
        . ( ( defined $tips ) ? $tips : '' ) . '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</div></fieldset>';
    print '<fieldset class="cmtsetting">';
    print '<legend>入力文字列制御(コメント欄)</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_taboowords">禁止文字列</label></td>';
    print '<td class="field" colspan="3"><textarea name="'
        . $name
        . '_taboowords" id="'
        . $name
        . '_taboowords" cols="56" rows="4" wrap="off">'
        . $this->escape( $this->{'taboowords'} )
        . '</textarea>';
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_tabooregexp" value="1"'
        . ( ( defined $this->{'tabooregexp'} && $this->{'tabooregexp'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 正規表現を使用する</label></div>';
    print '<div class="note">禁止文字列ごとに改行</div>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_convtable">文字変換表</label></td>';
    print '<td class="field" colspan="3"><textarea name="'
        . $name
        . '_convtable" id="'
        . $name
        . '_convtable" cols="56" rows="4" wrap="off" title="下記書式に従って文字変換表を設定します。">'
        . $this->escape( $this->{'convtable'} )
        . '</textarea>';
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_convregexp" value="1"'
        . ( ( defined $this->{'convregexp'} && $this->{'convregexp'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 正規表現を使用する</label></div>';
    print
        '<div class="note">書式：変換対象文字列=&gt;変換後文字列[改行]</div>';
    print
        '<div class="example">例）、=>，（句読点の統一例）/SPAM=>spam（語句の統一例）</div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    if ( defined $html_disabled && $html_disabled ) {
        print '<input type="hidden" name="' . $name . '_csv" value="0" />';

    }
    else {
        print '<div class="cmtsetting">';

        #タグの処理
        $this->print_html_tag_setting_form( $name, '(コメント欄)' );

        #文字設定
        $this->print_font_setting_form( $name, '(コメント欄)' );

        #テーブル設定
        $this->print_table_setting_form( $name, '(コメント欄)' );
        print '</div>';
    }

    $this->print_setting_save_button;
    print $this->javascript(
        'cmonos.element.tagClass(\'div\',\'cmtsetting\',\'fieldset\',\'cmtsetting\').disappear(!this.checked);'
    ) if !$this->{'comment'};
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting {
    my $this     = shift;
    my $is_valid = 1;
    $is_valid = 0 if !$this->is_valid_text_setting;
    $is_valid = 0 if !$this->is_valid_file_setting;

    #チェックボックス
    $main::data{ $this->{'id'} . '_comment' } = ''
        if !defined $main::data{ $this->{'id'} . '_comment' }
        || $main::data{ $this->{'id'} . '_comment' } eq '';
    $main::data{ $this->{'id'} . '_imagesize' } = ''
        if !defined $main::data{ $this->{'id'} . '_imagesize' }
        || $main::data{ $this->{'id'} . '_imagesize' } eq '';
    $main::data{ $this->{'id'} . '_noFileSearchForm' } = ''
        if !defined $main::data{ $this->{'id'} . '_noFileSearchForm' }
        || $main::data{ $this->{'id'} . '_noFileSearchForm' } eq '';
    $main::data{ $this->{'id'} . '_dlDisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_dlDisabled' }
        || $main::data{ $this->{'id'} . '_dlDisabled' } eq '';
    $main::data{ $this->{'id'} . '_convregexp' } = ''
        if !defined $main::data{ $this->{'id'} . '_convregexp' }
        || $main::data{ $this->{'id'} . '_convregexp' } eq '';
    $main::data{ $this->{'id'} . '_tabooregexp' } = ''
        if !defined $main::data{ $this->{'id'} . '_tabooregexp' }
        || $main::data{ $this->{'id'} . '_tabooregexp' } eq '';
    $main::data{ $this->{'id'} . '_usertitledisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_usertitledisabled' }
        || !$main::data{ $this->{'id'} . '_usertitledisabled' };
    $main::data{ $this->{'id'} . '_useFlash' } = ''
        if !$main::data{ $this->{'id'} . '_useFlash' };
    $main::data{ $this->{'id'} . '_html5Enabled' } = ''
        if !$main::data{ $this->{'id'} . '_html5Enabled' };
    $main::data{ $this->{'id'} . '_autoplayEnabled' } = ''
        if !$main::data{ $this->{'id'} . '_autoplayEnabled' };
    $main::data{ $this->{'id'} . '_preloadDisabled' } = ''
        if !$main::data{ $this->{'id'} . '_preloadDisabled' };
    $main::data{ $this->{'id'} . '_loopEnabled' } = ''
        if !$main::data{ $this->{'id'} . '_loopEnabled' };
    $main::data{ $this->{'id'} . '_controlsDisabled' } = ''
        if !$main::data{ $this->{'id'} . '_controlsDisabled' };

    #タグ除去
    $this->detag( \$main::data{ $this->{'id'} . '_mimetype' } )
        if defined $main::data{ $this->{'id'} . '_mimetype' }
        && $main::data{ $this->{'id'} . '_mimetype' };

    if (   defined $main::data{ $this->{'id'} . '_maxitem' }
        && $main::data{ $this->{'id'} . '_maxitem' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_maxitem' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '表示ファイル数を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_maxitem' };
        $is_valid = 0;
    }
    $main::data{ $this->{'id'} . '_ftpurl' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_ftpurl' }, 'utf8' )
        if defined $main::data{ $this->{'id'} . '_ftpurl' }
        && $main::data{ $this->{'id'} . '_ftpurl' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $is_valid;
}

######################################################################
sub get_enclosure_attributes ($$$$$) {
    my ( $this, $str, $path, $c, $n ) = @_;
    my ( %data, $size );
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ()
        if !defined $data{'name'} || $data{'name'} eq '' || !$data{'type'};
    $path
        = $this->get_media_directory_path . '/'
        . $data{'name'} . '.'
        . $data{'type'};
    $size = -s $path;
    return (
        'url'    => $this->full_path($path),
        'length' => ( ($size) ? $size : '' ),
        'type'   => (
            ( $data{'type'} )
            ? ( ref $this->{'ext_type'}
                    && $this->{'ext_type'}{ $data{'type'} } )
                    ? $this->{'ext_type'}{ $data{'type'} }
                    : ( $Common::mime_type{ $data{'type'} } )
                ? $Common::mime_type{ $data{'type'} }
                : 'application/octet-stream'
            : 'application/octet-stream'
        )
    );
}

######################################################################
sub editor_enabled ($) {
    my $this = shift;
    return 0;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    return 0;
}

sub set_user_generated_field_editor_page_settings ($) {
    my $this = shift;
    return 0;
}

sub print_user_generated_field_editor ($) {
    my $this = shift;
    return 0;
}

sub user_generated_field_edit ($) {
    my $this = shift;
    return 0;
}

sub get_query_for_editor ($;$$$) {
    my ( $this, $c ) = @_;
    return '';
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    if (   !$setting::field_for_mail
        && !$env::subdirectory_disabled
        && !$env::user_site_template_dir )
    {
        Field::class_register( 'file_media', 'MediaFile',
            'メディアファイル選択' );
    }
}

1;
