package RequirementsControl;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（必須項目制御）
# RequirementsControl 1.1.5
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-08-11
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    if ( ref $this->{'condition'} ) {
        foreach ( keys %{ $this->{'condition'} } ) {
            $this->scalar_to_array( \$this->{'condition'}{$_}{'target'} );
        }
    }
    else {
        $this->{'condition'} = {};
    }
    $this->scalar_to_array( \$this->{'order'} ) if !ref $this->{'order'};
    $this->{'selectortype'} = 'checkbox' if !defined $this->{'selectortype'};
    return;
}

######################################################################
#	(1) obj->match(str);
sub match_enabled ($) {
    my $this = shift;
    return (
        (   defined $main::search{ $this->{'id'} }{'str'}
                && $main::search{ $this->{'id'} }{'str'} ne ''
        )
            || ( ref $main::search{ $this->{'id'} }{'str'}
            && @{ $main::search{ $this->{'id'} }{'str'} } > 0 )
    ) ? 1 : 0;
}

sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $pat, @str );
    return 1
        unless ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' )
        || ( ref $main::search{ $this->{'id'} }{'str'}
        && @{ $main::search{ $this->{'id'} }{'str'} } > 0 );
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} )
        if !ref $main::search{ $this->{'id'} }{'str'};
    @str = split( /,/, $$str );
    foreach $pat ( @{ $main::search{ $this->{'id'} }{'str'} } ) {
        next if $pat eq '';
        if ( grep( $_ eq $pat, @str ) > 0 ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ($form);
    my $default_enabled = 0;
    if ( !ref $main::data{ $this->{'id'} }{'str'} ) {
        my @temp;
        if ( defined $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} =~ /,/ )
        {
            @temp = split( /,/, $main::data{ $this->{'id'} }{'str'} );
            delete $main::data{ $this->{'id'} }{'str'};
            @{ $main::data{ $this->{'id'} }{'str'} } = @temp;
        }
        elsif ( defined $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} ne '' )
        {
            @temp = ( $main::data{ $this->{'id'} }{'str'} );
            delete $main::data{ $this->{'id'} }{'str'};
            @{ $main::data{ $this->{'id'} }{'str'} } = @temp;
        }
        else {
            $default_enabled = 1
                if ( !defined $status
                || $status eq ''
                || $this->{'required'} )
                && !defined $main::data{ $this->{'id'} }{'str'};
            $main::data{ $this->{'id'} }{'str'} = [];
        }
    }
    $form = $this->field_header(
        50,
        (   (          $this->{'selectortype'} eq 'menu'
                    || $this->{'selectortype'} eq 'multiplemenu'
            ) ? 'data:' . $this->{'id'} . ':str' : ''
        )
    );
    $form .= $this->get_selector(
        'data', $main::data{ $this->{'id'} }{'str'},
        0, $this->{'is_invalid_field'}{'str'},
        1, $default_enabled
    );
    $form .= $this->requirements_control_js;
    $form .= $this->field_footer;
    $this->requirements_control( $main::data{ $this->{'id'} }{'str'},
        $default_enabled );
    return $form;
}

sub requirements_control ($$;$) {
    my ( $this, $selected_conditions, $default_enabled ) = @_;
    my ( $myid_flag, @fields );
    foreach my $field_id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        if (   $myid_flag
            && ref $this->{'field_obj'}->{$field_id}
            && $this->{'field_obj'}->{$field_id}->required_enabled )
        {
            push( @fields, $field_id );
        }
        $myid_flag = 1 if $field_id eq $this->{'id'};
    }
    while ( my ($id) = each %{ $this->{'condition'} } ) {
        if (   ref $this->{'condition'}{$id}{'target'}
            && @{ $this->{'condition'}{$id}{'target'} }
            && ((   $this->{'condition'}{$id}{'status'} eq 'selected'
                    && ((      $default_enabled
                            && $this->{'condition'}{$id}{'selected'}
                        )
                        || (   !$default_enabled
                            && ref $selected_conditions
                            && @$selected_conditions
                            && grep( $id eq $_, @$selected_conditions ) )
                    )
                )
                || ($this->{'condition'}{$id}{'status'} eq 'neglected'
                    && ((   $default_enabled
                            && !$this->{'condition'}{$id}{'selected'}
                        )
                        || (!$default_enabled
                            && (   !ref $selected_conditions
                                || !@$selected_conditions
                                || !grep( $id eq $_, @$selected_conditions ) )
                        )
                    )
                )
            )
            )
        {
            foreach my $target ( @{ $this->{'condition'}{$id}{'target'} } ) {
                if (   grep( $_ eq $target, @fields )
                    && ref $this->{'field_obj'}->{$target}
                    && $this->{'field_obj'}->{$target}->required_enabled )
                {
                    if (  !$this->{'field_obj'}->{$target}->{'required'}
                        && $this->{'condition'}{$id}{'require'} eq 'true' )
                    {
                        $this->{'field_obj'}->{$target}->{'required'} = 1;
                    }
                    elsif (
                        $this->{'field_obj'}->{$target}->{'required'}
                        && (   $this->{'condition'}{$id}{'require'} eq 'false'
                            || $this->{'condition'}{$id}{'require'} eq
                            'hide' )
                        )
                    {
                        $this->{'field_obj'}->{$target}->{'required'} = 0;
                    }
                }
            }
        }
    }
}

sub save_required_fields ($) {
    my $this = shift;
    if ( !$RequirementsControl::last ) {
        my ( $fields, $required_fields );
        foreach my $field_id (
            sort {
                $this->{'field_obj'}->{$a}->{'ORDER'}
                    <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                    || $a <=> $b
            } keys %{ $this->{'field_obj'} }
            )
        {
            $RequirementsControl::last = $field_id
                if $this->{'field_obj'}->{$field_id}->{'class'} eq
                'select_rcontrol';
            if ( ref $this->{'field_obj'}->{$field_id}
                && $this->{'field_obj'}->{$field_id}->required_enabled )
            {
                $RequirementsControl::fields .= (
                    (   defined $RequirementsControl::fields
                            && $RequirementsControl::fields ne ''
                    ) ? ',' : ''
                    )
                    . "'"
                    . $field_id . "'";
                $RequirementsControl::required_fields .= (
                    (   defined $RequirementsControl::required_fields
                            && $RequirementsControl::required_fields ne ''
                    ) ? ',' : ''
                    )
                    . "'"
                    . $field_id . "'"
                    if $this->{'field_obj'}->{$field_id}->{'required'};
            }
        }
    }
}

sub requirements_control_js ($) {
    my $this = shift;
    $this->save_required_fields;
    $RequirementsControl::conditions
        .= ( ($RequirementsControl::conditions) ? ', ' : '' )
        . '\'data:'
        . $this->{'id'}
        . ':str\', {';
    my $n = 0;
    foreach my $id ( sort keys %{ $this->{'condition'} } ) {
        if ( ref $this->{'condition'}{$id}{'target'}
            && @{ $this->{'condition'}{$id}{'target'} } )
        {
            $RequirementsControl::conditions .= ', ' if $n++;
            $RequirementsControl::conditions .= "'$id'" . ' : {';
            $RequirementsControl::conditions .= '\'target\' : ['
                . join(
                ',',
                grep( ref $this->{'field_obj'}->{$_}
                        && $this->{'field_obj'}->{$_}->required_enabled,
                    @{ $this->{'condition'}{$id}{'target'} } )
                ) . '], ';
            $RequirementsControl::conditions .= '\'status\' : \''
                . $this->{'condition'}{$id}{'status'} . '\', ';
            $RequirementsControl::conditions
                .= '\'selected\' : '
                . (
                ( $this->{'condition'}{$id}{'selected'} ) ? 'true' : 'false' )
                . ', ';
            $RequirementsControl::conditions .= '\'required\' : '
                . (
                (          $this->{'condition'}{$id}{'require'}
                        && $this->{'condition'}{$id}{'require'} eq 'true'
                ) ? 'true' : 'false'
                ) . ', ';
            $RequirementsControl::conditions .= '\'hide\' : '
                . (
                (          $this->{'condition'}{$id}{'require'}
                        && $this->{'condition'}{$id}{'require'} eq 'hide'
                ) ? 'true' : 'false'
                );
            $RequirementsControl::conditions .= '}';
        }
    }
    $RequirementsControl::conditions .= '}';
    if ( $this->{'id'} eq $RequirementsControl::last ) {
        my $js = <<JAVASCRIPT;
cmonos.form.requirementsControl = {
	set : function (this_form,no_effect) {
		var fields = new Array($RequirementsControl::fields);
		var required_fields = new Array($RequirementsControl::required_fields);
		for (var i=0; i<fields.length; i++) {
			this.toggle(cmonos.value.isIncluded(required_fields,fields[i]),fields[i],false,no_effect);
		}
		var requirement_settings = new Array($RequirementsControl::conditions);
		for (var i=0; i<requirement_settings.length; i+=2) {
			this.all(this_form,requirement_settings[i],requirement_settings[i+1],no_effect);
		}
	},

	all : function (this_form,selector_name,condition_hash,no_effect) {
		var this_selector = cmonos.element.form(this_form).fieldname(selector_name).shift();
		var selected_conditions = new Array();
		var n = 0;
		if (this_selector.type == 'radio' || this_selector.type == 'checkbox') {
			cmonos.element.form(this_form).fieldname(this_selector.name).exec(function (selector) {
				if (selector.checked) selected_conditions[n++] = selector.value;
			});
		} else if (this_selector.type.search(/select/) != -1) {
			for(var i=0; i<this_selector.options.length; i++) {
				if (this_selector.options[i].selected) selected_conditions[n++] = this_selector.options[i].value;
			}
		}
		for (var field_id in condition_hash) {
			if (condition_hash[field_id] != null && condition_hash[field_id].target != null && (
				(condition_hash[field_id].status == 'selected' && cmonos.value.isIncluded(selected_conditions,field_id)) ||
				(condition_hash[field_id].status == 'neglected' && !cmonos.value.isIncluded(selected_conditions,field_id))
			)) {
				for(var i=0; i<condition_hash[field_id].target.length; i++) {
					this.toggle(condition_hash[field_id].required,condition_hash[field_id].target[i],condition_hash[field_id].hide,no_effect);
				}
			}
		}
	},

	toggle : function (this_required,target_id,hide,no_effect) {
		var target_field = document.getElementById('field-'+target_id);
		if (target_field != null) {
			var target_label = document.getElementById('fieldlabel-'+target_id);
			cmonos.element.clearFadeTimer(target_field);
			var opacity = cmonos.element.getProperty(target_field,'opacity');
			if (this_required) {
				if (target_label != null && target_label.innerHTML.search(/<strong>/i) == -1) {
					target_label.innerHTML = '<strong>' + target_label.innerHTML + '</strong>';
				}
				this.appear(target_field,opacity,no_effect);
				cmonos.element.item(target_field).restoreAttribute('required');
			} else {
				if (target_label != null && target_label.innerHTML.search(/<strong>/i) != -1) {
					target_label.innerHTML = target_label.innerHTML.replace(/<strong>/i,'').replace(/<\\/strong>/i,'');
				}
				if (hide) {
					this.disappear(target_field,no_effect);
				} else {
					this.appear(target_field,opacity,no_effect);
				}
				cmonos.element.item(target_field).disableAttribute('required');
			}
		}
	},

	appear : function (target_field,opacity,no_effect) {
		var controller = cmonos.element.getProperty(target_field,'controller') || [];
		controller = cmonos.value.deleteFromArray(controller,'requirementsControl');
		if (controller.length == 0) {
			cmonos.element.setProperty(target_field,'controller',null);
			if ((opacity && opacity != 1) || (target_field.style.display && target_field.style.display == "none")) {
				if (no_effect) {
					cmonos.element.item(target_field).setOpacity(1);
				} else {
					cmonos.element.item(target_field).fadeIn();
				}
			}
		} else {
			cmonos.element.setProperty(target_field,'controller',controller);
		}
	},

	disappear : function (target_field,no_effect) {
		var controller = cmonos.element.getProperty(target_field,'controller') || [];
		if (!cmonos.value.isIncluded(controller,'requirementsControl')) controller.push('requirementsControl');
		cmonos.element.setProperty(target_field,'controller',controller);
		if (controller.length == 1) {
			if (!target_field.style.display || target_field.style.display != "none") {
				if (no_effect) {
					cmonos.element.item(target_field).setOpacity(0);
				} else {
					cmonos.element.item(target_field).fadeOut();
				}
			}
		}
	}
};
cmonos.window.setOnLoad(function () {cmonos.form.requirementsControl.set(cmonos.form.name('input').currentForm,true);});
JAVASCRIPT
        undef $RequirementsControl::last;
        undef $RequirementsControl::fields;
        undef $RequirementsControl::required_fields;
        undef $RequirementsControl::conditions;
        return $this->javascript($js);
    }
    else {
        return '';
    }
}

sub get_selector ($$;$$$$$) {
    my ( $this, $name, $default, $multiple_flag, $is_invalid, $js_required,
        $default_enabled )
        = @_;
    my $form = '';
    my $js
        = ($js_required)
        ? 'cmonos.form.requirementsControl.set(this.form);'
        : '';
    $name .= ':' . $this->{'id'} . ':str';
    if (   $this->{'selectortype'} eq 'menu'
        || $this->{'selectortype'} eq 'multiplemenu' )
    {
        $form .= '<select name="' . $name . '" id="' . $name . '"';
        if ( $multiple_flag || $this->{'selectortype'} eq 'multiplemenu' ) {
            if ( !$this->{'row'} ) {
                my $row
                    = ( ref $this->{'condition'} )
                    ? keys %{ $this->{'condition'} }
                    : 1;
                $this->{'row'} = ( $row > 4 ) ? 4 : $row;
            }
            $form .= ' multiple="multiple" size="' . $this->{'row'} . '"';
        }
        if ($is_invalid) {
            $form .= ' class="invalid-field"';
            $form .= ' onchange="cmonos.validate.field(this).bailOut();'
                . $js . '"';
        }
        elsif ($js) {
            $form .= ' onchange="' . $js . '"';
        }
        $form .= '>';
        $form .= '<option value=""></option>'
            unless $multiple_flag
            || $this->{'selectortype'} eq 'multiplemenu'
            || $this->{'required'};
        foreach my $id ( @{ $this->{'order'} } ) {
            $form
                .= '<option value="'
                . $id . '"'
                . (
                (   (          ref $default
                            && @$default
                            && grep( $_ eq $id, @$default )
                    )
                        || ( $default_enabled
                        && ( !ref $default || !@$default )
                        && $this->{'condition'}{$id}{'selected'} )
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->detag( $this->{'condition'}{$id}{'name'} )
                . '</option>';
        }
        $form .= '</select>';
    }
    else {
        my $type
            = ( $multiple_flag || $this->{'selectortype'} eq 'checkbox' )
            ? 'checkbox'
            : 'radio';
        $form .= '<ol class="checkbox">';
        foreach my $id ( @{ $this->{'order'} } ) {
            $form
                .= '<li><label'
                . ( ($is_invalid) ? ' class="invalid-field"' : '' )
                . (
                ( $type eq 'radio' && !$this->{'required'} )
                ? ' title="'
                    . (
                    ($default::english)
                    ? 'Click the radio button to reset.'
                    : '選択済みラジオボタンをクリックすると選択を解除できます。'
                    )
                    . '"'
                : ''
                )
                . '><input type="'
                . $type
                . '" name="'
                . $name
                . '" value="'
                . $id . '"'
                . (
                (   (          ref $default
                            && @$default
                            && grep( $_ eq $id, @$default )
                    )
                        || ( $default_enabled
                        && ( !ref $default || !@$default )
                        && $this->{'condition'}{$id}{'selected'} )
                ) ? ' checked="checked"' : ''
                )
                . ( ($is_invalid)
                ? ' onclick="cmonos.validate.field(this).bailOut();'
                    . $js . '"'
                : ($js) ? ' onclick="' . $js . '"'
                :         '' )
                . ( ( $type eq 'radio' && !$this->{'required'} )
                ? ' onmousedown="var t=this;if(t.checked)setTimeout(function(){t.checked=false;'
                    . $js
                    . '},200)"'
                : '' )
                . ' /> '
                . ( $this->{'condition'}{$id}{'name'} || '' )
                . '</label></li>';
        }
        $form .= '</ol>';
    }
    return $form;
}

sub detag ($$) {
    my ( $this, $str ) = @_;
    $str =~ s/<(.*?)>/(($1 =~ m! alt="(.*?)"!i) ? $1 : '')/egs;
    $str =~ s/"/&quot;/g;
    $str =~ s/</&lt;/g;
    $str =~ s/>/&gt;/g;
    $str =~ s/\x0D\x0A/ /gs;
    $str =~ s/\x0D/ /gs;
    return $str;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( !ref $main::data{ $this->{'id'} }{'str'} ) {
        if (   $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} =~ /,/ )
        {
            $main::data{ $this->{'id'} }{'str'} = [
                grep( $_ ne '',
                    split( /,/, $main::data{ $this->{'id'} }{'str'} ) )
            ];
        }
        else {
            $this->scalar_to_array( \$main::data{ $this->{'id'} }{'str'} );
        }
    }
    @{ $main::data{ $this->{'id'} }{'str'} }
        = grep( ref $this->{'condition'}->{$_},
        @{ $main::data{ $this->{'id'} }{'str'} } );
    $this->save_required_fields;
    $this->requirements_control( $main::data{ $this->{'id'} }{'str'} );
    $main::data{ $this->{'id'} }{'str'}
        = ( @{ $main::data{ $this->{'id'} }{'str'} } )
        ? ( $this->{'selectortype'} eq 'checkbox'
            || $this->{'selectortype'} eq 'multiplemenu' )
            ? join( ",", @{ $main::data{ $this->{'id'} }{'str'} } )
            : shift( @{ $main::data{ $this->{'id'} }{'str'} } )
        : '';
    $this->escape_data_tag('str');
    if ( $main::data{ $this->{'id'} }{'str'} ne '' ) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if defined $this->{'cookie'}
            && $this->{'cookie'}
            && defined $main::set_cookie
            && $main::set_cookie;
        return 1;
    }
    elsif ( $this->{'required'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} )
                ? $this->{'name'} . 'が'
                : ''
                )
                . '選択されていません。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'str'} = 1;
        return 0;
    }
    return 1;
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $this->id_to_list( $str, $this->{'listtype'} ),
            $this->{'style'},     $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
            )
    );
}

sub id_to_list ($$;$$) {
    my ( $this, $str, $type, $html_disabled ) = @_;
    my $id;
    my $no   = 1;
    my $list = '';
    my @id   = ( ref $str ) ? @$str : split( /,/, $str );
    return '' if !@id;
    return ($html_disabled)
        ? $this->detag( $this->{'condition'}{ $id[0] }{'name'} )
        : $this->{'condition'}{ $id[0] }{'name'}
        if @id == 1;
    $list .= ( $type eq 'ul' ) ? '<ul>' : '<ol>'
        if !$html_disabled && $type && $type ne 'csv';

    foreach $id (@id) {
        next if !ref $this->{'condition'}->{$id};
        if ( !$type || $type eq 'csv' ) {
            $list
                .= ( ( $list ne '' ) ? ', ' : '' )
                . ( ($html_disabled)
                ? $this->detag( $this->{'condition'}{$id}{'name'} )
                : $this->{'condition'}{$id}{'name'} );
        }
        elsif ($html_disabled) {
            $list .= ( ( $type eq 'ul' ) ? '・' : $no++ . ') ' )
                . $this->detag( $this->{'condition'}{$id}{'name'} ) . "\x0A";
        }
        else {
            $list .= '<li>' . $this->{'condition'}{$id}{'name'} . '</li>';
        }
    }
    $list .= ( $type eq 'ul' ) ? '</ul>' : '</ol>'
        if !$html_disabled && $type && $type ne 'csv';
    return $list;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    $str = $this->id_to_list( $str, $this->{'listtype'}, 1 );
    $str = '[' . $this->name . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return $this->id_to_list( $str, 'csv', 1 );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};
    my $n    = 1;
    my $id   = 1;
    $this->print_field_info_form($name);
    print '<fieldset>';
    print '<legend>選択肢の表示</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="menu"'
        . ( ( $this->{'selectortype'} && $this->{'selectortype'} eq 'menu' )
        ? ' checked="checked"'
        : '' )
        . ' />メニュー</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="multiplemenu"'
        . (
        (          $this->{'selectortype'}
                && $this->{'selectortype'} eq 'multiplemenu'
        ) ? ' checked="checked"' : ''
        ) . ' />複数選択可能メニュー</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="checkbox"'
        . (
        (   !$this->{'selectortype'}
                || ( $this->{'selectortype'}
                && $this->{'selectortype'} eq 'checkbox' )
        ) ? ' checked="checked"' : ''
        ) . ' />チェックボックス</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="radio"'
        . ( ( $this->{'selectortype'} && $this->{'selectortype'} eq 'radio' )
        ? ' checked="checked"'
        : '' )
        . ' />ラジオボタン</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>選択肢設定</legend>';
    print '<table class="tooltable">';
    print '<thead>';
    print '<tr class="odd">';
    print '<th class="odd">削除</th>';
    print '<th class="even">表示順</th>';
    print '<th class="odd">選択済</th>';
    print '<th class="even">選択肢の内容</th>';
    print '<th class="odd">選択状態</th>';
    print '<th class="even">対象フィールド</th>';
    print '<th class="odd">指定内容</th>';
    print '</tr>';
    print '</thead>';
    print '<tbody>';

    if ( ref $this->{'condition'} ) {
        foreach $id ( @{ $this->{'order'} } ) {
            $this->print_condition_setting_form( $name, $id, $n++ );
        }
        $id = 1;
        $id++ while ref $this->{'condition'}{$id};
    }
    $this->print_condition_setting_form( $name, $id, $n, 1 );
    print '</tbody></table>';
    print
        '<div class="note">+ 必須項目 / - 非必須項目 / &laquo; 必須項目制御</div>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>複数選択可能な場合の表示</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="csv"'
        . (
        (   !$this->{'listtype'}
                || ( $this->{'listtype'} && $this->{'listtype'} eq 'csv' )
        ) ? ' checked="checked"' : ''
        ) . ' /> カンマ区切りテキスト</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="ul"'
        . ( ( $this->{'listtype'} && $this->{'listtype'} eq 'ul' )
        ? ' checked="checked"'
        : '' )
        . ' /> リスト(&lt;ul&gt;)</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="ol"'
        . ( ( $this->{'listtype'} && $this->{'listtype'} eq 'ol' )
        ? ' checked="checked"'
        : '' )
        . ' /> 番号付リスト(&lt;ol&gt;)</label></li>';
    print '</ol>';
    print '</fieldset>';
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;
    $this->print_setting_save_button;
    return;
}

sub print_condition_setting_form ($$$$;$) {
    my ( $this, $name, $id, $n, $new ) = @_;
    $name .= '_condition_' . $id . '_';
    print '<tr class="' . ( ( $n % 2 ) ? 'even' : 'odd' ) . '">';
    print '<td class="caution">'
        . ( ( !$new )
        ? '<input type="checkbox" name="delete:' . $id . '" value="1" />'
        : '新規' )
        . '</td>';
    print '<td class="even"><input type="hidden" name="oldorder:'
        . $id
        . '" value="'
        . $n
        . '" /><input type="number" name="order:'
        . $id
        . '" value="'
        . $n
        . '" size="3" /></td>';
    print '<td class="odd"><input type="checkbox" name="'
        . $name
        . 'selected" value="1"'
        . ( ( $id && $this->{'condition'}{$id}{'selected'} )
        ? ' checked="checked"'
        : '' )
        . ' /></td>';
    print '<td class="even"><textarea name="'
        . $name
        . 'name" cols="24" rows="3" title="選択肢の内容を入力します。">'
        . $this->escape( $this->{'condition'}{$id}{'name'} )
        . '</textarea></td>';
    print '<td class="odd">';
    print '<select name="' . $name . 'status">';
    print '<option value="selected"'
        . (
        (          $id
                && $this->{'condition'}{$id}{'status'}
                && $this->{'condition'}{$id}{'status'} eq 'selected'
        ) ? ' selected="selected"' : ''
        ) . '>選択されたとき</option>';
    print '<option value="neglected"'
        . (
        (          $id
                && $this->{'condition'}{$id}{'status'}
                && $this->{'condition'}{$id}{'status'} eq 'neglected'
        ) ? ' selected="selected"' : ''
        ) . '>選択されなかったとき</option>';
    print '</select>';
    print '</td>';
    print '<td class="even">';
    my $myid_flag = 0;
    print '<select name="' . $name
        . 'target" multiple="multiple" size="4" title="+ 必須項目 / - 非必須項目 / &laquo; 必須項目制御">';

    foreach my $field_id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        if (   $myid_flag
            && ref $this->{'field_obj'}->{$field_id}
            && $this->{'field_obj'}->{$field_id}->required_enabled )
        {
            print '<option value="'
                . $field_id . '"'
                . (
                (          $id
                        && ref $this->{'condition'}{$id}{'target'}
                        && grep( $_ eq $field_id,
                        @{ $this->{'condition'}{$id}{'target'} } )
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . ( ( $this->{'field_obj'}->{$field_id}->{'required'} )
                ? '+'
                : '-' )
                . $this->jfold( $this->{'field_obj'}->{$field_id}->name,
                32, 'I', 1 )
                . (
                (   $this->{'field_obj'}->{$field_id}->{'class'} eq
                        'select_rcontrol'
                ) ? '&laquo;' : ''
                ) . '</option>';
        }
        $myid_flag = 1 if $field_id eq $this->{'id'};
    }
    print '</select>';
    print '</td>';
    print '<td class="odd">';
    print '<select name="' . $name . 'require">';
    print '<option value="true"'
        . (
        (          $id
                && $this->{'condition'}{$id}{'require'}
                && $this->{'condition'}{$id}{'require'} eq 'true'
        ) ? ' selected="selected"' : ''
        ) . '>必須項目に指定する</option>';
    print '<option value="false"'
        . (
        (          $id
                && $this->{'condition'}{$id}{'require'}
                && $this->{'condition'}{$id}{'require'} eq 'false'
        ) ? ' selected="selected"' : ''
        ) . '>必須項目指定を解除する</option>';
    print '<option value="hide"'
        . (
        (          $id
                && $this->{'condition'}{$id}{'require'}
                && $this->{'condition'}{$id}{'require'} eq 'hide'
        ) ? ' selected="selected"' : ''
        ) . '>必須項目指定を解除して隠す</option>';
    print '</select>';
    print '</td>';
    print '</tr>';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    no warnings qw(numeric);
    my $this       = shift;
    my $selected   = 0;
    my @conditions = ();
    my $id;
    while ( ($id) = each %main::order ) {
        if ( $main::delete{$id}
            || !
            defined $main::data{ $this->{'id'}
                    . '_condition_'
                    . $id
                    . '_name' }
            || $main::data{ $this->{'id'} . '_condition_' . $id . '_name' }
            eq '' )
        {
            $main::data{ $this->{'id'} . '_condition_' . $id . '_name' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_condition_' . $id . '_selected' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_condition_' . $id . '_status' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_condition_' . $id . '_target' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_condition_' . $id . '_require' }
                = "\x7F";
        }
        else {
            push( @conditions, $id );
            $this->tag_fix(
                \$main::data{ $this->{'id'} . '_condition_' . $id . '_name' }
            );
            $main::data{ $this->{'id'} . '_condition_' . $id . '_selected' }
                = (
                (   $main::data{ $this->{'id'}
                            . '_condition_'
                            . $id
                            . '_selected' }
                        && ( $main::data{ $this->{'id'} . '_selectortype' } eq
                        'checkbox'
                        || $main::data{ $this->{'id'} . '_selectortype' } eq
                        'multiplemenu'
                        || !$selected )
                ) ? 1 : 0
                );
            $main::data{ $this->{'id'} . '_condition_' . $id . '_target' }
                = ''
                if !
                defined $main::data{ $this->{'id'}
                    . '_condition_'
                    . $id
                    . '_target' };
            $selected = 1
                if $main::data{ $this->{'id'}
                    . '_condition_'
                    . $id
                    . '_selected' };
        }
    }
    $main::data{ $this->{'id'} . '_order' } = [
        (   sort {
                       $main::order{$a} <=> $main::order{$b}
                    || $main::oldorder{$b} <=> $main::oldorder{$a}
                    || $main::order{$a} cmp $main::order{$b}
                    || $a <=> $b
            } @conditions
        )
    ];
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $this->is_valid_font_setting;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} );
    $form = '<tr><td class="field-name">'
        . (
        (          $this->{'selectortype'} eq 'menu'
                || $this->{'selectortype'} eq 'multiplemenu'
        )
        ? '<label for="search:'
            . $this->{'id'}
            . ':str">'
            . $this->{'name'}
            . '</label>'
        : '<span class="datatitle">' . $this->{'name'} . '</span>'
        ) . '</td><td class="field">';
    $form .= $this->get_selector( 'search',
        $main::search{ $this->{'id'} }{'str'}, 1 );
    if (   $this->{'selectortype'} eq 'checkbox'
        || $this->{'selectortype'} eq 'multiplemenu' )
    {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode',
            '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => (
                ($default::english) ? 'Matches on all selection'
                : '全ての選択肢に一致'
            ),
            'or' => (
                ($default::english) ? 'Matches on any selection'
                : 'いずれかの選択肢に一致'
            )
        );
    }
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'select_rcontrol', 'RequirementsControl',
        '必須項目制御' );
}

1;
