package SCStock;
require CMONOS::CGI_Lib::Field::SCPrice;
@ISA = qw(SCPrice);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（在庫状況）
# SCStock.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return (
        defined $main::search{ $this->{'id'} }{'stock'}
            && ( $main::search{ $this->{'id'} }{'stock'} ne ''
            || @{ $main::search{ $this->{'id'} }{'stock'} } )
    ) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1 if !$this->sc_stock_is_enabled;
    return $this->{'showcase'}->stock_is_matched( $this, $str );
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->field_tag('') if !$this->sc_stock_is_enabled;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return $this->field_tag('') if $data{'digitalContentRequired'};
    if ( !$cgi::on_refreshing && %main::data ) {
        if (defined $main::data{ $this->{'field_for'}->{'showcase'} }
            {'availability'}
            || defined $main::data{ $this->{'field_for'}->{'showcase'} }
            {'stock'} )
        {
            $data{'availability'}
                = $main::data{ $this->{'field_for'}->{'showcase'} }
                {'availability'}
                if !defined $data{'availability'}
                || $data{'availability'} eq '';
            $data{'stock'}
                = $main::data{ $this->{'field_for'}->{'showcase'} }{'stock'}
                if !defined $data{'stock'} || $data{'stock'} eq '';
        }
        elsif (
            defined $main::data{ $this->{'field_for'}->{'showcase'} }{'str'} )
        {
            %data = $this->elements(
                $main::data{ $this->{'field_for'}->{'showcase'} }{'str'} );
        }
    }
    my $is_dc = $this->is_digital_content( \%data );
    return $this->field_tag('')
        if ( !defined $data{'stock'} || $data{'stock'} eq '' )
        && ( !defined $data{'availability'} || $data{'availability'} eq '' )
        && ( $is_dc || !$data{'withdrawn'} );
    return $this->field_tag(
        $this->data_tag_from_hash(
            'availability', $data{'availability'},
            'stock',        $data{'stock'},
            'withdrawn',    $data{'withdrawn'}
            )
            . $this->style(
            $this->{'showcase'}->sc_stock_tag(
                $data{'availability'}, $data{'stock'},
                $is_dc,                $data{'withdrawn'},
                1
            ),
            $this->{'style'},
            $this->{'fontsize'},
            $this->{'fontcolor'},
            $this->{'fontface'}
            )
    );
}

sub has_content {
    my ( $this, $str ) = @_;
    return 0 if !$this->sc_stock_is_enabled;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    if ( !$cgi::on_refreshing && %main::data ) {
        $data{'availability'}
            = $main::data{ $this->{'field_for'}->{'showcase'} }
            {'availability'}
            if !defined $data{'availability'};
        $data{'stock'}
            = $main::data{ $this->{'field_for'}->{'showcase'} }{'stock'}
            if !defined $data{'stock'};
    }
    return ( ( defined $data{'stock'} && $data{'stock'} ne '' )
            || ( defined $data{'availability'}
            && $data{'availability'} ne '' ) ) ? 1 : 0;
}

sub sc_stock_is_enabled ($) {
    my $this = shift;
    return 0
        if !$this->showcase_object_enabled
        || $this->{'showcase'}->{'digitalContentRequired'};
    if ((   (   $default::static
                || ( defined $this->{'showcase'}->{'stockview'}
                    && $this->{'showcase'}->{'stockview'} eq 'menu' )
            )
            && ref $this->{'showcase'}->{'stockAvailability'} eq 'ARRAY'
            && $this->{'showcase'}->{'stockAvailability'}[0]
            && $this->{'showcase'}->{'stockAvailability'}[0] ne ''
        )
        || (   $this->{'showcase'}->{'stockview'}
            && $this->{'showcase'}->{'stockview'} eq 'sync'
            && $this->{'showcase'}->{'inStockBounds'} )
        )
    {
        return 1;
    }
    else {
        return 0;
    }
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    my (%data);
    return '' if !$this->sc_stock_is_enabled;
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    if ( !defined $cgi::on_refreshing || !$cgi::on_refreshing ) {
        $data{'availability'}
            = $main::data{ $this->{'field_for'}->{'showcase'} }
            {'availability'}
            if !defined $data{'availability'};
        $data{'stock'}
            = $main::data{ $this->{'field_for'}->{'showcase'} }{'stock'}
            if !defined $data{'stock'};
    }
    return '' if $data{'stock'} eq '' && $data{'availability'} eq '';
    $str = $this->get_showcase_info( \%data );
    $str = '[' . $this->name . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    my (%data);
    return '' if !$this->sc_stock_is_enabled;
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    if ( !defined $cgi::on_refreshing || !$cgi::on_refreshing ) {
        $data{'availability'}
            = $main::data{ $this->{'field_for'}->{'showcase'} }
            {'availability'}
            if !defined $data{'availability'};
        $data{'stock'}
            = $main::data{ $this->{'field_for'}->{'showcase'} }{'stock'}
            if !defined $data{'stock'};
    }
    return '' if $data{'stock'} eq '' && $data{'availability'} eq '';
    return $this->get_showcase_info( \%data );
}

sub get_showcase_info($$) {
    my ( $this, $data ) = @_;
    my $out;
    if ( ( $default::static || $this->{'showcase'}->{'stockview'} eq 'menu' )
        && $$data{'availability'} ne ''
        && ref $this->{'showcase'}->{'stockAvailability'} eq 'ARRAY'
        && $this->{'showcase'}
        ->{'stockAvailability'}[ $$data{'availability'} ] ne '' )
    {
        $out .= '／' if defined $out && $out ne '';
        $out .= $this->{'showcase'}
            ->{'stockAvailability'}[ $$data{'availability'} ];
    }
    if ( defined $$data{'stock'} && $$data{'stock'} ne '' ) {
        $out .= '／' if defined $out && $out ne '';
        $out .= '在庫 ';
        $out .= $this->digit( $$data{'stock'} );
        $out .= $this->{'showcase'}->{'stockunit'}
            if $this->{'showcase'}->{'stockunit'};
    }
    return $out;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
    my $this = shift;
    return '' if !$this->sc_stock_is_enabled;
    my ($form);
    $form
        = '<tr><td class="field-name"><span class="datatitle">'
        . $this->{'name'}
        . '</span></td><td class="field">';
    $form .= $this->{'showcase'}->search_form_for_stock($this);
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    if (   $env::checkout
        && -e $env::checkout
        && !$setting::field_for_mail
        && ( !defined $default::type || $default::type eq '' ) )
    {
        Field::class_register( 'ysc_stock', 'SCStock', '在庫状況' );
    }
}

1;
