package Url;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（URL）
# Url.pm 1.1.5
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-09-28
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    return;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $modifier, $p );
    return 1
        if !defined $main::search{ $this->{'id'} }{'str'}
        || $main::search{ $this->{'id'} }{'str'} eq '';
    if ( !ref $this->{'pattern'} ) {
        $main::search{ $this->{'id'} }{'str'}
            = $this->z_to_h( $main::search{ $this->{'id'} }{'str'} );
        @{ $this->{'pattern'} } = $this->make_patterns(
            \$main::search{ $this->{'id'} }{'str'},
            (   (          $this->{'ignoreCase'}
                        || $main::search{ $this->{'id'} }{'i'}
                ) ? 1 : 0
            ),
            $main::search{ $this->{'id'} }{'mode'}
        );
    }
    return $this->pattern_matched(
        $str,
        $this->{'pattern'},
        (   ( $this->{'ignoreCase'} || $main::search{ $this->{'id'} }{'i'} )
            ? 1
            : 0
        ),
        $main::search{ $this->{'id'} }{'mode'}
    );
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ( $name, $form );

    #名前にデータIDを埋め込む
    $name = 'data:' . $this->{'id'} . ':str';

    #フィールドネーム+ヘッダ
    $form = $this->field_header( '50', $name );

    #デフォルト作成
    $main::data{ $this->{'id'} }{'str'} = $this->{'default'}
        if ( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'str'}
        || $main::data{ $this->{'id'} }{'str'} eq '' );

    $form
        .= '<input type="'
        . ( ( $this->{'pathEnabled'} ) ? 'text' : 'url' )
        . '" id="'
        . $name
        . '" name="'
        . $name
        . '" size="40"';
    $form
        .= ' value="'
        . $this->escape( $main::data{ $this->{'id'} }{'str'} ) . '"'
        if defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'};
    $form .= ' class="invalid-field"' if $this->{'is_invalid_field'}{'str'};
    $form .= ' placeholder="' . $this->escape( $this->{'placeholder'} ) . '"'
        if defined $this->{'placeholder'} && $this->{'placeholder'} ne '';
    $form .= ' required="required"' if $this->{'required'};
    $form .= ' />';

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    my ($is_valid);

    $this->escape_data_tag('str');

    #半角変換
    $main::data{ $this->{'id'} }{'str'}
        = $this->z_to_h( $main::data{ $this->{'id'} }{'str'} );
    $main::data{ $this->{'id'} }{'str'} =~ s/\x0A//gs;

    #必須項目/文字数チェック
    $is_valid = 1;
    $is_valid = 0
        unless $this->is_not_empty('str') && $this->is_not_too_long('str');

    #書式チェック
    if (   defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne ''
        && $main::data{ $this->{'id'} }{'str'} ne '/'
        && $this->is_invalid_url( $main::data{ $this->{'id'} }{'str'} ) )
    {
        my $url = $main::data{ $this->{'id'} }{'str'};
        $url = $1 if $url =~ /^(.*?)[\?\#]/s;
        $url =~ s!([^\.])/$!$1!;
        if ( $this->{'pathEnabled'} && $url !~ m![^\.]/\.+/! ) {
            my $is_invalid_path = 0;
            if ( $url =~ m!^/! ) {
                $url = $this->path_change( $url, $ENV{'SCRIPT_NAME'}, 'rel' );
            }
            else {
                $this->home_location
                    if !defined $cgi::document_root
                    || !defined $cgi::user_directory;
                if ($default::static) {
                    my $here
                        = ( $default::lib eq 'HomePageMakerLite' )
                        ? $default::home
                        : (   !$master::home
                            || $master::home eq $default::home )
                        ? $default::home
                        . ( ( defined $main::c && $main::c ne '' )
                        ? '/' . $main::c
                        : '' )
                        . '/'
                        . $main::n
                        . '/index.html'
                        : $default::home . '/' . $main::n . '/index.html';
                    $url = $this->un_base_change( $url, $here, 'rel', 1 );
                }
                my $path = $this->path_change( $url, $this->get_cwd . '/here',
                    'abs' );
                if (   $path !~ /^$cgi::document_root/
                    && $cgi::document_root ne $path )
                {
                    push(
                        @{ $cgi::action->{'dialog'} },
                        ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                            . 'を確認してください。ブラウザからアクセスできないパスです。'
                    ) if ref $cgi::action;
                    $is_valid        = 0;
                    $is_invalid_path = 1;
                }
            }
            if ( !$is_invalid_path && !-e $url ) {
                push(
                    @{ $cgi::action->{'dialog'} },
                    ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                        . 'を確認してください。入力されたパスにファイルが存在しません。'
                ) if ref $cgi::action;
                $is_valid = 0;
            }
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'を確認してください。URLではありません。'
            ) if ref $cgi::action;
            $is_valid = 0;
        }
    }

    #フィルターのチェック
    if (   $this->{'extfilter'}
        && defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne '' )
    {
        my @ext_filter = split( /,/, $this->{'extfilter'} );
        @ext_filter = grep( $_ ne '', @ext_filter );
        my $ext;
        my $matched = 0;
        foreach $ext (@ext_filter) {
            if ( $main::data{ $this->{'id'} }{'str'} =~ /\.$ext$/i ) {
                if ( !$this->{'extmatched'} ) {
                    push(
                        @{ $cgi::action->{'dialog'} },
                        (   ( defined $this->{'name'} && $this->{'name'} )
                            ? $this->{'name'}
                            : '入力'
                            )
                            . 'を確認してください。禁止されたファイルです。'
                    ) if ref $cgi::action;
                    $is_valid = 0;
                    last;
                }
                $matched = 1;
            }
        }
        if ( !$matched && $this->{'extmatched'} ) {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'}
                    : '入力'
                    )
                    . 'を確認してください。禁止されたファイルです。'
            ) if ref $cgi::action;
            $is_valid = 0;
        }
    }

    if ($is_valid) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if $this->{'cookie'} && $main::set_cookie;
    }
    else {
        $this->{'is_invalid_field'}{'str'} = 1;
    }
    return $is_valid;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';
    my $rel_path = $str;
    my $url      = $str;
    if ( $url !~ /^https?:\/\//i ) {
        if ( $url =~ m!^/! ) {
            $url = $this->full_path($url);
        }
        else {
            $rel_path
                = $this->un_base_change( $rel_path, $cgi::output,
                ( $cgi::output_option || 'rel' ), 1 )
                if $cgi::output || $cgi::output_option;
            $url = $this->full_path($rel_path);
        }
    }
    my $title = ( $this->{'text'} ) ? $this->escape( $this->{'text'} ) : $url;
    if ( $this->{'getTitle'} ) {
        require CMONOS::CGI_Lib::HTTP_Client;
        my $res
            = HTTP_Client->new->request( 'GET' => $url, {}, '', '', 4096 );
        if ( $res->is_success ) {
            my $content = $res->content('utf8');
            if ($content
                && ( $content
                    =~ m/<title(?![0-9a-zA-Z_])[^>]*>(.*?)<\/title(?![0-9a-zA-Z_])[^>]*>/si
                    || $content
                    =~ m/<h[1-6](?![0-9a-zA-Z_])[^>]*>(.*?)<\/h[1-6]>/si )
                )
            {
                $title = $this->unescape($1);
            }
        }
    }
    if ( $this->{'apiurl'} ) {
        my $thumnail
            = $this->get_website_thumnail_url( $this->{'apiurl'}, $url );
        if ($thumnail) {
            return $this->field_tag(
                      $this->data_tag_from_hash( 'str', $str )
                    . '<a href="'
                    . $str . '"'
                    . ( ( !$this->{'sameWindow'} ) ? ' target="_blank"' : '' )
                    . ' title="'
                    . $this->escape_except_html_entity($title) . '"'
                    . ( ( $this->{'nofollow'} ) ? ' rel="nofollow"' : '' )
                    . '>'
                    . $cgi::Image->image_tag(
                    $thumnail,                $this->{'previewwidth'},
                    $this->{'previewheight'}, 0
                    )
                    . '</a>'
            );
        }
    }
    if ( $this->{'button'} ) {
        $this->use_deco($cgi::output);
        return $this->field_tag(
            $this->data_tag_from_hash( 'str', $str )
                . $cgi::Deco->button(
                'jump',
                $this->{'button'},
                $rel_path,
                $title,
                ( ( !$this->{'sameWindow'} ) ? '_blank' : '' ),
                ( ( $this->{'nofollow'} ) ? { 'rel' => 'nofollow' } : '' )
                )
        );

    }
    else {
        my $fixed = ( $str ne $title ) ? 1 : 0;
        return $this->field_tag(
            ( ($fixed) ? $this->data_tag_from_hash( 'str', $str ) : '' )
            . $this->style(
                '<a href="'
                    . $this->escape_except_html_entity($str)
                    . '" title="'
                    . $this->escape_except_html_entity($title) . '"'
                    . ( ( !$this->{'sameWindow'} ) ? ' target="_blank"' : '' )
                    . ( ( $this->{'nofollow'} )    ? ' rel="nofollow"'  : '' )
                    . '>'
                    . (
                    ( !$fixed )
                    ? $this->data_tag( 'str', $str )
                    : $this->escape_except_html_entity($title)
                    )
                    . '</a>',
                $this->{'style'},
                $this->{'fontsize'},
                $this->{'fontcolor'},
                $this->{'fontface'}
            )
        );
    }
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    $str =~ s/\x0A//g;
    return $str;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->{'default'} =~ s/\x0A//sg if $this->{'default'};
    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_default">デフォルト</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" value="'
        . $this->escape( $this->{'default'} )
        . '" size="50" title="入力欄のデフォルトの値を設定します。" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_placeholder">プレースホルダ</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_placeholder" id="'
        . $name
        . '_placeholder" size="50" title="入力欄の placeholder 属性の値を設定します。" value="'
        . $this->escape( $this->{'placeholder'} ) . '" />';
    print '</fieldset>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_extfilter">リンク先拡張子フィルタ</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_extfilter" id="'
        . $name
        . '_extfilter" value="'
        . ( ( defined $this->{'extfilter'} )
        ? $this->escape( $this->{'extfilter'} )
        : 'exe,app,scr,pif,bat,com,cmd' )
        . '" size="50" title="拡張子でフィルタリングします。" />';
    print
        ' <span class="note">(拡張子ごとにカンマで区切ります)</span>';
    print '<fieldset>';
    print '<legend>処理</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_extmatched" value="1"'
        . ( ( $this->{'extmatched'} ) ? ' checked="checked"' : '' )
        . ' /> 拡張子が一致するとき、登録を許可する。</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_extmatched" value="0"'
        . ( ( !$this->{'extmatched'} ) ? ' checked="checked"' : '' )
        . ' /> 拡張子が一致しないとき、登録を許可する。</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '</fieldset>';

    if ( !defined $html_disabled || !$html_disabled ) {

        print '<fieldset>';
        print '<legend>リンク設定</legend>';
        print '<ol class="checkbox">';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_nofollow" id="'
            . $name
            . '_nofollow" value="1"'
            . ( ( defined $this->{'nofollow'} && $this->{'nofollow'} )
            ? ' checked="checked"'
            : '' )
            . ' /> リンク先を検索エンジンに無視させる</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_sameWindow" value="1"'
            . ( ( defined $this->{'sameWindow'} && $this->{'sameWindow'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 同じウィンドウで開く</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_pathEnabled" value="1"'
            . ( ( defined $this->{'pathEnabled'} && $this->{'pathEnabled'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 相対パスによる指定を許可する</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_getTitle" value="1"'
            . ( ( defined $this->{'getTitle'} && $this->{'getTitle'} )
            ? ' checked="checked"'
            : '' )
            . ' /> ページタイトルを取得する'
            . ( ($default::static) ? '' : '【非推奨】' )
            . '</label></li>';
        print '</ol>';
        print '</fieldset>';

        print '<fieldset>';
        print '<legend><label for="' . $name
            . '_text">リンクテキスト</label></legend>';
        print '<input type="text" name="'
            . $name
            . '_text" id="'
            . $name
            . '_text" value="'
            . $this->escape( $this->{'text'} )
            . '" size="50" title="リンクテキストを設定します。" />';
        print
            ' <span class="note">(設定なしで URL を表示します)</span>';
        print '</fieldset>';

        #ボタンメニュー
        print
            '<fieldset><legend title="設定がない場合、URLが表示されます。">ボタン</legend>';
        print $cgi::Deco->button_menu( $name . '_button',
            'jump', 120, $this->{'button'} );
        print '</fieldset>';

        print '<fieldset>';
        print
            '<legend>ウェブページ・サムネイル化サービス API</legend>';
        print '<fieldset>';
        print '<legend><label for="' . $name
            . '_apiurl">API URL</label></legend>';
        print '<input type="text" name="'
            . $name
            . '_apiurl" id="'
            . $name
            . '_apiurl" value="'
            . $this->escape( $this->{'apiurl'} )
            . '" size="72" />';
        print
            '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'',
            $name, '_apiurl\').textByMenu(this)">';
        print '<option value="">↓主なサービス</option>';
        print
            '<option value="http://img.simpleapi.net/small/%u">SimpleAPI</option>';
        print
            '<option value="http://mozshot.nemui.org/shot?%u">Mozshot</option>';
        print
            '<option value="http://capture.heartrails.com/medium?%u">HeartRails Capture</option>';
        print
            '<option value="http://images.websnapr.com/?url=%u&amp;size=s">WebSnapr</option>';
        print
            '</select><div class="note">URL が入る場所を %u とします。</div>';
        print '</fieldset>';
        print '<fieldset>';
        print '<legend>サムネイルサイズ</legend>';
        print '<label>幅 <input type="number" name="'
            . $name
            . '_previewwidth" id="'
            . $name
            . '_previewwidth" value="'
            . $this->escape( $this->{'previewwidth'} )
            . '" size="4" /> <span class="unit">ピクセル</span></label> &times <label>高さ <input type="number" name="'
            . $name
            . '_previewheight" id="'
            . $name
            . '_previewheight" value="'
            . $this->escape( $this->{'previewheight'} )
            . '" size="4" /> <span class="unit">ピクセル</span></label>';
        print '</fieldset>';
        print '</fieldset>';

        $this->print_ignorecase_setting_form($name);

        #文字設定
        $this->print_font_setting_form($name);
    }
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;

    #タグの除去
    if ( defined $main::data{ $this->{'id'} . '_default' }
        && $main::data{ $this->{'id'} . '_default' } )
    {
        $main::data{ $this->{'id'} . '_default' } =~ s/[\x0A\x0D]//sg;
        $this->detag( \$main::data{ $this->{'id'} . '_default' } );
    }
    $main::data{ $this->{'id'} . '_placeholder' } =~ s/[\x0A\x0D]+//sg
        if defined $main::data{ $this->{'id'} . '_placeholder' };

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    if ( $main::data{ $this->{'id'} . '_extfilter' } ) {
        $main::data{ $this->{'id'} . '_extfilter' }
            = $this->z_to_h( $main::data{ $this->{'id'} . '_extfilter' } );
        $main::data{ $this->{'id'} . '_extfilter' } =~ s/[^a-zA-Z0-9,]/,/g;
        $main::data{ $this->{'id'} . '_extfilter' } =~ s/,+/,/g;
        $main::data{ $this->{'id'} . '_extfilter' } =~ s/^,//;
        $main::data{ $this->{'id'} . '_extfilter' } =~ s/,$//;
    }
    $main::data{ $this->{'id'} . '_nofollow' } = ''
        if !defined $main::data{ $this->{'id'} . '_nofollow' }
        || !$main::data{ $this->{'id'} . '_nofollow' };
    $main::data{ $this->{'id'} . '_getTitle' } = ''
        if !defined $main::data{ $this->{'id'} . '_getTitle' }
        || $main::data{ $this->{'id'} . '_getTitle' } eq '';
    $main::data{ $this->{'id'} . '_pathEnabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_pathEnabled' }
        || $main::data{ $this->{'id'} . '_pathEnabled' } eq '';
    $main::data{ $this->{'id'} . '_sameWindow' } = ''
        if !defined $main::data{ $this->{'id'} . '_sameWindow' }
        || $main::data{ $this->{'id'} . '_sameWindow' } eq '';
    if (   defined $main::data{ $this->{'id'} . '_apiurl' }
        && $main::data{ $this->{'id'} . '_apiurl' } ne ''
        && $this->is_invalid_url( $main::data{ $this->{'id'} . '_apiurl' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル化 API URLを確認してください。'
        ) if ref $cgi::action;
        $is_valid = 0;
        delete $main::data{ $this->{'id'} . '_apiurl' };
    }
    if (   defined $main::data{ $this->{'id'} . '_previewwidth' }
        && $main::data{ $this->{'id'} . '_previewwidth' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_previewwidth' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル横幅設定を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_previewwidth' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_previewheight' }
        && $main::data{ $this->{'id'} . '_previewheight' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_previewheight' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル高さ設定を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_previewheight' };
        $is_valid = 0;
    }
    if ( $main::data{ $this->{'id'} . '_apiurl' }
        && !$main::data{ $this->{'id'} . '_previewwidth' } )
    {
        my $thumnail
            = $this->get_website_thumnail_url(
            $main::data{ $this->{'id'} . '_apiurl' },
            'http://www.google.com/' );
        if ($thumnail) {
            require CMONOS::CGI_Lib::HTTP_Client;
            my $res = HTTP_Client->new->request( 'GET' => $thumnail );
            if ( $res->is_success ) {
                my $content = $res->content;
                (   $main::data{ $this->{'id'} . '_previewwidth' },
                    $main::data{ $this->{'id'} . '_previewheight' }
                ) = $cgi::Image->info( \$content );
            }
        }
    }
    $main::data{ $this->{'id'} . '_ignoreCase' } = ''
        if !$main::data{ $this->{'id'} . '_ignoreCase' };
    $is_valid = 0 if !$this->is_valid_font_setting;
    return $is_valid;
}

sub get_website_thumnail_url ($$$) {
    my ( $this, $api, $url ) = @_;
    $url = $this->url_encode($url) if $url && $api =~ /\?/ && $api =~ /=/;
    return ( $url && $api =~ s/\%u/$url/g ) ? $api : '';
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'text_url', 'Url', 'URL' );
    $setting::deco_dir{'jump'}  = 'ジャンプボタン';
    $setting::deco_type{'jump'} = 'button';
}

1;
