package UserAgentInfo;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールドモジュール（ユーザー環境情報）
# UserAgentInfo.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
#　support@cmonos.jp
#　http://cmonos.jp/
#
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    unless ( ref $cgi::UserAgent ) {
        require CMONOS::CGI_Lib::UserAgent;
        $cgi::UserAgent = UserAgent->new;
    }
    $this->{'separator'} = '/'
        if !defined $this->{'separator'} || $this->{'separator'} eq '';
}

######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'agent';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'p'} );
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'b'} );
    if ( defined $this->{'searchOption'} && $this->{'searchOption'} ) {
        return ( defined $main::search{ $this->{'id'} }{'str'}
                && $main::search{ $this->{'id'} }{'str'} ne '' ) ? 1 : 0;
    }
    else {
        return (
            (   ref $main::search{ $this->{'id'} }{'p'}
                    && @{ $main::search{ $this->{'id'} }{'p'} } > 0
            )
                || ( ref $main::search{ $this->{'id'} }{'b'}
                && @{ $main::search{ $this->{'id'} }{'b'} } > 0 )
        ) ? 1 : 0;
    }
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    if ( defined $this->{'searchOption'} && $this->{'searchOption'} ) {
        return 1
            if !defined $main::search{ $this->{'id'} }{'str'}
            || $main::search{ $this->{'id'} }{'str'} eq '';
        @{ $this->{'pattern'} } = $this->make_patterns(
            \$main::search{ $this->{'id'} }{'str'},
            (   (          $this->{'ignoreCase'}
                        || $main::search{ $this->{'id'} }{'i'}
                ) ? 1 : 0
            ),
            $main::search{ $this->{'id'} }{'mode'}
        ) if !ref $this->{'pattern'};
        return $this->pattern_matched(
            $str,
            $this->{'pattern'},
            (   (          $this->{'ignoreCase'}
                        || $main::search{ $this->{'id'} }{'i'}
                ) ? 1 : 0
            ),
            $main::search{ $this->{'id'} }{'mode'}
        );

    }
    else {
        my ( @info, $matched_flag, $check_flag );
        @info = $cgi::UserAgent->get_user_agent_info($$str);
        if ( ref $main::search{ $this->{'id'} }{'p'}
            && @{ $main::search{ $this->{'id'} }{'p'} } )
        {
            if (grep( $info[0] eq $_,
                    @{ $main::search{ $this->{'id'} }{'p'} } )
                || (grep( $_ eq 'Other',
                        @{ $main::search{ $this->{'id'} }{'p'} } )
                    && $info[0] !~ /^(Windows|Macintosh|UNIX)$/
                )
                )
            {
                if ( !defined $main::search{ $this->{'id'} }{'mode'}
                    || $main::search{ $this->{'id'} }{'mode'} ne 'and' )
                {
                    return 1;
                }
                else {
                    $matched_flag = 1;
                }
            }
            elsif ( defined $main::search{ $this->{'id'} }{'mode'}
                && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
            {
                return 0;
            }
            $check_flag = 1;
        }
        if ( ref $main::search{ $this->{'id'} }{'b'}
            && @{ $main::search{ $this->{'id'} }{'b'} } )
        {
            if (grep( $info[2] eq $_,
                    @{ $main::search{ $this->{'id'} }{'b'} } )
                || (grep( $_ eq 'Other',
                        @{ $main::search{ $this->{'id'} }{'b'} } )
                    && $info[2]
                    !~ /^(InternetExplorer|NetscapeNavigator|Mozilla|Opera|iCab|OmniWeb)$/
                )
                )
            {
                return 1;
            }
            elsif ( defined $main::search{ $this->{'id'} }{'mode'}
                && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
            {
                return 0;
            }
            $check_flag = 1;
        }
        return ($check_flag) ? $matched_flag : 1;
    }
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my ( $this, $status, $original ) = @_;
    $main::data{ $this->{'id'} }{'str'} = $ENV{'HTTP_USER_AGENT'};
    my $form = $this->field_header;
    $form
        .= $this->get_user_agent_info( $main::data{ $this->{'id'} }{'str'} );
    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    $main::data{ $this->{'id'} }{'str'} = $ENV{'HTTP_USER_AGENT'};
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag('') if !defined $str || $str eq '';
    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $this->get_user_agent_info($str), $this->{'style'},
            $this->{'fontsize'},              $this->{'fontcolor'},
            $this->{'fontface'}
            )
    );
}

sub get_user_agent_info ($;$$) {
    my ( $this, $user_agent, $rmtag ) = @_;
    my ($info);
    my @info = $cgi::UserAgent->get_user_agent_info($user_agent);
    $info[2] .= $info[3];
    splice( @info, 3, 1 );
    shift @info;
    @info = grep( defined $_ && $_ ne '', @info );
    my $separator = $this->{'separator'};

    if ( defined $rmtag && $rmtag ) {
        $separator =~ s/<br(?![0-9a-zA-Z_])[^>]*>/\x0A/g;
        $separator =~ s/<.*?>//g;
    }
    else {
        map( $_ = $this->escape($_), @info );
    }
    $info = join( $separator, @info );

    if ( defined $this->{'bracket'} && $this->{'bracket'} ) {
        if ( $this->{'bracket'} == 1 ) {
            $info = '(' . $info . ')';
        }
        elsif ( $this->{'bracket'} == 2 ) {
            $info = '[' . $info . ']';
        }
        elsif ( $this->{'bracket'} == 3 ) {
            $info = '【' . $info . '】';
        }
        elsif ( $this->{'bracket'} == 4 ) {
            if ( defined $rmtag && $rmtag ) {
                $info = '<' . $info . '>';
            }
            else {
                $info = '&lt;' . $info . '&gt;';
            }
        }
        elsif ( $this->{'bracket'} == 5 ) {
            $info = '{' . $info . '}';
        }
    }
    return $info;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return
          '['
        . $this->name . "]\x0A"
        . $this->get_user_agent_info( $str, 1 )
        . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->get_user_agent_info( $str, 1 );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);
    print '<fieldset>';
    print '<legend>表示設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_separator">区切り文字</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_separator" id="'
        . $name
        . '_separator" value="'
        . $this->escape( $this->{'separator'} )
        . '" size="20" title="ユーザー環境情報の区切り文字を設定します。" /></td>';
    print '<td class="field-name"><label for="' . $name
        . '_bracket">かっこ</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_bracket',
        'ユーザー環境情報を囲うかっこを選択します。',
        '', $this->{'bracket'},
        ''  => '',
        '1' => '( )',
        '2' => '[ ]',
        '3' => '【 】',
        '4' => '< >',
        '5' => '{ }'
    );
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';

    #文字設定
    if ( !defined $html_disabled || !$html_disabled ) {
        if ( !defined $default::static || !$default::static ) {
            print '<fieldset>';
            print '<legend>検索設定</legend>';
            print '<label><input type="checkbox" name="'
                . $name
                . '_searchOption" value="1"'
                . (
                (   defined $this->{'searchOption'} && $this->{'searchOption'}
                ) ? ' checked="checked"' : ''
                )
                . ' /> ユーザー環境情報を文字列として検索する</label>';
            print '</fieldset>';
        }
        $this->print_font_setting_form($name);
    }
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_searchOption' } = ''
        if !defined $main::data{ $this->{'id'} . '_searchOption' }
        || !$main::data{ $this->{'id'} . '_searchOption' };
    return $this->is_valid_font_setting;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;

    if ( defined $this->{'searchOption'} && $this->{'searchOption'} ) {
        my $key
            = ( defined $main::search{ $this->{'id'} }{'str'} )
            ? $this->escape( $main::search{ $this->{'id'} }{'str'} )
            : '';
        my $form
            = '<tr><td class="field-name"><label for="search:'
            . $this->{'id'}
            . ':str">'
            . $this->{'name'}
            . '</label></td><td class="field">';
        $form
            .= '<input type="text" size="30" name="search:'
            . $this->{'id'}
            . ':str" value="'
            . $key . '" /> ';

        #英語表記
        if ( defined $default::english && $default::english ) {
            $form .= $this->mk_select_menu(
                'search:' . $this->{'id'} . ':mode', '', '',
                $main::search{ $this->{'id'} }{'mode'},
                'and' => 'Matches on all words',
                'or'  => 'Matches on any words',
                'A'   => 'Begins with any words',
                'Z'   => 'Finishes with any words',
                'eq'  => 'Equal to any words',
            );
            $form
                .= '<div class="extra-field"><label><input type="checkbox" name="search:'
                . $this->{'id'}
                . ':i" value="1"'
                . (
                (   defined $main::search{ $this->{'id'} }{'i'}
                        && $main::search{ $this->{'id'} }{'i'}
                ) ? ' checked="checked"' : ''
                ) . ' />';
            $form .= ' Do case-insensitive pattern matching.</label></div>';

            #日本語
        }
        else {
            $form .= $this->mk_select_menu(
                'search:' . $this->{'id'} . ':mode', '', '',
                $main::search{ $this->{'id'} }{'mode'},
                'and' => '全ての文字列を含む',
                'or'  => 'いずれかの文字列を含む',
                'A'   => 'いずれかの文字列から始まる',
                'Z'   => 'いずれかの文字列で終わる',
                'eq'  => 'いずれかの文字列に一致する',
            );
            $form
                .= '<div class="extra-field"><label><input type="checkbox" name="search:'
                . $this->{'id'}
                . ':i" value="1"'
                . (
                (   defined $main::search{ $this->{'id'} }{'i'}
                        && $main::search{ $this->{'id'} }{'i'}
                ) ? ' checked="checked"' : ''
                ) . ' />';
            $form .= ' 大文字と小文字を区別しない</label></div>';
        }
        $form .= '</td></tr>';
        return $form;

    }
    else {
        my $form
            = '<tr><td class="field-name"><span class="datatitle">'
            . $this->{'name'}
            . '</span></td><td class="field">';
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':p',
            '',
            ' multiple="multiple" size="4"',
            $main::search{ $this->{'id'} }{'p'},
            'Windows'   => 'Windows',
            'Macintosh' => 'Macintosh',
            'UNIX'      => 'UNIX',
            'Other'     => (
                ( defined $default::english && $default::english )
                ? 'Other'
                : 'その他'
            )
        );
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode',
            '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => (
                ( defined $default::english && $default::english ) ? 'and'
                : 'かつ'
            ),
            'or' => (
                ( defined $default::english && $default::english ) ? 'or'
                : 'または'
            )
        );
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':b',
            '',
            ' multiple="multiple" size="4"',
            $main::search{ $this->{'id'} }{'b'},
            'InternetExplorer'  => 'InternetExplorer',
            'NetscapeNavigator' => 'NetscapeNavigator',
            'Firefox'           => 'Firefox',
            'Chrome'            => 'Chrome',
            'Safari'            => 'Safari',
            'Mozilla'           => 'Mozilla',
            'Opera'             => 'Opera',
            'iCab'              => 'iCab',
            'OmniWeb'           => 'OmniWeb',
            'Other'             => (
                ( defined $default::english && $default::english )
                ? 'Other'
                : 'その他'
            )
        );
        $form .= '</td></tr>';
        return $form;
    }
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    return join( ',', $cgi::UserAgent->get_user_agent_info($str) );
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'user_agent', 'UserAgentInfo',
        'ユーザー環境情報' );
}

1;
