package ZipCodeNum;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（郵便番号）
# ZipCodeNum.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-05-28
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    return;
}

sub elements ($$) {
    my ( $this, $str ) = @_;
    my $d3 = '';
    my $d4 = '';
    if ( $str && $str =~ /^(\d{3})\-?(\d{4})/ ) {
        $d3 = $this->z_to_h($1);
        $d4 = $this->z_to_h($2);
    }
    return ( '3' => $d3, '4' => $d4 );
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $i, $addr );
    return 1
        if !defined $main::search{ $this->{'id'} }{'str'}
        || $main::search{ $this->{'id'} }{'str'} eq '';

    if ( !ref $this->{'pattern'} ) {
        @{ $this->{'pattern'} }
            = ( defined $main::search{ $this->{'id'} }{'str'} )
            ? split( /\s+/, $main::search{ $this->{'id'} }{'str'} )
            : ();
        map {
            $_ = $this->z_to_h($_);
            $_ =~ s/[^0-9]+/-/g;
            $_ =~ s/([0-9]{3})([0-9]{2,4})/$1-$2/g;
        } @{ $this->{'pattern'} };
    }

    foreach ( @{ $this->{'pattern'} } ) {
        next if $_ eq '';
        if ( eval { $$str =~ /$_/ } ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ( $form, $param );

    #検索パラメータ
    if (   $env::zipcode
        && $this->{'addrfield'}
        && ref $this->{'field_obj'}->{ $this->{'addrfield'} }
        && $this->{'field_obj'}->{ $this->{'addrfield'} }->{'class'} eq
        'addr_j' )
    {
        $param = '\''
            . $this->path_change( $env::zipcode_search, $ENV{'SCRIPT_NAME'},
            'abs' )
            . '\',';
        $param .= '\'data:' . $this->{'id'} . ':3\',';
        $param .= '\'data:' . $this->{'id'} . ':4\',';
        $param
            .= '\'data:'
            . $this->{'addrfield'}
            . ':pref\',\'data:'
            . $this->{'addrfield'}
            . ':city\',\'data:'
            . $this->{'addrfield'}
            . ':street\',\'data:'
            . $this->{'addrfield'}
            . ':building\'';
    }

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #デフォルト作成
    if ( defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne '' )
    {
        %{ $main::data{ $this->{'id'} } }
            = $this->elements( $main::data{ $this->{'id'} }{'str'} );
    }
    elsif ( ( !defined $status || $status eq '' )
        && !defined $main::data{ $this->{'id'} }{'3'} )
    {
        $main::data{ $this->{'id'} }{'3'} = $this->{'d3'};
        $main::data{ $this->{'id'} }{'4'} = $this->{'d4'};
    }

    $form
        .= '<input type="text" name="data:'
        . $this->{'id'}
        . ':3" size="3" maxlength="3"';
    $form
        .= ' value="'
        . $this->escape( $main::data{ $this->{'id'} }{'3'} ) . '"'
        if defined $main::data{ $this->{'id'} }{'3'}
        && $main::data{ $this->{'id'} }{'3'} ne '';
    $form
        .= ' class="zip3'
        . ( ( $this->{'is_invalid_field'}{'3'} ) ? ' invalid-field' : '' )
        . '"';
    $form
        .= ' onchange="'
        . ( ($param)
        ? 'cmonos.form.item(this.form).getAddressFromZipCode('
            . $param . ');'
        : '' )
        . ( ( $this->{'is_invalid_field'}{'3'} )
        ? 'cmonos.validate.field(this).bailOut();'
        : '' )
        . '"'
        if $param || $this->{'is_invalid_field'}{'3'};
    $form .= ' required="required"' if $this->{'required'};
    $form .= ' />';
    $form
        .= ' - <input type="text" name="data:'
        . $this->{'id'}
        . ':4" size="4" maxlength="4"';
    $form
        .= ' value="'
        . $this->escape( $main::data{ $this->{'id'} }{'4'} ) . '"'
        if defined $main::data{ $this->{'id'} }{'4'}
        && $main::data{ $this->{'id'} }{'4'} ne '';
    $form
        .= ' class="zip4'
        . ( ( $this->{'is_invalid_field'}{'4'} ) ? ' invalid-field' : '' )
        . '"';
    $form
        .= ' onchange="'
        . ( ($param)
        ? 'cmonos.form.item(this.form).getAddressFromZipCode('
            . $param . ');'
        : '' )
        . ( ( $this->{'is_invalid_field'}{'4'} )
        ? 'cmonos.validate.field(this).bailOut();'
        : '' )
        . '"'
        if $param || $this->{'is_invalid_field'}{'4'};
    $form .= ' required="required"' if $this->{'required'};
    $form .= ' />';

    #検索ボタンの付加
    $form
        .= '<input class="tool" type="button" value="〒→住所" onclick="cmonos.form.item(this.form).openZipCodeSearchWindow('
        . $param . ')" />'
        if $param;

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    my $is_valid = 1;
    if ( defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne '' )
    {
        %{ $main::data{ $this->{'id'} } }
            = $this->elements( $main::data{ $this->{'id'} }{'str'} );
    }

    #半角化
    $main::data{ $this->{'id'} }{'3'}
        = $this->z_to_h( $main::data{ $this->{'id'} }{'3'} )
        if defined $main::data{ $this->{'id'} }{'3'}
        && $main::data{ $this->{'id'} }{'3'} =~ /[^0-9]/;
    $main::data{ $this->{'id'} }{'4'}
        = $this->z_to_h( $main::data{ $this->{'id'} }{'4'} )
        if defined $main::data{ $this->{'id'} }{'4'}
        && $main::data{ $this->{'id'} }{'4'} =~ /[^0-9]/;

    if ($this->{'required'}
        || ( defined $main::data{ $this->{'id'} }{'3'}
            && $main::data{ $this->{'id'} }{'3'} ne '' )
        || ( defined $main::data{ $this->{'id'} }{'4'}
            && $main::data{ $this->{'id'} }{'4'} ne '' )
        )
    {
        if ( !defined $main::data{ $this->{'id'} }{'3'}
            || $main::data{ $this->{'id'} }{'3'} !~ /^[0-9]{3}$/ )
        {
            $main::data{ $this->{'id'} }{'3'}
                = ( defined $main::data{ $this->{'id'} }{'3'}
                    && $main::data{ $this->{'id'} }{'3'} =~ /([0-9]{1,3})/ )
                ? $1
                : '';
            $this->{'is_invalid_field'}{'3'} = 1;
            $is_valid = 0;
        }
        if ( !defined $main::data{ $this->{'id'} }{'4'}
            || $main::data{ $this->{'id'} }{'4'} !~ /^[0-9]{4}$/ )
        {
            $main::data{ $this->{'id'} }{'4'}
                = ( defined $main::data{ $this->{'id'} }{'4'}
                    && $main::data{ $this->{'id'} }{'4'} =~ /([0-9]{1,4})/ )
                ? $1
                : '';
            $this->{'is_invalid_field'}{'4'} = 1;
            $is_valid = 0;
        }
        if ($is_valid) {
            $main::data{ $this->{'id'} }{'str'}
                = $main::data{ $this->{'id'} }{'3'} . '-'
                . $main::data{ $this->{'id'} }{'4'};
            $cookie::data{ 'data:' . $this->{'id'} . ':str' }
                = $main::data{ $this->{'id'} }{'str'}
                if $this->{'cookie'} && $main::set_cookie;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'を確認してください。7桁の郵便番号を半角数字で入力してください。'
            ) if ref $cgi::action;
            $main::data{ $this->{'id'} }{'str'} = '';
        }
    }
    else {
        $main::data{ $this->{'id'} }{'str'} = '';
    }
    return $is_valid;
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';
    return $this->field_tag(
        $this->style(
            $this->data_tag( 'str', $this->escape( $this->tag_to_lf($str) ) ),
            $this->{'style'},     $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
        )
    );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>デフォルト</legend>';
    print '<input type="text" name="'
        . $name
        . '_d3" size="3" maxlength="3" value="'
        . $this->escape( $this->{'d3'} )
        . '" /> - ';
    print '<input type="text" name="'
        . $name
        . '_d4" size="4" maxlength="4" value="'
        . $this->escape( $this->{'d4'} ) . '" />';
    print '</fieldset>';

    if ($env::zipcode) {
        my ($menu);
        foreach my $id (
            sort {
                $this->{'field_obj'}->{$a}->{'ORDER'}
                    <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                    || $a <=> $b
            } keys %{ $this->{'field_obj'} }
            )
        {
            next
                unless ref $this->{'field_obj'}->{$id}
                && $this->{'field_obj'}->{$id}->{'class'} eq 'addr_j';
            $menu
                .= '<option value="'
                . $id . '"'
                . (
                (          defined $id
                        && defined $this->{'addrfield'}
                        && $id eq $this->{'addrfield'}
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->{'field_obj'}->{$id}->name
                . '</option>';
        }
        if ( defined $menu && $menu ne '' ) {
            print '<fieldset>';
            print '<legend><label for="' . $name
                . '_addrfield">住所検索ウィンドウ設定</label></legend>';
            print '<select name="'
                . $name
                . '_addrfield" id="'
                . $name
                . '_addrfield" title="郵便番号から検索した結果を書き出す住所フィールドを選択します。">';
            print '<option value=""></option>';
            print $menu;
            print '</select>';
            print
                '<div class="note">検索結果を書き出す住所フィールドを選択してください</div>';
            print '</fieldset>';
        }
    }

    #文字設定
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;

    #フォントチェック
    my $is_valid = $this->is_valid_font_setting;

    #半角化
    $main::data{ $this->{'id'} . '_d3' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_d3' } )
        if $main::data{ $this->{'id'} . '_d3' } =~ /[^0-9]/;
    $main::data{ $this->{'id'} . '_d4' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_d4' } )
        if $main::data{ $this->{'id'} . '_d4' } =~ /[^0-9]/;

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };

    if (   $main::data{ $this->{'id'} . '_d3' } ne ''
        && $main::data{ $this->{'id'} . '_d3' } !~ /^[0-9]{1,3}$/ )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デフォルト番号を更新できませんでした。3文字以内の半角数字で入力してください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_d3' };
        $is_valid = 0;
    }
    if (   $main::data{ $this->{'id'} . '_d4' } ne ''
        && $main::data{ $this->{'id'} . '_d4' } !~ /^[0-9]{1,4}$/ )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デフォルト番号を更新できませんでした。4文字以内の半角数字で入力してください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_d4' };
        $is_valid = 0;
    }

    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $form
        = '<tr><td class="field-name"><label for="search:'
        . $this->{'id'}
        . ':str">'
        . $this->{'name'}
        . '</label></td><td class="field">';
    $form
        .= '<input type="text" size="30" name="search:'
        . $this->{'id'}
        . ':str" value="'
        . $this->escape( $main::search{ $this->{'id'} }{'str'} ) . '" /> ';

    #英語表記
    if ( defined $default::english && $default::english ) {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode', '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => 'Matches on all numbers',
            'or'  => 'Matches on any number'
        );

        #日本語
    }
    else {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode', '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => '全ての番号に一致',
            'or'  => 'いずれかの番号に一致'
        );
    }
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'addr_zipcode', 'ZipCodeNum', '郵便番号' );
}

1;
