package OGPTypeMenu;
use strict;
use utf8;
######################################################################
# og:type メニューモジュール
# OGPTypeMenu.pm 1.0
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-12-18
######################################################################
sub new ($;@) {
    my $pkg  = shift;
    my $this = {
        'type_hash' => {
            'Activities' => [ 'activity', 'sport' ],
            'Businesses' =>
                [ 'bar', 'company', 'cafe', 'hotel', 'restaurant' ],
            'Groups'        => [ 'cause', 'sports_league', 'sports_team' ],
            'Organizations' => [
                'band', 'government', 'non_profit', 'school', 'university'
            ],
            'People' => [
                'actor',    'athlete',    'author',  'director',
                'musician', 'politician', 'profile', 'public_figure'
            ],
            'Places' => [ 'city', 'country', 'landmark', 'state_province' ],
            'Products and Entertainment' => [
                'album',   'book', 'drink', 'food', 'game', 'movie',
                'product', 'song', 'tv_show'
            ],
            'Websites' => [ 'article', 'blog', 'website' ],
        }
    };
    bless $this;
    return $this;
}

######################################################################
#ソケットを開いて接続する
sub menu ($$;$) {
    my ( $this, $name, $selected ) = @_;
    my $form = '<select name="' . $name . '" id="' . $name . '">';
    $form
        .= '<optgroup label="なし"><option value="">&lt;なし&gt;</option></optgroup>';
    foreach my $grp ( sort { $a cmp $b } keys %{ $this->{'type_hash'} } ) {
        $form .= '<optgroup label="' . $grp . '">';
        foreach my $t ( @{ $this->{'type_hash'}{$grp} } ) {
            $form
                .= '<option value="'
                . $t . '"'
                . ( ( $selected && $selected eq $t )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $t
                . '</option>';
        }
        $form .= '</optgroup>';
    }
    $form .= '</select>';
    return $form;
}

1;
