package PendingItemViewerBase;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 保留項目一覧表示モジュール
# PendingItemViewerBase.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this       = shift;
    my $pending_db = $this->get_pending_db_path;
    my %pending;
    my $count = 0;
    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';

    #全削除
    if ( $pending_db && $main::a ) {
        if ( $main::a eq 'clear' ) {
            tie( %pending, $env::dbm_file, $pending_db, O_RDWR,
                $env::dbm_mode );
            if ( ref tied %pending ) {
                %pending = ();
            }
            untie %pending;
        }
        if ( $setting::security_key ne 'tools' ) {
            my $javascript = <<JAVA;
cmonos.tool.refreshNavi = function () {
	if (parent.tool_navi) {
		parent.tool_navi.location.reload();
	}
};
JAVA
            $this->set_onload('cmonos.tool.refreshNavi()');
            $this->set_javascript($javascript);
        }
    }

    #ページヘッダ
    $this->jump_menu($setting::key) if $setting::security_key eq 'tools';
    $this->print_page_header($setting::key);

    #タイトル
    print '<h1>未読の承認待ち項目一覧</h1>';
    if ($pending_db) {
        print $this->form_start(
            'key'      => $setting::security_key,
            'name'     => 'input',
            'method'   => 'post',
            'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
            'required' => \@setting::form
        );
        print
            '<fieldset><legend><label for="target">未読の承認待ち項目</label></legend>';
        tie( %pending, $env::dbm_file, $pending_db, O_RDONLY,
            $env::dbm_mode );
        if ( ref tied %pending ) {
            print '<ol>';
            foreach my $editor_url (
                sort {
                    $this->sort_by( \$pending{$b}, \$pending{$a} )
                        || $this->sort_by( \$a, \$b )
                } keys %pending
                )
            {
                my ( $mtime, $title ) = split(
                    /\x09/,
                    $this->decode_utf8(
                        $pending{ $this->encode_utf8($editor_url) }
                    )
                );
                print '<li><a href="'
                    . $this->escape($editor_url)
                    . '" target="UserGeneratedFieldEditor" onclick="cmonos.window.open(\'UserGeneratedFieldEditor\',640,600)">'
                    . $title
                    . '</a> ('
                    . $this->date( $mtime, 7, 'gmt/' )
                    . ')</li>';
                $count++;
            }
            print '</ol>';
            print '未読の承認待ち項目はありません。'
                if !$count;
        }
        else {
            print '未読の承認待ち項目はありません。';
        }
        untie %pending;
        print '</fieldset>';
        print
            '<fieldset class="submit"><input type="submit" name="a=refresh" value="再読み込み" class="save" /></fieldset>';
        print
            '<fieldset class="delete"><input type="submit" name="a=clear" value="未読の承認待ち項目情報を全て削除する" onclick="return confirm(\'この操作は取り消せません。本当に削除しますか？\')" /></fieldset>'
            if $count;
        print '</form>';
    }
    else {
        print
            '<p>未読の承認待ち項目を保存するデータベースが設定されていません。</p>';
    }

    #ページフッタ
    $this->print_page_footer($setting::key);
}

######################################################################
sub get_pending_db_path ($) {
    my $this = shift;
    return ($default::preference_dir)
        ? $default::preference_dir . '/pending'
        : '';
}

1;
