package Clear;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
no warnings qw(once);
######################################################################
# データクリアモジュール
# SetUp.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;

    #データベース・設定 のバックアップ
    if ( defined $main::a && $main::a eq 'clear' ) {
        my (@db);
        @db = $this->db;

        if (@db) {
            my ($pat);
            $pat = ($main::backup) ? '\.default$' : '(\.bak|\.default)$';
            $pat = '(' . $clear::ignore . '|' . $pat . ')'
                if defined $clear::ignore && $clear::ignore ne '';

            foreach (@db) {
                unlink( $this->fileglob( $_, $pat, 'f', $clear::find, 1 ) );
            }
            push(
                @{ $this->{'dialog'} },
                'データベースを消去しました。'
            );

        }
        else {
            push(
                @{ $this->{'dialog'} },
                '消去対象が指定されていません。'
            );

        }
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>データベースの消去</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="clear" />';

    $this->print_db_selector;

    print '<fieldset class="delete">';
    print
        '<label><input type="checkbox" name="backup" value="1" checked="checked" /> バックアップファイルも消去する</label>';
    print
        ' <input type="submit" value="データベースを完全に消去する" onclick="return confirm(\'この操作は取り消せません。本当にデータベースを消去しますか？\');" />';
    print '</fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');

}

######################################################################
# 消去対象DB取得
sub db ($) {
    my $this = shift;
}

######################################################################
# 消去対象選択メニュー
sub print_db_selector ($) {
    my $this = shift;
}

1;
