package General;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
use utf8;
######################################################################
# 一般設定モジュール
# General.pm ver1.1.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-12-12
######################################################################
# 設定チェック項目取得
sub get_setting_items ($) {
    my $this = shift;

    $this->get_sub_setting_items;

    #チェックボックス
    push( @check::checkbox, 'notforwindowtitle' );
    push( @check::checkbox, 'lastModifiedHeaderEnabled' )
        if $this->is_database_cgi;

    #メール書式チェック
    $check::email{'master'} = '管理人アドレス';

    #複数メール書式チェック
    $check::emails{'owners'} = '共同オーナーアドレス';
    $check::emails{'staff'}  = 'スタッフアドレス';

}

######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    return;
}

######################################################################
# 設定環境
sub set_preferences ($) {
    no warnings qw(once);
    my $this = shift;
    $preference::db   = 'general';         # 記録用データベース名
    $preference::id   = '';                # データキー
    $preference::name = '一般設定';    # 設定パネル名
    $preference::title
        = '管理人名などプログラム全体に関わる設定をします。';
    $this->sub_set_preferences;
}

######################################################################
# 設定環境2
sub sub_set_preferences ($) {
    my $this = shift;
    return;
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;

    print '<fieldset><legend>基本情報</legend>';
    print '<table class="field-table"><tbody>';
    print( ( !$this->ogtype_disabled ) ? '<tr>' : '<tr class="tbody-end">' );
    print
        '<td class="field-name"><label for="data:cginame">タイトル</label></td>';
    print '<td class="field">';
    print
        '<input type="text" name="data:cginame" id="data:cginame" size="56" value="'
        . $this->escape_except_html_entity( $main::data{'cginame'} ) . '" />';
    print
        '<br /><label><input type="checkbox" name="data:notforwindowtitle" value="1"'
        . ( ( $main::data{'notforwindowtitle'} ) ? ' checked="checked"' : '' )
        . ' />ウィンドウタイトルに使用しない</label>';
    print '</td>';
    print '</tr>';

    if ( !$this->ogtype_disabled ) {
        print '<tr class="tbody-end">';
        print
            '<td class="field-name"><label for="data:ogtype">og:type</label></td>';
        print '<td class="field">';
        require CMONOS::CGI_Lib::OGPTypeMenu;
        print OGPTypeMenu->new->menu( 'data:ogtype', $main::data{'ogtype'} );
        print '</td>';
        print '</tr>';
    }
    print '</tbody><tbody>';

    $main::data{'master'} = $main::email
        if !defined $main::data{'master'} || $main::data{'master'} eq '';

    #管理人のみ変更可能
    if ( $this->is_master || $this->is_owner ) {

        print
            '<tr class="tbody-end"><td class="field-name"><label for="data:mastername">管理人名</label></td>';
        print
            '<td class="field"><input type="text" name="data:mastername" id="data:mastername" size="56" value="'
            . $this->escape( $main::data{'mastername'} )
            . '" /></td></tr>';

        print
            '<tr><td class="field-name"><label for="data:master">管理人アドレス</label></td>';
        print
            '<td class="field"><input type="email" name="data:master" id="data:master" size="56" value="'
            . $this->escape( $main::data{'master'} )
            . '" onchange="cmonos.validate.field(this).asEMailAddress()" /></td></tr>';

        print '</tbody><tbody>';

        print
            '<tr><td class="field-name"><label for="data:owners">共同オーナーアドレス</label></td>';
        print
            '<td class="field"><textarea name="data:owners" id="data:owners" cols="56" rows="5" wrap="off">'
            . $this->escape( $main::data{'owners'} )
            . '</textarea>';
        print
            '<div class="note">共同オーナーが複数の時はカンマ（+改行）で区切ります。</div></td></tr>';

        print
            '<tr class="tbody-end"><td class="field-name"><label for="data:staff">スタッフアドレス</label></td>';
        print
            '<td class="field"><textarea name="data:staff" id="data:staff" cols="56" rows="5" wrap="off">'
            . $this->escape( $main::data{'staff'} )
            . '</textarea>';
        print
            '<div class="note">スタッフが複数の時はカンマ（+改行）で区切ります。</div></td></tr>';

        print '</tbody><tbody>';

        print
            '<tr><td class="field-name"><label for="data:postMethod">送信メソッド</label></td>';
        print '<td class="field">';
        print $this->mk_select_menu(
            'data:postMethod', '', '', $main::data{'postMethod'},
            '0' => 'できるだけ GET で送信する',
            '1' => '常に POST で送信する'
        );
        print '</td></tr>';

        if ( $this->is_database_cgi ) {
            if ($default::static) {
                print
                    '<tr><td class="field-name"><span class="datatitle">meta タグ</span></td><td class="field">';
                print
                    '<label><input type="checkbox" name="data:lastModifiedHeaderEnabled" value="1"'
                    . ( ( $main::data{'lastModifiedHeaderEnabled'} )
                    ? ' checked="checked"'
                    : '' )
                    . ' /> &lt;meta http-equiv="Last-Modified"&gt; を出力する</label>';
                print '</td></tr>';
            }
            else {
                print
                    '<tr><td class="field-name"><span class="datatitle">HTTP ヘッダ</span></td><td class="field">';
                print
                    '<label><input type="checkbox" name="data:lastModifiedHeaderEnabled" value="1"'
                    . ( ( $main::data{'lastModifiedHeaderEnabled'} )
                    ? ' checked="checked"'
                    : '' )
                    . ' /> Last-Modified ヘッダを出力する</label>';
                print '</td></tr>';
            }
        }

        print '</tbody></table></fieldset>';
        $this->print_sub_preference_panel(1);

    }
    else {
        my $owners = $this->escape( $main::data{'owners'} );
        $owners =~ s/[\x0A\x0D,]+/<br \/>/g;
        my $staff = $this->escape( $main::data{'staff'} );
        $staff =~ s/[\x0A\x0D,]+/<br \/>/g;

        print
            '<tr><td class="field-name"><span class="datatitle">管理人名</span></td><td class="field">'
            . $this->escape( $main::data{'mastername'} )
            . '</td></tr>';
        print
            '<tr><td class="field-name"><span class="datatitle">管理人アドレス</span></td><td class="field">'
            . $this->escape( $main::data{'master'} )
            . '</td></tr>';

        print '</tbody><tbody>';
        print
            '<tr><td class="field-name"><span class="datatitle">共同オーナーアドレス</span></td><td class="field">'
            . $owners
            . '</td></tr>';

        print
            '<tr class="tbody-end"><td class="field-name"><span class="datatitle">スタッフアドレス</span></td><td class="field">'
            . $staff
            . '</td></tr>';

        print '</tbody><tbody>';

        print
            '<tr><td class="field-name"><span class="datatitle">送信メソッド</span></td><td class="field">';
        if ( defined $main::data{'postMethod'} && $main::data{'postMethod'} )
        {
            print '常に POST で送信する';
        }
        else {
            print 'できるだけ GET で送信する';
        }
        print '</td></tr>';

        if ( $this->is_database_cgi ) {
            if ($default::static) {
                print
                    '<tr><td class="field-name"><span class="datatitle">meta タグ</span></td><td class="field">';
                print( ( $main::data{'lastModifiedHeaderEnabled'} )
                    ? '&lt;meta http-equiv="Last-Modified"&gt; を出力する'
                    : '&lt;meta http-equiv="Last-Modified"&gt; を出力しない'
                );
                print '</td></tr>';
            }
            else {
                print
                    '<tr><td class="field-name"><span class="datatitle">HTTP ヘッダ</span></td><td class="field">';
                print( ( $main::data{'lastModifiedHeaderEnabled'} )
                    ? 'Last-Modified ヘッダを出力する'
                    : 'Last-Modified ヘッダを出力しない' );
                print '</td></tr>';
            }
        }

        print '</tbody></table></fieldset>';
        $this->print_sub_preference_panel;

    }

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

sub ogtype_disabled ($) {
    my $this = shift;
    return 0;
}

sub is_database_cgi ($) {
    my $this = shift;
    return 0;
}

######################################################################
# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;
    return;
}

######################################################################
# 設定チェック
sub is_valid_setting ($) {
    my $this = shift;
    delete $main::data{'ogtype'}
        if $this->ogtype_disabled || $main::data{'ogtype'} =~ /[^a-z]/;
    if ( $this->is_master || $this->is_owner ) {
        $main::data{'master'}
            = ( ( defined $main::email ) ? $main::email : '' )
            if !defined $main::data{'master'} || $main::data{'master'} eq '';
        $this->escape_except_html_entity( \$main::data{'cginame'} );
        $main::data{'cginame'} = $default::lib
            if !defined $main::data{'cginame'}
            || $main::data{'cginame'} eq '';

        if (!grep( $default::lib eq $_,
                'GateKeeper',     'NaviMaker',
                'SetupAssistant', 'MaintenanceStation',
                'ZipCodeSearch' )
            )
        {
            my ( %general, $t, $update );
            use Fcntl qw(:DEFAULT);
            eval 'use ' . $env::dbm_file . ';';
            tie(%general, $env::dbm_file,
                $default::preference_dir . '/general',
                O_RDWR | O_CREAT,
                $env::dbm_mode
            );
            if (ref tied %general
                && ($this->decode_utf8( $general{'cginame'} ) ne
                    $main::data{'cginame'}
                    || ( defined $general{'description'}
                        && $this->decode_utf8( $general{'description'} ) ne
                        $main::data{'description'} )
                )
                )
            {
                $t = time;
                $general{'cginame'}
                    = $this->encode_utf8( $main::data{'cginame'} );
                $general{'notforwindowtitle'} = $this->encode_utf8(
                    ( $main::data{'notforwindowtitle'} ) ? 1 : 0 );
                $general{'description'}
                    = $this->encode_utf8( $main::data{'description'} )
                    if $general{'description'}
                    && defined $main::data{'description'};
            }
            $update = 1 if $t || $this->navidata_is_changed( \%general );
            untie %general;
            if ($update) {
                require CMONOS::CGI_Lib::NavUpdate;
                NavUpdate->new->scan->update;
            }
            if ($t) {
                my $javascript = <<JAVA;
cmonos.tool.refreshNavi = function () {
	if (parent.tool_navi) {
		parent.tool_navi.location.href = parent.tool_navi.location.href + '?mode=tool&amp;stamp=$t';
	}
};
JAVA
                $this->set_onload('cmonos.tool.refreshNavi()');
                $this->set_javascript($javascript);
            }
        }

    }
    else {
        delete $main::data{'cginame'};
        delete $main::data{'mastername'};
        delete $main::data{'master'};
        delete $main::data{'owners'};
        delete $main::data{'staff'};
    }
    $this->_is_valid_setting;
    return;
}

sub navidata_is_changed ($$) {
    my ( $this, $db ) = @_;
    return 0;
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    return;
}

1;
