package Security;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# アクセス権設定モジュール
# Security.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;

    #全体編集書き込み
    if ( defined $main::a && $main::a eq 'w' ) {

        #不正なデータの除去
        my ( $k, $v );
        while ( ( $k, $v ) = each %setting::security_name ) {
            if ( defined $main::data{ $k . '_passwordCheck' } ) {
                if ((   $this->is_registered_user == 0
                        && ( $main::data{ $k . '_passwordCheck' } eq 'master'
                            || $main::data{ $k . '_passwordCheck' } eq 'owner'
                            || $main::data{ $k . '_passwordCheck' } eq
                            'owners'
                            || $main::data{ $k . '_passwordCheck' } eq 'staff'
                            || $main::data{ $k . '_passwordCheck' } eq
                            'member' )
                    )
                    || ($this->is_staff == 0
                        && ( $main::data{ $k . '_passwordCheck' } eq 'master'
                            || $main::data{ $k . '_passwordCheck' } eq 'owner'
                            || $main::data{ $k . '_passwordCheck' } eq
                            'owners'
                            || $main::data{ $k . '_passwordCheck' } eq
                            'staff' )
                    )
                    || ($this->is_one_of_owners == 0
                        && ( $main::data{ $k . '_passwordCheck' } eq 'master'
                            || $main::data{ $k . '_passwordCheck' } eq 'owner'
                            || $main::data{ $k . '_passwordCheck' } eq
                            'owners' )
                    )
                    || ($this->is_owner == 0
                        && ( $main::data{ $k . '_passwordCheck' } eq 'master'
                            || $main::data{ $k . '_passwordCheck' } eq
                            'owner' )
                    )
                    || (   $this->is_master == 0
                        && $main::data{ $k . '_passwordCheck' } eq 'master' )
                    || (%setting::security_limit
                        && ((      $setting::security_limit{$k} eq 'master'
                                && $main::data{ $k . '_passwordCheck' } ne
                                'master'
                            )
                            || ($setting::security_limit{$k} eq 'owner'
                                && ( $main::data{ $k . '_passwordCheck' } eq
                                    'nocheck'
                                    || $main::data{ $k . '_passwordCheck' }
                                    eq 'member'
                                    || $main::data{ $k . '_passwordCheck' }
                                    eq 'staff'
                                    || $main::data{ $k . '_passwordCheck' }
                                    eq 'owners' )
                            )
                            || ($setting::security_limit{$k} eq 'owners'
                                && ( $main::data{ $k . '_passwordCheck' } eq
                                    'nocheck'
                                    || $main::data{ $k . '_passwordCheck' }
                                    eq 'member'
                                    || $main::data{ $k . '_passwordCheck' }
                                    eq 'staff' )
                            )
                            || ($setting::security_limit{$k} eq 'staff'
                                && ( $main::data{ $k . '_passwordCheck' } eq
                                    'nocheck'
                                    || $main::data{ $k . '_passwordCheck' }
                                    eq 'member' )
                            )
                            || (   $setting::security_limit{$k} eq 'member'
                                && $main::data{ $k . '_passwordCheck' } eq
                                'nocheck' )
                        )
                    )
                    )
                {
                    delete $main::data{ $k . '_passwordCheck' };
                }
            }
            $main::data{ $k . '_GoodIPCheck' } = 0
                if !defined $main::data{ $k . '_GoodIPCheck' }
                || $main::data{ $k . '_GoodIPCheck' } eq '';
            $main::data{ $k . '_BadIPCheck' } = 0
                if !defined $main::data{ $k . '_BadIPCheck' }
                || $main::data{ $k . '_BadIPCheck' } eq '';
            $main::data{ $k . '_GoodUACheck' } = 0
                if !defined $main::data{ $k . '_GoodUACheck' }
                || $main::data{ $k . '_GoodUACheck' } eq '';
            $main::data{ $k . '_BadUACheck' } = 0
                if !defined $main::data{ $k . '_BadUACheck' }
                || $main::data{ $k . '_BadUACheck' } eq '';
            $main::data{ $k . '_refererCheck' } = 0
                if !defined $main::data{ $k . '_refererCheck' }
                || $main::data{ $k . '_refererCheck' } eq '';
        }
        if ( !$this->is_master ) {
            delete $main::data{'GoodIPs'};
            delete $main::data{'BadIPs'};
            delete $main::data{'GoodUA'};
            delete $main::data{'BadUA'};
            delete $main::data{'refUrl'};
            delete $main::data{'refJump'};
            delete $main::data{'refOp'};
        }
        else {
            $main::data{'refOp'} = 0
                if !defined $main::data{'refOp'}
                || $main::data{'refOp'} eq '';
            if (   defined $main::data{'refJump'}
                && $main::data{'refJump'} ne ''
                && $this->is_invalid_url( $main::data{'refJump'} ) )
            {
                push(
                    @{ $this->{'dialog'} },
                    'ジャンプ先を更新できませんでした。URLを確認してください。'
                );
                delete $main::data{'refJump'};
            }
            $this->detag(
                \$main::data{'GoodIPs'},
                \$main::data{'BadIPs'},
                \$main::data{'refUrl'}
            );
        }
        $this->write_db( $default::preference_dir . '/security',
            \%main::data, '', '', \%setting::security, 1 );

    }
    else {
        #読み込み
        $this->import_db( $default::preference_dir . '/security',
            \%setting::security, 1 );
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print
        '<h1 title="各機能へのアクセス権限を設定します。">アクセス権設定</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="w" />';
    print '<fieldset><legend>アクセス制限設定</legend>';

    #テーブル設定
    require CMONOS::CGI_Lib::Table;
    my $table = Table->new;
    $table->set(
        'tableclass' => 'tooltable',
        'trclass'    => 'odd,even',
        'class0'     => 'odd,even',
        'style0'     => 'white-space: nowrap;text-align: center;',
        'thenabled'  => 'true',
        'classF'     => 'name'
    );

    print $table->table;

    #ヘッダ
    print $table->tr;
    print $table->td('対象');
    print $table->td('チェックレベル');
    print $table->td('接続承認IPチェック');
    print $table->td('接続拒絶IPチェック');
    print $table->td('接続承認UAチェック');
    print $table->td('接続拒絶UAチェック');
    print $table->td('リンク元チェック');
    print $table->_tr;

    #設定項目
    foreach (
        sort { $setting::security_name{$a} cmp $setting::security_name{$b} }
        keys %setting::security_name )
    {
        print $table->tr;
        print $table->td( $setting::security_name{$_} );
        print $table->td(
            $this->security_level_selector(
                $_, $setting::security{$_}{'passwordCheck'}
            )
        );
        print $table->td(
                  '<input type="checkbox" name="data:'
                . $_
                . '_GoodIPCheck" value="1"'
                . (
                (   defined $setting::security{$_}{'GoodIPCheck'}
                        && $setting::security{$_}{'GoodIPCheck'}
                ) ? ' checked="checked"' : ''
                )
                . ' />'
        );
        print $table->td(
                  '<input type="checkbox" name="data:'
                . $_
                . '_BadIPCheck" value="1"'
                . (
                (   defined $setting::security{$_}{'BadIPCheck'}
                        && $setting::security{$_}{'BadIPCheck'}
                ) ? ' checked="checked"' : ''
                )
                . ' />'
        );
        print $table->td(
                  '<input type="checkbox" name="data:'
                . $_
                . '_GoodUACheck" value="1"'
                . (
                (   defined $setting::security{$_}{'GoodUACheck'}
                        && $setting::security{$_}{'GoodUACheck'}
                ) ? ' checked="checked"' : ''
                )
                . ' />'
        );
        print $table->td(
                  '<input type="checkbox" name="data:'
                . $_
                . '_BadUACheck" value="1"'
                . (
                (   defined $setting::security{$_}{'BadUACheck'}
                        && $setting::security{$_}{'BadUACheck'}
                ) ? ' checked="checked"' : ''
                )
                . ' />'
        );
        print $table->td(
                  '<input type="checkbox" name="data:'
                . $_
                . '_refererCheck" value="1"'
                . (
                (   defined $setting::security{$_}{'refererCheck'}
                        && $setting::security{$_}{'refererCheck'}
                ) ? ' checked="checked"' : ''
                )
                . ' />'
        );
        print $table->_tr;
    }

    print $table->_table;

    print '</fieldset>';

    if ( $this->is_master ) {
        print '<fieldset><legend>IP によるアクセス制御</legend>';
        print '<table class="field-table"><tbody>';

        print
            '<tr><td class="field-name"><label for="data:GoodIPs">接続承認IP</label></td><td class="field">';
        print
            '<textarea name="data:GoodIPs" id="data:GoodIPs" cols="70" rows="3" wrap="off">'
            . $this->escape( $setting::security{'GoodIPs'} )
            . '</textarea>';
        print
            '<div class="hints">複数指定するときは改行または半角スペースで区切ります。</div>';
        print
            '<div class="hints">指定された文字列にIPが合致する場合のみ接続を許可します（正規表現可）。</div>';
        print '</td></tr>';

        print
            '<tr><td class="field-name"><label for="data:BadIPs">接続拒絶IP</label></td><td class="field">';
        print
            '<textarea name="data:BadIPs" id="data:BadIPs" cols="70" rows="3" wrap="off">'
            . $this->escape( $setting::security{'BadIPs'} )
            . '</textarea>';
        print
            '<div class="hints">複数指定するときは改行または半角スペースで区切ります。</div>';
        print
            '<div class="hints">指定された文字列にIPが合致する場合、接続を拒絶します（正規表現可）。</div>';
        print '</td></tr>';

        print '</tbody></table></fieldset>';

        print
            '<fieldset><legend>User Agent によるアクセス制御</legend>';
        print '<table class="field-table"><tbody>';

        print
            '<tr><td class="field-name"><label for="data:GoodUA">接続承認 User Agent</label></td><td class="field">';
        print
            '<textarea name="data:GoodUA" id="data:GoodUA" cols="70" rows="3" wrap="off">'
            . $this->escape( $setting::security{'GoodUA'} )
            . '</textarea>';
        print
            '<div class="hints">複数指定するときは改行または半角スペースで区切ります。</div>';
        print
            '<div class="hints">指定された文字列に User Agent が合致する場合のみ接続を許可します（正規表現可）。</div>';
        print '</td></tr>';

        print
            '<tr><td class="field-name"><label for="data:BadUA">接続拒絶 User Agent</label></td><td class="field">';
        print
            '<textarea name="data:BadUA" id="data:BadUA" cols="70" rows="3" wrap="off">'
            . $this->escape( $setting::security{'BadUA'} )
            . '</textarea>';
        print
            '<div class="hints">複数指定するときは改行または半角スペースで区切ります。</div>';
        print
            '<div class="hints">指定された文字列に User Agent が合致する場合、接続を拒絶します（正規表現可）。</div>';
        print '</td></tr>';

        print '</tbody></table></fieldset>';

        print
            '<fieldset><legend>リンク元 URL によるアクセス制御</legend>';
        print '<table class="field-table"><tbody>';

        print
            '<tr><td class="field-name"><label for="data:refUrl">リンク元 URL 指定</label></td><td class="field">';
        print
            '<textarea name="data:refUrl" id="data:refUrl" cols="70" rows="3" wrap="off">'
            . $this->escape( $setting::security{'refUrl'} )
            . '</textarea>';
        print
            '<div class="hints">複数指定するときは改行または半角スペースで区切ります。</div>';
        print
            '<div class="hints">指定された文字列にリンク元 URL が合致しない場合、接続を拒絶します（フルパス/正規表現可）。</div>';
        print '</td></tr>';

        print
            '<tr><td class="field-name"><label for="data:refJump">ジャンプ先 URL</label></td><td class="field">';
        print
            '<input type="text" name="data:refJump" id="data:refJump" size="70" value="'
            . $this->escape( $setting::security{'refJump'} ) . '" />';
        print
            '<div class="hints">不正なリンク元 URL の場合にジャンプする URL を指定します（フルパス）。</div>';
        print
            '<div class="hints">ジャンプ先が設定されていない場合、ユーザーディレクトリの最上層に設定されます。</div>';
        print '</td></tr>';

        print
            '<tr><td class="field-name"><input type="checkbox" name="data:refOp" id="data:refOp"  value="1"'
            . (
            (   defined $setting::security{'refOp'}
                    && $setting::security{'refOp'}
            ) ? ' checked="checked"' : ''
            ) . ' /></td><td class="field">';
        print
            '<label for="data:refOp">リンク元 URL 情報が取得できないときは接続を許可する。</label></td></tr>';
        print '</tbody></table></fieldset>';

    }
    else {
        print '<fieldset><legend>IP によるアクセス制御</legend>';
        print '<table class="field-table"><tbody>';

        print
            '<tr><td class="field-name"><span class="datatitle">接続承認IP</span></td><td class="field">';
        if ( defined $setting::security{'GoodIPs'}
            && $setting::security{'GoodIPs'} )
        {
            print $this->escape(
                $this->tag_to_lf( $setting::security{'GoodIPs'} ) )
                . "\x0A";
        }
        else {
            print '設定されていません。';
        }
        print '</td></tr>';

        print
            '<tr><td class="field-name"><span class="datatitle">接続拒絶IP</span></td><td class="field">';
        if ( defined $setting::security{'BadIPs'}
            && $setting::security{'BadIPs'} )
        {
            print $this->escape(
                $this->tag_to_lf( $setting::security{'BadIPs'} ) )
                . "\x0A";
        }
        else {
            print '設定されていません。';
        }
        print '</td></tr>';

        print '</tbody></table></fieldset>';
        print
            '<fieldset><legend>リンク元 URL によるアクセス制御</legend>';
        print '<table class="field-table"><tbody>';

        print
            '<tr><td class="field-name"><span class="datatitle">リンク元指定</span></td><td class="field">';
        if ( defined $setting::security{'refUrl'}
            && $setting::security{'refUrl'} )
        {
            print $this->escape(
                $this->tag_to_lf( $setting::security{'refUrl'} ) )
                . "\x0A";
        }
        else {
            print '設定されていません。';
        }
        print
            '<div class="hints">リンク元 URL が取得できない場合は接続を許可します。</div>'
            if defined $setting::security{'refOp'}
            && $setting::security{'refOp'};
        print '</td></tr>';

        print
            '<tr><td class="field-name"><span class="datatitle">ジャンプ先 URL</span></td><td class="field">';
        if ( defined $setting::security{'refJump'}
            && $setting::security{'refJump'} )
        {
            print $setting::security{'refJump'};
        }
        else {
            print 'ユーザーディレクトリ最上層';
        }
        print '</td></tr>';

        print '</tbody></table></fieldset>';
    }

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');

}

######################################################################
# 選択肢
sub security_level_selector ($$$) {
    my ( $this, $id, $default ) = @_;
    my ($menu);
    $default = '' if !defined $default;
    $menu
        .= '<select name="data:'
        . $id
        . '_passwordCheck" id="data:'
        . $id
        . '_passwordCheck">';
    if ( $this->is_master ) {
        $menu
            .= '<option value="master"'
            . ( ( $default eq 'master' ) ? ' selected="selected"' : '' )
            . '>マスターパスワード</option>';
    }
    elsif ( $default eq 'master' ) {
        return '';
    }
    if ( $this->is_owner ) {
        $menu
            .= '<option value="owner"'
            . ( ( $default eq 'owner' ) ? ' selected="selected"' : '' )
            . '>管理人パスワード</option>'
            if !%setting::security_limit
            || !$setting::security_limit{$id}
            || $setting::security_limit{$id} ne 'master';
    }
    elsif ( $default eq 'master' || $default eq 'owner' ) {
        return '';
    }
    if ( $this->is_one_of_owners ) {
        $menu
            .= '<option value="owners"'
            . ( ( $default eq 'owners' ) ? ' selected="selected"' : '' )
            . '>共同オーナーパスワード</option>'
            if !%setting::security_limit
            || !$setting::security_limit{$id}
            || ( $setting::security_limit{$id} ne 'master'
            && $setting::security_limit{$id} ne 'owner' );
    }
    elsif ($default eq 'master'
        || $default eq 'owner'
        || $default eq 'owners' )
    {
        return '';
    }
    if ( $this->is_staff ) {
        $menu
            .= '<option value="staff"'
            . ( ( $default eq 'staff' ) ? ' selected="selected"' : '' )
            . '>スタッフパスワード</option>'
            if !%setting::security_limit
            || !$setting::security_limit{$id}
            || ( $setting::security_limit{$id} ne 'master'
            && $setting::security_limit{$id} ne 'owner'
            && $setting::security_limit{$id} ne 'owners' );
    }
    elsif ($default eq 'master'
        || $default eq 'owner'
        || $default eq 'owners'
        || $default eq 'staff' )
    {
        return '';
    }
    if ( $this->is_registered_user ) {
        $menu
            .= '<option value="member"'
            . ( ( $default eq 'member' ) ? ' selected="selected"' : '' )
            . '>登録パスワード</option>'
            if !%setting::security_limit
            || !$setting::security_limit{$id}
            || ( $setting::security_limit{$id} ne 'master'
            && $setting::security_limit{$id} ne 'owner'
            && $setting::security_limit{$id} ne 'owners'
            && $setting::security_limit{$id} ne 'staff' );
    }
    elsif ($default eq 'master'
        || $default eq 'owner'
        || $default eq 'owners'
        || $default eq 'staff'
        || $default eq 'member' )
    {
        return '';
    }
    $menu
        .= '<option value="nocheck"'
        . ( ( $default eq 'nocheck' ) ? ' selected="selected"' : '' )
        . '>チェックなし</option>'
        if !%setting::security_limit || !$setting::security_limit{$id};

    $menu .= '</select>';
    return $menu;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( '0001', 'Security' );

    #メニュー登録
    $setting::jump_menu{'0001'} = 'アクセス権設定';
}

1;
