package VicunaSkinManager;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# Vicuna 専用 CSS スキン設定モジュール
# VicunaSkinManager.pm ver1.0.2
# Copyright (C) 2008-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-03-18
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    if ( -f $env::css . '/vicuna/0-import.css' ) {
        $this->{'eyecatch_path'} = $env::css . '/vicuna/images/eyeCatch';
        $this->skin_manager_for_original;
    }
    else {
        $this->{'eyecatch_path'} = $env::css . '/vicuna/images/eyecatch';
        $this->skin_manager;
    }
}

sub skin_manager ($) {
    my $this = shift;
    my ($layouts_css,               $eyecatch_header_name,
        $eyecatch_header_link_name, $eyecatch_main_name,
        $eyecatch_content_name
    );
    local (*DIR);
    $layouts_css = $this->read_file( $env::css . '/vicuna/layouts.css', 1 );
    $eyecatch_header_name = $this->get_eyecatch_name( \$layouts_css, 'h' );
    $eyecatch_header_link_name
        = $this->get_eyecatch_name( \$layouts_css, 'hb' );
    $eyecatch_main_name    = $this->get_eyecatch_name( \$layouts_css, 'm' );
    $eyecatch_content_name = $this->get_eyecatch_name( \$layouts_css, 'c' );

    if ($main::w) {
        my $r
            = ( $layouts_css =~ /\x0D\x0A/s ) ? "\x0D\x0A"
            : ( $layouts_css =~ /\x0D/s ) ? "\x0D"
            :                               "\x0A";
        my $eyecatch_image_updated = 0;
        $eyecatch_image_updated = 1
            if $main::eyecatch_header
            && $this->update_eyecatch_image( 'header',
            \$eyecatch_header_name, 1 );
        $eyecatch_image_updated = 1
            if $main::eyecatch_header_link
            && $this->update_eyecatch_image( 'header_link',
            \$eyecatch_header_link_name, 1, 'リンク付き header' );
        $eyecatch_image_updated = 1
            if $main::eyecatch_main
            && $this->update_eyecatch_image( 'main', \$eyecatch_main_name,
            1 );
        $eyecatch_image_updated = 1
            if $main::eyecatch_content
            && $this->update_eyecatch_image( 'content',
            \$eyecatch_content_name, 1 );
        if ($eyecatch_image_updated) {
            $this->replace_eyecatch_style( \$layouts_css, 'h',
                $eyecatch_header_name )
                if $main::eyecatch_header;
            $this->replace_eyecatch_style( \$layouts_css, 'hb',
                $eyecatch_header_link_name )
                if $main::eyecatch_header_link;
            $this->replace_eyecatch_style( \$layouts_css, 'm',
                $eyecatch_main_name )
                if $main::eyecatch_main;
            $this->replace_eyecatch_style( \$layouts_css, 'c',
                $eyecatch_content_name )
                if $main::eyecatch_content;
            $this->write_file( $env::css . '/vicuna/layouts.css',
                \$layouts_css, 1 );
        }
    }

    #ページヘッダ
    $this->jump_menu( 'tools', 'vicuna' );
    $this->print_page_header('tools');

    print '<h1>Vicuna スキン設定</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'multi'    => 1,
        'required' => \@setting::form
    );
    print '<input type="hidden" name="w" value="1" />';
    print '<fieldset><legend>EyeCatch 画像の変更</legend>';
    $this->print_eyecatch_image_field( 'header', $eyecatch_header_name );
    $this->print_eyecatch_image_field( 'header_link',
        $eyecatch_header_link_name, 'リンク付き header' );
    $this->print_eyecatch_image_field( 'main',    $eyecatch_main_name );
    $this->print_eyecatch_image_field( 'content', $eyecatch_content_name );
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="画像を変更する" /></fieldset>';

    print '</form>';
    print '<p>Powered by Vicuna CMS</p>';

    #ページフッタ
    $this->print_page_footer('tools');

}

sub skin_manager_for_original ($) {
    my $this = shift;
    if ( $main::module && !@main::module ) {
        @main::module = ($main::module);
        undef $main::module;
    }
    my ($eyecatch_header_name, $eyecatch_long_name,
        $eyecatch_mini_name,   $eyecatch_short_name
    );
    local (*DIR);
    if ( opendir( DIR, $this->{'eyecatch_path'} ) ) {
        my @images
            = grep( $_ !~ /^\./ && -f $this->{'eyecatch_path'} . '/' . $_,
            readdir(DIR) );
        closedir(DIR);
        $eyecatch_header_name
            = ( grep( $_ =~ /^header\.[0-9a-zA-Z_]+$/, @images ) )[0]
            if grep( $_ =~ /^header\.[0-9a-zA-Z_]+$/, @images );
        $eyecatch_long_name
            = ( grep( $_ =~ /^long\.[0-9a-zA-Z_]+$/, @images ) )[0]
            if grep( $_ =~ /^long\.[0-9a-zA-Z_]+$/, @images );
        $eyecatch_mini_name
            = ( grep( $_ =~ /^mini\.[0-9a-zA-Z_]+$/, @images ) )[0]
            if grep( $_ =~ /^mini\.[0-9a-zA-Z_]+$/, @images );
        $eyecatch_short_name
            = ( grep( $_ =~ /^short\.[0-9a-zA-Z_]+$/, @images ) )[0]
            if grep( $_ =~ /^short\.[0-9a-zA-Z_]+$/, @images );
    }
    if ($main::w) {
        my $data = $this->read_file( $env::css . '/vicuna/5-module.css', 1 );
        my $r
            = ( $data =~ /\x0D\x0A/s ) ? "\x0D\x0A"
            : ( $data =~ /\x0D/s ) ? "\x0D"
            :                        "\x0A";
        $data =~ s{
		(/\*[\x09\x0A\x0C\x0D\x20]*|)\@import[\x09\x0A\x0C\x0D\x20]+url\(["']?(.*?)["']?\);([\x09\x0A\x0C\x0D\x20]*\*/|)
	}{
		(grep($_ eq $2,@main::module)) ? '@import url(\'' . $2 . '\');' : '/*' . $r . $r . '@import url(\'' . $2 . '\');' . $r . $r . '*/'
	}gex;
        $this->write_file( $env::css . '/vicuna/5-module.css', \$data, 1 );

        my $eyecatch_image_updated = 0;
        $eyecatch_image_updated = 1
            if $main::eyecatch_header
            && $this->update_eyecatch_image( 'header',
            \$eyecatch_header_name );
        $eyecatch_image_updated = 1
            if $main::eyecatch_long
            && $this->update_eyecatch_image( 'long', \$eyecatch_long_name );
        $eyecatch_image_updated = 1
            if $main::eyecatch_mini
            && $this->update_eyecatch_image( 'mini', \$eyecatch_mini_name );
        $eyecatch_image_updated = 1
            if $main::eyecatch_short
            && $this->update_eyecatch_image( 'short', \$eyecatch_short_name );

        if ($eyecatch_image_updated) {
            foreach my $css (
                'mod_eyeCatch-header.css', 'mod_eyeCatch-long.css',
                'mod_eyeCatch-mini.css',   'mod_eyeCatch-short.css'
                )
            {
                my $data
                    = $this->read_file( $env::css . '/vicuna/module/' . $css,
                    1 );
                $data
                    =~ s!/header.(gif|jpg|jpeg|png)!/$eyecatch_header_name!gi
                    if $eyecatch_header_name;
                $data =~ s!/long.(gif|jpg|jpeg|png)!/$eyecatch_long_name!gi
                    if $eyecatch_long_name;
                $data =~ s!/mini.(gif|jpg|jpeg|png)!/$eyecatch_mini_name!gi
                    if $eyecatch_mini_name;
                $data =~ s!/short.(gif|jpg|jpeg|png)!/$eyecatch_short_name!gi
                    if $eyecatch_short_name;
                $this->write_file( $env::css . '/vicuna/module/' . $css,
                    \$data, 1 );
            }
        }
        $cgi::input->clear_clipboard;
    }

    #ページヘッダ
    $this->jump_menu( 'tools', 'vicuna' );
    $this->print_page_header('tools');

    print '<h1>Vicuna スキン設定</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'multi'    => 1,
        'required' => \@setting::form
    );
    print '<input type="hidden" name="w" value="1" />';
    print '<fieldset><legend>モジュールの読み込み</legend>';
    my $data = $this->read_file( $env::css . '/vicuna/5-module.css', 1 );

    if ($data) {
        my %module_name;
        my %module_enabled;
        my @modules;
        while ( $data
            =~ m!/\*-+[\x09\x0A\x0C\x0D\x20]+(.*?)[\x09\x0A\x0C\x0D\x20]+-+\*/(.*?)[\x09\x0A\x0C\x0D\x20](?=(/\*-+|\Z))!sg
            )
        {
            my ( $name, $import ) = ( $1, $2 );
            $module_name{$1} = $name
                if $import
                =~ /\@import[\x09\x0A\x0C\x0D\x20]+url\(["']?(.*?)["']?\);/;
        }
        while ( $data
            =~ m!(/\*|)[\x09\x0A\x0C\x0D\x20]*\@import[\x09\x0A\x0C\x0D\x20]+url\(["']?(.*?)["']?\);[\x09\x0A\x0C\x0D\x20]*(\*/|)!sg
            )
        {
            my $url = $2;
            push( @modules, $url );
            $module_enabled{$url} = ( $1 && $3 ) ? 0 : 1;
            $module_name{$url} = $1
                if !$module_name{$url} && $url =~ m!/([^/]*?)\.css$!i;
        }
        if (@modules) {
            print '<ol class="checkbox">';
            foreach my $url (@modules) {
                $module_name{$url} =~ s/[\x0A\x0D]+/<br \/>/gs;
                print
                    '<li><label><input type="checkbox" name="module" value="'
                    . $this->escape($url) . '"'
                    . (
                    ( $module_enabled{$url} ) ? ' checked="checked"' : '' )
                    . ' /> '
                    . $module_name{$url}
                    . '</label></li>';
            }
            print '</ol>';
        }
    }
    undef $data;
    print '</fieldset>';

    print '<fieldset><legend>EyeCatch 画像の変更</legend>';
    $this->print_eyecatch_image_field( 'header', $eyecatch_header_name );
    $this->print_eyecatch_image_field( 'long',   $eyecatch_long_name );
    $this->print_eyecatch_image_field( 'mini',   $eyecatch_mini_name );
    $this->print_eyecatch_image_field( 'short',  $eyecatch_short_name );
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="設定を変更する" /></fieldset>';

    print '</form>';
    print '<p>Powered by Vicuna CMS</p>';

    #ページフッタ
    $this->print_page_footer('tools');

}

sub update_eyecatch_image ($$$;$$) {
    my ( $this, $name, $image_file_ref, $keep_file, $title ) = @_;
    my $input_name = 'eyecatch_' . $name;
    my ( $width, $height, $ext )
        = $cgi::Image->input_info( $cgi::input, $input_name );
    if ($ext) {
        unlink $this->{'eyecatch_path'} . '/' . $$image_file_ref
            if !$keep_file;
        $cgi::input->save_file(
            $input_name, '!' . $name,
            '', '', $this->{'eyecatch_path'},
        );
        $$image_file_ref = $name . '.' . $ext;
        return 1;
    }
    else {
        push(
            @{ $this->{'dialog'} },
            ( ($title) ? $title : $name )
                . '画像を更新できませんでした。ファイルタイプを確認してください。'
        );
        return 0;
    }
}

sub print_eyecatch_image_field ($$$$;$) {
    my ( $this, $image_name, $image_file, $title ) = @_;
    my $input_name = 'eyecatch_' . $image_name;
    print '<fieldset><legend><label for="'
        . $input_name
        . '">EyeCatch '
        . ( ($title) ? $title : $image_name )
        . '</label></legend>';
    print '<input type="file" id="'
        . $input_name
        . '" name="'
        . $input_name . '" />';
    if ($image_file) {
        print '<div class="sample-image">';
        print $cgi::Image->tag(
            $this->{'eyecatch_path'} . '/' . $image_file,
            0, '現在の ' . ( ($title) ? $title : $image_name ) . ' 画像',
            '', 640, 160
        );
        print '<br />現在の '
            . ( ($title) ? $title : $image_name )
            . ' 画像</div>';
    }
    print '</fieldset>';
}

sub get_eyecatch_name ($$$) {
    my ( $this, $css_ref, $type ) = @_;
    pos($$css_ref) = 0;
    while (
        $$css_ref =~ /[\x09\x0A\x0C\x0D\x20]+body\.eye-$type .*?\{(.*?)\}/sg )
    {
        my $style = $1;
        return $1
            if $style
            =~ /[\x09\x0A\x0C\x0D\x20]background-image:[\x09\x0A\x0C\x0D\x20]*url\(["']?.*?\/([0-9a-zA-Z_\.\-]+)["']?\)/
            || $style
            =~ /[\x09\x0A\x0C\x0D\x20]background:[^;]*url\(["']?.*?\/([0-9a-zA-Z_\.\-]+)["']?\)/;
    }
    return '';
}

sub replace_eyecatch_style ($$$) {
    my ( $this, $css_ref, $type, $name ) = @_;
    my $url = './images/eyecatch/' . $name;
    $$css_ref
        =~ s/([\x09\x0A\x0C\x0D\x20]+body\.eye-$type .*?\{)(.*?)(\})/$1 . $this->_replace_eyecatch_path($2,$url) . $3/seg;
}

sub _replace_eyecatch_path ($$$) {
    my ( $this, $style, $url ) = @_;
    return $style if !$url;
    $style
        =~ s/([\x09\x0A\x0C\x0D\x20]background-image:[\x09\x0A\x0C\x0D\x20]*url\().*?(\);)/$1"$url"$2/sg;
    $style
        =~ s/([\x09\x0A\x0C\x0D\x20]background:[^;]*url\().*?(\))/$1"$url"$2/sg;
    return $style;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);
    unless ( defined $default::subdivided
        && defined $main::c
        && $default::subdivided
        && $main::c ne '' )
    {
        Common::class_register( '01v0', 'VicunaSkinManager' );

        #登録
        if (   -f $env::css . '/vicuna/0-import.css'
            || -f $env::css . '/vicuna/import.css' )
        {
            $setting::jump_menu{'01v0'} = 'Vicuna スキン設定(共通)';
            $setting::sub_jump_menu{'vicuna'}{'01v0'}
                = 'Vicuna スキン設定(共通)';
            $setting::selected_jump_menu{'01v0'} = '01v0'
                ; #サブメニューがあるときメインメニューのデフォルトキー
        }

    }
}

1;
