package UserGeneratedFieldUpdaterBase;
require CMONOS::CGI_Lib::AjaxSetUp;
@ISA = qw(AjaxSetUp);
use strict;
use utf8;
######################################################################
# ユーザー作成フィールド更新モジュール
# UserGeneratedFieldUpdaterBase.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-09-27
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->error404
        if !defined $main::id
        || $main::id eq ''
        || !ref $field::obj{$main::id}
        || !$field::obj{$main::id}->update_enabled;
    if ( !$field::obj{$main::id}->is_secure_user_for_update ) {
        my $msg
            = ($default::english)
            ? 'Authorization Error.'
            : '書き込み権限がありません。';
        if ($main::js) {
            $this->print_http_header('text/javascript');
        }
        elsif ($main::ajax) {
            $this->print_response(
                {   'status'  => 'error',
                    'message' => $msg
                }
            );
        }
        else {
            $this->print_http_header;
            print '<html><head>';
            print
                '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" /></head>';
            print '<body onload="alert(\''
                . $msg
                . '\');history.back();"><a href="javascript:void(0)" onclick="history.back();">'
                . ( ($default::english) ? 'Back.' : '戻る' )
                . '</a></body></html>';
        }
    }
    elsif ($main::js) {
        $field::obj{$main::id}->update;
        $this->print_http_header('text/javascript');
    }
    elsif ($main::ajax) {
        $this->print_response( $field::obj{$main::id}->update(1) );
    }
    elsif ( $field::obj{$main::id}->update ) {
        my $url
            = $field::obj{$main::id}->get_viewer_url( $main::c, $main::n );
        $this->print_http_header;
        print '<html><head><meta http-equiv="Refresh" content="0; URL='
            . $url . '" />';
        print
            '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" /></head>';
        print '<body'
            . $this->mk_alert_form_dialog
            . '><a href="'
            . $url . '">'
            . ( ($default::english) ? 'Back.' : '戻る' )
            . '</a></body></html>';
    }
    else {
        my $url
            = $field::obj{$main::id}->get_viewer_url( $main::c, $main::n );
        $this->print_http_header;
        print '<html><head>';
        print
            '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" /></head>';
        print '<body'
            . $this->mk_alert_form_dialog('history.back();')
            . '><a href="javascript:void(0)" onclick="history.back();">'
            . ( ($default::english) ? 'Back.' : '戻る' ) . '</a>';
        print '<noscript><a href="'
            . $url . '">'
            . ( ($default::english) ? 'Back.' : '戻る' )
            . '</a></noscript>';
        print '</body></html>';
    }
}

sub mk_alert_form_dialog ($;$) {
    my ( $this, $js2 ) = @_;
    my $js = '';
    foreach my $alert ( $this->dialog ) {
        next if !defined $alert || $alert eq '';
        $alert =~ s/["']//g;
        $js .= "alert('$alert');";
    }
    $js .= $js2 if $js2;
    return ($js) ? ' onload="' . $js . '"' : '';
}

######################################################################
# モジュール読み込み
#sub import {
BEGIN {
    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    $setting::security_key                                = 'ugfieldupdater';
    $setting::key                                         = 'ugfieldupdater';
    $setting::security{'ugfieldupdater'}{'passwordCheck'} = 'nocheck';
    $main::k                                              = 'ugfieldupdater';

    $setting::general  = 1;     #一般設定読み込み
    $setting::deco     = 1;     #テキスト装飾設定読み込み
    $setting::security = 1;     #アクセス権設定読み込み
    $setting::table    = 1;     #テーブル設定読み込み
    $setting::page     = 0;     #ページ設定読み込み

    #フィールド読み込み設定
    $setting::field_db_name = 'inputfield'
        if !$setting::field_db_name;    #フィールド設定DB
    $setting::field = 2
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 0
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled
        = 'no'; #tag=タグのみ/all=全ての設定/no=タグをつけない

}

1;
