package CalWeeklyView;
require CMONOS::Calendar::CalDayView;
@ISA = qw(CalDayView);
use strict;
use utf8;
######################################################################
# カレンダー週表示モジュール
# CalWeeklyView.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# オブジェクト作成
sub new ($) {
    my $pkg  = shift;
    my $this = {};
    bless $this, $pkg;
    return $this;
}

sub get_target_dates ($$) {
    my ( $this, $date ) = @_;
    if ( $date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})$/ ) {
        my ( $y, $m, $d ) = ( $1, $2 + 0, $3 + 0 );
        my @dates = ();
        $d -= $this->get_wday( $y, $m, $d );
        if ( $d < 1 ) {
            if ( $m == 1 ) {
                $y--;
                $m = 12;
            }
            else {
                $m--;
            }
            $d += $this->get_last_mday( $y, $m );
        }
        my $dt = $y . sprintf( "%.2d", $m ) . sprintf( "%.2d", $d );
        push( @dates, $dt );
        for ( my $i = 1; $i < 7; $i++ ) {
            $dt = $this->get_next_date( $dt, 1 );
            push( @dates, $dt );
        }
        return @dates;
    }
    else {
        return ();
    }
}

sub prev_calendar_date ($$) {
    my ( $this, $date ) = @_;
    return $this->get_prev_date( $date, 7 );
}

sub next_calendar_date ($$) {
    my ( $this, $date ) = @_;
    return $this->get_next_date( $date, 7 );
}

sub page_title ($$) {
    my ( $this, $date ) = @_;
    if ( $date =~ /^([0-9]{4})([0-9]{2})([0-9]{2})$/ ) {
        my ( $y, $m, $d ) = ( $1, $2 + 0, $3 + 0 );
        my $w = int( ( $d + $this->get_wday( $y, $m, 1 ) ) / 7 ) + 1;
        return $y . '年' . $m . '月 第' . $w . '週';
    }
    return '';
}

sub calendar_type ($) {
    my $this = shift;
    return 'weekly';
}

sub day_limit ($) {
    my $this = shift;
    return 7;
}

sub have_timetable ($) {
    my $this = shift;
    return 1;
}

1;
