package DetailPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
no warnings qw(once);
######################################################################
# 詳細ページ設定モジュール
# DetailPage.pm ver1.2.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2016-05-26
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    no warnings qw(once);
    my $this = shift;

    #チェックボックス
    push( @check::checkbox, 'fieldTitleOption' );

    #数字チェック
    $check::num{'fieldTitleWidth'} = '項目名幅';
    $check::num{'fieldWidth'}      = '項目幅';
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    no warnings qw(once);
    my $this = shift;
    $preference::id = 'detail';    # データキー
    $preference::name
        = '詳細表示ページレイアウト';    # 設定パネル名
    $preference::title
        = '詳細表示ページのレイアウトについて設定します。';
    require CMONOS::CGI_Lib::Deco;
    $this->{'icon_obj'} = Deco->new( $env::image_dir . '/calendar',
        $env::image_lib . '/calendar' );
}

######################################################################
# 設定パネル
sub _print_header_tool ($) {
    my $this = shift;
    return
        '<option value="&lt;!--date format=&quot;&quot;--&gt;&lt;!--/date--&gt;">日付 (&lt;!--date--&gt;)</option><option value="&lt;!--return--&gt;&lt;!--/return--&gt;">戻るリンク (&lt;!--return--&gt;)</option>';
}

sub print_sub_preference_panel ($;$$) {
    my ( $this, $id, $key ) = @_;
    print '<fieldset>';
    print '<legend>詳細表示ウィンドウサイズ</legend>';
    print
        '<span id="window-size-settings"><label>幅 <input type="text" name="data:detailWindowWidth" id="data:detailWindowWidth" value="'
        . $this->escape( $main::data{'detailWindowWidth'} )
        . '" size="7" maxlength="7" /> <span class="unit">ピクセル</span></label> ';
    print
        '&times; <label>高さ <input type="text" name="data:detailWindowHeight" id="data:detailWindowHeight" value="'
        . $this->escape( $main::data{'detailWindowHeight'} )
        . '" size="7" maxlength="7" /> <span class="unit">ピクセル</span></label> </span>';
    print
        '<label><input type="checkbox" name="data:detailInSameWindow" value="1"'
        . (
        (   defined $main::data{'detailInSameWindow'}
                && $main::data{'detailInSameWindow'}
        ) ? ' checked="checked"' : ''
        )
        . ' onclick="cmonos.element.item(\'window-size-settings\').disappear(this.checked);" /> 同じウィンドウで開く</label>';
    print $this->javascript(
        'cmonos.element.item(\'window-size-settings\').disappear(true);')
        if $main::data{'detailInSameWindow'};
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>詳細表示設定</legend>';
    print '<fieldset>';
    print '<legend>一覧表示設定</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'table">一覧表示テーブルタイプ</label></td>';
    print '<td class="field">';
    print $this->table_menu( 'data:' . $id . 'table',
        $main::data{ $key . 'table' } );
    print '</td>';
    print '<td><label for="data:' . $id
        . 'tableValign">一覧表示位置</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'data:' . $id . 'tableValign', '', '',
        $main::data{ $key . 'tableValign' },
        'top'    => '上',
        'bottom' => '下'
    );
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    print '<fieldset class="foldable">';
    print '<legend>項目名フレーム</legend>';
    print '<label for="data:'
        . $id
        . 'fieldTitleOption"><input type="checkbox" name="data:'
        . $id
        . 'fieldTitleOption" id="data:'
        . $id
        . 'fieldTitleOption" value="1"'
        . (
        (   defined $main::data{ $key . 'fieldTitleOption' }
                && $main::data{ $key . 'fieldTitleOption' }
        ) ? ' checked="checked"' : ''
        )
        . ' title="この設定をチェックすると下記の項目名フレーム設定は無視されます。" /> 項目名を項目フレームのタイトルバー部分に表示する</label>';
    print $cgi::Deco->frame_menu( 'data:' . $id . 'fieldTitleFrame',
        'frame', $main::data{ $key . 'fieldTitleFrame' } );
    print '<div class="additional-field"><label for="data:'
        . $id
        . 'fieldTitleWidth">項目名幅</label><input type="text" name="data:'
        . $id
        . 'fieldTitleWidth" id="data:'
        . $id
        . 'fieldTitleWidth" value="'
        . $this->escape( $main::data{ $key . 'fieldTitleWidth' } )
        . '" size="7" maxlength="7" /> <span class="unit">ピクセル</span></div>';
    print '</fieldset>';
    print '<fieldset class="foldable">';
    print '<legend>項目フレーム</legend>';
    print $cgi::Deco->frame_menu( 'data:' . $id . 'fieldFrame',
        'frame', $main::data{ $key . 'fieldFrame' } );
    print '<div class="additional-field"><label for="data:'
        . $id
        . 'fieldWidth">項目幅</label><input type="text" name="data:'
        . $id
        . 'fieldWidth" id="data:'
        . $id
        . 'fieldWidth" value="'
        . $this->escape( $main::data{ $key . 'fieldWidth' } )
        . '" size="7" maxlength="7" /> <span class="unit">ピクセル</span> ';
    print '<label for="data:' . $id
        . 'boxAlign">項目フレーム内行揃え</label>';
    print $this->mk_select_menu(
        'data:' . $id . 'boxAlign', '', '', $main::data{ $key . 'boxAlign' },
        ''       => '',
        'left'   => '左寄せ',
        'center' => '中央揃え',
        'right'  => '右寄せ'
    );
    print $this->mk_select_menu(
        'data:' . $id . 'boxValign', '', '',
        $main::data{ $key . 'boxValign' },
        ''       => '',
        'top'    => '上寄せ',
        'middle' => '中央揃え',
        'bottom' => '下寄せ'
    );
    print '</div>';
    print '</fieldset>';
    print '</fieldset>';
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );
    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new( \%field::obj );
    $this_template->print_template_form(
        'data:' . $id . 'template',
        '詳細表示テンプレート（上記詳細表示設定よりテンプレートが優先されます）',
        \$main::data{ $key . 'template' },
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:'
            . $id
            . 'template\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切なタグに変換されます。">'
            . '<option value="">▼独自タグを挿入する</option>'
            . '<option value="&lt;!--dt--&gt;&lt;!--/dt--&gt;">予定の日時 (&lt;!--dt--&gt;&lt;!--/dt--&gt;)</option>'
            . '<option value="&lt;!--date format=&quot;&quot;--&gt;&lt;!--/date--&gt;">日付 (&lt;!--date--&gt;)</option>'
            . '<option value="&lt;!--return--&gt;&lt;!--/return--&gt;">戻るリンク (&lt;!--return--&gt;)</option>'
            . '<option value="&lt;!--editbutton--&gt;&lt;!--/editbutton--&gt;">編集ボタン (&lt;!--editbutton--&gt;)</option>'
            . '<option value="&lt;!--dailylist--&gt;&lt;!--/dailylist--&gt;">同日イベントリスト (&lt;!--dailylist--&gt;)</option>'
            . '<option value="&lt;!--monthlylist--&gt;&lt;!--/monthlylist--&gt;">同月イベントリスト (&lt;!--monthlylist--&gt;)</option>'
            . '</select>'
    );

    print '<fieldset><legend>予定編集ボタン設定</legend>';
    print '<fieldset><legend>予定編集ボタン</legend>';
    print $this->{'icon_obj'}
        ->button_menu( 'data:detail_eventedit', 'eventedit', 120,
        $main::data{'detail_eventedit'} );
    print '</fieldset>';
    print '<fieldset><legend>予定削除ボタン</legend>';
    print $this->{'icon_obj'}
        ->button_menu( 'data:detail_eventdelete', 'eventdelete', 120,
        $main::data{'detail_eventdelete'} );
    print '</fieldset>';
    print '</fieldset>';
}

######################################################################
# 設定チェック
sub is_valid_setting ($) {
    my $this = shift;
    if (   defined $main::data{'detailWindowWidth'}
        && $main::data{'detailWindowWidth'} ne ''
        && $this->is_nan( $main::data{'detailWindowWidth'} ) )
    {
        push(
            @{ $this->{'dialog'} },
            '詳細表示ウィンドウ幅を更新できませんでした。半角数字にしてください。'
        );
        delete $main::data{'detailWindowWidth'};
    }
    if (   defined $main::data{'detailWindowHeight'}
        && $main::data{'detailWindowHeight'} ne ''
        && $this->is_nan( $main::data{'detailWindowHeight'} ) )
    {
        push(
            @{ $this->{'dialog'} },
            '詳細表示ウィンドウ高さを更新できませんでした。半角数字にしてください。'
        );
        delete $main::data{'detailWindowHeight'};
    }
    $main::data{'detailInSameWindow'} = 0
        if !$main::data{'detailInSameWindow'};
    return;
}

######################################################################
#sub import {
BEGIN {
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {
        no warnings qw(once);

        #クラス登録
        Common::class_register( 'c011', 'DetailPage' );

        #ツール登録
        $setting::sub_jump_menu{'page'}{'c011'} = '詳細表示ページ';
        $setting::selected_jump_menu{'c011'} = 'c010'
            ; #サブメニューがあるときメインメニューのデフォルトキー
        $preference::page{'c011'} = 'detail';
    }
}

1;
