package IconEditor;
require CMONOS::CGI_Lib::Tools::ImageEditor;
@ISA = qw(ImageEditor);
use strict;
use utf8;
######################################################################
# Calendarアイコンライブラリ編集モジュール
# IconEditor.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 画像情報
sub get_image_info ($) {
    my $this = shift;
    undef %setting::deco_type;
    undef %setting::deco_dir;

    %setting::deco_type = (
        'calprev'  => 'button',
        'calreset' => 'button',
        'calindex' => 'button',
        'caltoday' => 'button',
        'calnext'  => 'button',

        'daily'     => 'button',
        'weekly'    => 'button',
        'monthly'   => 'button',
        'calsearch' => 'button',

        'calendarpanel' => 'button',
        'togglepanel'   => 'button',

        'calinput' => 'button',
        'caltool'  => 'button',
        'callogin' => 'button',

        'eventedit'   => 'button',
        'eventdelete' => 'button',
        'eventadd'    => 'button',
    );

    %setting::deco_dir = (
        'calprev'  => '001:前へ ボタン',
        'calreset' => '002:検索条件をリセット ボタン',
        'calindex' => '003:カレンダーインデックス ボタン',
        'caltoday' => '004:今日 ボタン',
        'calnext'  => '005:次へ ボタン',

        'daily'     => '101:日表示ボタン',
        'weekly'    => '102:週表示ボタン',
        'monthly'   => '103:月表示ボタン',
        'calsearch' => '104:検索ページ ボタン',

        'calendarpanel' => '201:カレンダーパネル ボタン',
        'togglepanel'   => '202:表示コントロールパネル ボタン',

        'calinput' => '301:新規予定ボタン',
        'caltool'  => '302:環境設定を開く ボタン',
        'callogin' => '303:ログインボタン',

        'eventedit'   => '401:予定編集ボタン',
        'eventdelete' => '402:予定削除ボタン',
        'eventadd'    => '403:予定追加ボタン',
    );

    $main::dir = 'weekly' if !defined $main::dir || $main::dir eq '';
    return (
        $env::image_dir . '/calendar',
        $env::image_lib . '/calendar',
        '', '', $env::css . '/' . $setting::image_css
    );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    unless ( $default::subdivided && defined $main::c && $main::c ne '' ) {

        #クラス登録
        Common::class_register( '0102', 'IconEditor' );

        #メニュー登録
        $setting::jump_menu{'0102'}
            = 'アイコンライブラリ編集(カレンダー共通)';
        $setting::master_check_option{'0102'} = 1;

        #イメージCSS
        $setting::image_css = 'calendar-image.css';
    }
}

1;
