package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# 一般設定モジュール
# GeneralSetting.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-05-24
######################################################################
# 追加設定
sub print_sub_preference_panel ($) {
    my $this = shift;
    print '<fieldset><legend>日付変更時刻繰り上げ設定</legend>';
    print '<label>';
    print '<select name="advance">';
    foreach my $gap ( 0 .. 23 ) {
        my $h = 24 - $gap;
        print '<option value="'
            . $gap . '"'
            . ( ( $gap == $default::advance ) ? ' selected="selected"' : '' )
            . '>'
            . $h
            . '</option>';
    }
    print '</select>';
    print
        '時以降は翌日扱いとする</label>（業務終了時刻等を設定します）';
    if ( $this->{'advance_updated'} ) {
        my $mkcal = $ENV{'SCRIPT_NAME'};
        $mkcal =~ s/start.cgi$/mkcal.cgi/;
        print '<img src="' . $mkcal
            . '?refresh" width="1" height="1" alt="" />';
    }
    print '</fieldset>';
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    $main::advance = 0
        if !$main::advance
        || $this->is_nan($main::advance)
        || $main::advance < 0
        || $main::advance >= 24;
    return;
}

sub update_settings ($) {
    my $this = shift;
    return
        if defined $default::advance && $default::advance == $main::advance;
    my ( $data, $default_path );
    $default_path = './default.pl';
    $data = $this->read_file( $default_path, 1 );
    unless ( $data
        =~ s/^[\x20\x09]*\$advance[\x20\x09]*=[^;]*;/\$advance = $main::advance;/gm
        )
    {
        $data =~ s/1;/\$advance = $main::advance;\x0A\x0A1;/gm;
    }
    if ( $this->write_file( $default_path, \$data, 1, $env::cgi_file_mode ) )
    {
        $default::advance = $main::advance;
        undef $main::advance;
        $this->{'advance_updated'} = 1;
    }
    else {
        push(
            @{ $this->{'dialog'} },
            '日付変更時刻繰り上げ設定の更新に失敗しました。設定ファイルを開けませんでした。'
        );
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定';
}

1;
