package FeedMixerPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# フィードリストページ設定モジュール
# FeedMixerPage.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    no warnings qw(once);
    my $this = shift;

    #数字チェック
    $check::num{'limit'}             = '1サイトあたりの記事数';
    $check::num{'max'}               = '全体の表示数';
    $check::num{'descriptionLength'} = '説明の最大文字数';

    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'feed';    # データキー
    $preference::name = 'フィードリスト・ページレイアウト'
        ;                        # 設定パネル名
}

sub is_valid_setting ($) {
    my $this = shift;
    unlink $default::preference_dir . '/cache.html';
    unlink $default::preference_dir . '/cache.js';
    return;
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$;$) {
    my ( $this, $id, $key ) = @_;
    my ($tool);
    print '<fieldset><legend>フィードリスト設定</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'limit">1サイトあたりの記事数</label></td>';
    print '<td class="field"><input type="text" name="data:'
        . $id
        . 'limit" id="data:'
        . $id
        . 'limit" value="'
        . $this->escape( $main::data{ $key . 'limit' } )
        . '" size="3" maxlength="3" />件まで</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'max">全体の表示数</label></td>';
    print '<td class="field"><input type="text" name="data:'
        . $id
        . 'max" id="data:'
        . $id
        . 'max" value="'
        . $this->escape( $main::data{ $key . 'max' } )
        . '" size="3" maxlength="3" />件まで</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'descriptionLength">説明の最大文字数</label></td>';
    print '<td class="field"><input type="text" name="data:'
        . $id
        . 'descriptionLength" id="data:'
        . $id
        . 'descriptionLength" value="'
        . $this->escape( $main::data{ $key . 'descriptionLength' } )
        . '" size="3" maxlength="6" />文字(半角)</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'window">リンク先を開くウィンドウ</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'data:' . $id . 'window', '', '', $main::data{ $key . 'window' },
        ''       => '同じウィンドウ',
        '_blank' => '新しいウィンドウ',
    );
    print '</td>';
    print '</tr>';
    print '</tbody></table>';

    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new;

    #入力支援ツール
    $tool
        = '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:'
        . $id
        . 'template\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切な表示に変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--article--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/article--&gt;">記事</option>';
    $tool
        .= '<option value="&lt;!--title--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;">タイトル</option>';
    $tool
        .= '<option value="&lt;!--description--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/description--&gt;">要約</option>';
    $tool
        .= '<option value="&lt;!--content--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/content--&gt;">内容(HTML)</option>';
    $tool
        .= '<option value="&lt;!--author--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/author--&gt;">記事の筆者</option>';
    $tool
        .= '<option value="&lt;!--mtime--&gt;&lt;!--/mtime--&gt;">更新時</option>';
    $tool
        .= '<option value="&lt;!--date--&gt;&lt;!--/date--&gt;">日付</option>';
    $tool
        .= '<option value="&lt;!--link--&gt;&lt;!--/link--&gt;">記事の URL</option>';
    $tool
        .= '<option value="&lt;!--site--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/site--&gt;">サイトの名前</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--mtime--&gt;&lt;!--/mtime--&gt;">更新時</option>';
    $tool .= '<option value=""></option>';
    $tool .= '<option value="';
    $tool
        .= $this->jsquot( '&lt;!--mtime--&gt;&lt;!--/mtime--&gt; 更新\n'
            . '&lt;ul class=&quot;index&quot;&gt;\n'
            . '&lt;!--article--&gt;\n'
            . '&lt;!--head--&gt;\n'
            . '&lt;li&gt;\n'
            . '&lt;!--/head--&gt;\n'
            . '&lt;div class=&quot;title&quot;&gt;\n'
            . '&lt;!--title--&gt;&lt;!--/title--&gt;\n'
            . '&lt;!--site--&gt;&lt;!--head--&gt; (&lt;!--/head--&gt;&lt;!--foot--&gt;)&lt;!--/foot--&gt;&lt;!--/site--&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;!--description--&gt;&lt;!--head--&gt;\n'
            . '&lt;div class=&quot;description&quot;&gt;\n'
            . '&lt;!--/head--&gt;&lt;!--foot--&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;!--/foot--&gt;&lt;!--/description--&gt;\n'
            . '&lt;!--foot--&gt;\n'
            . '&lt;/li&gt;\n'
            . '&lt;!--/foot--&gt;\n'
            . '&lt;!--/article--&gt;\n'
            . '&lt;/ul&gt;\n' );
    $tool .= '">テンプレートの例</option>';
    $tool .= '</select>';
    $this_template->print_template_form( 'data:' . $id . 'template',
        'テンプレート', \$main::data{ $key . 'template' }, \$tool );
    print '</fieldset>';
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'f000', 'FeedMixerPage' );

    #ツール登録
    $setting::jump_menu{'f000'}
        = 'フィードリスト・ページレイアウト';
}

1;
