package FeedMixerSSI;
require CMONOS::FeedMixer::Tools::FeedMixerPage;
@ISA = qw(FeedMixerPage);
use strict;
use utf8;
######################################################################
# SSI埋め込みリスト設定モジュール
# FeedMixerSSI.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-08-21
######################################################################
# 設定チェック項目取得
sub get_setting_items ($) {
    my $this = shift;
    $this->get_sub_setting_items;
}

######################################################################
# 設定環境
sub set_preferences ($) {
    my $this = shift;
    $preference::db = 'page'
        if !defined $preference::db
        || $preference::db ne 'page';    # 記録用データベース名
    $preference::submenukey = 'page'
        if !defined $preference::submenukey
        || $preference::submenukey ne 'page';    # サブメニューキー
    $preference::id = 'ssi'
        if !defined $preference::id
        || $preference::id ne 'ssi';             # データキー
    $preference::name = 'SSI 埋め込みリスト'
        if !defined $preference::name
        || $preference::name ne
        'SSI 埋め込みリスト';             # 設定パネル名
    $preference::title
        = 'SSI 埋め込みリストのレイアウトを設定します。';
}

sub is_valid_setting ($) {
    my $this = shift;
    unlink $default::preference_dir . '/ssi_cache.html';
    unlink $default::preference_dir . '/ssi_cache.js';
    return;
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;
    my ( $id, $key );

    $id = ( defined $preference::id ) ? $preference::id : '';
    $id .= '_' if $id ne '';

    #設定のインポート
    if ( defined $main::import && $main::import ne '' && %preference::page ) {
        $key = $main::import . '_';
        $this->escape(
            \$main::data{ $id . 'title' },
            \$main::data{ $id . 'titleText' }
        );
    }
    else {
        $key = $id;
    }

    print '<input type="hidden" name="id" value="' . $preference::id . '" />';
    $this->print_sub_preference_panel( $id, $key );
    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';

    print
        '</form><form name="sample-codes" id="sample-codes" action="#"><fieldset class="sample"><legend><label for="sample-ssi">埋め込みタグ(動的 JavaScript)</label></legend>';
    print
        '<textarea cols="70" rows="3">&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;'
        . $this->http_my_domain
        . $ENV{'SCRIPT_NAME'}
        . '?mode=js&quot;&gt;&lt;/script&gt;&lt;noscript&gt;&lt;a href=&quot;'
        . $this->http_my_domain
        . $ENV{'SCRIPT_NAME'}
        . '&quot;&gt;フィード・リスト&lt;/a&gt;&lt;/noscript&gt;</textarea>';
    print '</fieldset>';
    my $target_uri
        = $this->path_change( $default::file, $ENV{'SCRIPT_NAME'}, 'abs' );

    if ( defined $env::ssi && $env::ssi ) {
        print
            '<fieldset class="sample"><legend><label for="sample-ssi">埋め込みタグ(静的 SSI)</label></legend>';
        print '<textarea cols="70" rows="3">&lt;!--#include virtual=&quot;'
            . $target_uri
            . '&quot;--&gt;</textarea>';
        print '</fieldset>';
    }
    $target_uri =~ s/\.ssi$/.js/i;
    $target_uri = $this->http_my_domain . $target_uri;
    print
        '<fieldset class="sample"><legend><label for="sample-js">埋め込みタグ(静的 JavaScript)</label></legend>';
    print
        '<textarea cols="70" rows="3">&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;'
        . $target_uri
        . '&quot;&gt;&lt;/script&gt;&lt;noscript&gt;&lt;a href=&quot;'
        . $this->http_my_domain
        . $ENV{'SCRIPT_NAME'}
        . '&quot;&gt;フィード・リスト&lt;/a&gt;&lt;/noscript&gt;</textarea>';
    my $mklist = $ENV{'SCRIPT_NAME'};
    $mklist =~ s/start.cgi$/mklist.cgi/;
    print '<img src="' . $mklist . '?refresh" width="1" height="1" alt="" />'
        if $main::id;
    print '</fieldset>';
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'f001', 'FeedMixerSSI' );

    #ツール登録
    $setting::jump_menu{'f001'} = 'SSI 埋め込みリスト設定';
}

1;
