package GoogleMaps;
require CMONOS::CGI_Lib::Field::GoogleMapsBase;
@ISA = qw(GoogleMapsBase);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（Googleマップ）
# GoogleMaps.pm 1.1.3
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-01-25
######################################################################
sub _form ($$) {
    my ( $this, $name ) = @_;
    my $form = '';
    if ( $main::p && $main::p eq 'i' ) {
        $form .= '<fieldset><legend>section マーカー</legend>';
        $form
            .= '<label><input type="checkbox" name="'
            . $name
            . 'wp" value="1"'
            . ( ( $main::data{ $this->{'id'} }{'wp'} )
            ? ' checked="checked"'
            : '' )
            . ' /> section マーカーを表示する</label></li>';
        $form .= '</fieldset>';
    }
    return $form;
}

sub _is_valid_data ($;$) {
    my ( $this, $path ) = @_;
    $main::data{ $this->{'id'} }{'wp'} = ''
        if $main::p && $main::p eq 'i' && !$main::data{ $this->{'id'} }{'wp'};
    return 1;
}

sub waypoints_kml_path ($) {
    my $this = shift;
    my $dir
        = $default::home . '/'
        . $main::n
        . ( ($main::pending) ? '.pending' : '' ) . '/i';
    my $path = $dir . '/waypoints.kml';
    $this->write_file( $path, '<?xml version="1.0"?><kml></kml>', 1 )
        if $this->set_dir($dir) && !-f $path;
    return $this->full_path($path);
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->field_tag('') if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    my $data_tag = $this->data_tag_from_ref( \%data );
    delete $this->{'indexmap'}
        if defined $this->{'field_for'}{'coordinates'}
        && $this->{'field_for'}{'coordinates'} ne $this->{'id'};
    if (%data) {
        my $static_map = $this->get_static_map( \%data );
        if ( $data{'enabled'} ) {
            if ( $this->{'is_temporary_data'} && $this->{'is_posted_marker'} )
            {
                $data{'mk'} = $this->full_path(
                          $cgi::input->get_public_clipboard . '/'
                        . $this->{'id'}
                        . '.marker.'
                        . (
                        ( $data{'type'} ) ? $data{'type'}
                        : (        $data{'mk'}
                                && $data{'mk'} =~ /\.([0-9a-zA-Z_]+)$/ ) ? $1
                        : 'gif'
                        )
                );
            }
            elsif ( $data{'mk'} && $data{'mk'} !~ /^https?:\/\//i ) {
                $data{'mk'} = $this->full_path( $path . '/' . $data{'mk'} );
            }
            if ( $this->{'is_temporary_data'} && $this->{'is_posted_kml'} ) {
                $data{'url'}
                    = $this->full_path(
                          $cgi::input->get_public_clipboard . '/'
                        . $this->{'id'}
                        . ( ( $data{'kml'} eq 'kmz' ) ? '.kmz' : '.kml' ) )
                    if $data{'kml'};
                $data{'m'} = '中心座標マーカー' if !$data{'m'};
            }
            else {
                if ( $data{'kml'} ) {
                    $data{'bg'}
                        = $this->full_path( ($default::date)
                        ? $history::path . '/' . $history::name . '.kml'
                        : $default::home . '/index.kml' );
                    $data{'url'}
                        = $this->full_path( $path . '/'
                            . $this->{'id'}
                            . ( ( $data{'kml'} eq 'kmz' ) ? '.kmz' : '.kml' )
                        );
                }
                elsif (!$data{'m'}
                    && defined $this->{'field_for'}{'coordinates'}
                    && $this->{'field_for'}{'coordinates'} eq $this->{'id'} )
                {
                    $data{'bg'}
                        = $this->full_path( ($default::date)
                        ? $history::path . '/' . $history::name . '.kml'
                        : $default::home . '/index.kml' );
                    $data{'opener_url'} = $default::home . '/' . $main::n;
                    $data{'opener_url'} .= '.pending'
                        if !-d $data{'opener_url'}
                        && ( $main::pending
                        || -d $data{'opener_url'} . '.pending' );
                    $data{'opener_url'}
                        .= '/'
                        . (
                        ( !$main::p || $main::p eq 'i' ) ? '1' : $main::p )
                        . '.'
                        . ( ( $env::ssi && $env::ssi_ext )
                        ? $env::ssi_ext
                        : 'html' );
                    $data{'opener_url'}
                        .= ( $main::p eq 'i' )
                        ? ''
                        : '#a'
                        . sprintf( "%.2d", $main::p )
                        . sprintf( "%.2d", $main::chap )
                        . sprintf( "%.2d", $main::sect );
                    $data{'opener_url'}
                        = $this->full_path( $data{'opener_url'} );
                    $data{'tr'} = 'p';
                    delete $data{'fit'};
                    delete $data{'mk'};
                    delete $data{'mka'};
                    delete $data{'mkv'};
                    delete $data{'m'};
                }
            }
        }
        return $this->field_tag(
            $data_tag
                . (
                  ( $data{'enabled'} && ( $data{'url'} || $data{'c'} ) )
                ? ( $this->{'is_temporary_data'} )
                        ? $this->gmap_iframe(
                            \%data,
                            $this->mk_user_generated_field_id( $c, $n ),
                            (   (          $this->{'maxwidth'}
                                        && $this->{'maxwidth'}
                                        < $this->{'canvasWidth'}
                                )
                                ? $this->{'maxwidth'}
                                : $this->{'canvasWidth'}
                            ),
                            $this->{'canvasHeight'},
                            $this->{'canvasOverView'},
                            $this->{'canvasStreetView'},
                            $this->{'viewerGSearch'},
                            $this->{'viewerLinkTarget'}
                        )
                        . ( (   $main::data{ $this->{'id'} }{'delete'}
                                    && !$this->{'is_posted_file'}
                            )
                            ? '<div class="note">このKMLファイルを削除する</div>'
                            : ''
                        )
                        . ( (   $main::data{ $this->{'id'} }{'delmk'}
                                    && !$this->{'is_posted_marker'}
                            )
                            ? '<div class="note">このマーカー画像を削除する</div>'
                            : ''
                        )
                        : $this->gmap_iframe(
                            \%data,
                            $this->mk_user_generated_field_id( $c, $n ),
                            (   (          $this->{'maxwidth'}
                                        && $this->{'maxwidth'}
                                        < $this->{'viewerWidth'}
                                )
                                ? $this->{'maxwidth'}
                                : $this->{'viewerWidth'}
                            ),
                            $this->{'viewerHeight'},
                            $this->{'viewerOverView'},
                            $this->{'viewerStreetView'},
                            $this->{'viewerGSearch'},
                            $this->{'viewerLinkTarget'}
                        )
                        . $static_map
                : ''
                )
        );
    }
    else {
        return $this->field_tag('');
    }
}

sub print_additional_gmap_option ($$) {
    my ( $this, $name ) = @_;
    print
        '<fieldset><legend>Googleマップインデックス設定</legend><label><input type="checkbox" name="'
        . $name
        . '_showKml" id="'
        . $name
        . '_showKml" value="1"'
        . ( ( $this->{'showKml'} ) ? ' checked="checked"' : '' )
        . ' /> インデックスでも KML を表示する</label></fieldset>';
}

sub _is_valid_setting ($) {
    my $this = shift;
    $main::data{ $this->{'id'} . '_showKml' } = '0'
        if !$main::data{ $this->{'id'} . '_showKml' };
    return 1;
}

sub center_marker_comment_note ($) {
    my $this = shift;
    return ( defined $this->{'field_for'}{'coordinates'}
            && $this->{'field_for'}{'coordinates'} eq $this->{'id'} )
        ? '無記入の場合'
        . ( ($default::date) ? '履歴地図' : 'インデックス地図' )
        . 'が表示されます'
        : '無記入の場合中心座標マーカーは表示されません';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'webapi_gmap', 'GoogleMaps', 'Googleマップ' )
        if !$setting::field_for_mail;
}

1;
