package Tools;
use strict;
use utf8;
######################################################################
# メンテナンスモジュール
# Tools.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::table    = 1;    #テーブル設定読み込み
    $setting::page     = 0;    #ページ設定読み込み

    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    #フィールド読み込み設定
    $setting::field = 0
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 2
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled
        = 'no'; #tag=タグのみ/all=全ての設定/no=タグをつけない

    #必須フォーム
    @setting::form = ( 'm', 'k' );

    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #サブカテゴリがある場合
        if ($default::subdivided) {
            $cgi::input->error404
                unless -d "$default::preference_dir/$main::c";
            push( @setting::form, 'c' );
        }

        #アクセス権設定名
        $setting::security_name{'edit'}   = '記事編集';
        $setting::security_name{'delete'} = '記事削除';
        $setting::security_name{'rewind'} = '以前の記事を復元';

    }
    else {
        $setting::security_name{'edit'} = '記事カテゴリー選択';
    }

    #各種キー設定
    $setting::key          = 'tools'; #ページ設定キー
    $setting::security_key = 'tools'; #デフォルトセキュリティキー

    #アクセス権設定名
    $setting::security_name{'tools'} = '環境設定';

    #デフォルトキー
    $main::k = '0000'
        if !defined $main::k || $main::k eq '' || $main::k eq 'general';

    #バックアップデフォルトディレクトリ
    my $default_path = 'homepagemaker';
    $default_path .= '_date' if defined $default::date && $default::date;
    if (   $default::subdivided
        && ( !defined $main::c || $main::c eq '' )
        && $main::k ne '00H0'
        && $main::k ne 'H220' )
    {
        $backup::default{'pref'} = $default_path . '/masterdefault';
    }
    else {
        $backup::default{'pref'}  = $default_path . '/default';
        $backup::default{'field'} = $backup::default{'pref'} . '/field';
    }

    #ツールページ設定
    $setting::page{'tools'}{'title'} = '環境設定';
    $setting::page{'tools'}{'text'}  = '#000000';

    #	$setting::page{'tools'}{'link'} = '#0000ff';
    #	$setting::page{'tools'}{'alink'} = '#99ffff';
    #	$setting::page{'tools'}{'vlink'} = '#000099';
    #	$setting::page{'tools'}{'hover'} = '#00ffff';
    #	$setting::page{'tools'}{'nodeco'} = 'no';
    $setting::page{'tools'}{'bgcolor'}     = '#ffffff';
    $setting::page{'tools'}{'cssFileName'} = 'tools.css';

# 	$setting::page{'tools'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'tools'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'tools'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'tools'}{'background'} = '';
# 	$setting::page{'tools'}{'bgproperties'} = '';
# 	$setting::page{'tools'}{'topmargin'} = '';
# 	$setting::page{'tools'}{'leftmargin'} = '';
# 	$setting::page{'tools'}{'javascript'} = '';
# 	$setting::page{'tools'}{'header'} = '';
# 	$setting::page{'tools'}{'headerFileName'} = '';
# 	$setting::page{'tools'}{'titleImageAlign'} = '';
# 	$setting::page{'tools'}{'titleImage'} = '';
# 	$setting::page{'tools'}{'align'} = '';
# 	$setting::page{'tools'}{'width'} = '';
# 	$setting::page{'tools'}{'deco'} = '';
# 	$setting::page{'tools'}{'titleText'} = '';

    $cgi::input->query_filter( $cgi::input->secure_query_for_tools_ref )
        if ref $cgi::input;

    #メンテナンスモジュール読み込み
    Common::use_modules('CGI_Lib/Tools');
    Common::use_modules( $default::lib . '/Tools' );

}

1;
