package HomePage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# ページ設定モジュール
# HomePage.pm ver1.0.7
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-11-10
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #数字項目
    $check::num{'limit'} = 'インデックス見出し数'
        if !defined $check::num{'limit'};
    $check::num{'metalimit'} = 'メタインデックス見出し数'
        if !defined $check::num{'metalimit'};
    return;
}

######################################################################
# 入力支援ツール取得
sub input_support ($) {
    my $this = shift;
    my ( $tool, $id );
    $id = 'data:' . $preference::id . '_template';
    $tool
        .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $id
        . '\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切なタグに変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--tool--&gt;&lt;!--/tool--&gt;">環境設定へのリンク</option>';
    $tool
        .= '<option value="&lt;!--edit--&gt;&lt;!--/edit--&gt;">編集画面へのリンク</option>';
    $tool
        .= '<option value="&lt;!--indexpage title=&quot;インデックス&quot;--&gt;&lt;!--/indexpage--&gt;">インデックスページへのリンク</option>';
    $tool
        .= '<option value="&lt;!--history title=&quot;履歴&quot;--&gt;&lt;!--/history--&gt;">履歴ページへのリンク</option>'
        if defined $default::date && $default::date;

    if ( $preference::id =~ /article/ ) {
        $tool
            .= '<option value="&lt;!--prev title=&quot;前の記事&quot;--&gt;&lt;!--/prev--&gt;">前の記事へのリンク</option>';
        $tool
            .= '<option value="&lt;!--next title=&quot;次の記事&quot;--&gt;&lt;!--/next--&gt;">次の記事へのリンク</option>';

        $tool
            .= '<option value="&lt;!--prevpage title=&quot;前のページ&quot;--&gt;&lt;!--/prevpage--&gt;">前のページへのリンク</option>';
        $tool
            .= '<option value="&lt;!--nextpage title=&quot;次のページ&quot;--&gt;&lt;!--/nextpage--&gt;">次のページへのリンク</option>';
        $tool
            .= '<option value="&lt;!--here--&gt;&lt;!--/here--&gt;">ページ位置</option>';
        $tool
            .= '<option value="&lt;!--pagenavi--&gt;&lt;!--/pagenavi--&gt;">ページナビ</option>';
        $tool
            .= '<option value="&lt;!--pagenavi type=&quot;list&quot; max=&quot;(最大表示数)&quot; margin=&quot;(前方ページ表示数)&quot; class=&quot;(CSS クラス)&quot;--&gt;&lt;!--/pagenavi--&gt;">ページナビ(リスト)</option>';

        $tool
            .= '<option value="&lt;!--mtime--&gt;&lt;!--/mtime--&gt;">更新時</option>';
        $tool
            .= '<option value="&lt;!--date--&gt;&lt;!--/date--&gt;">日付</option>'
            if defined $default::date && $default::date;
        $tool
            .= '<option value="&lt;EntryPermalink&gt;">パーマリンクURL</option>';
        $tool
            .= '<option value="&lt;EntryPermalink encode_url=&quot;1&quot;&gt;">パーマリンクURL(URLエンコード)</option>';

        $tool
            .= '<option value="&lt;!--icon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/icon--&gt;">カテゴリーアイコン</option>';
        $tool
            .= '<option value="&lt;!--description--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/description--&gt;">カテゴリー説明</option>';

        if ($default::subdivided) {
            $tool
                .= '<option value="&lt;!--mastericon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/mastericon--&gt;">総合インデックスのアイコン</option>';
            $tool
                .= '<option value="&lt;!--masterdescription--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/masterdescription--&gt;">総合インデックスの説明</option>';
        }

    }
    elsif ( $preference::id =~ /history/ ) {
        $tool
            .= '<option value="&lt;!--prevpage title=&quot;前のページ&quot;--&gt;&lt;!--/prevpage--&gt;">前のページへのリンク</option>';
        $tool
            .= '<option value="&lt;!--nextpage title=&quot;次のページ&quot;--&gt;&lt;!--/nextpage--&gt;">次のページへのリンク</option>';
    }
    $tool
        .= '<option value="&lt;!--title--&gt;&lt;!--/title--&gt;">カテゴリータイトル</option>';
    $tool
        .= '<option value="&lt;!--mastertitle--&gt;&lt;!--/mastertitle--&gt;">総合インデックスのタイトル</option>'
        if defined $default::subdivided && $default::subdivided;
    $tool
        .= '<option value="&lt;!--cal span=&quot;1&quot; reverse=&quot;reverse&quot;--&gt;&lt;!--/cal--&gt;">カレンダー（前後[span]月分）</option>'
        if defined $default::date && $default::date;
    $tool
        .= '<option value="&lt;!--recentcalendars--&gt;&lt;!--/recentcalendars--&gt;">最近のカレンダー</option>'
        if defined $default::date && $default::date;
    $tool .= $this->recent_item_support;
    if ( $preference::id =~ /(index|history)/ ) {
        $tool .= '<option value=""></option>';
        $tool .= $this->index_support;
    }
    $tool .= '</select>';
    $tool .= $this->image_support($id);
    $tool .= $this->field_support($id);
    return $tool;
}

sub recent_item_support ($) {
    my $this = shift;
    my $tool = '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--topicpath--&gt;&lt;!--/topicpath--&gt;">トピックパス</option>';
    $tool
        .= '<option value="&lt;!--topicpath type=&quot;list&quot;--&gt;&lt;!--/topicpath--&gt;">トピックパス(&lt;ul&gt;)</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--navi--&gt;&lt;!--/navi--&gt;">新着記事リスト</option>';
    $tool
        .= '<option value="&lt;!--metanavi--&gt;&lt;!--/metanavi--&gt;">総合新着記事リスト</option>'
        if $default::subdivided && $main::c;
    $tool
        .= '<option value="&lt;!--masternavi--&gt;&lt;!--/masternavi--&gt;">サイト全体新着記事リスト</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--recentcomments--&gt;&lt;!--/recentcomments--&gt;">新着コメントリスト</option>';
    $tool
        .= '<option value="&lt;!--metarecentcomments--&gt;&lt;!--/metarecentcomments--&gt;">総合新着コメントリスト</option>'
        if $default::subdivided && $main::c;
    $tool
        .= '<option value="&lt;!--masterrecentcomments--&gt;&lt;!--/masterrecentcomments--&gt;">サイト全体新着コメントリスト</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--recenttrackbacks--&gt;&lt;!--/recenttrackbacks--&gt;">新着トラックバックリスト</option>';
    $tool
        .= '<option value="&lt;!--metarecenttrackbacks--&gt;&lt;!--/metarecenttrackbacks--&gt;">総合新着トラックバックリスト</option>'
        if $default::subdivided && $main::c;
    $tool
        .= '<option value="&lt;!--masterrecenttrackbacks--&gt;&lt;!--/masterrecenttrackbacks--&gt;">サイト全体新着トラックバックリスト</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--rss title=&quot;RSS2.0&quot;--&gt;&lt;!--/rss--&gt;">新着記事 RSS へのリンク</option>';
    $tool
        .= '<option value="&lt;!--metarss title=&quot;RSS2.0&quot;--&gt;&lt;!--/metarss--&gt;">総合新着記事 RSS へのリンク</option>'
        if $default::subdivided && $main::c;
    $tool
        .= '<option value="&lt;!--masterrss title=&quot;RSS2.0&quot;--&gt;&lt;!--/masterrss--&gt;">サイト全体新着記事 RSS へのリンク</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--commentrss title=&quot;RSS2.0(Comment)&quot;--&gt;&lt;!--/commentrss--&gt;">新着コメント RSS へのリンク</option>';
    $tool
        .= '<option value="&lt;!--metacommentrss title=&quot;RSS2.0(Comment)&quot;--&gt;&lt;!--/metacommentrss--&gt;">総合新着コメント RSS へのリンク</option>'
        if $default::subdivided && $main::c;
    $tool
        .= '<option value="&lt;!--mastercommentrss title=&quot;RSS2.0(Comment)&quot;--&gt;&lt;!--/mastercommentrss--&gt;">サイト全体新着コメント RSS へのリンク</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--trackbackrss title=&quot;RSS2.0(Trackback)&quot;--&gt;&lt;!--/trackbackrss--&gt;">新着トラックバック RSS へのリンク</option>';
    $tool
        .= '<option value="&lt;!--metatrackbackrss title=&quot;RSS2.0(Trackback)&quot;--&gt;&lt;!--/metatrackbackrss--&gt;">総合新着トラックバック RSS へのリンク</option>'
        if $default::subdivided && $main::c;
    $tool
        .= '<option value="&lt;!--mastertrackbackrss title=&quot;RSS2.0(Trackback)&quot;--&gt;&lt;!--/mastertrackbackrss--&gt;">サイト全体新着トラックバック RSS へのリンク</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--podcast title=&quot;RSS2.0(Podcast)&quot;--&gt;&lt;!--/podcast--&gt;">新着ポッドキャスト RSS へのリンク</option>';
    $tool
        .= '<option value="&lt;!--metapodcast title=&quot;RSS2.0(Podcast)&quot;--&gt;&lt;!--/metapodcast--&gt;">総合新着ポッドキャスト RSS へのリンク</option>'
        if $default::subdivided && $main::c;
    $tool
        .= '<option value="&lt;!--masterpodcast title=&quot;RSS2.0(Podcast)&quot;--&gt;&lt;!--/masterpodcast--&gt;">サイト全体新着ポッドキャスト RSS へのリンク</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--sitemap--&gt;&lt;!--/sitemap--&gt;">サイトマップ(&lt;!--sitemap--&gt;)</option>';
    return $tool;
}

sub index_support ($;$) {
    my ( $this, $metaindex_flag ) = @_;
    my ($tool);
    $tool
        .= '<option value="&lt;!--title--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;">タイトル</option>';
    $tool
        .= '<option value="&lt;!--icon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/icon--&gt;">アイコン</option>';
    $tool
        .= '<option value="&lt;!--description--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/description--&gt;">要約</option>';
    $tool
        .= '<option value="&lt;!--teaser maxlength=&quot;140&quot;--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/teaser--&gt;">本文抜粋</option>';
    $tool
        .= '<option value="&lt;!--readmore--&gt;&lt;!--/readmore--&gt;">続きを読む...</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--index--&gt;&lt;!--/index--&gt;">インデックス</option>';
    $tool
        .= '<option value="&lt;!--subindex--&gt;&lt;!--/subindex--&gt;">サブインデックス</option>';
    $tool
        .= '<option value="&lt;!--count--&gt;&lt;!--/count--&gt;">記事数</option>';
    $tool
        .= '<option value="&lt;!--separator interval=&quot;&quot;--&gt;&lt;!--/separator--&gt;">セパレータ</option>';
    $tool
        .= '<option value="&lt;!--article--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/article--&gt;">記事</option>';
    $tool
        .= '<option value="&lt;!--mainicon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/mainicon--&gt;">カテゴリーアイコン</option>';
    $tool
        .= '<option value="&lt;!--mastericon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/mastericon--&gt;">トップアイコン</option>'
        if defined $default::subdivided && $default::subdivided;
    $tool
        .= '<option value="&lt;!--author--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/author--&gt;">記事の筆者</option>';
    $tool
        .= '<option value="&lt;!--author email=&quot;yes&quot;--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/author--&gt;">記事の筆者(メールアドレス)</option>';
    $tool
        .= '<option value="&lt;!--label--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/label--&gt;">ラベル画像</option>';
    $tool
        .= '<option value="&lt;!--mark--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/mark--&gt;">マーク画像</option>';
    $tool
        .= '<option value="&lt;!--price--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/price--&gt;">価格</option>';
    $tool
        .= '<option value="&lt;!--score--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/score--&gt;">点数</option>';
    $tool
        .= '<option value="&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--subtitle--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitle--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;">記事サブタイトル(chapterタイトル・sectionタイトル)</option>';
    $tool
        .= '<option value="&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--chaptertitle--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/chaptertitle--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;">記事サブタイトル(chapterタイトル)</option>';
    $tool
        .= '<option value="&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--chaptertitle branchhead="&amp;lt;ul&amp;gt;" branchfoot="&amp;lt;/ul&amp;gt;"--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/chaptertitle--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;">記事サブタイトル(chapterタイトル・sectionタイトル)</option>';
    $tool
        .= '<option value="&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--sectiontitle--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/sectiontitle--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;">記事サブタイトル(sectionタイトル)</option>';
    $tool
        .= '<option value="&lt;!--mtime--&gt;&lt;!--/mtime--&gt;">更新時</option>';
    $tool
        .= '<option value="&lt;!--date--&gt;&lt;!--/date--&gt;">日付</option>'
        if defined $default::date && $default::date;
    $tool
        .= '<option value="&lt;!--gmap--&gt;&lt;!--/gmap--&gt;">Googleマップインデックス</option>'
        if $preference::id;
    $tool .= '<option value=""></option>';
    $tool .= '<option value="';
    $tool
        .= $this->jsquot( '&lt;!--index--&gt;\n'
            . '&lt;!--subindex--&gt;\n'
            . '&lt;div class=&quot;section&quot;&gt;\n'
            . '&lt;h2&gt;&lt;!--title--&gt;&lt;!--/title--&gt;&lt;/h2&gt;\n'
            . '&lt;div class=&quot;body&quot;&gt;\n'
            . '&lt;!--description--&gt;&lt;!--/description--&gt;\n'
            . '&lt;ul class=&quot;index&quot;&gt;\n'
            . '&lt;!--article--&gt;\n'
            . '&lt;!--head--&gt;&lt;li&gt;&lt;!--/head--&gt;\n'
            . '&lt;!--title--&gt;&lt;!--head--&gt;&lt;div class=&quot;title&quot;&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;/div&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;\n'
            . '&lt;!--description--&gt;&lt;!--head--&gt;&lt;div class=&quot;description&quot;&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;/div&gt;&lt;!--/foot--&gt;&lt;!--/description--&gt;\n'
            . '&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;ul&gt;&lt;!--/head--&gt;\n'
            . '&lt;!--subtitle--&gt;&lt;!--head--&gt;&lt;li&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;/li&gt;&lt;!--/foot--&gt;&lt;!--/subtitle--&gt;\n'
            . '&lt;!--foot--&gt;&lt;/ul&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;\n'
            . '&lt;!--foot--&gt;&lt;/li&gt;&lt;!--/foot--&gt;\n'
            . '&lt;!--/article--&gt;\n'
            . '&lt;/ul&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;!--/subindex--&gt;\n'
            . '&lt;!--/index--&gt;\n' );
    $tool .= '">インデックス例</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--recommendedindex--&gt;&lt;!--/recommendedindex--&gt;">おすすめインデックス</option>';
    $tool .= '<option value="';
    $tool
        .= $this->jsquot(
        '&lt;!--recommendedindex sort=&quot;mtimedescend&quot; limit=&quot;10&quot;--&gt;&lt;!--head--&gt;\n'
            . '&lt;ul class=&quot;index&quot;&gt;\n'
            . '&lt;!--/head--&gt;\n'
            . '&lt;!--article--&gt;&lt;!--head--&gt;\n'
            . '&lt;li&gt;\n'
            . '&lt;!--/head--&gt;\n'
            . '&lt;!--title--&gt;&lt;!--head--&gt;\n'
            . '&lt;div class=&quot;title&quot;&gt;\n'
            . '&lt;!--/head--&gt;&lt;!--foot--&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;!--/foot--&gt;&lt;!--/title--&gt;\n'
            . '&lt;!--description--&gt;&lt;!--head--&gt;\n'
            . '&lt;div class=&quot;description&quot;&gt;\n'
            . '&lt;!--/head--&gt;&lt;!--foot--&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;!--/foot--&gt;&lt;!--/description--&gt;\n'
            . '&lt;ul&gt;\n'
            . '&lt;!--subtitle--&gt;&lt;!--head--&gt;\n'
            . '&lt;li&gt;\n'
            . '&lt;!--/head--&gt;&lt;!--foot--&gt;\n'
            . '&lt;/li&gt;\n'
            . '&lt;!--/foot--&gt;&lt;!--/subtitle--&gt;\n'
            . '&lt;/ul&gt;\n'
            . '&lt;!--foot--&gt;\n'
            . '&lt;/li&gt;\n'
            . '&lt;!--/foot--&gt;\n'
            . '&lt;!--/article--&gt;&lt;!--foot--&gt;\n'
            . '&lt;/ul&gt;\n'
            . '&lt;!--/foot--&gt;\n'
            . '&lt;!--/recommendedindex--&gt;\n' );
    $tool .= '">おすすめインデックス例</option>';

    if ( defined $metaindex_flag && $metaindex_flag ) {
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--metaindex--&gt;&lt;!--/metaindex--&gt;">メタインデックス</option>';
        $tool .= '<option value="';
        $tool
            .= $this->jsquot(
            '&lt;!--metaindex sort=&quot;mtimedescend&quot; limit=&quot;10&quot;--&gt;&lt;!--head--&gt;\n'
                . '&lt;ul class=&quot;index&quot;&gt;\n'
                . '&lt;!--/head--&gt;\n'
                . '&lt;!--article--&gt;&lt;!--head--&gt;\n'
                . '&lt;li&gt;\n'
                . '&lt;!--/head--&gt;\n'
                . '&lt;!--title--&gt;&lt;!--head--&gt;\n'
                . '&lt;div class=&quot;title&quot;&gt;\n'
                . '&lt;!--/head--&gt;&lt;!--foot--&gt;\n'
                . '&lt;/div&gt;\n'
                . '&lt;!--/foot--&gt;&lt;!--/title--&gt;\n'
                . '&lt;!--description--&gt;&lt;!--head--&gt;\n'
                . '&lt;div class=&quot;description&quot;&gt;\n'
                . '&lt;!--/head--&gt;&lt;!--foot--&gt;\n'
                . '&lt;/div&gt;\n'
                . '&lt;!--/foot--&gt;&lt;!--/description--&gt;\n'
                . '&lt;ul&gt;\n'
                . '&lt;!--subtitle--&gt;&lt;!--head--&gt;\n'
                . '&lt;li&gt;\n'
                . '&lt;!--/head--&gt;&lt;!--foot--&gt;\n'
                . '&lt;/li&gt;\n'
                . '&lt;!--/foot--&gt;&lt;!--/subtitle--&gt;\n'
                . '&lt;/ul&gt;\n'
                . '&lt;!--foot--&gt;\n'
                . '&lt;/li&gt;\n'
                . '&lt;!--/foot--&gt;\n'
                . '&lt;!--/article--&gt;&lt;!--foot--&gt;\n'
                . '&lt;/ul&gt;\n'
                . '&lt;!--/foot--&gt;\n'
                . '&lt;!--/metaindex--&gt;\n' );
        $tool .= '">メタインデックス例</option>';
    }
    return $tool;
}

sub image_support ($$) {
    my ( $this, $id ) = @_;
    my ($tool);
    $tool
        .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $id
        . '\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切な画像タグに変換されます。">';
    $tool
        .= '<option value="">▼画像付きリンクタグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--link image=&quot;indexButton&quot; location=&quot;（リンク先を記入）&quot; title=&quot;インデックス&quot;--&gt;&lt;!--/link--&gt;">インデックス ボタン</option>';
    $tool
        .= '<option value="&lt;!--link image=&quot;returnButton&quot; location=&quot;（リンク先を記入）&quot; title=&quot;戻る&quot;--&gt;&lt;!--/link--&gt;">戻る ボタン</option>';
    $tool
        .= '<option value="&lt;!--link image=&quot;topButton&quot; location=&quot;（リンク先を記入）&quot; title=&quot;トップページ&quot;--&gt;&lt;!--/link--&gt;">トップページ ボタン</option>';
    $tool .= '</select>';
    return $tool;
}

sub field_support ($$) {
    my ( $this, $id ) = @_;
    return '';
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$;$) {
    my ( $this, $id, $key ) = @_;
    my ($tool);
    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new;
    $this->set_template($this_template);

    #入力支援ツール
    $tool = $this->input_support;
    $this_template->print_template_form(
        'data:' . $id . 'template',
        'ページテンプレート',
        \$main::data{ $key . 'template' },
        \$tool,
        'ページテンプレート中に &lt;html&gt; タグおよび &lt;body&gt; タグがある場合、各ページレイアウト設定よりページテンプレートが優先されます。'
    );

    $this->_print_sub_preference_panel( $id, $key );
}

sub set_template ($$) {
    my ( $this, $this_template ) = @_;
    return;
}

######################################################################
# 設定パネル
sub _print_sub_preference_panel ($) {
    my ( $this, $id, $key ) = @_;
    $this->print_index_setting_form( $id, $key );
    return;
}

######################################################################
sub print_index_template ($$;$$) {
    my ( $this, $id, $key, $masterindex_flag ) = @_;
    my ($tool);

    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new( \%field::obj );

    #入力支援ツール
    $tool
        .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:'
        . $id
        . 'template\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切なタグに変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool .= $this->index_support($masterindex_flag);
    $tool .= '</select>';
    $tool .= $this->image_support( 'data:' . $id . 'template' );

    $this_template->print_template_form(
        'data:' . $id . 'template',
        ( ( !$id || $id eq 'metanavi_' ) ? '埋め込み' : '' )
            . 'インデックステンプレート',
        \$main::data{ $key . 'template' },
        \$tool
    );
}

sub print_index_setting_form ($$;$$) {
    my ( $this, $id, $key, $masterindex_flag ) = @_;
    my $limit_enabled
        = (    $masterindex_flag
            || ( $default::date && $preference::id !~ /history/ )
            || ( !$default::date && !$key && $preference::id eq '' ) )
        ? 1
        : 0;
    print '<fieldset><legend>'
        . ( ( !$id || $id eq 'metanavi_' ) ? '埋め込み' : '' )
        . 'インデックス設定</legend><table class="field-table"><tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'sort">インデックス見出し</label></td>';
    print( ($limit_enabled) ? '<td class="q-field">' : '<td class="field">' );
    print $this->mk_select_menu(
        'data:' . $id . 'sort',
        'インデックスの記事リスト表示順を設定します。',
        '',
        $main::data{ $key . 'sort' },
        'descend' => (
            ($default::date) ? '日付の新しい順'
            : '降順（フォルダ名）'
        ),
        'ascend' => (
            ($default::date) ? '日付の古い順'
            : '昇順（フォルダ名）'
        ),
        'mtimedescend' => '更新時の新しい順',
        'mtimeascend'  => '更新時の古い順'
    );
    print '</td>';

    if ($limit_enabled) {
        print '<td class="field-name"><label for="data:' . $id
            . 'limit">インデックス見出し数</label></td>';
        print '<td class="q-field"><input type="text" name="data:'
            . $id
            . 'limit" id="data:'
            . $id
            . 'limit" value="'
            . ( ( defined $main::data{ $key . 'limit' } )
            ? $main::data{ $key . 'limit' }
            : '' )
            . '" size="3" title="記事見出し表示数を設定します。" />';
        print '件</td></tr>';
    }
    if ( defined $masterindex_flag && $masterindex_flag ) {
        print '<tr class="tbody-end">';
        print '<td class="field-name"><label for="data:' . $id
            . 'reverse">インデックス増設方向</label></td>';
        print '<td class="q-field"><select name="data:'
            . $id
            . 'reverse" id="data:'
            . $id
            . 'reverse" title="インデックスのインデックス追加方向を設定します。">';
        print
            '<option value="">一番後ろに追加する(古い順)</option>';
        print '<option value="reverse"'
            . (
            (   defined $main::data{ $key . 'reverse' }
                    && $main::data{ $key . 'reverse' }
            ) ? ' selected="selected"' : ''
            ) . '>一番前に追加する(新しい順)</option>';
        print '</select>';
        print '</td></tr>';
        print '</tbody><tbody>';
        print '<tr>';
        print '<td class="field-name"><label for="data:' . $id
            . 'metasort">メタインデックス見出し</label></td>';
        print '<td class="q-field">';
        print $this->mk_select_menu(
            'data:' . $id . 'metasort',
            'メタインデックスの記事リスト表示順を設定します。',
            '',
            $main::data{ $key . 'metasort' },
            'descend' => (
                ($default::date) ? '日付の新しい順'
                : '降順（フォルダ名）'
            ),
            'ascend' => (
                ($default::date) ? '日付の古い順'
                : '昇順（フォルダ名）'
            ),
            'mtimedescend' => '更新時の新しい順',
            'mtimeascend'  => '更新時の古い順'
        );
        print '</td><td class="field-name"><label for="data:' . $id
            . 'metalimit">メタインデックス見出し数</label></td>';
        print '<td class="q-field"><input type="text" name="data:'
            . $id
            . 'metalimit" id="data:'
            . $id
            . 'metalimit" value="'
            . ( ( defined $main::data{ $key . 'metalimit' } )
            ? $main::data{ $key . 'metalimit' }
            : '' )
            . '" size="3" title="記事見出しの表示数を設定します。" />';
        print '件</td></tr>';
    }
    print '</tbody></table></fieldset>';
}

1;
