package InfoField;
require CMONOS::CGI_Lib::Tools::FieldEditor;
@ISA = qw(FieldEditor);
use strict;
use utf8;
######################################################################
# ページ情報フィールド編集モジュール
# InfoField.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-03-24
######################################################################
# フィールド読み込み設定
sub set_field ($) {
    my $this = shift;
    $setting::field_db_name = 'infofield' if !defined $setting::field_db_name;
    $setting::field = 2 if !defined $setting::field || $setting::field != 2;
    $setting::field_tag_name = 'info' if !defined $setting::field_tag_name;
    $master::home = $default::home;
    if ( $default::subdivided && defined $main::c && $main::c ne '' ) {
        $default::home = '.'
            if !defined $default::home || $default::home eq '';
        $default::home .= '/' . $main::c;
    }
}

######################################################################
#サブ設定
sub print_sub_setting_items ($) {
    my $this = shift;
    return if !%field::obj;

    print
        '<fieldset><legend>特殊フィールド</legend><table class="field-table"><tbody>';

    print
        '<tr><td class="field-name"><label for="data:for_title">タイトルフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_title" id="data:for_title" title="インデックスで、記事のタイトルとして表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && $field::obj{$id}->{'class'}
            =~ /^(?:text|addr_pref|time_date|time_span)/;
        print '<option value="'
            . $id . '"'
            . (
            ( defined $field::for{'title'} && $field::for{'title'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_description">要約フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_description" id="data:for_description" title="インデックスで、記事の要約として表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && $field::obj{$id}->{'class'} =~ /^(?:text|num)/;
        print '<option value="'
            . $id . '"'
            . (
            (   defined $field::for{'description'}
                    && $field::for{'description'} eq $id
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_icon">アイコンフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_icon" id="data:for_icon" title="インデックスで、記事のアイコンとして表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && ( $field::obj{$id}->{'class'} =~ /^file/i
            || $field::obj{$id}->{'class'} =~ /_image/i );
        print '<option value="'
            . $id . '"'
            . ( ( defined $field::for{'icon'} && $field::for{'icon'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_icon2">アイコンフィールド(予備1)</label></td>';
    print
        '<td class="field"><select name="data:for_icon2" id="data:for_icon2" title="インデックスで、記事のアイコンとして表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && ( $field::obj{$id}->{'class'} =~ /^file/i
            || $field::obj{$id}->{'class'} =~ /_image/i );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $field::for{'icon2'} && $field::for{'icon2'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_icon3">アイコンフィールド(予備2)</label></td>';
    print
        '<td class="field"><select name="data:for_icon3" id="data:for_icon3" title="インデックスで、記事のアイコンとして表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && ( $field::obj{$id}->{'class'} =~ /^file/i
            || $field::obj{$id}->{'class'} =~ /_image/i );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $field::for{'icon3'} && $field::for{'icon3'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_author">筆者フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_author" id="data:for_author" title="インデックスで、記事の筆者として表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && ( $field::obj{$id}->{'class'} =~ /^text/
            || $field::obj{$id}->{'class'} eq 'select_menu'
            || $field::obj{$id}->{'class'} eq 'select_box' );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $field::for{'author'} && $field::for{'author'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_label">ラベルフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_label" id="data:for_label" title="インデックスで、記事のラベルとして表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && ( $field::obj{$id}->{'class'} =~ /^file/i
            || $field::obj{$id}->{'class'} =~ /_image/i );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $field::for{'label'} && $field::for{'label'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_mark">マークフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_mark" id="data:for_mark" title="インデックスで、記事のマークとして表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && ( $field::obj{$id}->{'class'} =~ /^file/i
            || $field::obj{$id}->{'class'} =~ /_image/i );
        print '<option value="'
            . $id . '"'
            . ( ( defined $field::for{'mark'} && $field::for{'mark'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><price for="data:for_price">価格フィールド</price></td>';
    print
        '<td class="field"><select name="data:for_price" id="data:for_price" title="インデックスで、記事の価格として表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && ( $field::obj{$id}->{'class'} eq 'num'
            || $field::obj{$id}->{'class'} eq 'num_limit'
            || $field::obj{$id}->{'class'} eq 'ysc_cart'
            || $field::obj{$id}->{'class'} =~ /_price/i );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $field::for{'price'} && $field::for{'price'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><score for="data:for_score">点数フィールド</score></td>';
    print
        '<td class="field"><select name="data:for_score" id="data:for_score" title="インデックスで、記事の点数として表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && grep( $field::obj{$id}->{'class'} eq $_,
            'num',       'num_limit', 'num_bargraph',
            'ug_grader', 'ug_vote',   'ug_toggler' );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $field::for{'score'} && $field::for{'score'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_media">メディアフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_media" id="data:for_media">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$i} }
            && ( $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_media'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq
            'file_shipainter'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_epub' );
        print '<option value="'
            . $field::ORDER{$i} . '"'
            . (
            (   defined $field::for{'media'}
                    && $field::for{'media'} eq $field::ORDER{$i}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$i} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_media2">メディアフィールド(予備1)</label></td>';
    print
        '<td class="field"><select name="data:for_media2" id="data:for_media2">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$i} }
            && ( $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_media'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq
            'file_shipainter'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_epub' );
        print '<option value="'
            . $field::ORDER{$i} . '"'
            . (
            (   defined $field::for{'media2'}
                    && $field::for{'media2'} eq $field::ORDER{$i}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$i} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_media3">メディアフィールド(予備2)</label></td>';
    print
        '<td class="field"><select name="data:for_media3" id="data:for_media3">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$i} }
            && ( $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_media'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq
            'file_shipainter'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_epub' );
        print '<option value="'
            . $field::ORDER{$i} . '"'
            . (
            (   defined $field::for{'media3'}
                    && $field::for{'media3'} eq $field::ORDER{$i}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$i} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_coordinates">座標フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_coordinates" id="data:for_coordinates" title="Googleマップにインデックスを表示する際座標とするフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && $field::obj{$id}->{'class'} eq 'webapi_gmap';
        print '<option value="'
            . $id . '"'
            . (
            (   defined $field::for{'coordinates'}
                    && $field::for{'coordinates'} eq $id
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print '</tbody></table>';
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #クラス登録
        Common::class_register( 'H101', 'InfoField' );

        #ツール登録
        $setting::jump_menu{'H101'} = 'ページ情報フィールド設定'
            if !defined $setting::jump_menu{'H101'};
    }
}

1;
