package PageObj;
require CMONOS::HomePageMaker::Tools::HomePage;
@ISA = qw(HomePage);
use strict;
use utf8;
######################################################################
# 共通部品モジュール
# PageObj.pm ver1.1.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-09-13
######################################################################
# 設定チェック項目
sub get_setting_items ($) {
    my $this = shift;

    #数字チェック
    $check::num{'limit'}     = 'インデックス記事見出し数';
    $check::num{'metalimit'} = 'インデックス記事見出し数';

    if ( !$default::subdivided || ( defined $main::c && $main::c ne '' ) ) {

        #数字チェック
        $check::num{'gmapWidth'}    = 'Googleマップ幅';
        $check::num{'gmapHeight'}   = 'Googleマップ高さ';
        $check::num{'gmapMaxWidth'} = '情報ウィンドウ最大幅';

        #チェックボックス
        push( @check::checkbox,
            'gmapOverView', 'gmapStreetView', 'gmapSearch' );
    }

    #文字数チェック
    $check::maxlength{'template'} = 'インデックステンプレート';
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id   = '';                      # データキー
    $preference::name = '共通部品設定';    # 設定パネル名
    $preference::title
        = '共通して利用されるオブジェクトについて設定します。';
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;
    print '<fieldset>';
    print '<legend>ページ移動ボタン設定</legend>';
    print '<fieldset>';
    print '<legend>戻る ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:returnButton', 'return', 120,
        $main::data{'returnButton'} );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>インデックス ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:indexButton', 'index', 120,
        $main::data{'indexButton'} );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>トップページ ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:topButton', 'index', 120,
        $main::data{'topButton'} );
    print '</fieldset>';

    #カテゴリー可かつカテゴリー無指定以外
    unless ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) )
    {
        if ( defined $default::date && $default::date ) {
            print '<fieldset>';
            print '<legend>履歴ページ ボタン</legend>';
            print $cgi::Deco->button_menu( 'data:historyButton', 'index',
                120, $main::data{'historyButton'} );
            print '</fieldset>';
            print '<fieldset>';
            print '<legend>最新の履歴ページ ボタン</legend>';
            print $cgi::Deco->button_menu( 'data:latestHistoryButton',
                'index', 120, $main::data{'latestHistoryButton'} );
            print '</fieldset>';
        }
        print '<fieldset>';
        print '<legend>「前の記事」ボタン</legend>';
        print $cgi::Deco->button_menu( 'data:prevArticle', 'prev', 120,
            $main::data{'prevArticle'} );
        print '</fieldset>';

        print '<fieldset>';
        print '<legend>「次の記事」ボタン</legend>';
        print $cgi::Deco->button_menu( 'data:nextArticle', 'next', 120,
            $main::data{'nextArticle'} );
        print '</fieldset>';

        print '<fieldset>';
        print '<legend>「前のページ」ボタン</legend>';
        print $cgi::Deco->button_menu( 'data:prevButton', 'prev', 120,
            $main::data{'prevButton'} );
        print '</fieldset>';

        print '<fieldset>';
        print '<legend>「次のページ」ボタン</legend>';
        print $cgi::Deco->button_menu( 'data:nextButton', 'next', 120,
            $main::data{'nextButton'} );
        print '</fieldset>';

        if ( defined $default::date && $default::date ) {
            print '<fieldset>';
            print '<legend>「前の履歴」ボタン</legend>';
            print $cgi::Deco->button_menu( 'data:prevHistory', 'prev', 120,
                $main::data{'prevHistory'} );
            print '</fieldset>';

            print '<fieldset>';
            print '<legend>「次の履歴」ボタン</legend>';
            print $cgi::Deco->button_menu( 'data:nextHistory', 'next', 120,
                $main::data{'nextHistory'} );
            print '</fieldset>';
        }
    }
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>ツールボタン設定</legend>';
    print '<fieldset>';
    print '<legend>編集 ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:editButton', 'edit', 120,
        $main::data{'editButton'} );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>環境設定 ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:toolButton', 'tools', 120,
        $main::data{'toolButton'} );
    print '</fieldset>';
    print '</fieldset>';

    $this->print_close_button_setting;
    $this->print_sc_button_setting;

    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {
        my $key = 'metanavi_';
        $key = $main::import . '_'
            if defined $main::import
            && $main::import ne ''
            && %preference::page;
        $this->print_index_template( 'metanavi_', $key, 1 );
        $this->print_index_setting_form( 'metanavi_', $key, 1 );
    }
    else {
        $this->print_index_template( '', '' );
        $this->print_index_setting_form( '', '' );
    }

    print '<fieldset>';
    print
        '<legend><label for="data:recentCommentsTemplate">最新コメント一覧 テンプレート</label></legend>';
    print
        '<textarea name="data:recentCommentsTemplate" id="data:recentCommentsTemplate" cols="72" rows="10" wrap="off" class="content-editor-area">'
        . $this->escape( $main::data{'recentCommentsTemplate'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'data:recentCommentsTemplate\').setAutoFit(this.checked);" />フィット</label> ';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:recentCommentsTemplate\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応する投稿データに変換されます。">';
    print '<option value="">▼投稿データタグを挿入する</option>';
    print
        '<option value="&lt;!--recentcomments limit=&quot;10&quot;--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/recentcomments--&gt;">最新のコメント &lt;!--recentcomments--&gt;&lt;!--/recentcomments--&gt;</option>';
    print
        '<option value="&lt;!--article--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/article--&gt;">記事 &lt;!--recentcomments--&gt;&lt;!--/recentcomments--&gt;</option>';
    print
        '<option value="&lt;!--name--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/name--&gt;">名前 &lt;!--name--&gt;&lt;!--/name--&gt;</option>';
    print
        '<option value="&lt;!--comment--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/comment--&gt;">コメント &lt;!--comment--&gt;&lt;!--/comment--&gt;</option>';
    print
        '<option value="&lt;!--title--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;">タイトル &lt;!--title--&gt;&lt;!--/title--&gt;</option>';
    print
        '<option value="&lt;!--email--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/email--&gt;">メールアドレスリンク &lt;!--email--&gt;&lt;!--/email--&gt;</option>';
    print
        '<option value="&lt;!--url--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/url--&gt;">URLリンク &lt;!--url--&gt;&lt;!--/url--&gt;</option>';
    print
        '<option value="&lt;!--icon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/icon--&gt;">アイコン &lt;!--icon--&gt;&lt;!--/icon--&gt;</option>';
    print
        '<option value="&lt;!--ip--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ip--&gt;">投稿者 IP &lt;!--ip--&gt;&lt;!--/ip--&gt;</option>';
    print
        '<option value="&lt;!--agent--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/agent--&gt;">投稿者環境情報 &lt;!--agent--&gt;&lt;!--/agent--&gt;</option>';
    print
        '<option value="&lt;!--ctime--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ctime--&gt;">投稿日時 &lt;!--ctime--&gt;&lt;!--/ctime--&gt;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot( '<!--recentcomments limit="10"-->\n'
            . '<!--head-->\n'
            . '<ul class="index">\n'
            . '<!--/head-->\n'
            . '<!--article--><!--head-->\n'
            . '<li>\n'
            . '<!--/head-->\n'
            . '<!--title maxlength="32"--><!--/title-->\n'
            . '<!--foot-->\n'
            . '</li>\n'
            . '<!--/foot-->\n'
            . '<!--/article--><!--foot-->\n'
            . '</ul>\n'
            . '<!--/foot-->\n'
            . '<!--/recentcomments-->\n' )
        . '">テンプレート例</option>';
    print '</select>';
    require CMONOS::CGI_Lib::HTMLHelper;
    my $helper = HTMLHelper->new;
    print $helper->html_helper_menu('data:recentCommentsTemplate');
    print '</div>';
    print '</fieldset>';

    print '<fieldset>';
    print
        '<legend><label for="data:recentTrackbacksTemplate">最新トラックバック一覧 テンプレート</label></legend>';
    print
        '<textarea name="data:recentTrackbacksTemplate" id="data:recentTrackbacksTemplate" cols="72" rows="10" wrap="off" class="content-editor-area">'
        . $this->escape( $main::data{'recentTrackbacksTemplate'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'data:recentTrackbacksTemplate\').setAutoFit(this.checked);" />フィット</label> ';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:recentTrackbacksTemplate\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応するトラックバックデータに変換されます。">';
    print '<option value="">▼投稿データタグを挿入する</option>';
    print
        '<option value="&lt;!--recenttrackbacks limit=&quot;10&quot;--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/recenttrackbacks--&gt;">最新のトラックバック &lt;!--recenttrackbacks--&gt;&lt;!--/recenttrackbacks--&gt;</option>';
    print
        '<option value="&lt;!--article--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/article--&gt;">記事 &lt;!--article--&gt;&lt;!--/article--&gt;</option>';
    print
        '<option value="&lt;!--blog_name--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/blog_name--&gt;">サイト名 &lt;!--blog_name--&gt;&lt;!--/blog_name--&gt;</option>';
    print
        '<option value="&lt;!--title--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;">タイトル &lt;!--title--&gt;&lt;!--/title--&gt;</option>';
    print
        '<option value="&lt;!--excerpt--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/excerpt--&gt;">要約 &lt;!--excerpt--&gt;&lt;!--/excerpt--&gt;</option>';
    print
        '<option value="&lt;!--url--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/url--&gt;">URL &lt;!--url--&gt;&lt;!--/url--&gt;</option>';
    print
        '<option value="&lt;!--ip--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ip--&gt;">トラックバック元 IP &lt;!--ip--&gt;&lt;!--/ip--&gt;</option>';
    print
        '<option value="&lt;!--ctime--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ctime--&gt;">トラックバック日時 &lt;!--ctime--&gt;&lt;!--/ctime--&gt;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot( '<!--recenttrackbacks limit="10"-->\n'
            . '<!--head-->\n'
            . '<ul class="index">\n'
            . '<!--/head-->\n'
            . '<!--article--><!--head-->\n'
            . '<li>\n'
            . '<!--/head-->\n'
            . '<!--title maxlength="32"--><!--/title-->\n'
            . '<!--foot-->\n'
            . '</li>\n'
            . '<!--/foot-->\n'
            . '<!--/article--><!--foot-->\n'
            . '</ul>\n'
            . '<!--/foot-->\n'
            . '<!--/recenttrackbacks-->\n' )
        . '">テンプレート例</option>';
    print '</select>';
    print $helper->html_helper_menu('data:recentTrackbacksTemplate');
    print '</div>';
    print '</fieldset>';

    if ( !$default::subdivided || ( defined $main::c && $main::c ne '' ) ) {
        $this->use_field( 'info', $default::field_pref_dir . '/infofield', 2 )
            if !%info::obj;
        $this->use_field( 'field', $default::field_pref_dir . '/inputfield',
            2 )
            if !%field::obj;
        print '<fieldset>';
        print
            '<legend><label for="data:kmlDescriptionTemplateForInfo">KML 情報ウィンドウ テンプレート(ページ情報)</label></legend>';
        print
            '<textarea name="data:kmlDescriptionTemplateForInfo" id="data:kmlDescriptionTemplateForInfo" cols="72" rows="10" wrap="off" class="content-editor-area">'
            . $this->escape( $main::data{'kmlDescriptionTemplateForInfo'} )
            . '</textarea>';
        print '<div class="toolbox">';
        print
            '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'data:kmlDescriptionTemplateForInfo\').setAutoFit(this.checked);" />フィット</label> ';
        print
            '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:kmlDescriptionTemplateForInfo\').quotationByMenu(this)" title="これらのタグは、対応するフィールドデータに変換されます。">';
        print
            '<option value="">▼ページ情報フィールドタグを挿入する</option>';

        foreach my $n ( sort { $a <=> $b } keys %info::ORDER ) {
            my $id = $info::ORDER{$n};
            next
                if !$id
                || $id < 1
                || !ref $info::obj{$id}
                || $info::obj{$id}->{'class'} eq 'webapi_gmap'
                || $info::obj{$id}->{'class'} eq 'select_xmap'
                || $info::obj{$id}->{'class'} =~ /^ug_/;
            print '<option value="&lt;!--info id=&quot;'
                . $id
                . '&quot;--&gt;&lt;!--/info--&gt;">'
                . $id . ' : '
                . $info::obj{$id}->{'name'}
                . '</option>';
        }
        print '<option value=""></option>';
        print
            '<option value="&lt;!--head--&gt;&lt;!--/head--&gt;">フィールドヘッダ</option>';
        print
            '<option value="&lt;!--foot--&gt;&lt;!--/foot--&gt;">フィールドフッタ</option>';
        print
            '<option value="&lt;!--name--&gt;&lt;!--/name--&gt;">フィールド名</option>';
        print
            '<option value="&lt;!--groupname--&gt;&lt;!--/groupname--&gt;">フィールドグループ名</option>';
        print '<option value=""></option>';
        print
            '<option value="&lt;!--counter id=&quot;&quot;--&gt;&lt;!--/counter--&gt;">カウンター</option>';
        print '<option value=""></option>';
        print
            '<option value="&lt;!--if:info id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/if--&gt;">id に値があるとき〜</option>';
        print
            '<option value="&lt;!--unless:info id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/unless--&gt;">id に値がないとき〜</option>';
        print '</select>';
        print $helper->html_helper_menu('data:kmlDescriptionTemplateForInfo');
        print '</div>';
        print '</fieldset>';

        print '<fieldset>';
        print
            '<legend><label for="data:kmlDescriptionTemplate">KML 情報ウィンドウ テンプレート(section)</label></legend>';
        print
            '<textarea name="data:kmlDescriptionTemplate" id="data:kmlDescriptionTemplate" cols="72" rows="10" wrap="off" class="content-editor-area">'
            . $this->escape( $main::data{'kmlDescriptionTemplate'} )
            . '</textarea>';
        print '<div class="toolbox">';
        print
            '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'data:kmlDescriptionTemplate\').setAutoFit(this.checked);" />フィット</label> ';
        print
            '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:kmlDescriptionTemplate\').quotationByMenu(this)" title="これらのタグは、対応するフィールドデータに変換されます。">';
        print
            '<option value="">▼入力フィールドタグを挿入する</option>';

        foreach my $n ( sort { $a <=> $b } keys %field::ORDER ) {
            my $id = $field::ORDER{$n};
            next
                if !$id
                || $id < 1
                || !ref $field::obj{$id}
                || $field::obj{$id}->{'class'} eq 'webapi_gmap'
                || $field::obj{$id}->{'class'} eq 'select_xmap'
                || $field::obj{$id}->{'class'} =~ /^ug_/;
            print '<option value="&lt;!--field id=&quot;'
                . $id
                . '&quot;--&gt;&lt;!--/field--&gt;">'
                . $id . ' : '
                . $field::obj{$id}->{'name'}
                . '</option>';
        }
        print '<option value=""></option>';
        print
            '<option value="&lt;!--head--&gt;&lt;!--/head--&gt;">フィールドヘッダ</option>';
        print
            '<option value="&lt;!--foot--&gt;&lt;!--/foot--&gt;">フィールドフッタ</option>';
        print
            '<option value="&lt;!--name--&gt;&lt;!--/name--&gt;">フィールド名</option>';
        print
            '<option value="&lt;!--groupname--&gt;&lt;!--/groupname--&gt;">フィールドグループ名</option>';
        print '<option value=""></option>';
        print
            '<option value="&lt;!--counter id=&quot;&quot;--&gt;&lt;!--/counter--&gt;">カウンター</option>';
        print '<option value=""></option>';
        print
            '<option value="&lt;!--if id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/if--&gt;">id に値があるとき〜</option>';
        print
            '<option value="&lt;!--unless id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/unless--&gt;">id に値がないとき〜</option>';
        print '</select>';
        print $helper->html_helper_menu('data:kmlDescriptionTemplate');
        print '</div>';
        print '</fieldset>';

        print '<fieldset>';
        print '<legend>Googleマップ表示設定</legend>';
        print
            '<label>幅 <input type="number" size="4" name="data:gmapWidth" id="data:gmapWidth" value="'
            . $this->escape( $main::data{'gmapWidth'} )
            . '" /> px</label> &times; ';
        print
            '<label>高さ <input type="number" size="4" name="data:gmapHeight" id="data:gmapHeight" value="'
            . $this->escape( $main::data{'gmapHeight'} )
            . '" /> px</label>';
        print '<ol class="checkbox">';
        print
            '<li><label><input type="checkbox" name="data:gmapOverView" id="data:gmapOverView" value="1"'
            . ( ( $main::data{'gmapOverView'} ) ? ' checked="checked"' : '' )
            . ' /> 概観地図を表示する</label></li>';
        print
            '<li><label><input type="checkbox" name="data:gmapStreetView" id="data:gmapStreetView" value="1"'
            . (
            ( $main::data{'gmapStreetView'} ) ? ' checked="checked"' : '' )
            . ' /> ストリートビューツールを表示する</label></li>';
        print
            '<li><label><input type="checkbox" name="data:gmapSearch" id="data:gmapSearch" value="1"'
            . ( ( $main::data{'gmapSearch'} ) ? ' checked="checked"' : '' )
            . ' /> 住所検索ツールを表示する</label></li>';
        print '</ol>';
        print '<label>情報ウィンドウ内リンクを';
        print $this->mk_select_menu(
            'data:gmapLinkTarget', '', '', $main::data{'gmapLinkTarget'},
            'p' => '同じウィンドウで開く',
            'b' => '新しいウィンドウで開く',
        );
        print '</label>';
        print
            ' (<label for="data:gmapMaxWidth">情報ウィンドウ最大幅</label>';
        print
            '<input type="number" size="4" name="data:gmapMaxWidth" id="data:gmapMaxWidth" value="'
            . $this->escape( $main::data{'gmapMaxWidth'} )
            . '" /> px)';
        print '</fieldset>';
    }

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

######################################################################
# 設定チェック
sub is_valid_setting ($) {
    my $this = shift;
    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {
        if (   defined $main::data{'metanavi_limit'}
            && $main::data{'metanavi_limit'} ne ''
            && $this->is_nan( $main::data{'metanavi_limit'} ) )
        {
            push(
                @{ $this->{'dialog'} },
                'インデックス記事見出し数を更新できませんでした。半角数字にしてください。'
            );
            delete $main::data{'metanavi_limit'};
        }
        if (   defined $main::data{'metanavi_metalimit'}
            && $main::data{'metanavi_metalimit'} ne ''
            && $this->is_nan( $main::data{'metanavi_metalimit'} ) )
        {
            push(
                @{ $this->{'dialog'} },
                'メタインデックス見出し数を更新できませんでした。半角数字にしてください。'
            );
            delete $main::data{'metanavi_metalimit'};
        }
        if (defined $main::data{'metanavi_template'}
            && bytes::length(
                'metanavi_template' . $main::data{'metanavi_template'}
            ) > $env::db_maxlength
            && $env::db_maxlength > 0
            )
        {
            push(
                @{ $this->{'dialog'} },
                '埋め込みインデックステンプレートを更新できませんでした。容量オーバーです。'
            );
            delete $main::data{'metanavi_template'};
        }
    }
    return;
}

######################################################################
# 登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'H0zz', 'PageObj' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'H0zz'} = '共通部品設定';
    $setting::selected_jump_menu{'H0zz'}
        = ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) )
        ? 'H000'
        : 'H010'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    #画像
    $setting::deco_dir{'index'}   = 'インデックス ボタン';
    $setting::deco_type{'index'}  = 'button';
    $setting::deco_dir{'return'}  = '戻る ボタン';
    $setting::deco_type{'return'} = 'button';
    $setting::deco_dir{'next'}    = '「次」ボタン';
    $setting::deco_type{'next'}   = 'button';
    $setting::deco_dir{'prev'}    = '「前」ボタン';
    $setting::deco_type{'prev'}   = 'button';
    $setting::deco_dir{'edit'}    = '環境設定 ボタン';
    $setting::deco_type{'edit'}   = 'button';
    $setting::deco_dir{'tools'}   = '編集画面 ボタン';
    $setting::deco_type{'tools'}  = 'button';
    $setting::deco_dir{'close'}   = '閉じる ボタン';
    $setting::deco_type{'close'}  = 'button';
    if ( defined $env::checkout && $env::checkout ) {
        $setting::deco_dir{'check'}  = 'カートを見る ボタン';
        $setting::deco_type{'check'} = 'button';
    }
}

1;
