package Editor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 記事編集モジュール
# Editor.pm ver1.1.5
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2016-07-05
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    $this->{'is_tool_master'} = $this->is_secure('tools');

    #---------------------------------------------------------------------
    #承認待ち項目警告
    $this->set_pending_item_alert
        if !defined $main::w
        && !defined $main::chap
        && !defined $main::sect
        && $this->is_secure('edit');

    #---------------------------------------------------------------------
    #必要なモジュール読み込み・設定調整
    use Fcntl qw(:DEFAULT :flock);
    eval 'use ' . $env::dbm_file . ';';
    use File::Path;
    require CMONOS::CGI_Lib::Template;
    require CMONOS::CGI_Lib::Taketori;
    $env::ssi = 0 if $default::home !~ /\.$env::ssi_ext$/;
    if ( !defined $default::file || $default::file eq '' ) {
        ( $default::file = $default::home ) =~ s/[^\/]+$/files/;
        $this->set_dir($default::file);
    }

    $setting::page{'edit'}{'infoLabel'} = 'ページ情報'
        if !$setting::page{'edit'}{'infoLabel'};

    #---------------------------------------------------------------------
    #ロールバック調整
    my $archives_dir = $default::file . '/archives.pending';
    if ($main::rewind) {
        $main::rewind =~ s/[^0-9]//g;
        undef $main::rewind
            if $main::w
            || !$main::rewind
            || !-d "$archives_dir/$main::rewind"
            || !$this->is_secure('rewind');
    }

    #---------------------------------------------------------------------
    #下書き
    my $is_draft;
    my $draft_home
        = $default::file
        . '/draft.pending/'
        . ( ( $default::home =~ /([^\/]+)$/ ) ? $1 : 'index.html' );
    my $draft_files = $default::file . '/draft.pending/files';
    if ( $main::delete && $main::delete eq 'rmdraft' ) {
        if ( -d $default::file . '/draft.pending' ) {
            rmtree $default::file . '/draft.pending';
            push(
                @{ $this->{'dialog'} },
                '下書きを削除しました。'
            );
            undef $main::delete;
        }
    }
    elsif ( -d $default::file . '/draft.pending' ) {
        if ( !$main::w || $main::pending ) {
            $is_draft = 1;
        }
        else {
            $this->file_directory_clear($default::file)
                ;    #旧版の添付ファイルを消す
            $this->file_directory_copy( $draft_files, $default::file )
                ;    #下書き添付ファイルを清書に移動
            $this->home_file_copy( $draft_home, $default::home, $draft_files,
                $default::file );
            $this->waypoints_kml_fix( $default::file . '/i/waypoints.kml',
                $draft_home, $default::home, $draft_files, $default::file );
            rmtree $default::file . '/draft.pending';
        }
    }
    elsif ($main::pending) {
        push(
            @{ $this->{'dialog'} },
            '下書きとして保存しました。'
        );
        $is_draft = 1;
        $this->file_directory_copy( $default::file, $draft_files );
        $this->home_file_copy( $default::home, $draft_home, $default::file,
            $draft_files );
        $this->waypoints_kml_fix( $draft_files . '/i/waypoints.kml',
            $default::home, $draft_home, $default::file, $draft_files );
    }
    if ($is_draft) {
        $this->template_fix(
            \$setting::page{'article'}{'template'},
            $default::home,
            $default::file
                . '/draft.pending/'
                . ( ( $default::home =~ /([^\/]+)$/ ) ? $1 : 'index.html' ),
            $default::file,
            $default::file . '/draft.pending/files'
        ) if $setting::page{'article'}{'template'};
        $this->write_file(
            $default::file . '/draft.pending/.htaccess',
            "order deny,allow\x0Adeny from all\x0A"
                . (
                ( $ENV{'REMOTE_ADDR'} )
                ? "allow from " . $ENV{'REMOTE_ADDR'} . "\x0A"
                : ''
                ),
            1
        );
        $default::home
            = $default::file
            . '/draft.pending/'
            . ( ( $default::home =~ /([^\/]+)$/ ) ? $1 : 'index.html' );
        $default::file = $default::file . '/draft.pending/files';
    }

    #---------------------------------------------------------------------
    #ロールバック
    if ($main::rewind) {
        my $current_dir  = $archives_dir . '/' . $main::rewind;
        my $current_home = $current_dir . '/'
            . ( ( $default::home =~ /([^\/]+)$/ ) ? $1 : 'index.html' );
        my $current_files = $current_dir . '/files';
        $this->file_directory_copy( $current_dir . '/files',
            $default::file, 1 );
        $this->home_file_copy( $current_home, $default::home, $current_files,
            $default::file );
        $this->waypoints_kml_fix( $default::file . '/i/waypoints.kml',
            $current_home, $default::home, $current_files, $default::file );
        $this->save_this_version($archives_dir);
    }

    #---------------------------------------------------------------------

    my $get_last_chapter
        = ( !$main::i && !$main::w && !$setting::general{'getNewChapter'} )
        ? 1
        : 0;
    my $get_last_section
        = ( !$main::i && !$main::w && !$setting::general{'getNewSection'} )
        ? 1
        : 0;
    if ( !$main::i ) {
        if ( $main::chap && $main::chap eq 'new' ) {
            $main::chap       = '';
            $get_last_chapter = 0;
        }
        if ( $main::sect && $main::sect eq 'new' ) {
            $main::sect       = '';
            $get_last_section = 0;
        }
        $main::chap = ''
            if !defined $main::chap
            || !$main::chap
            || $main::chap =~ /[^0-9]/;
        $main::sect = ''
            if !defined $main::sect
            || !$main::sect
            || $main::sect =~ /[^0-9]/;
        if ( $main::chap && $main::chap > 99 ) {
            $main::chap = 99;
            push(
                @{ $this->{'dialog'} },
                '作成できる chapter は 99 までです。'
            );
        }
        if ( $main::sect && $main::sect > 99 ) {
            $main::sect = 99;
            push(
                @{ $this->{'dialog'} },
                '作成できる section は 99 までです。'
            );
        }
    }

#-----------------------------------------------------------------------------
#記事ファイル読み込み
    my ($article);
    local (*FILE);
    if (   $setting::page{'article'}{'template'}
        && $main::delete
        && $main::delete eq 'refresh' )
    {
        $this->file_directory_clear($default::file);
        $this->write_html_file();
        $article = '';
        $this->index_sweeper;
    }
    else {
        $article = $this->read_html_file;
    }
    undef %main::data
        if !$main::w
        && $article
        && ( $main::i || ( $main::chap && $main::sect ) );
    $article = ''
        if $article !~ /[^\x09\x0A\x0C\x0D\x20]/s
        || $article =~ /<!--article_body--><!--\/article_body-->/s;
    my $info_enabled = 0;
    if ((      $article
            && $article
            =~ /<!--info(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/info(?![0-9a-zA-Z_])[^>]*-->/s
        )
        || (  !$article
            && $setting::page{'article'}{'template'}
            && $setting::page{'article'}{'template'}
            =~ /<!--info(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/info(?![0-9a-zA-Z_])[^>]*-->/s
        )
        )
    {
        $info_enabled = 1;
    }
    elsif ($main::i) {
        undef %main::data;
        undef $main::w;
        undef $main::i;
    }

#-----------------------------------------------------------------------------
#テンプレートオブジェクト作成
    $this->mk_template_obj;

#-----------------------------------------------------------------------------
#chapter/section移動
    if ($article) {
        $this->set_last_modified( $this->get_last_modified( \$article ),
            $default::home )
            if $setting::general{'lastModifiedHeaderEnabled'};
        if (  !$main::i
            && $main::moveto
            && $main::chap
            && ( $main::target eq 'chapter' || $main::sect ) )
        {
            $this->{'template'}->subdivision_move_to(
                \$article,   $main::target, $main::chap,
                $main::sect, $main::moveto,
            );
            $this->write_html_file($article);
            $this->save_this_version($archives_dir);
        }
        if ( !$main::i ) {
            $this->set_og_cgi_summary;
            $this->set_description(
                $this->get_metadata_by_name( \$article, 'og:description' ),
                1 );
            $this->set_og_image(
                $this->get_metadata_by_name( \$article, 'og:image' ), 1 );
            $this->set_og_latlng( $this->get_og_latlng( \$article ) );
        }
        $article =~ s/^.*?<!--article_body-->//s;
        $article =~ s/<!--\/article_body-->.*?$//s;
    }

  #テンプレートまたは記事から使用フィールドを取り出す
    $cgi::output = $default::home;
    $this->{'template'}
        ->scan( \$article, \$main::chap, \$main::sect, 'main', 'data',
        $get_last_chapter, $get_last_section );

#-----------------------------------------------------------------------------
#アップロードファイル保存先
    $this->{'filedir'}
        = ($main::i)
        ? $default::file . '/i'
        : $default::file . '/' . $main::chap . '/' . $main::sect;

#-----------------------------------------------------------------------------
#データユニット削除
    if (   !$main::i
        && defined $main::delete
        && ((      $main::delete eq 'rmchapter'
                && ref $this->{'template'}->{'stat'}{'chapter_order'}
                && @{ $this->{'template'}->{'stat'}{'chapter_order'} }
            )
            || (   $main::delete eq 'rmsection'
                && $main::sect
                && ref $this->{'template'}->{'stat'}{'section_order'}
                && @{ $this->{'template'}->{'stat'}{'section_order'} } > 1 )
        )
        && $main::chap
        )
    {

        #添付ファイルディレクトリ削除
        if ( $main::delete eq 'rmsection' ) {
            rmtree "$default::file/$main::chap/$main::sect";
        }
        else {
            rmtree "$default::file/$main::chap";
        }

        $article
            = $this->{'template'}
            ->replace( $main::chap, $main::sect, $this->tag_replace($article),
            \%main::data, $main::delete, $this->{'filedir'}, $main::c,
            $main::n );
        $this->write_html_file($article);

        if ( $main::delete eq 'rmsection' ) {
            $this->index_sweeper( $main::chap, $main::sect );
            $main::sect = '';
        }
        else {
            $this->index_sweeper($main::chap);
            $main::chap = $main::sect = '';
        }
        undef %main::data;
        $this->{'template'}->scan( \$article, \$main::chap, \$main::sect );
        $this->save_this_version($archives_dir);

    }
    elsif ( defined $main::delete
        && ( $main::delete eq 'rmsection' || $main::delete eq 'rmchapter' ) )
    {
        push(
            @{ $this->{'dialog'} },
            '削除に失敗しました。指定を確認してください。'
        );
        undef $main::delete;

#-----------------------------------------------------------------------------
#入力のチェック
    }
    elsif ( defined $main::w && $main::w ) {
        my $input_is_valid = 1;
        if ( @{ $this->{'template'}->{'stat'}{'field'} } ) {
            no warnings qw(numeric);
            foreach my $fid (
                sort {
                    $this->{'field'}->{$a}->{'ORDER'}
                        <=> $this->{'field'}->{$b}->{'ORDER'}
                } @{ $this->{'template'}->{'stat'}{'field'} }
                )
            {
                $input_is_valid = 0
                    if !$this->{'field'}->{$fid}
                    ->is_valid_data( $this->{'filedir'} );
            }
        }

#-----------------------------------------------------------------------------
#書き込み
        if ($input_is_valid) {

            #ファイル保存
            $cgi::input->fix_all_files( $this->{'filedir'} );

            if ( ref $cgi::input->{'dialog'}
                && @{ $cgi::input->{'dialog'} } > 0 )
            {
                push( @{ $this->{'dialog'} }, @{ $cgi::input->{'dialog'} } );
            }

            #後処理
            $this->field_settle_up;

            #ページの更新
            if ($main::i) {
                $this->page_info_update($article);
            }
            else {
                $this->section_update( $article, $main::chap, $main::sect );
            }
            undef $main::refresh;

            #RSS更新
            $this->feed_article_rss($is_draft);

            $this->save_this_version($archives_dir);

        }
        else {
            push(
                @{ $this->{'dialog'} },
                '書き込みに失敗しました。'
            );
        }
    }
    undef $cgi::output;
    undef $cgi::output_option;

#-----------------------------------------------------------------------------
#入力画面

    #ページヘッダ
    $this->print_page_header('edit');

    #戻る/オリジナルページ
    print '<div id="target-selector">';
    print '<ul>';
    print '<li><a href="'
        . $default::home
        . '" target="_blank">実際のページ</a></li>';
    if ($info_enabled) {
        print '<li>';
        print $this->form_start(
            'key'      => 'edit',
            'name'     => 'fieldtype',
            'required' => \@setting::form
        );
        if ($main::i) {
            print '<input type="submit" name="" value="&rsaquo; '
                . ( ( $setting::page{'edit'}{'mainLabel'} )
                ? $setting::page{'edit'}{'mainLabel'}
                : '本文' )
                . '" />';
        }
        else {
            print '<input type="submit" name="i=1" value="&lsaquo; '
                . $setting::page{'edit'}{'infoLabel'} . '" />';
        }
        print '</form></li>';
    }
    print '</ul>';

    #ボディ選択/新規作成
    if ($main::i) {
        push( @setting::form, 'i' );
    }
    else {
        if (   $this->{'template'}->{'chapter_limit'} eq ''
            || $this->{'template'}->{'chapter_limit'} > 1 )
        {
            my $chap_dir
                = ( $this->{'template'}->{'chapter_dir'} eq 'above' )
                ? '[↑]'
                : '[↓]';

            print '<ul>';
            if (   $this->{'template'}->{'stat'}{'prev_chapter'}
                && $this->{'template'}->{'stat'}{'prev_chapter'} ne '<new>' )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'prevchapter',
                    'required' => \@setting::form
                );
                print '<input type="submit" name="chap='
                    . $this->{'template'}->{'stat'}{'prev_chapter'}
                    . '" value="前の chapter" /></form></li>';
            }
            elsif (
                   $this->{'template'}->{'chapter_dir'} eq 'above'
                && !$this->{'template'}->{'stat'}{'new_chapter'}
                && (   !defined $this->{'template'}->{'chapter_limit'}
                    || $this->{'template'}->{'chapter_limit'} eq ''
                    || @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                    < $this->{'template'}->{'chapter_limit'} )
                )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextchapter',
                    'required' => \@setting::form
                );
                print
                    '<input type="submit" name="chap=new" value="新規 chapter 作成'
                    . $chap_dir
                    . '" /></form></li>';
            }

            if (   $this->{'template'}->{'stat'}{'next_chapter'}
                && $this->{'template'}->{'stat'}{'next_chapter'} ne '<new>' )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextchapter',
                    'required' => \@setting::form
                );
                print '<input type="submit" name="chap='
                    . $this->{'template'}->{'stat'}{'next_chapter'}
                    . '" value="次の chapter" /></form></li>';
            }
            elsif (
                   $this->{'template'}->{'chapter_dir'} ne 'above'
                && !$this->{'template'}->{'stat'}{'new_chapter'}
                && (   !defined $this->{'template'}->{'chapter_limit'}
                    || $this->{'template'}->{'chapter_limit'} eq ''
                    || @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                    < $this->{'template'}->{'chapter_limit'} )
                )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextchapter',
                    'required' => \@setting::form
                );
                print
                    '<input type="submit" name="chap=new" value="新規 chapter 作成'
                    . $chap_dir
                    . '" /></form></li>';
            }

            print '<li>';
            print $this->form_start(
                'key'      => 'edit',
                'name'     => 'chapterselector',
                'required' => \@setting::form
            );
            print '<select name="chap" onchange="submit()">';
            print '<option value="new">新規 chapter 作成'
                . $chap_dir
                . '</option>'
                if $this->{'template'}->{'chapter_dir'} eq 'above'
                && !$this->{'template'}->{'stat'}{'new_chapter'}
                && ( !defined $this->{'template'}->{'chapter_limit'}
                || $this->{'template'}->{'chapter_limit'} eq ''
                || @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                < $this->{'template'}->{'chapter_limit'} );
            foreach ( @{ $this->{'template'}->{'stat'}{'chapter_order'} } ) {
                next if $_ eq '';
                print '<option value="'
                    . $_ . '"'
                    . ( ( $main::chap eq $_ ) ? ' selected="selected"' : '' )
                    . '>'
                    . $this->jfold(
                    $this->{'template'}->{'stat'}{'chapter_title'}{$_},
                    24, 'I', 1 )
                    . '</option>';
            }
            print '<option value="new">新規 chapter 作成'
                . $chap_dir
                . '</option>'
                if $this->{'template'}->{'chapter_dir'} ne 'above'
                && !$this->{'template'}->{'stat'}{'new_chapter'}
                && ( !defined $this->{'template'}->{'chapter_limit'}
                || $this->{'template'}->{'chapter_limit'} eq ''
                || @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                < $this->{'template'}->{'chapter_limit'} );
            print
                '</select><input type="submit" value="選択" /></form></li>';
            print '</ul>';

        }
        push( @setting::form, 'chap' );

        #ユニット選択/新規作成
        if (   $this->{'template'}->{'section_limit'} eq ''
            || $this->{'template'}->{'section_limit'} > 1 )
        {
            my $sect_dir
                = ( $this->{'template'}->{'section_dir'} eq 'above' )
                ? '[↑]'
                : '[↓]';

            print '<ul>';
            if (   $this->{'template'}->{'stat'}{'prev_section'}
                && $this->{'template'}->{'stat'}{'prev_section'} ne '<new>' )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'prevsection',
                    'required' => \@setting::form
                );
                print '<input type="submit" name="sect='
                    . $this->{'template'}->{'stat'}{'prev_section'}
                    . '" value="前の section" /></form></li>';
            }
            elsif (
                   $this->{'template'}->{'section_dir'} eq 'above'
                && !$this->{'template'}->{'stat'}{'new_section'}
                && (   !defined $this->{'template'}->{'section_limit'}
                    || $this->{'template'}->{'section_limit'} eq ''
                    || @{ $this->{'template'}->{'stat'}{'section_order'} }
                    < $this->{'template'}->{'section_limit'} )
                )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextsection',
                    'required' => \@setting::form
                );
                print
                    '<input type="submit" name="sect=new" value="新規 section 作成'
                    . $sect_dir
                    . '" /></form></li>';
            }

            if (   $this->{'template'}->{'stat'}{'next_section'}
                && $this->{'template'}->{'stat'}{'next_section'} ne '<new>' )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextsection',
                    'required' => \@setting::form
                );
                print '<input type="submit" name="sect='
                    . $this->{'template'}->{'stat'}{'next_section'}
                    . '" value="次の section" /></form></li>';
            }
            elsif (
                   $this->{'template'}->{'section_dir'} ne 'above'
                && !$this->{'template'}->{'stat'}{'new_section'}
                && (   !defined $this->{'template'}->{'section_limit'}
                    || $this->{'template'}->{'section_limit'} eq ''
                    || @{ $this->{'template'}->{'stat'}{'section_order'} }
                    < $this->{'template'}->{'section_limit'} )
                )
            {
                print '<li>';
                print $this->form_start(
                    'key'      => 'edit',
                    'name'     => 'nextsection',
                    'required' => \@setting::form
                );
                print
                    '<input type="submit" name="sect=new" value="新規 section 作成'
                    . $sect_dir
                    . '" /></form></li>';
            }

            print '<li>';
            print $this->form_start(
                'key'      => 'edit',
                'name'     => 'sectionselector',
                'required' => \@setting::form
            );
            print '<select name="sect" onchange="submit()">';
            print '<option value="new">新規 section 作成'
                . $sect_dir
                . '</option>'
                if $this->{'template'}->{'section_dir'} eq 'above'
                && !$this->{'template'}->{'stat'}{'new_section'}
                && ( !defined $this->{'template'}->{'section_limit'}
                || $this->{'template'}->{'section_limit'} eq ''
                || @{ $this->{'template'}->{'stat'}{'section_order'} }
                < $this->{'template'}->{'section_limit'} );
            foreach ( @{ $this->{'template'}->{'stat'}{'section_order'} } ) {
                next if !defined $_ || $_ eq '';
                print '<option value="'
                    . $_ . '"'
                    . ( ( $main::sect eq $_ ) ? ' selected="selected"' : '' )
                    . '>'
                    . $this->jfold(
                    $this->{'template'}->{'stat'}{'section_title'}{$_},
                    24, 'I', 1 )
                    . '</option>';
            }
            print '<option value="new">新規 section 作成'
                . $sect_dir
                . '</option>'
                if $this->{'template'}->{'section_dir'} ne 'above'
                && !$this->{'template'}->{'stat'}{'new_section'}
                && ( !defined $this->{'template'}->{'section_limit'}
                || $this->{'template'}->{'section_limit'} eq ''
                || @{ $this->{'template'}->{'stat'}{'section_order'} }
                < $this->{'template'}->{'section_limit'} );
            print
                '</select><input type="submit" value="選択" /></form></li>';
            print '</ul>';
        }
        push( @setting::form, 'sect' );
    }
    print '</div>';

    #移動フォーム
    if (!$main::i
        && (   !$this->{'template'}->{'stat'}{'new_chapter'}
            || !$this->{'template'}->{'stat'}{'new_section'} )
        )
    {
        $this->{'template'}->print_subdivision_arrangement_form(
            $this->form_start(
                'key'    => 'edit',
                'name'   => 'subdivision-arrangement-form',
                'method' => 'post',
                'onsubmit' =>
                    'return cmonos.form.item(this).isNotSubmitted()',
                'required' => \@setting::form
            )
        );
    }

    #記事タイトル
    print '<h1 id="editor-article-title">';
    print(
        (   defined $setting::page{'article'}{'title'}
                && $setting::page{'article'}{'title'} ne ''
        ) ? $setting::page{'article'}{'title'} : $setting::general{'cginame'}
    );
    if ($main::i) {
        print ' - ' . $setting::page{'edit'}{'infoLabel'};
    }
    elsif ( $setting::page{'edit'}{'mainLabel'} ) {
        print ' - ' . $setting::page{'edit'}{'mainLabel'};
    }
    print
        ' <span style="color: #FFF; background-color: #f66" title="非公開">下書き</span> '
        if $is_draft;
    print '</h1>';

    #フォーム
    print $this->form_start(
        'key'   => 'edit',
        'name'  => 'input',
        'multi' => ( defined $cgi::enctype_multipart )
        ? $cgi::enctype_multipart
        : '',
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="w" value="1" />';

    print '<table class="field-table"><tbody>';
    if ( defined $this->{'template'}->{'stat'}{'chapter_title_enabled'}
        && $this->{'template'}->{'stat'}{'chapter_title_enabled'} )
    {
        print
            '<tr class="tbody-end"><td class="field-name"><label for="data:title">chapter タイトル</label></td>';
        print
            '<td class="field"><input type="text" size="50" name="data:title" id="data:title" value="'
            . $this->escape( $main::data{'title'} ) . '" />';
        print '</td></tr></tbody><tbody>';
    }
    my $cookie_enabled = 0;
    if ( @{ $this->{'template'}->{'stat'}{'field'} } ) {
        no warnings qw(numeric);
        foreach my $fid (
            sort {
                $this->{'field'}->{$a}->{'ORDER'}
                    <=> $this->{'field'}->{$b}->{'ORDER'}
                    || $a <=> $b
            } @{ $this->{'template'}->{'stat'}{'field'} }
            )
        {
            next unless ref $this->{'field'}->{$fid};
            $cookie_enabled = 1
                if $this->{'field'}->{$fid}->cookie_enabled
                && $this->{'field'}->{$fid}->{'cookie'};
            print $this->{'field'}->{$fid}->form(
                ( ( $this->{'template'}->{'stat'}{'new_section'} ) ? '' : 1 ),
                '', $this->{'filedir'}
            );
        }
    }
    print '</tbody><tbody>';
    print '<tr class="tbody-start"><td class="submit-box" colspan="2">';

    print
        '<label title="同じ内容を入力することが多いいくつかの項目を記憶します。"><input type="checkbox" name="set_cookie" value="1"'
        . ( ( $cookie::read{$cookie::name} || $main::set_cookie )
        ? ' checked="checked"'
        : '' )
        . ' />情報を記憶する</label> '
        if defined $cookie_enabled && $cookie_enabled;
    print
        '<label title="下書きとして保存します。"><input type="checkbox" name="pending" value="1"'
        . ( ($is_draft) ? ' checked="checked"' : '' )
        . ' />下書き</label> ';
    print '<label><input type="checkbox" name="refresh" value="1"'
        . ( ($main::refresh) ? ' checked="checked"' : '' )
        . ' onclick="cmonos.form.field(this).checkboxConfirm(\'最新のテンプレートと旧テンプレートの間に互換性がない場合、データが失われたり表示が崩れることがあります。\\nそれでも最新のテンプレートを使いますか？\')" />最新のテンプレートを使う</label> '
        if $this->{'is_tool_master'} && $setting::page{'article'}{'template'};
    print
        '<label title="RSSを更新します。"><input type="checkbox" name="feed_rss" value="1"'
        . ( ( $setting::general{'rssChecked'} ) ? ' checked="checked"' : '' )
        . ' />RSS更新</label> '
        if $setting::general{'siteRSSEnabled'};
    print
        '<input type="submit" value="保存" class="save" /></td></tr></tbody></table></form>';

    if ( !$setting::general{'rewindable'} ) {
        if ( -d $archives_dir ) {
            use File::Path;
            rmtree $archives_dir;
        }
    }
    elsif ( $this->is_secure('rewind') ) {
        if ( opendir( DIR, $archives_dir ) ) {
            my @dir
                = sort { $this->sort_by( \$a, \$b, 'descend' ) }
                grep( $_ !~ /[^0-9]/ && -d $archives_dir . '/' . $_,
                readdir(DIR) );
            shift @dir;
            my $ip = $ENV{'REMOTE_HOST'}
                || $this->to_host( $ENV{'REMOTE_ADDR'} );
            $this->write_file(
                $archives_dir . '/.htaccess',
                'Satisfy all' . "\x0A"
                    . 'order deny,allow' . "\x0A"
                    . 'deny from all' . "\x0A"
                    . 'allow from '
                    . $ip . "\x0A",
                1
            );
            if (@dir) {
                my $file_name
                    = ( $default::home =~ /([^\/]+)$/ ) ? $1 : 'index.html';
                my $js = <<JAVASCRIPT;
cmonos.tool.openPreviewWindow = function () {
	var preview_enabled = document.getElementById('preview-enabled');
	if (preview_enabled && preview_enabled.checked) {
		var d = cmonos.form.field('rewind').getValue();
		if (d != '') window.open('$archives_dir/'+d+'/$file_name');
	}
};
cmonos.tool.isRewindable = function () {
	if (cmonos.form.field('rewind').getValue() != "") {
		return confirm('この操作は取り消せません。本当に以前の状態に戻しますか？') && cmonos.form.item(this).isNotSubmitted();
	} else {
		alert('以前の記事を選択してください。');
		return false;
	}
};
JAVASCRIPT
                print $this->javascript($js);
                print $this->form_start(
                    'key'      => 'edit',
                    'id'       => 'rewind-form',
                    'name'     => 'rewind-form',
                    'method'   => 'post',
                    'onsubmit' => 'return cmonos.tool.isRewindable()',
                    'required' => \@setting::form
                );
                print '<fieldset class="risky">';
                print
                    '<select name="rewind" id="rewind" onchange="cmonos.tool.openPreviewWindow()">';
                print '<option value="">▼以前の記事'
                    . ( ( $main::email || $this->is_secure('tools') )
                    ? ' [編集者]'
                    : '' )
                    . '</option>';
                foreach my $d (@dir) {
                    my $user = '';
                    if ( $main::email || $this->is_secure('tools') ) {
                        my ( $ip, $ua, $email ) = split(
                            /\x0A/,
                            $this->read_file(
                                $archives_dir . '/' . $d . '/data/author', 1
                            )
                        );
                        if ($email
                            && ( ( $main::email && $email eq $main::email )
                                || $this->is_secure('tools') )
                            )
                        {
                            $user
                                = $cgi::Register->get_name_from_email($email);
                            $user .= ($user) ? '<' . $email . '>' : $email;
                        }
                    }
                    print '<option value="'
                        . $d . '">'
                        . $this->date( $d, 3, $setting::general{'datetype'} )
                        . ( ($user) ? ' [' . $this->escape($user) . ']' : '' )
                        . '</option>';
                }
                print '</select>';
                print 'に<input type="submit" value="戻す" />';
                print
                    ' <label><input type="checkbox" id="preview-enabled" onclick="cmonos.tool.openPreviewWindow()" />プレビュー</label>';
                print '</fieldset>';
                print '</form>';
            }
        }
    }
    if (( !defined $main::delete || $main::delete ne 'refresh' )
        && ($is_draft
            || (   ref $this->{'template'}->{'stat'}{'section_order'}
                && @{ $this->{'template'}->{'stat'}{'section_order'} } > 1
                && !$this->{'template'}->{'stat'}{'new_section'} )
            || (   ref $this->{'template'}->{'stat'}{'chapter_order'}
                && @{ $this->{'template'}->{'stat'}{'chapter_order'} } > 1
                && !$this->{'template'}->{'stat'}{'new_chapter'} )
            || $setting::page{'article'}{'template'}
        )
        )
    {
        print $this->form_start(
            'key'    => 'edit',
            'name'   => 'delete',
            'method' => 'post',
            'onsubmit' =>
                'return confirm(\'この操作は取り消せません。本当に削除しますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
            'required' => \@setting::form
        );
        print '<fieldset id="delete-menu" class="risky">';
        print '<select name="delete"';
        print
            ' title="記事全体を削除すると、新しいテンプレートが読み込まれます。"'
            if $setting::page{'article'}{'template'};
        print '>';
        print '<option value=""></option>';
        if ( !$main::i ) {
            print '<option value="rmsection">この section を</option>'
                if ref $this->{'template'}->{'stat'}{'section_order'}
                && @{ $this->{'template'}->{'stat'}{'section_order'} } > 1
                && !$this->{'template'}->{'stat'}{'new_section'};
            print '<option value="rmchapter">この'
                . (
                (   ref $this->{'template'}->{'stat'}{'chapter_order'}
                        && @{ $this->{'template'}->{'stat'}{'chapter_order'} }
                        > 1
                        && !$this->{'template'}->{'stat'}{'new_chapter'}
                ) ? ' chapter '
                : ( $setting::page{'edit'}{'mainLabel'} )
                ? $setting::page{'edit'}{'mainLabel'}
                : '本文'
                )
                . 'を</option>'
                if ref $this->{'template'}->{'stat'}{'chapter_order'}
                && @{ $this->{'template'}->{'stat'}{'chapter_order'} };
        }
        print '<option value=""></option>';
        if ($is_draft) {
            print '<option value="rmdraft">この下書きを</option>';
        }
        elsif ( $setting::page{'article'}{'template'} ) {
            print '<option value="refresh">記事全体を</option>';
        }
        print
            '</select><input type="submit" value="削除する" /></fieldset></form>';
    }

    #ページフッタ
    $this->print_page_footer('edit');
}

sub mk_template_obj ($) {
    my $this = shift;
    if ($main::i) {
        $this->use_field( 'info', $default::field_pref_dir . '/infofield',
            2, 0, $setting::field_tag_enabled, 'info' )
            if !%info::obj;
        $this->{'template'}  = $this->mk_info_template_obj;
        $this->{'field'}     = \%info::obj;
        $this->{'field_for'} = \%info::for;
    }
    else {
        $this->{'template'}  = $this->mk_article_template_obj;
        $this->{'field'}     = \%field::obj;
        $this->{'field_for'} = \%field::for;
    }
}

sub field_settle_up ($) {
    my $this = shift;
    if ( @{ $this->{'template'}->{'stat'}{'field'} } ) {
        no warnings qw(numeric);
        foreach my $fid (
            sort {
                $this->{'field'}->{$a}->{'ORDER'}
                    <=> $this->{'field'}->{$b}->{'ORDER'}
            } @{ $this->{'template'}->{'stat'}{'field'} }
            )
        {
            $this->{'field'}->{$fid}->settle_up( $this->{'filedir'} )
                if ref $this->{'field'}->{$fid};
        }
    }
}

sub page_info_update ($$) {
    my ( $this, $article ) = @_;
    $this->set_og_cgi_summary;
    if (   $this->{'field_for'}->{'description'}
        && ref $this->{'field'}->{ $this->{'field_for'}->{'description'} }
        && ref $main::data{ $this->{'field_for'}->{'description'} }
        && $main::data{ $this->{'field_for'}->{'description'} }{'str'} )
    {
        $this->set_description(
            $this->{'field'}->{ $this->{'field_for'}->{'description'} }
                ->format_for_text(
                $main::data{ $this->{'field_for'}->{'description'} }{'str'}
                )
        );
    }
    my $image_url;
    if (   $this->{'field_for'}->{'media'}
        && ref $this->{'field'}->{ $this->{'field_for'}->{'media'} }
        && ref $main::data{ $this->{'field_for'}->{'media'} }
        && $main::data{ $this->{'field_for'}->{'media'} }{'str'} )
    {
        $image_url
            = $this->{'field'}->{ $this->{'field_for'}->{'media'} }
            ->image_file_url(
            $main::data{ $this->{'field_for'}->{'media'} }{'str'},
            $default::file );
    }
    if (  !$image_url
        && $this->{'field_for'}->{'media2'}
        && ref $this->{'field'}->{ $this->{'field_for'}->{'media2'} }
        && ref $main::data{ $this->{'field_for'}->{'media2'} }
        && $main::data{ $this->{'field_for'}->{'media2'} }{'str'} )
    {
        $image_url
            = $this->{'field'}->{ $this->{'field_for'}->{'media2'} }
            ->image_file_url(
            $main::data{ $this->{'field_for'}->{'media2'} }{'str'},
            $default::file );
    }
    if (  !$image_url
        && $this->{'field_for'}->{'media3'}
        && ref $this->{'field'}->{ $this->{'field_for'}->{'media3'} }
        && ref $main::data{ $this->{'field_for'}->{'media3'} }
        && $main::data{ $this->{'field_for'}->{'media3'} }{'str'} )
    {
        $image_url
            = $this->{'field'}->{ $this->{'field_for'}->{'media3'} }
            ->image_file_url(
            $main::data{ $this->{'field_for'}->{'media3'} }{'str'},
            $default::file );
    }
    $this->set_og_image($image_url) if $image_url;
    $this->set_og_latlng(
        (   $this->{'field_for'}->{'coordinates'}
                && ref $this->{'field'}
                ->{ $this->{'field_for'}->{'coordinates'} }
                && ref $main::data{ $this->{'field_for'}->{'coordinates'} }
                && $main::data{ $this->{'field_for'}->{'coordinates'} }{'str'}
        )
        ? $this->{'field'}->{ $this->{'field_for'}->{'coordinates'} }
            ->get_latlng(
            $main::data{ $this->{'field_for'}->{'coordinates'} }{'str'},
            $default::file )
        : ( '', '' )
    );
    if (   $this->{'is_tool_master'}
        && $main::refresh
        && $setting::page{'article'}{'template'} )
    {
        my ($new_template);
        if ( $setting::page{'article'}{'template'}
            =~ /<!--field(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/field(?![0-9a-zA-Z_])[^>]*-->/s
            )
        {
            my $article_template = $this->mk_article_template_obj;
            $new_template
                = $article_template->refresh( \$article, '', $default::file,
                'detail' );
        }
        $article
            = $this->{'template'}
            ->refresh( \$article, \$new_template, $default::file . '/i',
            'detail' );
        $this->{'template'}->scan( \$article );
    }
    $this->write_html_file(
        $this->{'template'}->replace(
            $this->tag_replace($article), \%main::data,
            'detail',                     $this->{'filedir'}
        )
    );
}

sub section_update ($$$$) {
    my ( $this, $article, $chap, $sect ) = @_;
    if (   $this->{'is_tool_master'}
        && $main::refresh
        && $setting::page{'article'}{'template'} )
    {
        my ($new_template);
        if ( $setting::page{'article'}{'template'}
            =~ /<!--info(?![0-9a-zA-Z_])[^>]*-->.*?<!--\/info(?![0-9a-zA-Z_])[^>]*-->/s
            )
        {
            local ( %info::obj, %info::for );
            $this->use_field( 'info', $default::field_pref_dir . '/infofield',
                2, 0, $setting::field_tag_enabled, 'info' );
            my $info_template = $this->mk_info_template_obj;
            $new_template = $info_template->refresh( \$article, '',
                $default::file . '/i', 'detail' );
            undef %info::obj;
        }
        $article = $this->{'template'}
            ->refresh( \$article, \$new_template, $default::file, 'detail' );
        $this->{'template'}->scan( \$article, \$chap, \$sect );
    }
    $this->write_html_file(
        $this->{'template'}->replace(
            $chap, $sect, $this->tag_replace($article),
            \%main::data, 'detail', $this->{'filedir'}
        )
    );
    $this->set_dir( $default::file . '/i' );
    require CMONOS::CGI_Lib::WayPointsKML;
    WayPointsKML->new(
        $default::file . '/i/waypoints.kml',
        \%field::obj, \%field::for, $this->full_path($default::home),
        )->update(
        $this->full_path($default::home) . '#a'
            . sprintf( "%.2d", $chap )
            . sprintf( "%.2d", $sect ),
        ( ($main::delete) ? {} : \%main::data ),
        $this->full_path( $this->{'filedir'} )
        );
    push( @{ $this->{'template'}->{'stat'}{'chapter_order'} }, $chap )
        unless grep( $_ eq $chap,
        @{ $this->{'template'}->{'stat'}{'chapter_order'} } );
    push( @{ $this->{'template'}->{'stat'}{'section_order'} }, $sect )
        unless grep( $_ eq $sect,
        @{ $this->{'template'}->{'stat'}{'section_order'} } );
    $this->{'template'}->{'stat'}{'new_chapter'}
        = $this->{'template'}->{'stat'}{'new_section'} = 0;
}

sub feed_article_rss ($$) {
    my ( $this, $is_draft ) = @_;
    if (  !$is_draft
        && $main::feed_rss
        && $setting::general{'siteRSSEnabled'} )
    {
        my $url
            = $this->full_path($default::home)
            . ( ($main::i)
            ? ''
            : '#a'
                . sprintf( "%.2d", $main::chap )
                . sprintf( "%.2d", $main::sect ) );
        $this->feed_rss(
            {   'title' => (
                    (   $this->{'field_for'}->{'title'}
                            && ref $this->{'field'}
                            ->{ $this->{'field_for'}->{'title'} }
                            && $main::data{ $this->{'field_for'}->{'title'} }
                            {'str'}
                    )
                    ? $this->{'field'}->{ $this->{'field_for'}->{'title'} }
                        ->restore->format_for_text(
                        $main::data{ $this->{'field_for'}->{'title'} }{'str'},
                        $this->{'filedir'}, $main::c, $main::n )
                    : ''
                ),
                'link'            => $url,
                'content:encoded' => (
                    (   $this->{'field_for'}->{'description'}
                            && ref $this->{'field'}
                            ->{ $this->{'field_for'}->{'description'} }
                            && $main::data{ $this->{'field_for'}
                                ->{'description'} }{'str'}
                    )
                    ? $this->{'field'}
                        ->{ $this->{'field_for'}->{'description'} }
                        ->restore->format_for_detail(
                        $main::data{ $this->{'field_for'}->{'description'} }
                            {'str'},
                        $this->{'filedir'}, $main::c, $main::n )
                    : ''
                ),
                'enclosure' => $this->article_enclosure(
                    $this->{'field'}, $this->{'field_for'},
                    $this->{'filedir'}
                ),
                'dc:creator' => (
                    ( defined $setting::general{'mastername'} )
                    ? $setting::general{'mastername'}
                    : ''
                ),
                (   (          $env::checkout
                            && $this->{'field_for'}->{'showcase'}
                            && ref $this->{'field'}
                            ->{ $this->{'field_for'}->{'showcase'} }
                    )
                    ? $this->{'field'}->{ $this->{'field_for'}->{'showcase'} }
                        ->get_gdata( $url,
                        $main::data{ $this->{'field_for'}->{'showcase'} } )
                    : ()
                ),
            }
        );
    }
}

sub article_enclosure ($) {
    my $this = shift;
    my $hash
        = (    $this->{'field_for'}->{'media'}
            && ref $this->{'field'}->{ $this->{'field_for'}->{'media'} }
            && $main::data{ $this->{'field_for'}->{'media'} }{'str'} )
        ? {
        $this->{'field'}->{ $this->{'field_for'}->{'media'} }
            ->get_enclosure_attributes(
            $main::data{ $this->{'field_for'}->{'media'} }{'str'},
            $this->{'filedir'}, $main::c, $main::n
            )
        }
        : '';
    $hash
        = (    $this->{'field_for'}->{'media2'}
            && ref $this->{'field'}->{ $this->{'field_for'}->{'media2'} }
            && $main::data{ $this->{'field_for'}->{'media2'} }{'str'} )
        ? {
        $this->{'field'}->{ $this->{'field_for'}->{'media2'} }
            ->get_enclosure_attributes(
            $main::data{ $this->{'field_for'}->{'media2'} }{'str'},
            $this->{'filedir'}, $main::c, $main::n
            )
        }
        : ''
        if !ref $hash || !%$hash;
    $hash
        = (    $this->{'field_for'}->{'media3'}
            && ref $this->{'field'}->{ $this->{'field_for'}->{'media3'} }
            && $main::data{ $this->{'field_for'}->{'media3'} }{'str'} )
        ? {
        $this->{'field'}->{ $this->{'field_for'}->{'media3'} }
            ->get_enclosure_attributes(
            $main::data{ $this->{'field_for'}->{'media3'} }{'str'},
            $this->{'filedir'}, $main::c, $main::n
            )
        }
        : ''
        if !ref $hash || !%$hash;
    return $hash;
}

sub mk_info_template_obj ($) {
    my $this = shift;
    my $template
        = Template->new( \%info::obj, \%info::for, $frame::obj{'frame'} );
    $template->set(
        'field_style_disabled' => 0
        , # 1=フォント設定を無視する/2=スタイル設定も無視する
        'field_tag_enabled' => $setting::field_tag_enabled
        ,   # tag=タグのみ/all=全設定を付記/no=タグをつけない
        'field_tag_name' =>
            'info',    # フィールドタグ デフォルトは<!--field-->
        'default'           => \$setting::page{'article'}{'template'},
        'link_id'           => 'i',
        'tategaki_disabled' => 1,
    );
    return $template;
}

sub mk_article_template_obj ($) {
    my $this = shift;
    my $template
        = Template->new( \%field::obj, \%field::for, $frame::obj{'frame'} );
    $template->set(
        'field_style_disabled' => 0
        , # 1=フォント設定を無視する/2=スタイル設定も無視する
        'field_tag_enabled' => $setting::field_tag_enabled
        ,   # tag=タグのみ/all=全設定を付記/no=タグをつけない
        'field_tag_name' =>
            'field',    # フィールドタグ デフォルトは<!--field-->
        'chapter' => 'chapter',                               # chapter タグ
        'section' => 'section',                               # section タグ
        'default' => \$setting::page{'article'}{'template'},
        'chapter_limit'     => $setting::page{'article'}{'ChapterLimit'},
        'section_limit'     => $setting::page{'article'}{'SectionLimit'},
        'chapter_dir'       => $setting::page{'article'}{'ChapterDir'},
        'section_dir'       => $setting::page{'article'}{'SectionDir'},
        'link_id'           => 'a',
        'tategaki_disabled' => 1,
    );
    return $template;
}

sub save_this_version ($$) {
    my ( $this, $archives_dir ) = @_;
    my $path = $default::home;
    $path =~ s/\.[a-zA-Z]+$//;
    if ( $setting::page{'article'}{'ssiReady'} ) {
        my $article = $this->read_file($default::home);
        $article = $1 if $article =~ /<!--ssi_body-->(.*)<!--\/ssi_body-->/s;
        $article =~ s/^.*?<!--article_body-->//s;
        $article =~ s/<!--\/article_body-->.*?$//s;
        $article =~ s/^.*?<body[^<>]*>//s;
        $article =~ s/<\/body[^<>]*>.*?$//s;
        $this->sim_ssi( \$article );
        $article = $this->rel_to_abs( $article, $default::home, 0, 1, 1 );
        $this->write_file( $path . '.ssi', \$article, 1 );
        $this->mk_external_javascript(
            $path . '.ssi',
            $path . '.js',
            $article
        );
    }
    else {
        $this->write_file( $path . '.ssi', '', 1 ) if !-f $path . '.ssi';
        $this->write_file( $path . '.js',  '', 1 ) if !-f $path . '.js';
    }
    if ( $setting::general{'rewindable'} ) {
        if ( $this->set_dir($archives_dir) ) {
            my $ver         = $this->time_id;
            my $current_dir = $archives_dir . '/' . $ver;
            $this->write_file(
                $archives_dir . '/.htaccess',
                'Satisfy all' . "\x0A"
                    . 'order deny,allow' . "\x0A"
                    . 'deny from all' . "\x0A",
                1
            );
            rmtree $current_dir if -d $current_dir;
            if ( $this->set_dir($current_dir) ) {
                my $current_home
                    = $current_dir . '/'
                    . (
                    ( $default::home =~ /([^\/]+)$/ ) ? $1 : 'index.html' );
                my $current_files = $current_dir . '/files';
                $this->file_directory_copy( $default::file,
                    $current_dir . '/files', 1 );
                $this->home_file_copy(
                    $default::home, $current_home, $default::file,
                    $current_files, $ver
                );
                $this->waypoints_kml_fix(
                    $current_files . '/i/waypoints.kml',
                    $default::home, $current_home,
                    $default::file, $current_files
                );
                if ( $this->set_dir( $current_dir . '/data' ) ) {
                    $this->write_file(
                        $current_dir . '/data/.htaccess',
                        'Satisfy all' . "\x0A"
                            . 'order deny,allow' . "\x0A"
                            . 'deny from all' . "\x0A",
                        1
                    );
                    $this->write_file(
                        $current_dir . '/data/author',
                        (          $ENV{'REMOTE_HOST'}
                                || $this->to_host( $ENV{'REMOTE_ADDR'} )
                            )
                            . "\x0A"
                            . $ENV{'HTTP_USER_AGENT'} . "\x0A"
                            . ( ($main::email) ? $main::email : '' ),
                        1
                    );
                }
            }
            if ( opendir( DIR, $archives_dir ) ) {
                my @dir
                    = sort { $this->sort_by( \$a, \$b, 'descend' ) }
                    grep( $_ !~ /^\./ && -d $archives_dir . '/' . $_,
                    readdir(DIR) );
                closedir(DIR);
                if ( ( $setting::general{'rewindable'} + 1 ) < @dir ) {
                    foreach my $n ( ( $setting::general{'rewindable'} + 1 )
                        .. ( @dir - 1 ) )
                    {
                        rmtree $archives_dir . '/' . $dir[$n];
                    }
                }
            }
        }
    }
}

######################################################################
# ディレクトリをコピー
sub file_directory_copy ($$$;$) {
    my ( $this, $dir, $clone, $skip ) = @_;
    my ( @files, @directories );
    local (*DIR);
    return unless $this->set_dir($clone) && opendir( DIR, $dir );
    while ( my $entry = readdir(DIR) ) {
        my $path = $dir . '/' . $entry;
        next
            if $entry =~ /^\./
            || $entry eq 'draft.pending'
            || $entry eq 'archives.pending'
            || $entry eq 'author'
            || $entry eq 'data';
        if ( -f $path ) {
            push( @files, $entry );
        }
        elsif ( -d $path ) {
            push( @directories, $entry );
        }
    }
    closedir(DIR);
    if (@files) {
        my @clone_files;
        if ( opendir( DIR, $clone ) ) {
            @clone_files
                = grep( $_ !~ /^\./ && $_ ne 'author' && -f $clone . '/' . $_,
                readdir(DIR) );
            closedir(DIR);
        }
        foreach my $f (@files) {
            if (  !$skip
                || $f !~ /\.(?:ssi|js|dat)$/
                || $f =~ /^[0-9]+\.[0-9a-zA-Z_]+\.[0-9a-zA-Z_]+\.dat$/
                || !-f $clone . '/' . $f )
            {
                $this->file_copy( $dir . '/' . $f, $clone . '/' . $f );
            }
            @clone_files = grep( $_ ne $f, @clone_files );
        }
        if (@clone_files) {
            foreach my $f (@clone_files) {
                unlink $clone . '/' . $f;
            }
        }
    }
    if (@directories) {
        my @clone_directories;
        if ( opendir( DIR, $clone ) ) {
            @clone_directories
                = grep( $_ !~ /^\./
                    && $_ ne 'draft.pending'
                    && $_ ne 'archives.pending'
                    && $_ ne 'author'
                    && $_ ne 'data'
                    && -d $clone . '/' . $_,
                readdir(DIR) );
            closedir(DIR);
        }
        foreach my $d (@directories) {
            $this->file_directory_copy( $dir . '/' . $d,
                $clone . '/' . $d, $skip );
            @clone_directories = grep( $_ ne $d, @clone_directories );
        }
        if (@clone_directories) {
            foreach my $d (@clone_directories) {
                rmtree $clone . '/' . $d;
            }
        }
    }
}

sub file_directory_clear ($$) {
    my ( $this, $dir ) = @_;
    my @delete = $this->fileglob( $dir, '^([0-9]+|i)$', 'd' );
    foreach my $d (@delete) {
        rmtree $d;
    }
}

sub home_file_copy ($$$$$;$) {
    my ( $this, $source, $copy, $source_file, $copy_file, $info ) = @_;
    my $data = $this->read_html_file($source);
    my $mtime;
    $mtime = $this->get_last_modified( \$data, $source )
        if $setting::general{'lastModifiedHeaderEnabled'};
    $this->template_fix( \$data, $source, $copy, $source_file, $copy_file,
        $info );
    return $this->write_html_file( $data, $copy, $mtime );
}

sub template_fix ($$$$$$;$) {
    my ( $this, $template_ref, $source, $copy, $source_file, $copy_file,
        $info )
        = @_;
    $$template_ref = Taketori->new->tategaki_to_text($$template_ref)
        if $$template_ref;

    my $here             = $ENV{'SCRIPT_NAME'};
    my $source_path      = $this->path_change( $source, $here, 'abs' );
    my $copy_path        = $this->path_change( $copy, $here, 'abs' );
    my $source_file_path = $this->path_change( $source_file, $here, 'abs' );
    my $copy_file_path   = $this->path_change( $copy_file, $here, 'abs' );
    my $source_file_rel  = $this->base_change( $source_file, $source );
    my $copy_file_rel    = $this->base_change( $copy_file, $copy );
    $$template_ref
        =~ s/(<[^<>]*[\x09\x0A\x0C\x0D\x20]+(?:href|src|background|action)=["']?)(?![0-9a-zA-Z_]+:)([^"\x09\x0A\x0C\x0D\x20]+)([^<>]*>)/$1 . $this->path_base_change($2,$source_path,$copy_path,$source_file_path,$copy_file_path,$source_file_rel,$copy_file_rel) . $3/seig;
    $$template_ref
        =~ s/(<param[\x09\x0A\x0C\x0D\x20]+name=["']?(?:src|movie)["']?[\x09\x0A\x0C\x0D\x20]+value=["']?)(?![0-9a-zA-Z_]+:)([^"\x09\x0A\x0C\x0D\x20]+)([^<>]*>)/$1 . $this->path_base_change($2,$source_path,$copy_path,$source_file_path,$copy_file_path,$source_file_rel,$copy_file_rel) . $3/seig;
    $$template_ref
        =~ s/(<video(?![0-9a-zA-Z_])[^<>]*[\x09\x0A\x0C\x0D\x20]+preview=["']?)(?![0-9a-zA-Z_]+:)([^"\x09\x0A\x0C\x0D\x20]+)([^<>]*>)/$1 . $this->path_base_change($2,$source_path,$copy_path,$source_file_path,$copy_file_path,$source_file_rel,$copy_file_rel) . $3/seig;
    $$template_ref
        =~ s/<!--#include virtual="\Q$source_file_path\E([^">]*)"-->/<!--#include virtual="$copy_file_path$1"-->/sg;

    my $source_url         = $this->full_path($source_path);
    my $copy_url           = $this->full_path($copy_path);
    my $source_url_encoded = $this->url_encode($source_url);
    my $copy_url_encoded   = $this->url_encode($copy_url);
    $$template_ref =~ s/\Q$source_url\E/$copy_url/g;
    $$template_ref =~ s/\Q$source_url_encoded\E/$copy_url_encoded/g;

    my $source_file_url         = $this->full_path($source_file_path);
    my $copy_file_url           = $this->full_path($copy_file_path);
    my $source_file_url_encoded = $this->url_encode($source_file_url);
    my $copy_file_url_encoded   = $this->url_encode($copy_file_url);
    my $source_fla_encoded      = $this->url_encode(
        $this->base_change( $source_file, $env::javascript . '/player' ) );
    my $copy_fla_encoded = $this->url_encode(
        $this->base_change( $copy_file, $env::javascript . '/player' ) );
    $$template_ref =~ s/\Q$source_file_url\E/$copy_file_url/g;
    $$template_ref =~ s/\Q$source_file_url_encoded\E/$copy_file_url_encoded/g;
    $$template_ref =~ s/\Q$source_fla_encoded\E/$copy_fla_encoded/g;

    if ( $source_file_rel ne $copy_file_rel ) {
        my $source_file_rel_encoded = $this->url_encode($source_file_rel);
        my $copy_file_rel_encoded   = $this->url_encode($copy_file_rel);
        $$template_ref
            =~ s/(["'=])\Q$source_file_rel_encoded\E/$1$copy_file_rel_encoded/g;
    }

    if ($info) {
        $info
            = '<div id="cms-rollback-information"><strong>【'
            . $this->date( $info, 3, $setting::general{'datetype'} )
            . '版】</strong></div>';
        $$template_ref =~ s/(<body(?![0-9a-zA-Z_])[^>]*>)/$1$info/si;
    }
    else {
        $$template_ref =~ s/<div id="cms-rollback-information">.*?<\/div>//si;
    }

    $$template_ref = Taketori->new->text_to_tategaki( $$template_ref, 1 )
        if $$template_ref;
}

sub waypoints_kml_fix ($$$$$$) {
    my ( $this, $path, $old_home, $new_home, $old_file, $new_file ) = @_;
    my $old_url              = $this->full_path($old_home);
    my $new_url              = $this->full_path($new_home);
    my $old_url_encoded      = $this->url_encode($old_url);
    my $new_url_encoded      = $this->url_encode($new_url);
    my $old_file_url         = $this->full_path($old_file);
    my $new_file_url         = $this->full_path($new_file);
    my $old_file_url_encoded = $this->url_encode($old_file_url);
    my $new_file_url_encoded = $this->url_encode($new_file_url);
    my $kml                  = $this->read_file( $path, 1 );
    my $is_changed           = 0;
    $is_changed = 1 if $kml =~ s/\Q$old_file_url/$new_file_url/gs;
    $is_changed = 1
        if $kml =~ s/\Q$old_file_url_encoded/$new_file_url_encoded/gs;
    $is_changed = 1 if $kml =~ s/\Q$old_url/$new_url/gs;
    $is_changed = 1 if $kml =~ s/\Q$old_url_encoded/$new_url_encoded/gs;
    $this->write_file( $path, \$kml, 1 ) if $is_changed;
}

sub path_base_change ($$$$$$$$) {
    my ( $this, $url, $source, $copy, $source_file, $copy_file, $source_rel,
        $copy_rel )
        = @_;
    return $url
        if $url eq ''
        || $url =~ s/^\Q$source_rel\E/$copy_rel/
        || $url =~ s/^\Q$source_file\E/$copy_file/
        || $url =~ m!^/!
        || $url =~ /:/
        || $url =~ /\&#58;/
        || $url =~ /^#/;
    return $this->path_change( $this->path_change( $url, $source, 'abs' ),
        $copy, 'rel' );
}

######################################################################
# 記事基本情報更新
sub tag_replace ($$) {
    my ( $this, $article ) = @_;
    my $mtime = $this->time_id;

    #タイトル更新
    if ( $setting::page{'article'}{'template'} ) {
        my $articletitle
            = ( defined $env::title && $env::title ne '' ) ? $env::title : '';
        $articletitle
            .= ( ( $articletitle ne '' ) ? ':' : '' )
            . $setting::general{'cginame'}
            if defined $setting::general{'cginame'}
            && $setting::general{'cginame'} ne '';
        $articletitle
            .= ( ( $articletitle ne '' ) ? ':' : '' )
            . $setting::page{'article'}{'title'}
            if defined $setting::page{'article'}{'title'}
            && $setting::page{'article'}{'title'} ne '';
        $this->escape( \$articletitle );
        $article
            =~ s/(<title(?![0-9a-zA-Z_])[^>]*>).*?(<\/title(?![0-9a-zA-Z_])[^>]*>)/$1$articletitle$2/sgi;
    }

#$article =~ s/<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('title',$1,$2,$setting::general{'cginame'},1)/ges;
    $article
        =~ s/(<\!--index(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/index(?![0-9a-zA-Z_])[^>]*-->|<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->)/(($2 || $3) ? $this->item_tag_replace('title',$2,$3,$setting::general{'cginame'},1) : $1)/ges;
    $article = $this->page_item_replace(
        $article, 1,
        $default::home,
        (   ( $setting::page{'article'}{'title'} ne '' )
            ? $setting::page{'article'}{'title'}
            : $setting::general{'cginame'}
        )
    );

#更新時更新
#$article =~ s/<\!--(mtime)(?![0-9a-zA-Z_])([^>]*)-->.*?<\!--\/mtime-->/$this->date_replace($1,$2,$mtime)/sge;
    $article
        =~ s/(<\!--index(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/index(?![0-9a-zA-Z_])[^>]*-->|<\!--(mtime)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mtime-->)/(($2) ? $this->date_replace($2,$3,$4,$mtime) : $1)/sge;

#日付更新
#$article =~ s/<\!--(date)(?![0-9a-zA-Z_])([^>]*)-->.*?<\!--\/date-->/$this->date_replace($1,$2,substr($mtime,0,8))/sge;
    $article
        =~ s/(<\!--index(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/index(?![0-9a-zA-Z_])[^>]*-->|<\!--(date)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/date-->)/(($2) ? $this->date_replace($2,$3,$4,substr($mtime,0,8)) : $1)/sge;

    #ツールアイコン
    $article
        =~ s/<\!--(edit|tool)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/\1-->/$this->tools_replace($1,$2,$3)/iges;

    #画像付きリンク
    $article
        =~ s/<\!--link(?![0-9a-zA-Z_])([^>]*)-->.*?<\!--\/link-->/$this->image_replace($1)/sge;

    #最新記事
    $article
        =~ s/<\!--(masternavi)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/masternavi-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/metaindex.ssi',1,$default::home),1)/iges;
    $article
        =~ s/<\!--(masterrecentcomments)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/masterrecentcomments-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/recentcomments.ssi',1,$default::home),1)/iges;
    $article
        =~ s/<\!--(masterrecenttrackbacks)(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/masterrecenttrackbacks-->/$this->item_tag_replace($1,$2,$3,$this->include_external_file($env::externalfiles . '\/recenttrackbacks.ssi',1,$default::home),1)/iges;

    return $article;
}

sub tools_replace ($$$$) {
    my ( $this, $tag, $setting, $content ) = @_;
    my ( $header, $footer )
        = $this->get_header_and_footer( $setting, $content );
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+head="([^"]+)"//sg;
    $setting =~ s/[\x09\x0A\x0C\x0D\x20]+foot="([^"]+)"//sg;
    $setting = '' if $setting eq '' || $setting !~ /[^\x09\x0A\x0C\x0D\x20]/;
    my $alt
        = ( $setting =~ / title="([^"]+)"/i ) ? $this->unescape($1)
        : ( $tag eq 'edit' ) ? '編集'
        :                      '環境設定';
    my ( $image_type, $image_id )
        = ( $tag eq 'edit' )
        ? ( 'edit', $setting::page{'editButton'} )
        : ( 'tools', $setting::page{'toolButton'} );
    my $url = $ENV{'SCRIPT_NAME'} . ( ( $tag eq 'tool' ) ? '?m=Tools' : '' );

    if ( $setting =~ / text="([^"]+)"/i ) {
        my $text = $1;
        $content
            = '<a href="'
            . $url . '"'
            . ( ( $setting =~ / class="([^"]+)"/i )
            ? ' class="' . $this->escape_except_html_entity($1) . '"'
            : '' )
            . ' title="'
            . $this->escape_except_html_entity($alt) . '">'
            . $this->escape_except_html_entity($text) . '</a>';
    }
    else {
        $this->use_deco($default::home);
        $content
            = $cgi::Deco->button( $image_type,
            ( ( $setting =~ / image="([0-9]+)"/i ) ? $1 : $image_id ),
            $url, $alt, '_blank', );
    }
    return
          '<!--'
        . $tag
        . $setting . '-->'
        . (
        ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->' : '' )
        . '<!--data-->'
        . $content
        . '<!--/data-->'
        . (
        ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->' : '' )
        . '<!--/'
        . $tag . '-->';
}

sub image_replace ($$) {
    my ( $this, $setting ) = @_;
    my ( $link_setting, $type, $image, $alt, $location, $target );
    $setting = '' if $setting eq '' || $setting !~ /[^\x09\x0A\x0C\x0D\x20]/;
    $link_setting = $setting;
    $this->use_deco($default::home);
    $alt = $this->unescape($1) if $setting =~ s/ title="([^"]+)"//gi;
    $image = $1 if $setting =~ s/ image="([^"]+)"//gi;
    if ( $image eq 'indexButton' ) {
        $type = 'index';
    }
    elsif ( $image eq 'returnButton' ) {
        $type = 'return';
    }
    elsif ( $image eq 'topButton' ) {
        $type   = 'index';
        $target = '_top';
    }
    $location
        = $this->path_change( $1,
        $this->path_change( $default::home, $ENV{'SCRIPT_NAME'}, 'abs' ),
        'abs' )
        if $setting
        =~ s/ location[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"//gi;
    $target = $1
        if $setting
        =~ s/ target[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"//gi;
    return
          '<!--link'
        . $link_setting . '-->'
        . $cgi::Deco->button( $type, $setting::page{$image}, $location, $alt,
        $target, $setting )
        . '<!--/link-->';
}

sub date_replace ($$;$$$$) {
    my ( $this, $tag, $attributes, $content, $time, $old_mtime ) = @_;
    my ( $type, $format, $date_only );
    if ( $content
        =~ s/[\x09\x0A\x0C\x0D\x20]*<\!--format(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/format(?![0-9a-zA-Z_])[^>]*-->//si
        )
    {
        $format = $1;
        $attributes
            .= ' format="'
            . $this->lf_to_entity( $this->escape($format) ) . '"'
            unless $attributes
            =~ s/([\x09\x0A\x0C\x0D\x20]+format[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*")[^"]*(")/$1 . $this->lf_to_entity($this->escape($format)) . $2/gesi;
    }
    elsif ( $attributes
        =~ /[\x09\x0A\x0C\x0D\x20]+format[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"/si
        )
    {
        $format = $this->unescape( $this->entity_to_lf($1) );
    }
    my ( $header, $footer )
        = $this->get_header_and_footer( $attributes, $content );
    $attributes =~ s/[\x09\x0A\x0C\x0D\x20]+head="([^"]+)"//sg;
    $attributes =~ s/[\x09\x0A\x0C\x0D\x20]+foot="([^"]+)"//sg;
    $attributes = ''
        if $attributes eq '' || $attributes !~ /[^\x09\x0A\x0C\x0D\x20]/;
    $date_only = $1
        if $attributes
        && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+dateonly="([12])"/s;
    $time = $1
        if $old_mtime
        && $attributes
        && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+value="([^"]+)"/s;
    $time = $this->time_id if !defined $time || !$time;
    $type
        = (    $attributes
            && $attributes =~ /[\x09\x0A\x0C\x0D\x20]+type="([^"]+)"/s )
        ? $1
        : $setting::general{'datetype'};
    $attributes .= ' value="' . $time . '"'
        unless $attributes
        =~ s/[\x09\x0A\x0C\x0D\x20]+value="([^"]+)"/ value="$time"/gs;
    $type .= ( $date_only == 2 ) ? '>dnw' : '>d' if $date_only;
    return
          '<!--'
        . $tag
        . $attributes . '-->'
        . (
        ( $header ne '' ) ? '<!--head-->' . $header . '<!--/head-->' : '' )
        . $this->date( $time, 0, $type, $format )
        . (
        ( $footer ne '' ) ? '<!--foot-->' . $footer . '<!--/foot-->' : '' )
        . '<!--/'
        . $tag . '-->';
}

######################################################################
# RSSの掃除
sub index_sweeper ($;$$) {
    my ( $this, $chap, $sect ) = @_;
    my ( $target_url, $target_id );
    $target_url = $this->full_path($default::home);
    if ($chap) {
        $target_url .= '#a' . sprintf( "%.2d", $chap );
        $target_id = $chap;
        if ($sect) {
            $target_url .= sprintf( "%.2d", $sect );
            $target_id .= '-' . $sect;
        }
    }
    require CMONOS::CGI_Lib::IndexSweeper;
    IndexSweeper->new(
        'index_files' => [
            $env::externalfiles . '/recentcomments.ssi',
            $env::externalfiles . '/recenttrackbacks.ssi',
        ],
        'rss_files' => [
            '../../index.xml',     '../../comment.xml',
            '../../trackback.xml', '../../podcast.xml',
        ],
        'kml_files' => [ $default::file . '/i/waypoints.kml', ],
        )
        ->sweep( [$target_url],
        { $default::id => ( ( !$target_id ) ? [] : [$target_id] ) } );
}

######################################################################
# 記事取得
sub read_html_file ($;$) {
    my ( $this, $path ) = @_;
    $path = $default::home if !$path;
    if ( !-f $path ) {
        my $old_path = $path;
        $old_path =~ s/\.\w+$//;
        $old_path
            = ( -f $old_path . '.html' ) ? $old_path . '.html'
            : ( -f $old_path . '.htm' )   ? $old_path . '.htm'
            : ( -f $old_path . '.shtml' ) ? $old_path . '.shtml'
            : ( -f $old_path . '.stml' )  ? $old_path . '.stml'
            : ( -f $old_path . '.shtm' )  ? $old_path . '.shtm'
            : ( -f $old_path . '.stm' )   ? $old_path . '.stm'
            :                               '';
        rename( $old_path, $path ) if $old_path;
    }
    my $data = '';
    if ( open( FILE, $path ) ) {
        binmode FILE;
        flock( FILE, LOCK_EX );
        $data = join( '', <FILE> );
        close(FILE);
        if ( !$setting::page{'data'}{'template'} ) {
            my $charset = $this->get_charset_from_html( \$data );
            $data = $this->jcode_convert( \$data, 'utf8', $charset )
                if $charset && $charset ne 'utf8';
        }
        utf8::decode($data);
        $data = Taketori->new->tategaki_to_text($data) if $data;
    }
    return $data;
}

# 記事書き込み
sub write_html_file ($$;$$) {
    my ( $this, $data, $path, $mtime ) = @_;
    $path = $default::home if !$path;
    my ($key);
    local (*OUT);
    $data = '' if !defined $data;
    $data = Taketori->new->text_to_tategaki( $data, 1 ) if $data;
    $this->set_last_modified( $mtime || time )
        if $setting::general{'lastModifiedHeaderEnabled'};
    if (   $data =~ /<body(?![0-9a-zA-Z_])[^>]*>/is
        && $data =~ /<html(?![0-9a-zA-Z_])[^>]*>/is )
    {

        if (   $setting::general{'lastModifiedHeaderEnabled'}
            && $this->{'Last_Modified'} )
        {
            my $last_modified = $this->meta_last_modified;
            unless ( $data
                =~ s/<meta(?!\w)[^>]*?\s+http-equiv=['"]?Last-Modified["']?[^>]*>/$last_modified/gis
                )
            {
                $data =~ s/(<\/title>)/$1\x0A$last_modified/gis;
            }
        }
        elsif ( !$setting::general{'lastModifiedHeaderEnabled'} ) {
            $data
                =~ s/<meta(?!\w)[^>]*?\s+http-equiv=['"]?Last-Modified["']?[^>]*>[\x09\x20]*\x0A?//gis;
        }
        if ( !$setting::page{'article'}{'template'} ) {
            my $charset = $this->get_charset_from_html( \$data );
            $this->jcode_convert( \$data, $charset, 'utf8' )
                if $charset && $charset ne 'utf8';
        }
    }
    else {
        $key = 'article';
    }
    if ( open( OUT, ">>$path" ) ) {
        if ($key) {
            binmode OUT, ":utf8";
        }
        else {
            binmode OUT;
            utf8::encode($data) if utf8::is_utf8($data);
        }
        flock( OUT, LOCK_EX );
        truncate( OUT, 0 );
        seek( OUT, 0, 0 );
        if ($key) {
            $this->set_canonical( $this->full_path($default::home) );
            $this->print_page_header( $key, \*OUT, $default::home );
            print OUT '<!--article_body-->';
        }
        print OUT $data;
        if ($key) {
            print OUT '<!--/article_body-->';
            $this->print_page_footer( $key, \*OUT, $default::home );
        }
        close(OUT);
        return 1;
    }
    push(
        @{ $this->{'dialog'} },
        'ファイルの書き込みに失敗しました。'
    );
    return 0;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::table    = 1;    #テーブル設定読み込み
    $setting::page     = 1;    #ページ設定読み込み

    $setting::field_db_name = 'inputfield';    #フィールド設定DB
    $setting::field         = 2
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 0
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled = 'tag'
        ;    #tag=タグのみ/all=全ての設定/no=タグをつけない

    #設定種キー設定
    $setting::security_key = 'edit';  #デフォルトセキュリティキー

    #クッキー
    $cookie::id_enabled = 1;          #ID情報クッキー読み込み
    $cookie::default_enabled
        = 1;    #ユーザー設定情報クッキー読み込み
    $cookie::name = 'EDITOR';
    $cookie::path = $ENV{'SCRIPT_NAME'};

    #デフォルトキー
    $main::k = 'edit' if !defined $main::k || !$main::k;

    #必須フォーム
    @setting::form = ( 'm', 'k' );
    if ($ENV{'QUERY_STRING'}
        || (   $ENV{'REQUEST_METHOD'}
            && $ENV{'REQUEST_METHOD'} eq 'POST'
            && !$cgi::input->referer_is_me )
        )
    {
        undef $main::w;
        undef $main::moveto;
        undef $main::delete;
    }

    #クラス登録
    Common::class_register( 'edit', 'Editor' );

    $setting::page{'edit'}{'title'} = '記事編集';
}

1;
