package SocialBookmark;
require CMONOS::HomePageMakerLite::Field::HMLUserGeneratedField;
require CMONOS::CGI_Lib::Field::SocialBookmarkBase;
@ISA = qw(HMLUserGeneratedField SocialBookmarkBase);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（ソーシャルブックマーク）
# SocialBookmark.pm 0.9
# Copyright (C) 2008-2018 CMONOS Co. Ltd.
#
#　support@cmonos.jp
#　http://cmonos.jp/
#  最終更新日：2008-01-08
######################################################################
sub get_title_field_id ($) {
    my $this = shift;
    return $field::for{'title'};
}

sub get_spare_title ($) {
    my $this = shift;
    if ( $setting::key && defined $setting::page{$setting::key}{'title'} ) {
        return $setting::page{$setting::key}{'title'};
    }
    elsif ( defined $setting::general{'cginame'} ) {
        return $setting::general{'cginame'};
    }
    else {
        return '';
    }
}

sub get_sbm_title ($) {
    my $this = shift;
    return $this->get_spare_title if $main::i;
    my $title_id = $this->get_title_field_id;
    my $title    = '';
    if ( defined $title_id && $title_id ne '' ) {
        if ( ref $this->{'input_hash'} ) {
            $title = $this->{'input_hash'}{$title_id}{'str'}
                if ref $this->{'input_hash'}{$title_id}
                && defined $this->{'input_hash'}{$title_id}{'str'};
        }
        elsif ( defined $main::data{$title_id}{'str'} ) {
            $title = $main::data{$title_id}{'str'};
        }
    }
    if ( $title ne '' ) {
        $this->text_color( \$title );
        $this->detag( \$title );
        $title =~ s/[\x09\x0A\x0C\x0D\x20]+/ /g;
    }
    else {
        $title = $this->get_spare_title;
    }
    return $title;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'ug_sbm', 'SocialBookmark',
        'ソーシャルブックマーク' );
}

1;
