package ArticlePage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# 記事ページ設定モジュール
# ArticlePage.pm ver1.0.4
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-10-10
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    push( @check::checkbox, 'ssiReady' );

    #数字項目
    $check::num{'ChapterLimit'} = 'chapter数/1ページ'
        if !defined $check::num{'ChapterLimit'};
    $check::num{'SectionLimit'} = 'section数/1ページ'
        if !defined $check::num{'SectionLimit'};
    $check::num{'limit'} = '記事見出し数'
        if defined $default::index
        && $default::index
        && !$check::num{'limit'};

    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'article' if !defined $preference::id; # データキー
    $preference::name = '記事ページレイアウト'
        if !defined $preference::name;    # 設定パネル名
    $preference::title
        = '記事ページのレイアウトについて設定します。'
        if !defined $preference::title;
    $preference::ssi = 1
        if $default::home =~ /\.$env::ssi_ext$/
        && !$preference::ssi;             #SSIを利用可能
    $preference::static_page = 1
        if !$preference::static_page;     #HTMLファイル
}

######################################################################
# フィールド入力支援
sub field_support ($$) {
    my ( $this, $id ) = @_;
    my $tool = '';
    $this->use_field( 'info',  $default::field_pref_dir . '/infofield',  2 );
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );
    if (%info::obj) {
        $tool
            = '<select class="tool" size="1" onchange="cmonos.form.item(this.form).fieldname(\''
            . $id
            . '\').quotationByMenu(this)" title="これらのタグは、対応するページ情報データに変換されます。">';
        $tool
            .= '<option value="">▼ページ情報フィールドタグを挿入する</option>';
        foreach my $n ( sort { $a <=> $b } keys %info::ORDER ) {
            my $id = $info::ORDER{$n};
            next if !ref $info::obj{$id};
            $tool
                .= '<option value="&lt;!--info id=&quot;'
                . $id
                . '&quot;--&gt;&lt;!--/info--&gt;">'
                . $id . ' : '
                . $info::obj{$id}->{'name'}
                . '</option>';
        }
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--head--&gt;&lt;!--/head--&gt;">フィールドヘッダ</option>';
        $tool
            .= '<option value="&lt;!--foot--&gt;&lt;!--/foot--&gt;">フィールドフッタ</option>';
        $tool
            .= '<option value="&lt;!--name--&gt;&lt;!--/name--&gt;">フィールド名</option>';
        $tool
            .= '<option value="&lt;!--groupname--&gt;&lt;!--/groupname--&gt;">フィールドグループ名</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--counter id=&quot;&quot;--&gt;&lt;!--/counter--&gt;">カウンター</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--if:info id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/if--&gt;">id に値があるとき〜</option>';
        $tool
            .= '<option value="&lt;!--unless:info id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/unless--&gt;">id に値がないとき〜</option>';
        $tool .= '</select>';
    }
    if (%field::obj) {
        $tool
            .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
            . $id
            . '\').quotationByMenu(this)" title="これらのタグは、対応するフィールドデータに変換されます。">';
        $tool
            .= '<option value="">▼入力フィールドタグを挿入する</option>';
        $tool
            .= '<option value="&lt;!--chaptertitle--&gt;&lt;!--/chaptertitle--&gt;">chapter タイトル</option>';
        $tool .= '<option value=""></option>';
        foreach my $n ( sort { $a <=> $b } keys %field::ORDER ) {
            my $id = $field::ORDER{$n};
            next if !ref $field::obj{$id};
            $tool
                .= '<option value="&lt;!--field id=&quot;'
                . $id
                . '&quot;--&gt;&lt;!--/field--&gt;">'
                . $id . ' : '
                . $field::obj{$id}->{'name'}
                . '</option>';
        }
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--head--&gt;&lt;!--/head--&gt;">フィールドヘッダ</option>';
        $tool
            .= '<option value="&lt;!--foot--&gt;&lt;!--/foot--&gt;">フィールドフッタ</option>';
        $tool
            .= '<option value="&lt;!--name--&gt;&lt;!--/name--&gt;">フィールド名</option>';
        $tool
            .= '<option value="&lt;!--groupname--&gt;&lt;!--/groupname--&gt;">フィールドグループ名</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--counter id=&quot;&quot;--&gt;&lt;!--/counter--&gt;">カウンター</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--if id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/if--&gt;">id に値があるとき〜</option>';
        $tool
            .= '<option value="&lt;!--unless id=&quot;&quot;--&gt;&lt;!--else--&gt;&lt;!--/unless--&gt;">id に値がないとき〜</option>';
        $tool .= '<option value=""></option>';
        $tool
            .= '<option value="&lt;!--chapterindex--&gt;&lt;!--/chapterindex--&gt;">chapter インデックス</option>';
        $tool
            .= '<option value="&lt;!--chapterarticle--&gt;&lt;!--/chapterarticle--&gt;">chapter 項目</option>';
        $tool
            .= '<option value="&lt;!--chaptertitle--&gt;&lt;!--/chaptertitle--&gt;">chapter タイトル</option>';
        $tool
            .= '<option value="&lt;!--sectionindex--&gt;&lt;!--/sectionindex--&gt;">section インデックス</option>';
        $tool
            .= '<option value="&lt;!--sectionarticle--&gt;&lt;!--/sectionarticle--&gt;">section 項目</option>';
        $tool
            .= '<option value="&lt;!--sectiontitle--&gt;&lt;!--/sectiontitle--&gt;">section タイトル</option>';
        $tool
            .= '<option value="&lt;!--sectiondescription--&gt;&lt;!--/sectiondescription--&gt;">section 説明</option>';
        $tool
            .= '<option value="&lt;!--sectionmedia--&gt;&lt;!--/sectionmedia--&gt;">section メディア</option>';
        $tool
            .= '<option value="'
            . $this->jsquot( '&lt;!--chapterindex--&gt;\n'
                . '&lt;!--head--&gt;&lt;ul class=&quot;chapterindex&quot;&gt;&lt;!--/head--&gt;\n'
                . '&lt;!--chapterarticle--&gt;\n'
                . '&lt;!--head--&gt;&lt;li&gt;&lt;!--/head--&gt;\n'
                . '&lt;!--chaptertitle--&gt;&lt;!--/chaptertitle--&gt;\n'
                . '&lt;!--sectionindex--&gt;\n'
                . '&lt;!--head--&gt;&lt;ul&gt;&lt;!--/head--&gt;\n'
                . '&lt;!--sectionarticle--&gt;\n'
                . '&lt;!--head--&gt;&lt;li&gt;&lt;!--/head--&gt;\n'
                . '&lt;!--sectiontitle--&gt;&lt;!--/sectiontitle--&gt;\n'
                . '&lt;!--sectiondescription--&gt;&lt;!--/sectiondescription--&gt;\n'
                . '&lt;!--foot--&gt;&lt;/li&gt;&lt;!--/foot--&gt;\n'
                . '&lt;!--/sectionarticle--&gt;\n'
                . '&lt;!--foot--&gt;&lt;/ul&gt;&lt;!--/foot--&gt;\n'
                . '&lt;!--/sectionindex--&gt;\n'
                . '&lt;!--foot--&gt;&lt;/li&gt;&lt;!--/foot--&gt;\n'
                . '&lt;!--/chapterarticle--&gt;\n'
                . '&lt;!--foot--&gt;&lt;/ul&gt;&lt;!--/foot--&gt;\n'
                . '&lt;!--/chapterindex--&gt;\n' );
        $tool .= '">chapter インデックス例</option>';
        $tool .= '</select>';
    }
    return $tool;
}

######################################################################
# 設定追加
sub _print_sub_preference_panel ($$;$) {
    my ( $this, $id, $key ) = @_;
    print
        '<fieldset><legend>chapter/section</legend><table class="field-table"><tbody><tr>';
    print
        '<td class="field-name"><label for="data:article_ChapterLimit"><span title="記事 section のセット">chapter</span> 数/1ページ</label></td>';
    print
        '<td class="q-field"><input type="number" size="3" name="data:article_ChapterLimit" id="data:article_ChapterLimit" value="'
        . $this->escape( $main::data{'article_ChapterLimit'} )
        . '" title="1ページあたりの chapter 数を設定してください。" />';
    print '</td>';
    print
        '<td class="field-name"><label for="data:article_ChapterDir"><span title="記事 section のセット">chapter</span> 増設方向</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:article_ChapterDir',
        'chapter の増設方向を設定してください。', '',
        $main::data{'article_ChapterDir'},
        'below' => '下方向↓',
        'above' => '上方向↑'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:article_SectionLimit"><span title="全フィールドを含む記事要素の最小単位">section</span> 数/1 chapter</label></td>';
    print
        '<td class="q-field"><input type="number" size="3" name="data:article_SectionLimit" id="data:article_SectionLimit" value="'
        . $this->escape( $main::data{'article_SectionLimit'} )
        . '" title="1chapter あたりの section 数を設定してください。" /></td>';
    print
        '<td class="field-name"><label for="data:article_SectionDir"><span title="全フィールドを含む記事要素の最小単位">section</span> 増設方向</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:article_SectionDir',
        'section の増設方向を設定してください。', '',
        $main::data{'article_SectionDir'},
        'below' => '下方向↓',
        'above' => '上方向↑'
    );
    print '</td>';
    print '</tr></tbody></table></fieldset>';

    print
        '<fieldset><legend><label><input type="checkbox" name="data:article_ssiReady" value="1"'
        . ( ( $main::data{'article_ssiReady'} ) ? ' checked="checked"' : '' )
        . ' onclick="cmonos.element.item(\'ssi-sample\').disappear(!this.checked);" /> ページテンプレート部分を埋め込み用ファイルに書き出す</label></legend>';
    print
        '<div id="ssi-sample"><p>下記をコピーしてテンプレートや外部 HTML ファイルに埋め込みます。</p><fieldset class="sample"><legend>埋め込みタグ(JavaScript)</legend>';
    my $path = $default::home;
    $path =~ s/\.[a-zA-Z]+$//;
    my $target_uri = $this->http_my_domain
        . $this->path_change( $path . '.js', $ENV{'SCRIPT_NAME'}, 'abs' );
    print
        '<textarea cols="70" rows="3">&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;'
        . $target_uri
        . '&quot; class=&quot;sim-ssi&quot;&gt;&lt;/script&gt;</textarea>';
    print '</fieldset>';

    if ( defined $env::ssi && $env::ssi ) {
        print
            '<fieldset class="sample"><legend>埋め込みタグ(SSI)</legend>';
        print '<textarea cols="70" rows="3">&lt;!--#include virtual=&quot;'
            . $this->path_change( $path . '.ssi', $ENV{'SCRIPT_NAME'}, 'abs' )
            . '&quot;--&gt;</textarea>';
        print '</fieldset>';
    }
    print '</div></fieldset>';
    if ( $main::data{'article_ssiReady'} ) {
        $this->write_file( $path . '.ssi', '', 1 ) if !-f $path . '.ssi';
        $this->write_file( $path . '.js',  '', 1 ) if !-f $path . '.js';
    }
    else {
        print $this->javascript(
            'cmonos.element.item(\'ssi-sample\').disappear(true);');
    }
}

######################################################################
# 入力支援ツール取得
sub input_support ($) {
    my $this = shift;
    my ( $tool, $id );
    $id = 'data:' . $preference::id . '_template';
    $tool
        .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $id
        . '\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切なタグに変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--tool--&gt;&lt;!--/tool--&gt;">環境設定へのリンク</option>';
    $tool
        .= '<option value="&lt;!--edit--&gt;&lt;!--/edit--&gt;">編集画面へのリンク</option>';
    $tool
        .= '<option value="&lt;!--mtime--&gt;&lt;!--/mtime--&gt;">更新時</option>';
    $tool
        .= '<option value="&lt;!--date--&gt;&lt;!--/date--&gt;">日付</option>'
        if defined $default::date && $default::date;
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--masternavi--&gt;&lt;!--/masternavi--&gt;">サイト全体新着記事リスト</option>';
    $tool
        .= '<option value="&lt;!--masterrecentcomments--&gt;&lt;!--/masterrecentcomments--&gt;">サイト全体新着コメントリスト</option>';
    $tool
        .= '<option value="&lt;!--masterrecenttrackbacks--&gt;&lt;!--/masterrecenttrackbacks--&gt;">サイト全体新着トラックバックリスト</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--masterrss title=&quot;RSS2.0&quot;--&gt;&lt;!--/masterrss--&gt;">サイト全体新着記事 RSS へのリンク</option>';
    $tool
        .= '<option value="&lt;!--mastercommentrss title=&quot;RSS2.0(Comment)&quot;--&gt;&lt;!--/mastercommentrss--&gt;">サイト全体新着コメント RSS へのリンク</option>';
    $tool
        .= '<option value="&lt;!--mastertrackbackrss title=&quot;RSS2.0(Trackback)&quot;--&gt;&lt;!--/mastertrackbackrss--&gt;">サイト全体新着トラックバック RSS へのリンク</option>';
    $tool
        .= '<option value="&lt;!--masterpodcast title=&quot;RSS2.0(Podcast)&quot;--&gt;&lt;!--/masterpodcast--&gt;">サイト全体新着ポッドキャスト RSS へのリンク</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--topicpath--&gt;&lt;!--/topicpath--&gt;">トピックパス</option>';
    $tool
        .= '<option value="&lt;!--topicpath type=&quot;list&quot;--&gt;&lt;!--/topicpath--&gt;">トピックパス(&lt;ul&gt;)</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--sitemap--&gt;&lt;!--/sitemap--&gt;">サイトマップ(&lt;!--sitemap--&gt;)</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--ssi_body--&gt;&lt;!--/ssi_body--&gt;">埋め込み用ファイル書き出し範囲</option>';

    if ( defined $default::index && $default::index ) {
        $tool .= '<option value=""></option>';
        $tool .= $this->index_support;
    }
    $tool .= '</select>';
    $tool .= $this->image_support($id);
    $tool .= $this->field_support($id);
    return $tool;
}

sub index_support ($) {
    my $this = shift;
    my ($tool);
    $tool
        .= '<option value="&lt;!--index--&gt;&lt;!--/index--&gt;">インデックス</option>';
    $tool
        .= '<option value="&lt;!--subindex--&gt;&lt;!--/subindex--&gt;">サブインデックス</option>';
    $tool
        .= '<option value="&lt;!--article--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/article--&gt;">記事区画</option>';
    $tool
        .= '<option value="&lt;!--title--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;">記事タイトル</option>';
    $tool
        .= '<option value="&lt;!--description--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/description--&gt;">記事要約</option>';
    $tool
        .= '<option value="&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--subtitle--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitle--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;">記事サブタイトル(chapterタイトル・sectionタイトル)</option>';
    $tool
        .= '<option value="&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--chaptertitle--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/chaptertitle--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;">記事サブタイトル(chapterタイトル)</option>';
    $tool
        .= '<option value="&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--chaptertitle branchhead="&amp;lt;ul&amp;gt;" branchfoot="&amp;lt;/ul&amp;gt;"--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/chaptertitle--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;">記事サブタイトル(chapterタイトル・sectionタイトル)</option>';
    $tool
        .= '<option value="&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--sectiontitle--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/sectiontitle--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;">記事サブタイトル(sectionタイトル)</option>';
    $tool .= '<option value=""></option>';

    $tool .= '<option value="';
    $tool
        .= $this->jsquot( '&lt;!--index--&gt;\n'
            . '&lt;!--subindex--&gt;\n'
            . '&lt;div class=&quot;section&quot;&gt;\n'
            . '&lt;h2&gt;&lt;!--title--&gt;&lt;!--/title--&gt;&lt;/h2&gt;\n'
            . '&lt;div class=&quot;body&quot;&gt;\n'
            . '&lt;!--description--&gt;&lt;!--/description--&gt;\n'
            . '&lt;ul class=&quot;index&quot;&gt;\n'
            . '&lt;!--article--&gt;\n'
            . '&lt;!--head--&gt;&lt;li&gt;&lt;!--/head--&gt;\n'
            . '&lt;!--title--&gt;&lt;!--head--&gt;&lt;div class=&quot;title&quot;&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;/div&gt;&lt;!--/foot--&gt;&lt;!--/title--&gt;\n'
            . '&lt;!--description--&gt;&lt;!--head--&gt;&lt;div class=&quot;description&quot;&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;/div&gt;&lt;!--/foot--&gt;&lt;!--/description--&gt;\n'
            . '&lt;!--subtitlelist--&gt;&lt;!--head--&gt;&lt;ul&gt;&lt;!--/head--&gt;\n'
            . '&lt;!--subtitle--&gt;&lt;!--head--&gt;&lt;li&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;/li&gt;&lt;!--/foot--&gt;&lt;!--/subtitle--&gt;\n'
            . '&lt;!--foot--&gt;&lt;/ul&gt;&lt;!--/foot--&gt;&lt;!--/subtitlelist--&gt;\n'
            . '&lt;!--foot--&gt;&lt;/li&gt;&lt;!--/foot--&gt;\n'
            . '&lt;!--/article--&gt;\n'
            . '&lt;/ul&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;!--/subindex--&gt;\n'
            . '&lt;!--/index--&gt;\n' );
    $tool .= '">インデックス例</option>';

    return $tool;
}

sub image_support ($$) {
    my ( $this, $id ) = @_;
    my ($tool);
    $tool
        .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $id
        . '\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切な画像タグに変換されます。">';
    $tool
        .= '<option value="">▼画像付きリンクタグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--link image=&quot;indexButton&quot; location=&quot;（リンク先を記入）&quot; title=&quot;インデックス&quot;--&gt;&lt;!--/link--&gt;">インデックスアイコン</option>';
    $tool
        .= '<option value="&lt;!--link image=&quot;returnButton&quot; location=&quot;（リンク先を記入）&quot; title=&quot;戻る&quot;--&gt;&lt;!--/link--&gt;">戻るアイコン</option>';
    $tool
        .= '<option value="&lt;!--link image=&quot;topButton&quot; location=&quot;（リンク先を記入）&quot; title=&quot;トップページ&quot;--&gt;&lt;!--/link--&gt;">トップページアイコン</option>';
    $tool .= '</select>';
    return $tool;
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$;$) {
    my ( $this, $id, $key ) = @_;
    my $tool = '';
    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new;
    $this_template->set(
        'chapter' => 'chapter',    # chapterタグ <!--chapter-->
        'section' => 'section'     # sectionタグ <!--section-->
    );

    #入力支援ツール
    $tool = $this->input_support;
    $this_template->print_template_form(
        'data:' . $id . 'template',
        'ページテンプレート（保存時に「最新のテンプレートを使う」まで新しいテンプレートは読み込まれません）',
        \$main::data{ $key . 'template' },
        \$tool,
        'ページテンプレート中に &lt;html&gt; タグおよび &lt;body&gt; タグがある場合、各ページレイアウト設定よりページテンプレートが優先されます。'
    );
    $this->_print_sub_preference_panel( $id, $key );
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'h010', 'ArticlePage' );

    #ツール登録
    $setting::jump_menu{'h010'} = 'ページレイアウト'
        if !defined $setting::jump_menu{'h010'};    #これがデフォルト
    $setting::sub_jump_menu{'page'}{'h010'} = '記事ページ'
        if !defined $setting::sub_jump_menu{'page'}{'h010'};
    $setting::selected_jump_menu{'h010'} = 'h010'
        if !defined $setting::selected_jump_menu{'h010'}
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'h010'} = 'article'
        if !defined $preference::page{'h010'};
}

1;
