package InputField;
require CMONOS::CGI_Lib::Tools::FieldEditor;
@ISA = qw(FieldEditor);
use strict;
use utf8;
######################################################################
# 入力フィールド編集モジュール
# InputField.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-03-16
######################################################################
# フィールド読み込み設定
sub set_field ($) {
    my $this = shift;
    $setting::field_db_name = 'inputfield'
        if !defined $setting::field_db_name;
    $setting::field = 2 if !defined $setting::field || $setting::field != 2;
}

######################################################################
#サブ設定
sub print_sub_setting_items ($) {
    my $this = shift;
    return if !%field::obj;

    print
        '<fieldset><legend>特殊フィールド</legend><table class="field-table"><tbody>';

    print
        '<tr><td class="field-name"><label for="data:for_title">タイトルフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_title" id="data:for_title" title="RSS 配信時に記事のタイトルとして表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && $field::obj{$id}->{'class'}
            =~ /^(?:text|addr_pref|time_date|time_span)/;
        print '<option value="'
            . $id . '"'
            . (
            ( defined $field::for{'title'} && $field::for{'title'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_description">本文フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_description" id="data:for_description" title="RSS配信時に記事の説明として表示するフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$i} }
            && $field::obj{ $field::ORDER{$i} }->{'class'} =~ /^text/;
        print '<option value="'
            . $field::ORDER{$i} . '"'
            . (
            (   defined $field::for{'description'}
                    && $field::for{'description'} eq $field::ORDER{$i}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$i} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_media">メディアフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_media" id="data:for_media">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$i} }
            && ( $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_media'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq
            'file_shipainter'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_epub' );
        print '<option value="'
            . $field::ORDER{$i} . '"'
            . (
            (   defined $field::for{'media'}
                    && $field::for{'media'} eq $field::ORDER{$i}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$i} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_media2">メディアフィールド(予備1)</label></td>';
    print
        '<td class="field"><select name="data:for_media2" id="data:for_media2">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$i} }
            && ( $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_media'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq
            'file_shipainter'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_epub' );
        print '<option value="'
            . $field::ORDER{$i} . '"'
            . (
            (   defined $field::for{'media2'}
                    && $field::for{'media2'} eq $field::ORDER{$i}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$i} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_media3">メディアフィールド(予備2)</label></td>';
    print
        '<td class="field"><select name="data:for_media3" id="data:for_media3">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$i} }
            && ( $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_media'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq
            'file_shipainter'
            || $field::obj{ $field::ORDER{$i} }->{'class'} eq 'file_epub' );
        print '<option value="'
            . $field::ORDER{$i} . '"'
            . (
            (   defined $field::for{'media3'}
                    && $field::for{'media3'} eq $field::ORDER{$i}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$i} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_coordinates">座標フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_coordinates" id="data:for_coordinates" title="Googleマップにインデックスを表示する際座標とするフィールドを指定します。">';
    print '<option value=""></option>';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        next
            unless ref $field::obj{$id}
            && $field::obj{$id}->{'class'} eq 'webapi_gmap';
        print '<option value="'
            . $id . '"'
            . (
            (   defined $field::for{'coordinates'}
                    && $field::for{'coordinates'} eq $id
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print '</tbody></table>';
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';

}

######################################################################
# クラス登録
#sub import {
BEGIN {

    #クラス登録
    Common::class_register( 'h100', 'InputField' );

    #ツール登録
    $setting::jump_menu{'h100'} = '入力フィールド設定'
        if !defined $setting::jump_menu{'h100'};
}

1;
