package ToolNavi;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# メンテナンスステーションモジュール
# ToolNavi.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-01-09
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my ( $pen_flag, %navi );
    $this->import_db( $default::navi_db_dir . '/navi_db', \%navi, 1 );
    $main::mode = $setting::general{'default'}
        if !defined $main::mode || $main::mode eq '';
    $pen_flag = ( defined $main::mode && $main::mode ne 'tool' ) ? 1 : 0;

    #ページヘッダ
    $this->print_navi_page_header(1);

    print '<ul><li id="mode-selector-box">';
    print $this->form_start(
        'key'      => 'toolnavi',
        'id'       => 'modeselector',
        'name'     => 'modeselector',
        'required' => \@setting::form
    );
    print '<input type="image" name="mode=pen" src="'
        . $env::image_dir
        . '/station/pen_'
        . ( ($pen_flag) ? 'down' : 'out' )
        . '.gif" width="20" height="20" alt="入力モード" />';
    print '<input type="image" name="mode=tool" src="'
        . $env::image_dir
        . '/station/tool_'
        . ( ( !$pen_flag ) ? 'down' : 'out' )
        . '.gif" width="20" height="20" alt="環境設定モード" />';
    print '</form></li>';

    # 承認待ち項目データベースをチェック
    if ($pen_flag) {
        if ($env::pending_db) {
            my %pending;
            my $count = 0;
            use Fcntl qw(:DEFAULT);
            eval 'use ' . $env::dbm_file . ';';
            tie( %pending, $env::dbm_file, $env::pending_db, O_RDONLY,
                $env::dbm_mode );
            if ( ref tied %pending ) {
                while ( my ( $k, $v ) = each %pending ) {
                    $count++;
                }
            }
            untie %pending;
            $this->print_cgi_tool_icon( 'station',
                '<strong>未読(' . $count . ')</strong>',
                'MaintenanceStation', 1 )
                if $count;
        }

        # ナビデータに含まれないCGIが利用するモジュール
    }
    else {
        $this->print_cgi_tool_icon( 'setup',
            'セットアップアシスタント',
            'SetupAssistant', 0 );
        $this->print_cgi_tool_icon( 'navimaker', 'ナビメーカー',
            'NaviMaker', 0 );
    }

    #ナビ
    my $registerer_listed = 0;
    foreach my $i ( sort { $a <=> $b } keys %{ $navi{'ORDER'} } ) {
        my ($id);
        $id = $navi{'ORDER'}{$i};
        next if !defined $navi{$id}{'lib'} || !$navi{$id}{'lib'};
        if (  !$pen_flag
            || $navi{$id}{'lib'} =~ /^(HomePage|TableMaker|Baobab|Calendar)/ )
        {
            $this->print_cgi_tool_icon( $id, $navi{$id}{'title'},
                $navi{$id}{'lib'}, $pen_flag );
            $registerer_listed = 1 if $id eq 'pswd';
        }
        elsif ( $navi{$id}{'lib'} eq 'AccessCounter' ) {
            $this->print_cgi_tool_icon( $id, $navi{$id}{'title'},
                'AccessCounter', 1, 'accesscounter' );
        }
        elsif ( $navi{$id}{'lib'} eq 'Accestat' ) {
            $this->print_cgi_tool_icon( $id, $navi{$id}{'title'},
                'Accestat', 1, 'accestat_viewer' );
        }
    }

    # ナビデータに含まれないCGIが利用するモジュール
    if ( !$pen_flag ) {
        if ( $env::zipcode_search eq '../zipcodesearch/start.cgi' ) {
            $this->print_cgi_tool_icon( 'zipcodesearch',
                '郵便番号検索', 'ZipCodeSearch', 0 );
        }
        else {
            $this->print_cgi_tool_icon( 'zipcode', '郵便番号検索',
                'ZipCodeSearch', 0 );
        }
        $this->print_cgi_tool_icon( 'gatekeeper', 'アクセス制限',
            'GateKeeper', 0 );
        $this->print_cgi_tool_icon( 'pswd', 'パスワード登録',
            'Register', 0 )
            if !$registerer_listed
            && $env::register_cgi eq '../pswd/start.cgi';
        $this->print_cgi_tool_icon( 'station',
            'メンテナンスステーション',
            'MaintenanceStation', 0 );
    }
    print '</ul>';

    #ページフッタ
    print '</body></html>';

    #アップデータチェック
    if ($setting::general{'updateCheckInterval'}
        && ( !$setting::general{'updateLastCheck'}
            || time - $setting::general{'updateLastCheck'}
            > $setting::general{'updateCheckInterval'} )
        )
    {
        require CMONOS::SetupAssistant::Tools::SetupEnv;
        my $setup = {};
        bless $setup, 'SetupEnv';
        $setup->get_setup_env(1);
        if ($cgi::cmonos_ver) {
            my $download_dir = 'http://cmonos.jp/download/CMONOS_JP_1x';
            if ( $] >= 5.008001 && $cgi::cmonos_ver >= 20110905 ) {
                $download_dir
                    = ($default::beta_enabled)
                    ? 'http://cmonos.jp/download/CMONOS_JP_beta'
                    : 'http://cmonos.jp/download/CMONOS_JP_2x';
            }
            require CMONOS::CGI_Lib::HTTP_Client;
            my $res = HTTP_Client->new->request(
                'GET' => $download_dir . '/latest_version.txt' );
            my $latest_version
                = ( $res->is_success ) ? $res->content : 20110214;
            $latest_version = 20110905
                if !$latest_version || $latest_version =~ /[^0-9]/s;
            if ( $latest_version > $cgi::cmonos_ver ) {
                print $this->javascript(
                    'if (window.confirm(\'新しいアップデータがみつかりました。システムアップデートに移動しますか？\')) { if (window.parent.tool_main) { window.parent.tool_main.location.href = \'../setup/start.cgi?m=Tools&k=s201\'; } else { window.open(\'../setup/start.cgi?m=Tools&k=s201\'); } }'
                );
            }
        }
        my %general;
        tie(%general, $env::dbm_file,
            $default::preference_dir . '/general',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %general ) {
            $general{'updateLastCheck'} = time;
        }
        untie %general;
    }
}

sub print_cgi_tool_icon ($$$$$;$) {
    my ( $this, $id, $title, $lib, $pen_flag, $name ) = @_;
    if ( $id eq 'order' ) {
        $name = 'checkout';
        $name .= '_pen' if defined $pen_flag && $pen_flag;
    }
    elsif ( !defined $name || !$name ) {
        $name = lc $lib;
        $name .= '_pen' if defined $pen_flag && $pen_flag;
    }
    my $path = '../' . $id . '/start.cgi';
    return '' if !-f $path;
    print '<li id="cgi-' . $id . '">';
    print '<form name="'
        . $id
        . '" method="post" action="'
        . $path . '"'
        . ( ( $main::noframe && !$pen_flag ) ? '' : ' target="tool_main"' )
        . '>';
    if (   !$env::session_enabled
        && defined $main::pswd
        && !ref $main::pswd
        && $main::pswd ne ''
        && !$cookie::read{ $this->login_cookie_name } )
    {
        print '<input type="hidden" name="email" value="'
            . $this->escape($main::email) . '" />';
        print '<input type="hidden" name="pswd" value="'
            . $this->escape($main::pswd) . '" />';
    }
    if ( !$pen_flag ) {
        print '<input type="hidden" name="m" value="Tools" />';
        print '<input type="hidden" name="k" value="0000" />'
            if $lib eq 'SetupAssistant';
    }
    elsif ( $lib eq 'MaintenanceStation' ) {
        print '<input type="hidden" name="m" value="PendingItemViewer" />';
    }
    else {
        print '<input type="hidden" name="m" value="TableViewer" />'
            if $id eq 'order';
        print '<input type="hidden" name="rev_mode" value="1" />'
            if $lib eq 'TableMaker';
    }
    print '<div class="tool-icon"><input type="image" src="'
        . $env::image_dir
        . '/station/'
        . $name
        . '.gif" width="32" height="32" onclick="switchBgColor(\'cgi-'
        . $id
        . '\')" /></div>';
    print '<div class="tool-title">' . $title . '</div></form></li>';
}

######################################################################
#ページヘッダ
sub print_navi_page_header ($;$) {
    my ( $this, $navi_flag ) = @_;
    my $is_mobile
        = (    $ENV{'HTTP_USER_AGENT'}
            && $ENV{'HTTP_USER_AGENT'} =~ /iphone|ipad|ipod|android|mobile/i )
        ? 1
        : 0;

    #クッキー設定
    if ( defined $env::session_enabled && $env::session_enabled ) {
        if ( $session::is_changed && $session::id ne '' ) {
            $this->set_cookie_direct( $env::cookie_lifetime,
                $this->login_cookie_name, $session::id, $env::cgi_server,
                $env::cookie_path );
        }
        elsif ( defined $session::is_deleted && $session::is_deleted ) {
            $this->set_cookie_direct( -1, $this->login_cookie_name, 'null',
                $env::cgi_server, $env::cookie_path );
        }
    }
    elsif ( defined $main::set_cookie_id && $main::set_cookie_id ) {
        $this->set_cookie(
            $env::cookie_lifetime,
            $this->login_cookie_name,
            $env::cgi_server,
            $env::cookie_path,
            { 'pswd', $main::pswd, 'email', $main::email }
        );
    }

    #背景画像
    my $bg_image
        = $env::image_dir
        . ( ( defined $main::mode && $main::mode ne 'tool' )
        ? '/station/bg.gif'
        : '/station/bg_metal.gif' );

    #HTMLヘッダ情報
    $this->{'common_html_header_disabled'} = 1;
    $this->set_alert( $this->dialog );
    $this->set_title( ($navi_flag)
        ? 'メンテナンスステーション'
        : 'ログイン' );
    $this->set_html_header(
        '<meta name="viewport" content="width=device-width" />')
        if $is_mobile;
    $this->set_base( $env::file_server . $ENV{'SCRIPT_NAME'} )
        if defined $env::file_server && $env::file_server;
    if ( $is_mobile && !$main::noframe ) {
        my $javascript .= <<'JAVA';
function moveToTop() {
	if (parent && parent.tool_navi) parent.document.location.href = self.document.location.href.replace(/\\?.*?$/,"") + '?noframe=1';
}
JAVA
        $this->set_onload('moveToTop()');
        $this->set_javascript($javascript);
    }
    if ($navi_flag) {
        my $javascript = <<'JAVA';
function switchBgColor (target_id) {
	var target_tag_array = document.getElementsByTagName('li');
	for (var i = 0; i < target_tag_array.length; i++) {
		if (target_tag_array[i].id == target_id) {
			target_tag_array[i].style.backgroundColor = '#cccccc';
		} else {
			target_tag_array[i].style.backgroundColor = 'transparent';
		}
	}
}
JAVA
        my $white_space = ($main::noframe) ? 'normal' : 'nowrap';
        my $margin      = ($main::noframe) ? '0 auto' : '0';
        my $css         = <<CSS;
body, table {
  font: 14px 'Lucida Grande','Hiragino Kaku Gothic Pro','ヒラギノ角ゴ Pro W3','HiraKakuProN-W3',Verdana,'メイリオ','Meiryo','ＭＳ Ｐゴシック','MS PGothic',Osaka,arial,helvetica,sans-serif;
}
body {
  background: #eee url("$bg_image");
  margin: 0;
  font-size: 14px;
}
form {
  margin: 0;
}
ul {
  word-spacing: -1em;
  display: table;
  margin: $margin;
  padding: 0;
  list-style-type: none;
  text-align: left;
  white-space: $white_space;
}
ul li {
  word-spacing: normal;
  margin: 0;
  padding: 0 5px;
  display: -moz-inline-box;
  display: inline-block;
  height: 70px;
  vertical-align: top;
  text-align: center;
  white-space: nowrap;
  /display: inline;
  /zoom: 1;
  _display: inline;
  _zoom: 1;
}
CSS
        if ($main::noframe) {
            $css .= <<'CSS';
ul li div.tool-icon {
  margin: 10px 0 0 0;
}
ul li#mode-selector-box {
  display: block;
}
ul li#mode-selector-box form input {
  margin: 25px 5px;
}
CSS
        }
        else {
            $javascript .= <<'JAVA';
var title_timer;
function setGetCurrentTitleTimer () {
	if (!parent || !parent.tool_main) {
		self.document.location.href = self.document.location.href.replace(/\\?.*?$/,"") + '?noframe=1';
		return;
	}
	parent.document.title = "";
	title_timer = setInterval("getCurrentTitle()",500);
}
function getCurrentTitle() {
	if (parent.tool_main && parent.document.title != parent.tool_main.document.title) {
		parent.document.title = parent.tool_main.document.title;
		if (parent.tool_main.document.location.href.search(/([0-9a-zA-Z_]+)\/start\.cgi/) > -1) switchBgColor("cgi-"+RegExp.$1);
	}
}
JAVA
            $this->set_onload('setGetCurrentTitleTimer()');
            $css .= <<'CSS';
ul li div.tool-icon {
  margin: 4px 0 0 0;
}
ul li#mode-selector-box form {
  margin: 6px 0 0 0;
}
ul li#mode-selector-box form input {
  display: block;
  margin: 0 0 3px 0;
}
CSS
        }
        $this->set_javascript($javascript);
        $this->set_css($css);
    }
    else {
        $this->set_style_sheet_link( $env::css . '/common.css' );
        $this->set_javascript_link( $env::javascript . '/cmonos.js' );
        if ($main::noframe) {
            $this->set_css(
                "body {  background: #eee none;  margin: 5px;  }\x0Atable.field-table {  margin: 1em auto;  }"
            );
        }
        else {
            $this->set_css( 'body {  background: #eee url("'
                    . $bg_image
                    . '");  margin: 5px;  }' );
        }
    }
    $this->print_html_header();
    $this->reset_html_header;
}

######################################################################
#	(3)-2 obj->print_password_check_form
sub print_password_check_form ($$;$) {
    my ( $this, $key, $new_addr ) = @_;
    push(
        @{ $this->{'dialog'} },
        'メールアドレスまたはパスワードを確認してください。'
    ) if defined $main::pswd && $main::pswd;
    $this->print_navi_page_header;
    print '<form name="gate" method="post" action="' . $cgi::path . '">';
    print $this->set_query( 'post', \@setting::form );
    print '<table class="field-table"><tbody><tr>';
    print
        '<td class="field-name" id="email-name"><label for="email">メールアドレス</label></td><td class="field" id="email-field"><input type="email" name="email" id="email" size="32" value="'
        . $this->escape($main::email)
        . '" /></td>';
    print '</tr><tr>' if $main::noframe;
    print
        '<td class="field-name" id="pswd-name"><label for="pswd">パスワード</label></td><td class="field" id="pswd-field"><input type="password" name="pswd" id="pswd" size="16" />';
    print ' <a href="'
        . $env::register_cgi
        . '" target="LoginWindow" onclick="window.open(\'\',\'LoginWindow\',\'width=450,height=300,scrollbars=no,resizable=yes\')" title="メールアドレス登録"><img src="'
        . $env::image_dir
        . '/tool/login.gif" width="20" height="20" border="0" alt="メールアドレス登録" /></a>';
    print '</td>';

    if ($main::noframe) {
        print '</tr><tr>';
        print '<td colspan="2" class="submit-box">';
    }
    else {
        print '<td class="submit-box">';
    }
    if ( !$env::session_enabled ) {
        print '<label><input type="checkbox" name="set_cookie_id" value="1"'
            . ( ( $cookie::read{ $this->login_cookie_name } )
            ? ' checked="checked"'
            : '' )
            . ' /> ブラウザに記憶させる(ログイン)</label> ';
    }
    print
        '<label><input type="checkbox" name="use_memorized_id" id="use_memorized_id" value="1" onclick="cmonos.element.item(\'email-name\',\'email-field\',\'pswd-name\',\'pswd-field\').disappear(this.checked)" /> ログイン済み</label> '
        if $env::openid_enabled;
    print '<input type="submit" value="ログイン" /></td>';
    print '</tr></tbody></table></form>';
    print '</body></html>';
    exit;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み

    #設定種キー設定
    $setting::security_key
        = 'toolnavi';          #デフォルトセキュリティキー
    $setting::key = 'toolnavi';    #ページ設定キー

    #クッキー
    $cookie::id_enabled = 1;       #ID情報クッキー読み込み

    #デフォルトキー
    $main::k = 'toolnavi' if !defined $main::k || !$main::k;

    #必須フォーム
    @setting::form = ( 'm', 'k', 'noframe' );

    #クラス登録
    Common::class_register( 'toolnavi', 'ToolNavi' );
}

1;
