package TabBgLib;
require CMONOS::CGI_Lib::Tools::BackgroundLib;
@ISA = qw(BackgroundLib);
use strict;
use utf8;
######################################################################
# 背景画像ライブラリ編集モジュール
# TabBgLib.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-02-25
######################################################################
# 設定フォーム
sub print_setting_form ($$$) {
    my $this = shift;
    print
        '<fieldset><legend><label for="setting:border">下端境界線幅</label></legend>';
    print
        '<div class="hints">背景画像の下端に境界線がある場合、その幅を指定します。</div>';
    print
        '<input name="setting:border" id="setting:border" type="text" size="4" value="'
        . $this->escape(
        $this->{'deco_obj'}{'setting'}{$main::dir}{$main::id}{'border'} )
        . '" /> <span class="unit">ピクセル</span>';
    print ' <input type="submit" value="設定を保存" />'
        if defined $main::id && $main::id ne '';
    print '</fieldset>';
    return;
}

######################################################################
# メニュー
sub menu ($$;$$$) {
    my ( $this, $name, $lib_dir, $id, $list ) = @_;
    return $this->{'deco_obj'}
        ->background_menu( $name, $main::dir, 100, $id, 1, $list, $lib_dir,
        1 );
}

######################################################################
# 画像設定登録
sub set_image ($) {
    my $this = shift;
    $this->update_css_files;
    if (   defined $main::image{'image'}
        && $main::image{'image'} ne ''
        && $main::image{'image'} =~ /_([0-9]+)\.[0-9a-zA-Z_]+$/ )
    {
        $setting::deco{$main::dir}{$main::id}{'border'} = $1;
    }
    elsif (defined $main::setting{'border'}
        && $main::setting{'border'} ne ''
        && $this->is_nan( $main::setting{'border'} ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '画像下端境界線幅を更新できませんでした。半角数字にしてください。'
        );
        delete $main::setting{'border'};
    }
    elsif ( defined $main::setting{'border'} ) {
        $setting::deco{$main::dir}{$main::id}{'border'}
            = $main::setting{'border'};
    }
    $setting::deco{$main::dir}{$main::id}{'name'}
        = $this->{'deco_obj'}->background_file_name( $main::dir, $main::id );
    $setting::deco{$main::dir}{$main::id}{'name'} = ''
        if !defined $setting::deco{$main::dir}{$main::id}{'name'};
    $this->set_deco( $main::dir, $main::id,
        $setting::deco{$main::dir}{$main::id} );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    no warnings qw(once);
    $ImageLib::modules{'tabbg'} = 'TabBgLib';
}

1;
