package TagSample;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# タグ見本モジュール
# TagSample.pm ver1.0.2
# Copyright (C) 2008-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-08-21
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my $http = $this->http_my_domain;
    my $xfile_path
        = $this->path_change( $env::externalfiles, $ENV{'SCRIPT_NAME'},
        'abs' );
    my $css_path
        = $this->path_change( $env::css, $ENV{'SCRIPT_NAME'}, 'abs' );

    my $js = <<SCRIPT;
function changeJcode () {
	var input_list = document.getElementsByTagName('input');
	var jcode = 'utf8';
	for (var i in input_list) {
		if (input_list[i].type != null && input_list[i].type == 'radio' && input_list[i].name == 'jcode' && input_list[i].checked) {
			jcode = input_list[i].value;
			break;
		}
	}
	var tag = document.getElementById('tag-sample');
	var js = document.getElementById('js-sample');
	if (jcode == 'sjis') {
		tag.value = tag.value.replace('site-navi.ssi','site-navi-sjis.ssi').replace('site-navi-euc.ssi','site-navi-sjis.ssi')
		js.value = js.value.replace('site-navi.js','site-navi-sjis.js').replace('site-navi-euc.js','site-navi-sjis.js')
	} else if (jcode == 'euc') {
		tag.value = tag.value.replace('site-navi.ssi','site-navi-euc.ssi').replace('site-navi-sjis.ssi','site-navi-euc.ssi')
		js.value = js.value.replace('site-navi.js','site-navi-euc.js').replace('site-navi-sjis.js','site-navi-euc.js')
	} else {
		tag.value = tag.value.replace('site-navi-sjis.ssi','site-navi.ssi').replace('site-navi-euc.ssi','site-navi.ssi')
		js.value = js.value.replace('site-navi-sjis.js','site-navi.js').replace('site-navi-euc.js','site-navi.js')
	}
}
SCRIPT
    $this->set_javascript($js);
    undef $js;

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print <<SMPL;
<h1 title="テキストボックスの中身をコピーしてください。">タグ見本</h1>
<p>追加 URL にサイトナビゲーションを埋め込む場合、コピーして使用します。なお、サイトナビゲーションのボタンあるいはタブを動作させるには、追加 URL の &lt;body&gt; に id 属性を追加する必要があります。id 属性の値は「"document__" + URL 追加時に設定した ID」となります。たとえば、設定した ID が "blog" だった場合「&lt;body id="document__blog"&gt;」となります。id 属性の値については「ナビゲーション作成」で確認できます。</p>
<form action="#">
<fieldset><legend>文字コード</legend>
<label><input type="radio" name="jcode" value="utf8" onclick="changeJcode()" />UTF-8</label>
<label><input type="radio" name="jcode" value="euc" onclick="changeJcode()" checked="checked" />EUC</label>
<label><input type="radio" name="jcode" value="sjis" onclick="changeJcode()" />Shift_JIS</label>
</fieldset>
<fieldset><legend>SSI で埋め込む場合</legend>
<fieldset><legend>&lt;head&gt; 部分に追加するタグ</legend>
<textarea rows="2" cols="96" wrap="off" title="テキストボックスの中身をコピーして &lt;head&gt; 部分に追加します。">
&lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;$css_path/site-navi.css&quot; /&gt;
</textarea>
</fieldset>
<fieldset><legend>&lt;body&gt; 先頭に追加するタグ</legend>
<textarea id="tag-sample" rows="2" cols="96" wrap="off" title="テキストボックスの中身をコピーして &lt;head&gt; 部分に追加します。">
&lt;!--#include virtual=&quot;$xfile_path/site-navi.ssi&quot;--&gt;
</textarea>
</fieldset>
</fieldset>
<fieldset><legend>JavaScript で埋め込む場合</legend>
<fieldset><legend>&lt;head&gt; 部分に追加するタグ</legend>
<textarea rows="2" cols="96" wrap="off" title="テキストボックスの中身をコピーして &lt;head&gt; 部分に追加します。">
&lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;$http$css_path/site-navi.css&quot; /&gt;
</textarea>
</fieldset>
<fieldset><legend>&lt;body&gt; 先頭に追加するタグ</legend>
<textarea id="js-sample" rows="2" cols="96" wrap="off" title="テキストボックスの中身をコピーして &lt;head&gt; 部分に追加します。">
&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;$http$xfile_path/site-navi.js&quot;&gt;&lt;/script&gt;
</textarea>
</fieldset>
</fieldset>
</form>
SMPL

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ($env::inline_navi) {
        no warnings qw(once);

        #クラス登録
        Common::class_register( 'n010', 'TagSample' );

        #メニュー登録
        $setting::jump_menu{'n010'} = 'タグ見本';

    }
}

1;
