package Inquiry;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 問い合わせモジュール
# Inquiry.pm ver1.0.5
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-04-17
######################################################################
# メイン
sub run ($) {
    my $this = shift;

    #期間チェック
    if ( $setting::general{'start'} || $setting::general{'end'} ) {
        my $this_time = time;
        my $start_time
            = ( $setting::general{'start'} )
            ? $setting::general{'fyear'} . '年'
            . $setting::general{'fmon'} . '月'
            . $setting::general{'fmday'} . '日'
            . $setting::general{'fhour'} . '時'
            : '';
        my $end_time
            = ( $setting::general{'end'} )
            ? $setting::general{'tyear'} . '年'
            . $setting::general{'tmon'} . '月'
            . $setting::general{'tmday'} . '日'
            . $setting::general{'thour'} . '時'
            : '';
        if (   $setting::general{'start'}
            && $setting::general{'start'} > $this_time )
        {
            if ( defined $setting::general{'startmsg'}
                && $setting::general{'startmsg'} ne '' )
            {
                $setting::general{'startmsg'} =~ s/<start>/$start_time/sig;
                $setting::general{'startmsg'} =~ s/<end>/$end_time/sig;
            }
            else {
                $setting::general{'startmsg'}
                    = '<p>このアンケートは '
                    . $start_time
                    . ' より開始します。<br />もうしばらくお待ちください。</p>';
            }
            $this->print_page_header('inq');
            print $setting::general{'startmsg'};
            $this->print_page_footer('inq');
            return;
        }
        elsif ($setting::general{'end'}
            && $setting::general{'end'} < $this_time )
        {
            if ( defined $setting::general{'endmsg'}
                && $setting::general{'endmsg'} ne '' )
            {
                $setting::general{'endmsg'} =~ s/<start>/$start_time/sig;
                $setting::general{'endmsg'} =~ s/<end>/$end_time/sig;
            }
            else {
                $setting::general{'endmsg'}
                    = '<p>このアンケートは '
                    . $end_time
                    . ' に終了しました。<br />ご協力ありがとうございました。</p>';
            }
            $this->print_page_header('inq');
            print $setting::general{'endmsg'};
            $this->print_page_footer('inq');
            return;
        }
        elsif ($setting::general{'end'}
            && $setting::general{'end'} < ( $this_time + 1800 ) )
        {
            push(
                @{ $this->{'dialog'} },
                '締め切りまで、あと '
                    . int( ( $setting::general{'end'} - $this_time ) / 60 )
                    . ' 分です。お急ぎください。'
            );
        }
    }
    if (   defined $main::subject
        && $main::subject ne ''
        && defined $field::for{'subject'}
        && ref $field::obj{ $field::for{'subject'} }
        && (   !defined $main::data{ $field::for{'subject'} }
            || !ref $main::data{ $field::for{'subject'} }
            || !defined $main::data{ $field::for{'subject'} }{'str'}
            || $main::data{ $field::for{'subject'} }{'str'} eq '' )
        )
    {
        $main::data{ $field::for{'subject'} }{'str'} = $main::subject;
    }
    undef $main::subject;
    if (   defined $main::message
        && $main::message ne ''
        && defined $field::for{'message'}
        && ref $field::obj{ $field::for{'message'} }
        && (   !defined $main::data{ $field::for{'message'} }
            || !ref $main::data{ $field::for{'message'} }
            || !defined $main::data{ $field::for{'message'} }{'str'}
            || $main::data{ $field::for{'message'} }{'str'} eq '' )
        )
    {
        $main::data{ $field::for{'message'} }{'str'} = $main::message;
    }
    undef $main::message;
    if (   defined $main::url
        && $main::url ne ''
        && defined $field::for{'url'}
        && ref $field::obj{ $field::for{'url'} }
        && (   !defined $main::data{ $field::for{'url'} }
            || !ref $main::data{ $field::for{'url'} }
            || !defined $main::data{ $field::for{'url'} }{'str'}
            || $main::data{ $field::for{'url'} }{'str'} eq '' )
        )
    {
        $main::data{ $field::for{'url'} }{'str'} = $main::url;
    }
    undef $main::url;

    use Fcntl qw(:DEFAULT :flock);
    eval 'use ' . $env::dbm_file . ';';

    #入力のチェック
    my ( $input_is_valid, $msg, $from_name );
    if ( defined $main::a && $main::a eq 'm' ) {
        if ( $field::for{'mail'} && $setting::general{'autoRegister'} ) {
            $field::obj{ $field::for{'mail'} }->{'required'} = 1;
            $field::obj{ $field::for{'mail'} }->{'single'}   = 1;
        }
        $input_is_valid = 1;
        foreach my $fid ( sort { $a <=> $b } keys %field::ORDER ) {
            $input_is_valid = 0
                unless ref $field::obj{ $field::ORDER{$fid} }
                && $field::obj{ $field::ORDER{$fid} }->is_valid_data;
        }

        #連続チェック
        if (   defined $setting::general{'ipStopper'}
            && $setting::general{'ipStopper'}
            && $setting::general{'latestmail'} )
        {
            my ( $mtime, $ip )
                = split( /:/, $setting::general{'latestmail'} );
            if (   $ip
                && $mtime
                && $ip eq (
                           $ENV{'REMOTE_HOST'}
                        || $this->to_host( $ENV{'REMOTE_ADDR'} )
                )
                && time - $mtime <= $setting::general{'ipStopper'}
                )
            {
                push(
                    @{ $this->{'dialog'} },
                    '連続投稿は制限されています。しばらくしてから投稿しなおしてください。'
                );
                $input_is_valid = 0;
            }
        }

        #データ処理
        if ( $input_is_valid && !$main::cancel ) {
            if ( $cgi::confirmation_disabled || $main::ok ) {
                my ( %general, $serial_no, $serial_msg, $list );
                if ( !$setting::general{'attachmentEnabled'} && $mail::file )
                {
                    undef $mail::file;
                    $setting::general{'mailonly'} = 0;
                }

                #一般情報更新
                tie(%general, $env::dbm_file,
                    $default::preference_dir . '/general',
                    O_RDWR | O_CREAT,
                    $env::dbm_mode
                );
                if ( ref tied %general ) {
                    $general{'latestmail'} = $this->encode_utf8(
                        time . ':'
                            . (
                                   $ENV{'REMOTE_HOST'}
                                || $this->to_host( $ENV{'REMOTE_ADDR'} )
                            )
                    );
                    $serial_no = ++$general{'serialno'};
                }
                untie %general;
                if (   $field::for{'serialno'}
                    && ref $main::data{ $field::for{'serialno'} }
                    && defined $main::data{ $field::for{'serialno'} }{'str'}
                    && $main::data{ $field::for{'serialno'} }{'str'} ne '' )
                {
                    $serial_no .= '-'
                        . $main::data{ $field::for{'serialno'} }{'str'};
                    $serial_no =~ s/[^0-9a-zA-Z\-_=\(\)\[\]\{\}]/-/sg;
                }

                #入力通知メール
                if ($this->is_invalid_email_address_header(
                        $setting::general{'mailto'}
                    )
                    && ( !ref $this->{'mail_to'} || !@{ $this->{'mail_to'} } )
                    )
                {
                    $list = $this->data_for_notice_mail( \%field::obj,
                        \%main::data );
                    $setting::general{'mailonly'} = 0;
                }
                else {
                    my ( $subject, $from, $from_name );
                    $subject
                        = (    defined $field::for{'subject'}
                            && ref $field::obj{ $field::for{'subject'} }
                            && ref $main::data{ $field::for{'subject'} }
                            && defined $main::data{ $field::for{'subject'} }
                            {'str'}
                            && $main::data{ $field::for{'subject'} }{'str'}
                            ne '' )
                        ? $field::obj{ $field::for{'subject'} }
                        ->format_for_text(
                        $main::data{ $field::for{'subject'} }{'str'} )
                        : ( defined $setting::general{'subject'} )
                        ? $setting::general{'subject'}
                        : '';
                    $this->detag( \$subject );
                    $subject
                        = ( $setting::general{'cginame'} )
                        ? $setting::general{'cginame'}
                        : 'アンケート'
                        if !$subject;
                    $from
                        = (    defined $field::for{'from'}
                            && ref $field::obj{ $field::for{'from'} }
                            && ref $main::data{ $field::for{'from'} }
                            && defined $main::data{ $field::for{'from'} }
                            {'str'}
                            && $main::data{ $field::for{'from'} }{'str'} )
                        ? $main::data{ $field::for{'from'} }{'str'}
                        : '';
                    $from_name
                        = (    $from ne ''
                            && defined $field::for{'name'}
                            && ref $field::obj{ $field::for{'name'} }
                            && ref $main::data{ $field::for{'name'} }
                            && defined $main::data{ $field::for{'name'} }
                            {'str'} )
                        ? $this->detag(
                        $main::data{ $field::for{'name'} }{'str'} )
                        : '';
                    $from = $from_name . ' <' . $from . '>' if $from ne '';
                    $list = $this->notice_mail(
                        $subject,
                        (   ( $setting::general{'serialnoenabled'} )
                            ? $subject . '(No.' . $serial_no . ')'
                            : $subject
                        ),
                        \%field::obj,
                        \%main::data,
                        $from,
                        $setting::general{'mailto'},
                        (   ( ref $this->{'mail_to'} )
                            ? @{ $this->{'mail_to'} }
                            : ()
                        )
                    );
                }

                #データ保存
                if ( !$setting::general{'mailonly'} ) {
                    no warnings qw(numeric);
                    my (@datafiles, $file_name, $file_no,
                        $file_path, $file_dir
                    );
                    local (*DATA);
                    $file_dir = $default::data . '/files/' . $serial_no;
                    $cgi::input->fix_all_files($file_dir);
                    if ( opendir( DATA, $file_dir ) ) {
                        my @files
                            = sort { $a <=> $b || $a cmp $b }
                            grep( $_ !~ /^\./ && -f $file_dir . '/' . $_,
                            readdir(DATA) );
                        foreach my $file (@files) {
                            if ( $file
                                =~ /^[0-9]+\.([0-9a-zA-Z_]+)\.([0-9a-zA-Z_]+)$/
                                )
                            {
                                my ( $name, $ext ) = ( $1, $2 );
                                while (
                                    -f $file_dir . '/' . $name . '.' . $ext )
                                {
                                    $name .= '-2'
                                        unless $name
                                        =~ s/\-([0-9]+)$/'-' . ($1 + 1)/e;
                                }
                                rename( $file_dir . '/' . $file,
                                    $file_dir . '/' . $name . '.' . $ext );
                            }
                        }
                        if (   $field::for{'name'}
                            && ref $main::data{ $field::for{'name'} }
                            && defined $main::data{ $field::for{'name'} }
                            {'str'}
                            && $main::data{ $field::for{'name'} }{'str'} ne
                            '' )
                        {
                            $this->write_file( $file_dir . '/name',
                                $main::data{ $field::for{'name'} }{'str'},
                                1 );
                        }
                        if (   $field::for{'from'}
                            && ref $main::data{ $field::for{'from'} }
                            && defined $main::data{ $field::for{'from'} }
                            {'str'}
                            && $main::data{ $field::for{'from'} }{'str'} ne
                            '' )
                        {
                            $this->write_file( $file_dir . '/from',
                                $main::data{ $field::for{'from'} }{'str'},
                                1 );
                        }
                        $this->write_file( $file_dir . '/ctime', time, 1 );
                    }

                    opendir( DATA, $default::data );
                    @datafiles
                        = sort { $a <=> $b || $a cmp $b }
                        grep( $_ =~ /[0-9]+\.tsv$/
                            && -f $default::data . '/' . $_,
                        readdir(DATA) );
                    closedir(DATA);

                    $file_name = $datafiles[$#datafiles];
                    $file_no   = $1
                        if $file_name && $file_name =~ /^([0-9]+)\./;
                    if ( !$file_no
                        || -d $default::data . '/' . $file_no . '.checked' )
                    {
                        my $new_file_no = $this->time_id;
                        $new_file_no = $this->time_id( time + 1 )
                            if $file_no && $new_file_no eq $file_no;
                        $file_name = $new_file_no . '.tsv';
                    }
                    $file_path = $default::data . '/' . $file_name;
                    local (*LOG);
                    if ( $this->filelock( $file_path, 2 )
                        && open( LOG, ">>$file_path" ) )
                    {
                        binmode LOG, ":utf8";
                        flock( LOG, LOCK_EX );
                        my $first_flag = 1;
                        print LOG $serial_no . "\x09"
                            if defined $setting::general{'serialnoenabled'}
                            && $setting::general{'serialnoenabled'};
                        foreach my $fid (
                            sort {
                                $field::obj{$a}->{'ORDER'}
                                    <=> $field::obj{$b}->{'ORDER'}
                                    || $a <=> $b
                            } keys %main::data
                            )
                        {
                            my ($data);
                            print LOG "\x09" if !$first_flag;
                            $data
                                = $field::obj{$fid}
                                ->format_for_text( $main::data{$fid}{'str'} )
                                if $field::obj{$fid}->format_for_text_enabled;
                            $data =~ s/\t/ /sg;
                            $data =~ s/(\x0D\x0A|\x0D|\x0A)/\x0B/sg;
                            print LOG $data;
                            $first_flag = 0;
                        }
                        print LOG "\x09", $this->date;
                        print LOG "\x09",
                            (      $ENV{'REMOTE_HOST'}
                                || $this->to_host( $ENV{'REMOTE_ADDR'} ) );
                        print LOG "\x0A";
                        close(LOG);
                        $this->filelock( $file_path, 8 );
                    }
                }

                #自動返信メール
                if ( defined $setting::general{'autores'}
                    && $setting::general{'autores'} )
                {
                    my %thanks;
                    $this->import_db( $default::preference_dir . '/thanks',
                        \%thanks );
                    if (   $thanks{'resmsg'}
                        && $field::for{'from'}
                        && ref $field::obj{ $field::for{'from'} }
                        && $field::obj{ $field::for{'from'} }->{'e-mail'}
                        && $field::obj{ $field::for{'from'} }->{'class'}
                        =~ /email/
                        && ref $main::data{ $field::for{'from'} }
                        && $main::data{ $field::for{'from'} }{'str'} )
                    {
                        if (   $field::for{'name'}
                            && ref $main::data{ $field::for{'name'} }
                            && defined $main::data{ $field::for{'name'} }
                            {'str'}
                            && $main::data{ $field::for{'name'} }{'str'} ne
                            '' )
                        {
                            $thanks{'resmsg'}
                                =~ s/<name>/$main::data{$field::for{'name'}}{'str'}/igs;
                            $thanks{'ressubject'}
                                =~ s/<name>/$main::data{$field::for{'name'}}{'str'}/igs;
                        }
                        else {
                            $thanks{'resmsg'}
                                =~ s/<name>/$thanks{'defaultname'}/igs;
                            $thanks{'ressubject'}
                                =~ s/<name>/$thanks{'defaultname'}/igs;
                        }
                        if ( $thanks{'ressubject'} =~ /<number>/i ) {
                            $thanks{'ressubject'}
                                =~ s/<number>/$serial_no/igs;
                        }
                        if ( $thanks{'resmsg'} =~ /<number>/i ) {
                            $thanks{'resmsg'} =~ s/<number>/$serial_no/igs;
                        }
                        if ( $thanks{'resmsg'} =~ /<data>/i ) {
                            $thanks{'resmsg'} =~ s/<data>/$list/igs;
                        }
                        unless ( ref $cgi::SendMail ) {
                            require CMONOS::CGI_Lib::SendMail;
                            $cgi::SendMail = SendMail->new( $env::sendmail,
                                $env::master_email, '', $cgi::input, 1 );
                        }
                        $cgi::SendMail->send_mail(
                            'Bcc' => (
                                (   $field::for{'name'}
                                        && ref
                                        $main::data{ $field::for{'name'} }
                                        && defined
                                        $main::data{ $field::for{'name'} }
                                        {'str'}
                                        && $main::data{ $field::for{'name'} }
                                        {'str'} ne ''
                                )
                                ? $main::data{ $field::for{'name'} }{'str'}
                                    . ' <'
                                    . $main::data{ $field::for{'from'} }
                                    {'str'} . '>'
                                : $main::data{ $field::for{'from'} }{'str'}
                            ),
                            'From' => (
                                ( $setting::general{'master'} )
                                ? ( ( $setting::general{'mastername'} )
                                    ? $setting::general{'mastername'} . ' <'
                                        . $setting::general{'master'} . '>'
                                    : $setting::general{'master'} )
                                : $env::master_email
                            ),
                            'Subject' => $thanks{'ressubject'},
                            'message' => $thanks{'resmsg'} . "\x0A\x0A",
                            'info'    => 0
                        );
                    }
                }

                #後処理
                foreach my $fid ( sort { $a <=> $b } keys %field::ORDER ) {
                    $field::obj{ $field::ORDER{$fid} }->settle_up
                        if ref $field::obj{ $field::ORDER{$fid} };
                }
                $cgi::input->clear_parameters_trash;
                $cgi::input->clear_clipboard;

                #メールアドレス自動登録
                if (   $setting::general{'autoRegister'}
                    && $field::for{'from'}
                    && $main::data{ $field::for{'from'} }{'str'}
                    && $this->use_register
                    && !$cgi::Register->exist(
                        $main::data{ $field::for{'from'} }{'str'}
                    )
                    )
                {
                    if ($cgi::Register->register(
                            $main::data{ $field::for{'from'} }{'str'}
                        )
                        )
                    {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->success_dialog
                        );
                    }
                    else {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->error_dialog
                        );
                        $input_is_valid = 0;
                    }
                }

                #書き込みお礼
                $setting::key = 'thanks';
                if ( defined $setting::page{'thanks'}{'thanks'}
                    && $setting::page{'thanks'}{'thanks'} ne '' )
                {
                    my $name = $this->escape(
                        (          $field::for{'name'}
                                && $main::data{ $field::for{'name'} }{'str'}
                                ne ''
                        )
                        ? $main::data{ $field::for{'name'} }{'str'}
                        : $setting::page{'thanks'}{'defaultname'}
                    );
                    $setting::page{'thanks'}{'thanks'} =~ s/<name>/$name/igs;
                    if ( $setting::page{'thanks'}{'thanks'} =~ /<number>/i ) {
                        $setting::page{'thanks'}{'thanks'}
                            =~ s/<number>/$serial_no/igs;
                    }
                    if ( $setting::page{'thanks'}{'thanks'} =~ /<data>/i ) {
                        $this->escape( \$list );
                        $setting::page{'thanks'}{'thanks'}
                            =~ s/<data>/$list/igs;
                    }
                    $this->print_page_header('thanks');
                    $this->tag_fix( \$setting::page{'thanks'}{'thanks'}, 2 );
                    print $setting::page{'thanks'}{'thanks'};
                }
                else {
                    $this->print_page_header('thanks');
                    print '<div id="form-thanks">送信しました。</div>';
                }
                $this->print_page_footer('thanks');

                return;

                #入力確認画面
            }
            else {
                $setting::key = 'confirm';
                $this->print_page_header('confirm');
                print $this->form_start(
                    'key'    => 'inq',
                    'name'   => 'input',
                    'method' => 'post',
                    'onsubmit' =>
                        'return cmonos.form.item(this).isNotSubmitted()',
                    'required' => \@setting::form
                );
                print '<input type="hidden" name="a" value="m" />';
                print '<input type="hidden" name="set_cookie" value="1" />'
                    if $main::set_cookie;
                print '<table class="field-table"><tbody>';
                foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
                    my $id = $field::ORDER{$i};
                    next
                        unless ref $field::obj{$id}
                        && $field::obj{$id}->format_for_mail_enabled;
                    $field::obj{$id}->print_confirmation_form_table_row;
                }
                print '</tbody><tbody>';
                print
                    '<tr class="tbody-start"><td class="submit-box" colspan="2"><input type="submit" name="cancel=1" value="'
                    . ( ($default::english) ? 'Cancel' : 'キャンセル' )
                    . '" class="cancel" />';
                print '<input type="submit" name="ok=1" value="'
                    . ( ($default::english) ? ' OK ' : '送信' )
                    . '" class="save" /></td></tr>';
                print '</tbody></table></form>';

                #ページフッタ
                $this->print_page_footer('confirm');
                return;
            }
        }
    }

    #---------------------------------------------------------------------
    #書き出し
    my ( $template, $temp, %temp, $path, $formcheck );

    #フォーム
    $setting::key = 'inq';
    $this->print_page_header('inq');
    print $this->form_start(
        'key'      => 'inq',
        'name'     => 'input',
        'multi'    => $cgi::enctype_multipart,
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="m" />';

    print '<table class="field-table"><tbody>';
    my $cookie_enabled = 0;
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $field = $field::obj{ $field::ORDER{$i} };
        next unless ref $field && $field->format_for_mail_enabled;
        print $field->form;
        $cookie_enabled = 1 if $field->cookie_enabled && $field->{'cookie'};
        $formcheck = 1;
    }
    print '</tbody><tbody>';
    print '<tr class="tbody-start"><td class="submit-box" colspan="2">';

    if ( defined $formcheck && $formcheck ) {

        #英語表記
        if ( defined $default::english && $default::english ) {
            print '<label><input type="checkbox" name="set_cookie" value="1"'
                . ( ($main::set_cookie) ? ' checked="checked"' : '' )
                . ' />Remember Me</label> '
                if defined $cookie_enabled && $cookie_enabled;
            print '<input type="submit" value="Send" class="save" />';

            #日本語
        }
        else {
            print
                '<label title="同じ内容を入力することが多いいくつかの項目を記憶します。"><input type="checkbox" name="set_cookie" value="1"'
                . ( ( $cookie::read{$cookie::name} || $main::set_cookie )
                ? ' checked="checked"'
                : '' )
                . ' />情報を記憶する</label> '
                if defined $cookie_enabled && $cookie_enabled;
            print '<input type="submit" value="'
                . ( ($cgi::confirmation_disabled) ? '送信' : '確認' )
                . '" class="save" />';
        }
    }
    print '</td></tr></tbody></table></form>';

    #ページフッタ
    $this->print_page_footer('inq');
}

#ファイルロック
sub filelock ($$$) {
    my ( $this, $file, $code ) = @_;
    my ( $lockdir, $i, $lock );
    $lockdir = $file . '.lock';

    $SIG{'TERM'} = $SIG{'PIPE'} = $SIG{'HUP'} = \&Unlock;

    if ( $code == 2 ) {
        for ( $i = 0; $i <= 10; $i++ ) {
            if ( mkdir( $lockdir, $env::dir_mode ) ) {
                $locked::file{$lockdir} = 1;
                return 1;
            }
            else {
                my @stat = stat($lockdir);
                if ( $stat[9] && time - $stat[9] > 5 ) {
                    rmdir($lockdir);
                    delete $locked::file{$lockdir};
                    next;
                }
                sleep(1);
            }
        }
        return 0;

    }
    elsif ( $code == 8 ) {
        delete $locked::file{$lockdir};
        return rmdir($lockdir);
    }
}

sub unlock {
    my ($lockdir);
    while ( ($lockdir) = each %locked::file ) {
        rmdir($lockdir);
    }
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general = 1 if !$setting::general;    #一般設定読み込み
    $setting::deco = 1
        if !$setting::deco;    #テキスト装飾設定読み込み
    $setting::security = 1
        if !$setting::security;    #アクセス権設定読み込み
    $setting::table = 1 if !$setting::table;   #テーブル設定読み込み
    $setting::page  = 1 if !$setting::page;    #ページ設定読み込み

    $setting::field_db_name = 'inquiryfield'
        if !defined $setting::field_db_name
        || $setting::field_db_name ne 'inquiryfield'; #フィールド設定DB
    $setting::field = 2
        if !defined $setting::field
        || $setting::field != 2
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 2
        if !defined $setting::field_style_disabled
        || $setting::field_style_disabled != 2
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled = 'no'
        if !defined $setting::field_tag_enabled
        || $setting::field_tag_enabled ne
        'no';   #tag=タグのみ/all=全ての設定/no=タグをつけない
    $setting::field_for_mail = 1;

    #設定種キー設定
    $setting::security_key = 'inq'
        if !defined $setting::security_key
        || $setting::security_key ne
        'inq';    #デフォルトセキュリティキー

    #クッキー
    $cookie::id_enabled = 1
        if !$cookie::id_enabled;    #ID情報クッキー読み込み
    $cookie::default_enabled = 1
        if !$cookie::default_enabled
        ;    #ユーザー入力情報クッキー読み込み
    $cookie::name = 'INQ' if !defined $cookie::name || $cookie::name ne 'INQ';
    $cookie::path = $ENV{'SCRIPT_NAME'} if !defined $cookie::path;

    #デフォルトキー
    $main::k = 'inq' if !defined $main::k || !$main::k || $main::k ne 'inq';

    #必須フォーム
    @setting::form = ( 'm', 'k' );
    if ($ENV{'QUERY_STRING'}
        || (   $ENV{'REQUEST_METHOD'}
            && $ENV{'REQUEST_METHOD'} eq 'POST'
            && !$cgi::input->referer_is_me )
        )
    {
        undef $main::a;
    }

    #クラス登録
    Common::class_register( 'inq', 'Inquiry' );
}

1;
