package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# 一般設定モジュール
# GeneralSetting.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #チェックボックス
    push( @check::checkbox,
        'autores',           'serialnoenabled', 'mailonly',
        'attachmentEnabled', 'autoRegister' );

    #数字チェック
    $check::num{'ipStopper'} = '連続送信の制限';
    $check::num{'fyear'}     = 'アンケート期間(開始年)';
    $check::num{'fmon'}      = 'アンケート期間(開始月)';
    $check::num{'fmday'}     = 'アンケート期間(開始日)';
    $check::num{'fhour'}     = 'アンケート期間(開始時)';
    $check::num{'tyear'}     = 'アンケート期間(終了年)';
    $check::num{'tmon'}      = 'アンケート期間(終了月)';
    $check::num{'tmday'}     = 'アンケート期間(終了日)';
    $check::num{'thour'}     = 'アンケート期間(終了時)';

    #複数メール書式チェック
    $check::emails{'mailto'} = '送信先アドレス';

    return;
}

######################################################################
# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;

    my ($this_year);
    $this_year = ( localtime() )[5] + 1900;
    print '<fieldset>';
    print '<legend>アンケート設定</legend>';

    print '<fieldset>';
    print '<legend>アンケート期間</legend>';
    $this->print_date_menu( 'f', $this_year );
    print ' から ';
    $this->print_date_menu( 't', $this_year );
    print ' まで';
    print '</fieldset>';

    print '<fieldset>';
    print
        '<legend><label for="data:startmsg">アンケート開始前メッセージ</label></legend>';
    print
        '<textarea name="data:startmsg" id="data:startmsg" cols="70" rows="5">'
        . $this->escape( $main::data{'startmsg'} )
        . '</textarea>';
    print
        '<div class="note">&lt;start&gt; は開始時に &lt;end&gt; は終了時にそれぞれ変換されます。</div>';
    print '</fieldset>';

    print '<fieldset>';
    print
        '<legend><label for="data:endmsg">アンケート終了後メッセージ</label></legend>';
    print '<textarea name="data:endmsg" id="data:endmsg" cols="70" rows="5">'
        . $this->escape( $main::data{'endmsg'} )
        . '</textarea>';
    print
        '<div class="note">&lt;start&gt; は開始時に &lt;end&gt; は終了時にそれぞれ変換されます。</div>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>連続送信の制限</legend>';
    print
        '<label><input type="number" size="3" maxlength="3" name="data:ipStopper" id="data:ipStopper" value="'
        . $main::data{'ipStopper'}
        . '" /> 秒間、同一IPからの送信を禁止する</label>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>回答通知メール設定</legend>';
    print '<table class="field-table"><tbody><tr>';
    print
        '<td class="field-name"><label for="data:subject">通知メールの表題</label></td>';
    print
        '<td class="field"><input type="text" name="data:subject" id="data:subject" size="56" value="'
        . $this->escape( $main::data{'subject'} )
        . '" /></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:mailto">送信先アドレス</label></td>';
    print
        '<td class="field"><textarea name="data:mailto" id="data:mailto" cols="56" rows="5" wrap="off">'
        . $this->escape( $main::data{'mailto'} )
        . '</textarea>';
    print
        '<div class="note">送信先が複数の時はカンマ（+改行）で区切ります。</div></td>';
    print '</tr><tr>';
    print
        '<td class="field-name"><span class="datatitle">添付ファイル</span></td>';
    print
        '<td class="field"><label><input type="checkbox" name="data:attachmentEnabled" id="data:attachmentEnabled" value="1"'
        . ( ( $main::data{'attachmentEnabled'} ) ? ' checked="checked"' : '' )
        . '" /> 送信されたファイルを通知メールに添付する。</label></td>';
    print '</tr></tbody></table>';
    print '</fieldset>';

    print '<ol class="checkbox">';
    print
        '<li><label><input type="checkbox" name="data:autores" id="data:autores" value="1"'
        . ( ( $main::data{'autores'} ) ? ' checked="checked"' : '' )
        . '" /> 送信者に自動返信する。</label></li>';
    print
        '<li><label><input type="checkbox" name="data:serialnoenabled" id="data:serialnoenabled" value="1"'
        . ( ( $main::data{'serialnoenabled'} ) ? ' checked="checked"' : '' )
        . '" /> 通し番号を発行する。</label></li>';
    print
        '<li><label><input type="checkbox" name="data:mailonly" id="data:mailonly" value="1"'
        . ( ( $main::data{'mailonly'} ) ? ' checked="checked"' : '' )
        . '" onclick="cmonos.form.checkboxSyncById(\'data:attachmentEnabled\',this.checked)" /> サーバに回答データを保存しない(通知メールのみ)。</label></li>';
    print
        '<li><label><input type="checkbox" name="data:autoRegister" value="1"'
        . ( ( $main::data{'autoRegister'} ) ? ' checked="checked"' : '' )
        . ' /> 「パスワード登録」の「アクセス権設定」に関わらず、「差出人メールアドレスフィールド」に入力されたメールアドレスを自動登録しパスワードを発行する</label></li>';
    print '</ol>';

    print '</fieldset>';
    return;
}

sub print_date_menu ($$$) {
    my ( $this, $type, $this_year ) = @_;
    print '<span class="date-selector"><label><select name="data:'
        . $type
        . 'year" id="data:'
        . $type
        . 'year">';
    print '<option value=""></option>';
    foreach ( 0 .. 4 ) {
        my $y = $this_year + $_;
        print '<option value="'
            . $y . '"'
            . (
            (          $main::data{ $type . 'year' }
                    && $main::data{ $type . 'year' } == $y
            ) ? ' selected="selected"' : ''
            )
            . '">'
            . $y
            . '</option>';
    }
    print '</select>年</label> ';
    print '<label><select name="data:'
        . $type
        . 'mon" id="data:'
        . $type . 'mon">';
    print '<option value=""></option>';
    foreach ( 1 .. 12 ) {
        print '<option value="'
            . $_ . '"'
            . (
            (          $main::data{ $type . 'mon' }
                    && $main::data{ $type . 'mon' } == $_
            ) ? ' selected="selected"' : ''
            )
            . '">'
            . $_
            . '</option>';
    }
    print '</select>月</label> ';
    print '<label><select name="data:'
        . $type
        . 'mday" id="data:'
        . $type
        . 'mday">';
    print '<option value=""></option>';
    foreach ( 1 .. 31 ) {
        print '<option value="'
            . $_ . '"'
            . (
            (          $main::data{ $type . 'mday' }
                    && $main::data{ $type . 'mday' } == $_
            ) ? ' selected="selected"' : ''
            )
            . '">'
            . $_
            . '</option>';
    }
    print '</select>日</label>';
    print
        '<a href="javascript:void(0)" onclick="cmonos.tool.calendarPalette.open(\'data:'
        . $type
        . 'year\',\'data:'
        . $type
        . 'mon\',\'data:'
        . $type
        . 'mday\')" title="クリックするとカレンダーから日付を設定できます。"><img src="'
        . $env::image_dir
        . '/tool/calendar.gif" width="15" height="15" border="0" alt="カレンダーパネル" /></a></span>';
    print ' <span class="time-selector"><label><select name="data:'
        . $type
        . 'hour" id="data:'
        . $type
        . 'hour">';
    print '<option value=""></option>';
    foreach ( 0 .. 23 ) {
        print '<option value="'
            . $_ . '"'
            . (
            (          defined $main::data{ $type . 'hour' }
                    && $main::data{ $type . 'hour' } ne ''
                    && $main::data{ $type . 'hour' } eq $_
            ) ? ' selected="selected"' : ''
            )
            . '">'
            . $_
            . '</option>';
    }
    print '</select>時</label></span> ';
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    use Time::Local;
    $main::data{'start'} = '';
    $main::data{'end'}   = '';
    if ( $main::data{'fyear'} && $main::data{'fmon'} && $main::data{'fmday'} )
    {
        if ($this->is_impossible_mday(
                $main::data{'fyear'}, $main::data{'fmon'},
                $main::data{'fmday'}
            )
            )
        {
            push(
                @{ $this->{'dialog'} },
                'アンケート期間開始日があり得ない日付です。'
            );
            delete $main::data{'fyear'};
            delete $main::data{'fmon'};
            delete $main::data{'fmday'};
            delete $main::data{'fhour'};
            delete $main::data{'start'};
            delete $main::data{'end'};
        }
        else {
            $main::data{'start'}
                = timelocal( 0, 0, $main::data{'fhour'},
                $main::data{'fmday'}, ( $main::data{'fmon'} - 1 ),
                $main::data{'fyear'} );
        }
    }
    if ( $main::data{'tyear'} && $main::data{'tmon'} && $main::data{'tmday'} )
    {
        if ($this->is_impossible_mday(
                $main::data{'tyear'}, $main::data{'tmon'},
                $main::data{'tmday'}
            )
            )
        {
            push(
                @{ $this->{'dialog'} },
                'アンケート期間終了日があり得ない日付です。'
            );
            delete $main::data{'tyear'};
            delete $main::data{'tmon'};
            delete $main::data{'tmday'};
            delete $main::data{'thour'};
            delete $main::data{'start'};
            delete $main::data{'end'};
        }
        else {
            $main::data{'end'}
                = timelocal( 0, 0, $main::data{'thour'},
                $main::data{'tmday'}, ( $main::data{'tmon'} - 1 ),
                $main::data{'tyear'} );
        }
    }
    if (   $main::data{'start'}
        && $main::data{'end'}
        && $main::data{'start'} >= ( $main::data{'end'} - 3600 ) )
    {
        push(
            @{ $this->{'dialog'} },
            'アンケート期間が短過ぎます。'
        );
        delete $main::data{'fyear'};
        delete $main::data{'fmon'};
        delete $main::data{'fmday'};
        delete $main::data{'fhour'};
        delete $main::data{'tyear'};
        delete $main::data{'tmon'};
        delete $main::data{'tmday'};
        delete $main::data{'thour'};
        delete $main::data{'start'};
        delete $main::data{'end'};
    }
    $this->tag_fix( \$main::data{'startmsg'} );
    $this->tag_fix( \$main::data{'endmsg'} );
    $main::data{'startmsg'} =~ s!</start>!!gis;
    $main::data{'startmsg'} =~ s!</end>!!gis;
    $main::data{'endmsg'} =~ s!</start>!!gis;
    $main::data{'endmsg'} =~ s!</end>!!gis;
    if (   $this->is_invalid_email_address_header( $main::data{'mailto'} )
        && $main::data{'mailonly'} )
    {
        push(
            @{ $this->{'dialog'} },
            '回答通知メールの「送信先アドレス」が設定されていません。送信時に送信先メールアドレスがみつからない場合、回答データは必ずサーバに保存されます。'
        );
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定'
        if !defined $setting::jump_menu{'0000'};
}

1;
