package InquiryField;
require CMONOS::CGI_Lib::Tools::FieldEditor;
@ISA = qw(FieldEditor);
use strict;
use utf8;
######################################################################
# アンケートフィールド編集モジュール
# InquiryField.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# フィールド読み込み設定
sub set_field ($) {
    my $this = shift;
    $setting::field_db_name = 'inquiryfield'
        if !defined $setting::field_db_name;
    $setting::field              = 2 if !$setting::field;
    $setting::field_for_mail     = 1 if !defined $setting::field_for_mail;
    $this->{'long_name_enabled'} = 1 if !$this->{'long_name_enabled'};
}

######################################################################
#サブ設定
sub print_sub_setting_items ($) {
    my $this = shift;
    return if !%field::obj;

    print
        '<fieldset><legend>特殊フィールド</legend><table class="field-table"><tbody>';

    print
        '<tr><td class="field-name"><label for="data:for_from">差出人メールアドレスフィールド</label></td>';
    print
        '<td class="field"><select name="data:for_from" id="data:for_from">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && defined $field::obj{ $field::ORDER{$_} }->{'e-mail'}
            && $field::obj{ $field::ORDER{$_} }->{'e-mail'};
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'from'}
                    && $field::for{'from'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_name">差出人名フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_name" id="data:for_name">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && $field::obj{ $field::ORDER{$_} }->{'class'} =~ /^text/
            && $field::obj{ $field::ORDER{$_} }->sort_enabled;
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'name'}
                    && $field::for{'name'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print
        ' <span class="note">入力欄高さが1文字以下の文字列フィールド</span>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_subject">メール表題フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_subject" id="data:for_subject">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && (
            (      $field::obj{ $field::ORDER{$_} }->{'class'} =~ /^text/
                && $field::obj{ $field::ORDER{$_} }->sort_enabled
            )
            || $field::obj{ $field::ORDER{$_} }->{'class'} =~ /^select_/
            );
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'subject'}
                    && $field::for{'subject'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print
        ' <span class="note">入力欄高さが1文字以下の文字列フィールド</span>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_message">メール本文フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_message" id="data:for_message">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && $field::obj{ $field::ORDER{$_} }->{'class'} =~ /^text/;
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'message'}
                    && $field::for{'message'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print
        ' <span class="note">「start.cgi?message=本文」の値を読み込みます。</span>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_url">メール関連URLフィールド</label></td>';
    print '<td class="field"><select name="data:for_url" id="data:for_url">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && $field::obj{ $field::ORDER{$_} }->{'class'} =~ /^text/;
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'url'}
                    && $field::for{'url'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print
        ' <span class="note">「start.cgi?url=URL」の値を読み込みます。</span>';
    print '</td></tr>';

    print
        '<tr><td class="field-name"><label for="data:for_serialno">シリアルNo フィールド</label></td>';
    print
        '<td class="field"><select name="data:for_serialno" id="data:for_serialno">';
    print '<option value=""></option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && ( $field::obj{ $field::ORDER{$_} }->{'class'} eq 'num'
            || $field::obj{ $field::ORDER{$_} }->{'class'} eq 'num_number' );
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $field::for{'serialno'}
                    && $field::for{'serialno'} eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 32, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td></tr>';

    print '</tbody></table>';
    print '</fieldset>';
    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

sub field_general_setting_check ($) {
    my $this = shift;
    if ( $setting::general{'autoRegister'} ) {
        if (!$main::data{'for_from'}
            || ( @main::delete
                && grep( $_ eq $main::data{'for_from'}, @main::delete ) )
            )
        {
            my @mail_fields = ();
            while ( my ( $k, $v ) = each %main::data ) {
                if ( $k && $v && $k =~ /^([0-9]+)_class$/ ) {
                    my $id = $1;
                    if ($v =~ /email/
                        && (   !@main::delete
                            || !grep( $_ eq $id, @main::delete ) )
                        )
                    {
                        push( @mail_fields, $id );
                    }
                }
            }
            if (@mail_fields) {
                if ( @mail_fields == 1 ) {
                    $main::data{'for_from'} = $mail_fields[0];
                    push(
                        @{ $this->{'dialog'} },
                        '「'
                            . (
                            $main::data{ $mail_fields[0] . '_name' }
                                || 'メールアドレス'
                            )
                            . '」フィールドを「差出人メールアドレスフィールド」に設定しました。'
                    );
                }
                else {
                    push(
                        @{ $this->{'dialog'} },
                        '「差出人メールアドレスフィールド」を設定してください。メールアドレス自動登録のために必要です。'
                    );
                }
            }
            else {
                push(
                    @{ $this->{'dialog'} },
                    '「メールアドレス」フィールドタイプを追加して「差出人メールアドレスフィールド」を設定してください。メールアドレス自動登録のために必要です。'
                );
            }
        }
        if ( $main::data{'for_from'}
            && !$main::data{ $main::data{'for_from'} . '_required' } )
        {
            $main::data{ $main::data{'for_from'} . '_required' } = 1;
            push(
                @{ $this->{'dialog'} },
                '「'
                    . (
                    $main::data{ $main::data{'for_from'} . '_name' }
                        || 'メールアドレス'
                    )
                    . '」フィールドを必須項目に設定しました。'
            );
        }
    }
    return;
}

######################################################################
#DBフィールド
sub is_not_html ($) {
    my $this = shift;
    return 1;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'q100', 'InquiryField' );

    #ツール登録
    $setting::jump_menu{'q100'} = 'アンケートフィールド設定'
        if !defined $setting::jump_menu{'q100'};
}

1;
