package SerialNoEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 通し番号リセットモジュール
# SerialNoEditor.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    use Fcntl qw(:DEFAULT);

    #通し番号リセット
    if ( defined $main::no && $main::no ne '' ) {
        if ( $this->is_nan($main::no) ) {
            push(
                @{ $cgi::action->{'dialog'} },
                '半角数字列にしてください。'
            ) if ref $cgi::action;
        }
        else {
            my (%general);
            tie(%general, $env::dbm_file,
                $default::preference_dir . '/general',
                O_RDWR | O_CREAT,
                $env::dbm_mode
            );
            if ( ref tied %general ) {
                $general{'serialno'} = $this->encode_utf8($main::no);
            }
            untie %general;
        }
    }
    $main::no = $setting::general{'serialno'}
        if !defined $main::no || $main::no eq '';

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>通し番号リセット</h1>';

    #フォーム開始
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
    );
    print '<fieldset class="delete">';
    print
        '<label for="no">通し番号</label><input type="text" name="no" id="no" value="'
        . $this->escape($main::no)
        . '" size="20" />';
    print ' <input type="submit" value="リセット" class="save" />';
    print '</fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'q210', 'SerialNoEditor' );

    #メニュー登録
    $setting::jump_menu{'q210'} = '通し番号リセット';

}

1;
