package RP;
require CMONOS::Register::RgCommon;
@ISA = qw(RgCommon);
use strict;
use utf8;
######################################################################
# OpenID ログインモジュール
# RP.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-04-04
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    $this->print_register_dialog( 'rp',
        '設定エラー！ : パスワード管理データベースディレクトリのパスが設定されていません。'
    ) if !$this->use_register;
    $this->print_register_dialog( 'rp', 'OpenID は利用できません。' )
        if !$env::openid_enabled;
    $this->jump($env::register_cgi)
        if $this->path_change( $env::register_cgi, $ENV{'SCRIPT_NAME'},
        'abs' ) ne $ENV{'SCRIPT_NAME'};

    require CMONOS::CGI_Lib::OpenID::SimpleConsumer;
    my $consumer = SimpleConsumer->new;

#---------------------------------------------------------------------
#OPからの応答時にはセッションからメールアドレスを取り出す
    $main::addr = $main::pswd->{'rp_email'}
        if $main::rp_nonce && ref $main::pswd && $main::pswd->{'rp_email'};

    #---------------------------------------------------------------------
    #変数チェック
    if ( !$main::addr ) {
        push(
            @{ $this->{'dialog'} },
            'メールアドレスが指定されていません。'
        );
        $this->print_openid_login_panel_opener();
    }
    elsif ( $cgi::Register->is_invalid_account($main::addr) ) {
        push( @{ $this->{'dialog'} }, $cgi::Register->error_dialog );
        $this->print_openid_login_panel_opener();
    }

    #メールアドレス移行
    if ( $main::transition && !$this->is_registered_email ) {
        $this->print_register_dialog( 'rp',
            'OpenID を変更する前に、これまでのメールアドレスでログインしてください。'
        );
    }

    #---------------------------------------------------------------------
    #セキュリティチェック
    my ( $is_secure, $is_registered, $claimed_id, $reregistry_enabled,
        $another_id_enabled );
    ( $is_secure, $is_registered, $claimed_id, $reregistry_enabled )
        = $this->id_info($main::addr);
    if ( !$is_registered ) {
        if ( !$is_secure ) {
            $this->print_register_dialog( 'rp',
                '未登録のメールアドレスです。' );
        }
        elsif ($setting::general{'firstRegistry'}
            && $setting::general{'firstRegistry'} eq 'password' )
        {
            $this->print_register_dialog( 'rp',
                '最初の登録についてはパスワードによる登録のみ許可されています。'
            );
        }
    }
    $another_id_enabled = 1
        if ( $main::transition || ( $main::email eq $main::addr ) )
        && $this->is_registered_email;

    #---------------------------------------------------------------------
    #OPからの応答を受ける
    if ($main::rp_nonce) {
        my ( $rp_nonce, $rp_return_to );
        if ( ref $main::pswd ) {
            $rp_return_to
                = ( $main::pswd->{'rp_return_to'} )
                ? $main::pswd->{'rp_return_to'}
                : '';
            $rp_nonce
                = ( $main::pswd->{'rp_nonce'} )
                ? $main::pswd->{'rp_nonce'}
                : '';
        }
        $claimed_id = '' if $another_id_enabled;
        if (   !$rp_nonce
            || !$rp_return_to
            || !%cgi::openid
            || !$cgi::openid{'openid.mode'}
            || $cgi::openid{'openid.mode'} ne 'id_res'
            || !$cgi::openid{'openid.claimed_id'}
            || !$consumer->is_verified(
                \%cgi::openid,   $rp_nonce, $rp_return_to,
                $main::rp_nonce, $claimed_id
            )
            )
        {
            push(
                @{ $this->{'dialog'} },
                '認証に失敗しました。',
                ( $consumer->message )
            );
            $this->print_openid_login_panel_opener($main::addr);
        }
        $claimed_id = $cgi::openid{'openid.claimed_id'};
        if ( $cgi::Register->password_register( $claimed_id, $main::addr ) ) {
            if ($main::transition) {
                if ( !defined $main::pswd || !ref $main::pswd ) {
                    $main::pswd = {};
                }
                else {
                    delete $main::pswd->{'rp_email'};
                    delete $main::pswd->{'rp_return_to'};
                    delete $main::pswd->{'rp_nonce'};
                }
                $main::pswd->{'new_email'} = $main::addr;
                $main::pswd->{'new_claimed_id'}
                    = $cgi::openid{'openid.claimed_id'};
            }
            else {
                $main::email = $main::addr;
                $main::pswd  = $claimed_id;
            }
        }
        $session::id
            = $cgi::Session->set_user_info( $main::email, $main::pswd,
            $session::id );
        $session::is_changed = 1;
        $this->print_register_dialog( 'rp',
            '認証に成功しました。' );
    }

    #---------------------------------------------------------------------
    #discovery
    my ( $endpoint_url, $request_claimed_id, $request_identity, $return_to,
        $rp_nonce, $registered_endpoint_url, $checkid_url );
    $registered_endpoint_url = $consumer->discovery($claimed_id)
        if $claimed_id;
    $request_claimed_id = '';
    if ( defined $main::op && $main::op ne '' ) {
        my $op = $this->op_info_from_id($main::op);
        if ( !%$op || !$op->{'endpoint_url'} ) {
            push(
                @{ $this->{'dialog'} },
                '指定された OpenID プロバイダーによる認証は許可されていません。'
            );
            $this->print_openid_login_panel_opener($main::addr);
        }
        $endpoint_url       = $op->{'endpoint_url'};
        $request_claimed_id = $op->{'claimed_id'};
        $request_identity   = $op->{'identity'};
    }
    elsif ($main::identifier) {
        $endpoint_url = $consumer->discovery($main::identifier);
        if ( !$endpoint_url ) {
            push(
                @{ $this->{'dialog'} },
                '指定された OpenID プロバイダーの認証 URL がみつかりません。このウェブアプリケーションは、URL の探索に対応していません。'
            );
            $this->print_openid_login_panel_opener($main::addr);
        }
        elsif ( !$this->is_secure_op($endpoint_url) ) {
            push(
                @{ $this->{'dialog'} },
                '指定された OpenID プロバイダーによる認証は許可されていません。'
            );
            $this->print_openid_login_panel_opener($main::addr);
        }
    }
    elsif ($claimed_id) {
        if ( !$registered_endpoint_url ) {
            $this->print_register_dialog( 'rp',
                '登録された OpenID がみつかりません。' );
        }
        elsif ( !$this->is_secure_op($registered_endpoint_url) ) {
            push(
                @{ $this->{'dialog'} },
                '指定された OpenID プロバイダーによる認証は許可されていません。'
            );
            $this->print_openid_login_panel_opener($main::addr);
        }
        else {
            $endpoint_url       = $registered_endpoint_url;
            $request_claimed_id = $claimed_id;
        }
    }
    else {
        push(
            @{ $this->{'dialog'} },
            'OpenID プロバイダーを指定してください。'
        );
        $this->print_openid_login_panel_opener($main::addr);
    }
    if (   $claimed_id
        && $registered_endpoint_url ne $endpoint_url
        && !$another_id_enabled )
    {
        $this->print_register_dialog( 'rp',
            'OpenID プロバイダーが登録された OpenID と一致しません。'
        );
    }

    #---------------------------------------------------------------------
    #リダイレクト
    ( $return_to, $rp_nonce ) = $consumer->get_return_to_url(
        $this->my_url . '?m=RP'
            . (
            ($main::referer_url)
            ? $this->make_query( 'url', 'referer_url', $main::referer_url )
            : ''
            )
            . ( ($main::transition) ? '&transition=1' : '' )
    );
    $checkid_url
        = $consumer->checkid_url( $endpoint_url, 'checkid_setup', $return_to,
        $request_claimed_id, $request_identity );
    $main::pswd = {} if !defined $main::pswd || !ref $main::pswd;
    $main::pswd->{'rp_email'}     = $main::addr;
    $main::pswd->{'rp_return_to'} = $return_to;
    $main::pswd->{'rp_nonce'}     = $rp_nonce;
    $session::id = $cgi::Session->set_user_info( $main::email, $main::pswd,
        $session::id );
    $session::is_changed = 1;
    $this->mkcookie;
    $this->jump($checkid_url);
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::page     = 1;    #ページ設定読み込み

    #設定種キー設定
    $setting::security_key = '';      #デフォルトセキュリティキー
    $setting::key          = 'rp';    #ページ設定キー

    #クッキー
    $cookie::id_enabled = 1;          #ID情報クッキー読み込み

    #デフォルトキー
    $main::k = 'rp' if !defined $main::k || !$main::k;

    #必須フォーム
    @setting::form = ( 'm', 'referer_url' );

    #クラス登録
    Common::class_register( 'rp', 'RP' );

}

1;
