package RegisterManager;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 登録パスワード編集モジュール
# RegisterManager.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-02-04
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->print_dialog( 'pswd',
        '設定エラー！ : パスワード管理データベースディレクトリのパスが設定されていません。'
    ) if !$this->use_register;
    push( @main::delete, $main::delete )
        if defined $main::delete && $main::delete;
    @main::delete = grep( defined $_ && $_ ne '', @main::delete );
    $main::span = '' if $main::span && $main::span =~ /[^0-9]/;
    my @keywords = ();
    if ( defined $main::search && $main::search ne '' ) {
        $main::search = $this->z_to_h($main::search);
        @keywords     = grep( $_ ne '',
            split( /[\x09\x0A\x0C\x0D\x20]+/, $main::search ) );
    }

    #削除/登録制限
    if (@main::delete) {
        if ( $main::target eq 'baduser' ) {
            $cgi::Register->cancel_in_bulk( \@main::delete );
        }
        else {
            my ($reason);
            $reason = '長期間ご利用がなかったため'
                if defined $main::span
                && defined $main::smode
                && $main::span ne ''
                && $main::smode eq 'before';
            if ($cgi::Register->remove_in_bulk(
                    \@main::delete, $main::notice, $reason, $main::refuse
                )
                )
            {
                push(
                    @{ $this->{'dialog'} },
                    '登録を抹消しました。'
                );
                push(
                    @{ $this->{'dialog'} },
                    '登録制限対象に指定しました。'
                ) if defined $main::refuse && $main::refuse;
            }
            else {
                push( @{ $this->{'dialog'} }, $cgi::Register->error_dialog );
            }
        }
    }

    push(
        @{ $this->{'dialog'} },
        '検索条件が設定されていません。'
        )
        if defined $main::mode
        && $main::mode ne ''
        && !@keywords
        && !$main::span;

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>登録メールアドレス編集</h1>';
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );

    print '<fieldset><legend>登録メールアドレス検索</legend>';
    print '<table class="field-table"><tbody>';

    print '<tr>';
    print
        '<td class="field-name"><label for="target">検索対象</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'target', '', '', $main::target,
        'pswd'    => '登録者',
        'baduser' => '登録制限対象者'
    );
    print '</td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="search">キーワード検索</label></td>';
    print
        '<td class="field"><input type="text" name="search" id="search" size="50" value="'
        . $this->escape($main::search) . '" />';
    print $this->mk_select_menu(
        'mode', '', '', $main::mode,
        'first' => 'いずれかの文字列が先頭で一致',
        'or'    => 'いずれかの文字列が一致',
        'and'   => '全ての文字列が一致'
    );
    print '</td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="span">最終接続日検索</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'span', '', '', $main::span,
        ''    => '',
        '548' => '18カ月',
        '365' => '一年',
        '183' => '半年',
        '92'  => '3カ月',
        '31'  => '1カ月',
        '14'  => '2週間',
        '7'   => '1週間',
        '3'   => '3日',
    );
    print $this->mk_select_menu(
        'smode', '', '', $main::smode,
        'before' => '以上前',
        'after'  => '以内'
    );
    print ' <label><input type="checkbox" name="pending" value="1"'
        . ( ($main::pending) ? ' checked="checked"' : '' )
        . ' /> アクセスなし</label>';
    print '</td>';
    print '</tr>';

    print '<tr>';
    print '<td class="field-name"><label for="s">ソート</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        's', '', '', $main::s,
        'k' => '登録メールアドレス',
        'v' => '最終接続時'
    );
    print $this->mk_select_menu(
        'w', '', '', $main::w,
        'ascend'  => '昇順',
        'descend' => '降順'
    );
    print '</td>';
    print '</tr></tbody></table></fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="検索" class="save" /></fieldset>';
    print '</form>';

    if ( @keywords || $main::span ) {
        my ( $title, $db_path, $time, %matched, $hints, $mcount, %db );
        $time = time - ( $main::span * 86400 ) if $main::span;

        if ( defined $main::target && $main::target eq 'baduser' ) {
            $title   = '登録制限対象者';
            $db_path = $env::register_db . '/baduser';
        }
        else {
            $title   = '登録者';
            $db_path = $env::register_db . '/mtime';
        }
        map( $_ = '^' . $_, @keywords )
            if defined $main::mode && $main::mode eq 'first';

        $mcount = 0;
        use Fcntl qw(:DEFAULT);
        eval 'use ' . $env::dbm_file . ';';
        tie( %db, $env::dbm_file, $db_path, O_RDONLY, $env::dbm_mode );
        while ( my ( $k, $t ) = each %db ) {
            utf8::decode($k) if !utf8::is_utf8($k);
            utf8::decode($t) if !utf8::is_utf8($t);
            if (( !@keywords || grep( eval { $k =~ /$_/ }, @keywords ) )
                && (!$main::span
                    || ((      ( !$main::pending && $t !~ /\.0$/ )
                            || ( $main::pending && $t =~ /\.0$/ )
                        )
                        && ((      defined $main::smode
                                && $main::smode eq 'before'
                                && $t <= $time
                            )
                            || (   defined $main::smode
                                && $main::smode eq 'before'
                                && $t <= $time )
                            || (   defined $main::smode
                                && $main::smode eq 'after'
                                && $t >= $time )
                        )
                    )
                )
                )
            {
                $mcount++;
                $matched{$k} = $t;
            }
            if ( $mcount >= 1000 ) {
                $hints
                    = '<div class="hints">1000 件を超えて表示することはできません。検索条件を絞り込む必要があります。</div>';
                last;
            }
        }
        untie %db;

        if ( defined $mcount && $mcount ) {
            print $this->form_start(
                'key'      => 'tools',
                'name'     => 'delete',
                'method'   => 'post',
                'required' => [
                    @setting::form, 'target', 'search',  'mode',
                    'span',         'smode',  'pending', 's',
                    'w'
                ]
            );
            print '<fieldset><legend>' . $title . '検索結果</legend>';
            print '<div class="note">' . $mcount
                . '件が条件に一致しました';
            print '（[ ]内は最終接続時）。</div>';
            print $hints if defined $hints;
            print '<ol class="checkbox">';
            print
                '<li><label><input type="checkbox" name="delete" onclick="cmonos.element.form(this.form).fieldname(\'delete\').select(this.checked)" /> 全て選択(解除)</label></li>';
            my (%name);
            tie( %name, $env::dbm_file, $env::register_db . '/email_to_name',
                O_RDONLY, $env::dbm_mode );

            foreach my $i (
                sort {
                    $this->sort_user_by( \$a, \$b, $main::w, $main::s,
                        \%matched )
                } keys %matched
                )
            {
                print
                    '<li><label><input type="checkbox" name="delete" value="'
                    . $i . '" /> '
                    . $i;
                print ' ('
                    . $this->escape_except_html_entity(
                    $this->decode_utf8( $name{ $this->encode_utf8($i) } ) )
                    . ')'
                    if ref tied %name
                    && defined $name{ $this->encode_utf8($i) }
                    && $name{ $this->encode_utf8($i) } ne '';
                print '</label> ['
                    . $this->date( $matched{$i}, 3, '/gmt' )
                    . ']</li>';
            }
            untie %name;
            print
                '<li><label><input type="checkbox" name="delete" onclick="cmonos.element.form(this.form).fieldname(\'delete\').select(this.checked)" /> 全て選択(解除)</label></li>';
            print '</ol></fieldset>';

            if ( $main::target eq 'baduser' ) {
                print '<fieldset class="submit">';
                print
                    '<input type="submit" value="登録制限指定を解除" />';
            }
            else {
                print '<fieldset class="delete">';
                print $this->mk_select_menu(
                    'refuse', '', '', '',
                    '' => '登録を抹消する',
                    '1' =>
                        '登録を抹消し登録制限対象に指定する'
                );
                print '<input type="submit" value="実行" />';
                print
                    ' <label><input type="checkbox" name="notice" value="1" /> 通知メールを送る</label>';
            }
            print '</fieldset></form>';

        }
        else {
            print '<fieldset><legend>' . $title . '検索結果</legend>';
            print '<div class="hints">検索条件に一致する' . $title
                . 'はみつかりませんでした。</div>';
            print '</fieldset>';
        }
    }

    #ページフッタ
    $this->print_page_footer('tools');

}

sub sort_user_by ($$$$$$) {
    no warnings qw(numeric);
    my ( $this, $a, $b, $type, $key, $hash ) = @_;
    if ( $type eq 'descend' ) {
        if ( $key eq 'v' ) {
            $$hash{$$b} <=> $$hash{$$a} || $$hash{$$b} cmp $$hash{$$a};
        }
        else {
            $$b <=> $$a || $$b cmp $$a;
        }
    }
    else {
        if ( $key eq 'v' ) {
            $$hash{$$a} <=> $$hash{$$b} || $$hash{$$a} cmp $$hash{$$b};
        }
        else {
            $$a <=> $$b || $$a cmp $$b;
        }
    }
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'r210', 'RegisterManager' );

    #メニュー登録
    $setting::jump_menu{'r210'} = '登録メールアドレス編集';
}

1;
