package Tools;
use strict;
use utf8;
######################################################################
# メンテナンスモジュール
# Tools.pm ver1.0.5
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-07-02
######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::table    = 1;    #テーブル設定読み込み
    $setting::page     = 0;    #ページ設定読み込み

    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    #フィールド読み込み設定
    $setting::field = 0
        ; #フィールド設定読み込み（2=オリジナルも読み込む）

#	$setting::field_style_disabled = 2;			#2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
#	$setting::field_tag_enabled = 'no';			#tag=タグのみ/all=全ての設定/no=タグをつけない

    #各種キー設定
    $setting::security_key = 'tools'; #デフォルトセキュリティキー
    $setting::key          = 'tools'; #ページ設定キー

    #	$setting::subkey = '';									#ページ詳細設定キー

    #アクセス権設定名
    $setting::security_name{'tools'} = '環境設定';

    #バックアップ対象DB
    $backup::db_name{'alldata'} = '全てのデータ';    #名前
    $backup::db_path{'alldata'} = $default::data; #データベースの位置
    $backup::find{'alldata'} = 1;    #1=ディレクトリの階層を下る
    $backup::skip{'alldata'} = 1
        ;   #1=デフォルトファイルのスキャンをスキップする
    $backup::db_name{'allpref'} = '全ての初期設定';    #名前
    $backup::db_path{'allpref'}
        = $default::preferences;    #データベースの位置
    $backup::find{'allpref'} = 1;   #1=ディレクトリの階層を下る
    $backup::skip{'allpref'} = 1
        ;   #1=デフォルトファイルのスキャンをスキップする

    if ( !$env::home_dir_id && -d $default::cgi_data ) {
        local (*DIR);
        if ( opendir( DIR, $default::cgi_data ) ) {
            no warnings qw(numeric);
            my (@dir);
            @dir
                = sort { $a <=> $b || $a cmp $b }
                grep( -d $default::cgi_data . '/' . $_
                    && $_ !~ /^[-\.]/
                    && $_
                    !~ /^(data|default|lib|preferences|template|zipcode|clipboard)$/,
                readdir(DIR) );
            closedir(DIR);
            foreach (@dir) {
                $backup::db_name{ 'x' . $_ }
                    = '全ての初期設定・データ(' . $_ . ')'; #名前
                $backup::db_path{ 'x' . $_ } = $default::cgi_data . '/'
                    . $_;    #データベースの位置
                $backup::find{ 'x' . $_ }
                    = 1;     #1=ディレクトリの階層を下る
                $backup::skip{ 'x' . $_ } = 1
                    ; #1=デフォルトファイルのスキャンをスキップする
            }
        }
    }

    #画像ライブラリ
    $setting::deco_dir{'background'}  = '背景画像';
    $setting::deco_type{'background'} = 'background';
    $setting::deco_dir{'frame'}       = 'フレーム';
    $setting::deco_type{'frame'}      = 'frame';
    $setting::deco_dir{'title'}       = 'タイトル';
    $setting::deco_type{'title'}      = 'image';

    $setting::deco_dir{'new'}  = '新着アイコン';
    $setting::deco_type{'new'} = 'image';

    $setting::deco_dir{'comment'}  = 'コメントする ボタン';
    $setting::deco_type{'comment'} = 'button';

    $setting::deco_dir{'vote'}  = '投票する ボタン';
    $setting::deco_type{'vote'} = 'button';

    $setting::deco_dir{'misc'}  = '画像選択用素材';
    $setting::deco_type{'misc'} = 'image';

    $setting::deco_dir{'jump'}  = 'ジャンプボタン';
    $setting::deco_type{'jump'} = 'button';

    $setting::deco_dir{'index'}   = 'インデックス ボタン';
    $setting::deco_type{'index'}  = 'button';
    $setting::deco_dir{'return'}  = '戻る ボタン';
    $setting::deco_type{'return'} = 'button';
    $setting::deco_dir{'next'}    = '「次」ボタン';
    $setting::deco_type{'next'}   = 'button';
    $setting::deco_dir{'prev'}    = '「前」ボタン';
    $setting::deco_type{'prev'}   = 'button';

    $setting::deco_dir{'close'}   = '閉じる ボタン';
    $setting::deco_type{'close'}  = 'button';
    $setting::deco_dir{'submit'}  = '送信 ボタン';
    $setting::deco_type{'submit'} = 'button';
    $setting::deco_dir{'cancel'}  = 'キャンセル ボタン';
    $setting::deco_type{'cancel'} = 'button';

    $setting::deco_dir{'detail'}  = '詳細ボタン';
    $setting::deco_type{'detail'} = 'button';
    $setting::deco_dir{'email'}   = 'E-Mailアイコン';
    $setting::deco_type{'email'}  = 'button';

    $setting::deco_dir{'bargraph'}    = '棒グラフ画像';
    $setting::deco_type{'bargraph'}   = 'image';
    $setting::deco_dir{'bargraphbg'}  = '棒グラフ枠画像';
    $setting::deco_type{'bargraphbg'} = 'image';

    $setting::deco_dir{'map'}     = '地図画像';
    $setting::deco_type{'map'}    = 'map';
    $setting::deco_dir{'marker'}  = '地図マーカー画像';
    $setting::deco_type{'marker'} = 'marker';

    $setting::deco_dir{'number'}  = '数字画像';
    $setting::deco_type{'number'} = 'number';

    $setting::deco_dir{'toggler'}  = 'トグルボタン';
    $setting::deco_type{'toggler'} = 'toggler';

    $setting::deco_dir{'edit'}   = '編集画面 ボタン';
    $setting::deco_type{'edit'}  = 'button';
    $setting::deco_dir{'tools'}  = '環境設定 ボタン';
    $setting::deco_type{'tools'} = 'button';

    if ( defined $env::checkout && $env::checkout ) {
        $setting::deco_dir{'check'}  = '901:カートを見る ボタン';
        $setting::deco_type{'check'} = 'button';
        $setting::deco_dir{'cart'}   = '903:カートに入れる ボタン';
        $setting::deco_type{'cart'}  = 'button';
        $setting::deco_dir{'sales'}  = '売れ行きタグ用素材';
        $setting::deco_type{'sales'} = 'image';
    }

    #ツールページ設定
    $setting::page{'tools'}{'title'} = '環境設定';

    #	$setting::page{'tools'}{'text'} = '#000000';
    #	$setting::page{'tools'}{'link'} = '#0000ff';
    #	$setting::page{'tools'}{'alink'} = '#99ffff';
    #	$setting::page{'tools'}{'vlink'} = '#000099';
    #	$setting::page{'tools'}{'hover'} = '#00ffff';
    #	$setting::page{'tools'}{'nodeco'} = 'no';
    #	$setting::page{'tools'}{'bgcolor'} = '#ffffff';
    $setting::page{'tools'}{'bodyId'}                   = 'tools';
    $setting::page{'tools'}{'commonHtmlHeaderDisabled'} = 1;
    $setting::page{'tools'}{'cssFileName'}              = 'tools.css';

# 	$setting::page{'tools'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'tools'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'tools'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'tools'}{'background'} = '';
# 	$setting::page{'tools'}{'bgproperties'} = '';
# 	$setting::page{'tools'}{'topmargin'} = '';
# 	$setting::page{'tools'}{'leftmargin'} = '';
# 	$setting::page{'tools'}{'javascript'} = '';
# 	$setting::page{'tools'}{'header'} = '';
# 	$setting::page{'tools'}{'headerFileName'} = '';
# 	$setting::page{'tools'}{'titleImageAlign'} = '';
# 	$setting::page{'tools'}{'titleImage'} = '';
# 	$setting::page{'tools'}{'align'} = '';
# 	$setting::page{'tools'}{'width'} = '';
# 	$setting::page{'tools'}{'deco'} = '';
# 	$setting::page{'tools'}{'titleText'} = '';

    my ( @ignore_lib, @ignore_common_lib );
    @ignore_common_lib = ( 'Clear', 'Exit', 'FieldEditor' );

    #必須フォーム
    @setting::form = ( 'm', 'k' );
    $cgi::input->query_filter( $cgi::input->secure_query_for_tools_ref )
        if ref $cgi::input;

    #ユーザー権限で動作しているかどうか
    if ( !defined $env::ownerpower || $env::ownerpower eq '' ) {
        my $uid = ( stat('./start.cgi') )[4];
        $env::ownerpower = ( $uid ne $> && $uid ne $< ) ? 0 : 1;
    }
    if ($env::ownerpower) {
        push( @ignore_lib, 'OptMod' );
    }
    else {
#push(@ignore_lib,'CartSetting','CGIInstaller','CGIRegister','CGIUninstaller','ImageCSSBuilder','JavaScriptUpdater','CSSUpdater','MasterInfo','SiteTemplateApplier','SiteTemplateMaker','SiteTemplateRemover','SubDirInstaller','SubDirInstallMsg','SubDirUninstaller');
    }

    #サブディレクトリ判定
    my $user_directory = $cgi::input->user_directory(1);
    $default::http_home_dir = $cgi::input->home_directory(1);
    $default::http_home_dir =~ s/^$user_directory//;
    $default::http_home_dir =~ s/^$env::top_dir// if $env::top_dir;
    $default::home_dir = $default::http_home_dir
        if !defined $default::home_dir;
    if ( ( defined $env::home_dir_id && $env::home_dir_id ne '' )
        || $env::multi_domain )
    {
        push( @ignore_lib,
            'OptMod',            'SiteChmod',  'SiteInfo',
            'JavaScriptUpdater', 'CSSUpdater', 'SystemUninstaller',
            'SystemUpdater' );
        $main::k = '0000'
            if !defined $main::k
            || $main::k eq ''
            || $main::k eq 's200'
            || $main::k eq 'i';
        $default::k = '0000'
            if !defined $default::k
            || $default::k eq ''
            || $default::k eq 's200'
            || $default::k eq 'i';
    }
    elsif ($env::ownerpower) {
        my $is_installed = 0;
        if ( defined $main::k && $main::k ne '' && $main::k ne '0' ) {
            $is_installed = 1;
        }
        else {
            use Fcntl qw(:DEFAULT :flock);
            eval 'use ' . $env::dbm_file . ';';
            my %general;
            tie( %general, $env::dbm_file,
                $default::preference_dir . '/general',
                O_RDONLY, $env::dbm_mode );
            $is_installed = 1 if ref tied %general;
            untie %general;
        }
        if ($is_installed) {
            push( @ignore_lib, 'Installer' );
            $main::k = '0000'
                if !defined $main::k || $main::k eq '' || $main::k eq 'i';
            $default::k = '0000'
                if !defined $default::k
                || $default::k eq ''
                || $default::k eq 'i';
        }
        else {
            push( @ignore_common_lib, 'TableSetting' );
            $setting::page{'tools'}{'title'}
                = 'CMONOS.JP インストーラー';
            $main::k           = '0';
            $default::k        = '0';
            $setting::general  = 0;     #一般設定読み込み
            $setting::deco     = 0;     #テキスト装飾設定読み込み
            $setting::security = 0;     #アクセス権設定読み込み
            $setting::table    = 0;     #テーブル設定読み込み
            $main::pswd = 'master' if !$main::pswd && !$main::a;
        }
    }
    else {
        $main::k = '0000'
            if !defined $main::k || $main::k eq '' || $main::k eq 'i';
        $default::k = '0000'
            if !defined $default::k
            || $default::k eq ''
            || $default::k eq 'i';
    }

    #メンテナンスモジュール読み込み
    Common::use_modules( 'CGI_Lib/Tools',          '', \@ignore_common_lib );
    Common::use_modules( $default::lib . '/Tools', '', \@ignore_lib );

}

1;
