package CGIUninstaller;
require CMONOS::SetupAssistant::Tools::CGIRegister;
@ISA = qw(CGIRegister);
use strict;
use utf8;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# CGIインストールモジュール
# CGIUninstaller.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-02-09
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my (@tools,    @enabled,   @folder,   $dir, %cgi,
        @del_dirs, @del_files, @del_urls, %del_cgis
    );
    if ( !@main::target && defined $main::target && $main::target ne '' ) {
        push( @main::target, $main::target );
        undef $main::target;
    }

#push(@main::target,'account') if grep($_ eq 'order',@main::target) && -d '../account' && !grep($_ eq 'account',@main::target);
    eval 'use ' . $env::dbm_file . ';';

    #CGIスキャン
    @tools = (
        'access_counter', 'accestat', 'gatekeeper', 'imageLib',
        'navimaker',      'postman2', 'pswd',       'setup',
        'station',        'top',      'zipcode',    'yahoosearch'
    );
    @enabled = (
        'Baobab',            'HomePageMaker',
        'HomePageMakerLite', 'TableMaker',
        'Calendar',          'DayCounter',
        'FeedMixer',         'Questionnaire'
    );
    local (*DIR);
    opendir( DIR, '../' );
    @folder = grep( $_ !~ /^\./ && -d '../' . $_, readdir(DIR) );
    closedir(DIR);
    foreach $dir (@folder) {
        my ( $setting, $preference_dir, $name, $lib, $title, %general );
        local (*SETTING);
        next if grep( $dir eq $_, @tools );
        next
            if !-f '../' . $dir . '/start.cgi'
            || !open( SETTING, '../' . $dir . '/default.pl' );
        binmode SETTING, ":utf8";
        flock( SETTING, LOCK_SH );
        $setting = join( '', <SETTING> );
        close(SETTING);

        if ( $setting
            =~ /^[\x20\x09]*\$lib[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m
            )
        {
            $lib = $1;
        }
        else {
            next;
        }
        next if grep( $_ eq $lib, @enabled ) == 0;
        $cgi{$dir} = $dir;
        $cgi{$dir} = $1
            if $setting
            =~ /^[\x20\x09]*\$name[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m;
        $preference_dir = eval($1)
            if $setting =~ /^[\x20\x09]*\$preference_dir[\x20\x09]*=(.*?);/m;
        if ( @main::target && grep( $dir eq $_, @main::target ) ) {
            push( @del_dirs, eval($1) )
                if $setting
                =~ /^[\x20\x09]*\$field_pref_dir[\x20\x09]*=(.*?);/m;
            push( @del_dirs, $preference_dir );
            push( @del_dirs, eval($1) )
                if $setting =~ /^[\x20\x09]*\$db[\x20\x09]*=(.*?);/m;
            if ( $lib eq 'DayCounter' || $lib eq 'FeedMixer' ) {
                if ( $setting =~ /^[\x20\x09]*\$file[\x20\x09]*=(.*?);/m ) {
                    my $file_path = eval($1);
                    push( @del_files, $file_path );
                    push( @del_files, $file_path )
                        if $file_path =~ s/\.ssi$/.js/;
                }
            }
            else {
                push( @del_dirs, eval($1) )
                    if $setting =~ /^[\x20\x09]*\$file[\x20\x09]*=(.*?);/m;
            }
            if ( $lib eq 'HomePageMaker' ) {
                $del_cgis{ eval($1) } = []
                    if $setting =~ /^[\x20\x09]*\$id[\x20\x09]*=(.*?);/m;
                if ( $setting =~ /^[\x20\x09]*\$home[\x20\x09]*=(.*?);/m ) {
                    my ($home);
                    $home = eval($1);
                    push( @del_urls, $this->full_path($home) );
                    push( @del_dirs, $home );
                }
            }
            elsif ( $lib eq 'HomePageMakerLite' ) {
                $del_cgis{ eval($1) } = []
                    if $setting =~ /^[\x20\x09]*\$id[\x20\x09]*=(.*?);/m;
                if ( $setting =~ /^[\x20\x09]*\$home[\x20\x09]*=(.*?);/m ) {
                    my ($home);
                    $home = eval($1);
                    push( @del_urls, $this->full_path($home) );
                    $home =~ s!/[^/]+$!!;
                    push( @del_dirs, $home );
                }
            }
            elsif ( $lib eq 'Questionnaire' ) {
                push( @del_dirs, eval($1) )
                    if $setting =~ /^[\x20\x09]*\$data[\x20\x09]*=(.*?);/m;
            }
            elsif ($lib eq 'Baobab'
                || $lib eq 'Calendar'
                || $lib eq 'TableMaker' )
            {
                $del_cgis{ eval($1) } = []
                    if $setting =~ /^[\x20\x09]*\$id[\x20\x09]*=(.*?);/m;
                push( @del_urls, $this->full_path( '../' . $dir ) );
            }
            push( @del_dirs, '../' . $dir );
        }
        if ($preference_dir) {
            tie( %general, $env::dbm_file, $preference_dir . '/general',
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %general ) {
                $cgi{$dir}
                    = ( $general{'cginame'} )
                    ? $this->decode_utf8( $general{'cginame'} )
                    : $dir;
            }
            untie %general;
        }
    }

    #アンインストール処理
    if (@main::target) {
        my $checkout_removed = 0;
        eval 'use File::Path';
        foreach my $i (@main::target) {
            if ( defined $cgi{$i} ) {
                push(
                    @{ $this->{'dialog'} },
                    '「'
                        . $cgi{$i} . '('
                        . $i
                        . ') 」をアンインストールしました。'
                );
                $checkout_removed = 1 if $i eq 'order';
                delete $cgi{$i};
            }
            elsif ( -d '../' . $i ) {
                push(
                    @{ $this->{'dialog'} },
                    '「'
                        . $i
                        . '」はアンインストールできません。'
                );
            }
            else {
                push(
                    @{ $this->{'dialog'} },
                    '「' . $i . '」は存在しません。'
                );
            }
        }
        undef @main::target;
        rmtree( \@del_dirs );
        undef @del_dirs;
        unlink @del_files;
        undef @del_files;
        $this->site_scan;
        $this->checkout_disabled if $checkout_removed;

        if (@del_urls) {
            require CMONOS::CGI_Lib::IndexSweeper;
            IndexSweeper->new(
                'index_files' => [
                    $env::externalfiles . '/metaindex.ssi',
                    $env::externalfiles . '/recentcomments.ssi',
                    $env::externalfiles . '/recenttrackbacks.ssi',
                ],
                'rss_files' => [
                    '../../index.xml',     '../../comment.xml',
                    '../../trackback.xml', '../../podcast.xml',
                ],
            )->sweep( \@del_urls, \%del_cgis );
        }
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>CGI アンインストーラー</h1>';

    if (%cgi) {
        no warnings qw(numeric);
        print $this->form_start(
            'key'    => 'tools',
            'name'   => 'input',
            'method' => 'post',
            'onsubmit' =>
                'return confirm(\'この操作は取り消せません。本当にアンインストールしますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted()',
            'required' => \@setting::form
        );
        print
            '<fieldset><legend>アンインストールする CGI を選択</legend>';
        my @cgi_list = sort { $a <=> $b || $a cmp $b } keys %cgi;
        print '<select name="target" multiple="multiple" size="'
            . ( scalar @cgi_list ) . '">';
        foreach (@cgi_list) {

#print '<option value="' . $_ . '">' . $cgi{$_} . (($_ eq 'order') ? ((defined $cgi{'account'}) ? ',' . $cgi{'account'} : '') . '(' . $_ . ((defined $cgi{'account'}) ? ', account' : '') : '') . ') </option>';
            print '<option value="'
                . $_ . '">'
                . $cgi{$_} . '('
                . $_
                . ') </option>';
        }
        print '</select>';
        print '</fieldset>';
        print
            '<fieldset class="delete"><input type="submit" value="アンインストール" /></fieldset></form>';
    }
    else {
        print
            '<fieldset>アンインストール可能な CGI が存在しません。</fieldset>';
    }

    #ページフッタ
    $this->print_page_footer('tools');
}

sub checkout_disabled ($) {
    my $this = shift;
    my ( $data, $env_path, $cmonos_js_path );
    $this->get_setup_env;
    $env_path = $default::cgi_data . '/lib/env.pl';
    $data = $this->read_file( $env_path, 1 );
    $this->write_file( $env_path, \$data, 1 )
        if $data
        && $data
        =~ s!^[\x20\x09]*\$checkout[\x20\x09]*=[^;]*;!\$checkout = '';!m;

    $cmonos_js_path = $env::javascript . '/cmonos.js';
    $data = $this->read_file( $cmonos_js_path, 1 );
    $this->write_file( $cmonos_js_path, \$data, 1 )
        if $data && $data =~ s!^(cmonos\.init\.loadCartJs\(\);)!//$1!m;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 's401', 'CGIUninstaller' );

    #メニュー登録
    $setting::jump_menu{'s401'} = 'CGIアンインストーラー';

}

1;
