package FTPAccess;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# FTPアクセス制限モジュール
# FTPAccess.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-06-07
######################################################################
# 実行
sub run ($) {
    my $this           = shift;
    my $ftpaccess_path = '../../.ftpaccess';
    if ( ( !defined $env::home_dir_id || $env::home_dir_id eq '' )
        && !$env::multi_domain )
    {
        my $uid
            = ( stat( $this->path_conv( $ENV{'SCRIPT_NAME'}, 'path' ) ) )[4];
        my $document_root = $this->document_root;
        my $prefix        = '';
        while ( $document_root =~ s!/[^/]+$!! ) {
            if ($document_root) {
                my $duid = ( stat($document_root) )[4];
                if ( !$duid || $duid ne $uid ) {
                    last;
                }
            }
            $prefix .= '../';
        }
        if ($prefix) {
            $ftpaccess_path = $prefix . $ftpaccess_path if $main::root;

            #ライブラリメニュー
            $setting::page{'tools'}{'subMenu'} = $this->form_start(
                'key'      => $setting::security_key,
                'name'     => 'dirselector',
                'required' => \@setting::form
            );
            $setting::page{'tools'}{'subMenu'}
                .= '<select name="root" onchange="submit()">';
            $setting::page{'tools'}{'subMenu'}
                .= '<option value="">このディレクトリ</option>';
            $setting::page{'tools'}{'subMenu'}
                .= '<option value="1"'
                . ( ($main::root) ? ' selected="selected"' : '' )
                . '>アクセス可能な最上層</option>';
            $setting::page{'tools'}{'subMenu'} .= '</select>';
            $setting::page{'tools'}{'subMenu'}
                .= '<input name="subJumpMenu" type="submit" value="選択" /></form>';
            $setting::page{'tools'}{'topicpath'} .= (
                (   defined $setting::page{'tools'}{'topicpath'}
                        && $setting::page{'tools'}{'topicpath'} ne ''
                ) ? ' &gt; ' : ''
                )
                . ( ($main::root)
                ? 'アクセス可能な最上層'
                : 'このディレクトリ' );
            $this->push_window_title( ($main::root)
                ? 'アクセス可能な最上層'
                : 'このディレクトリ' );
        }
        else {
            undef $main::root;
        }
    }

    my $current_ftpaccess = $this->read_file( $ftpaccess_path, 1 );
    my $allowed_ip;
    my $deny_from_all  = 0;
    my $allow_from_all = 0;
    if (   $current_ftpaccess
        && $current_ftpaccess
        =~ /<Limit[\x09\x0A\x0C\x0D\x20]+ALL>(.*?)<\/Limit>/is )
    {
        my $setting = $1;
        $allowed_ip = $1
            if $setting
            =~ /Allow[\x09\x0A\x0C\x0D\x20]+from[\x09\x0A\x0C\x0D\x20]+([0-9a-zA-Z_\-\.\/]+)/is;
        $deny_from_all = 1
            if !$allowed_ip
            && ( $setting =~ /Deny[\x09\x0A\x0C\x0D\x20]*All/is
            || $setting
            =~ /Deny[\x09\x0A\x0C\x0D\x20]+from[\x09\x0A\x0C\x0D\x20]+all/is
            );
        $allow_from_all = 1
            if $setting =~ /Allow[\x09\x0A\x0C\x0D\x20]*All/is;
    }
    if ($main::limit) {
        if ( $main::limit eq 'remove' ) {
            if ($current_ftpaccess) {
                $current_ftpaccess
                    =~ s/<Limit[\x09\x0A\x0C\x0D\x20]+ALL>.*?<\/Limit>\x0A?//igs;
                if ( $current_ftpaccess !~ /[^\x09\x0A\x0C\x0D\x20]/s ) {
                    unlink $ftpaccess_path;
                }
                else {
                    $this->write_file( $ftpaccess_path, \$current_ftpaccess,
                        1 );
                }
            }
            $allowed_ip     = '';
            $deny_from_all  = 0;
            $allow_from_all = 0;
        }
        elsif ( $main::limit eq 'none' ) {
            $current_ftpaccess = "<Limit ALL>\x0A  AllowAll\x0A</Limit>\x0A"
                unless $current_ftpaccess
                =~ s/<Limit[\x09\x0A\x0C\x0D\x20]+ALL>.*?<\/Limit>\x0A?/<Limit ALL>\x0A  AllowAll\x0A<\/Limit>\x0A/igs;
            $this->write_file( $ftpaccess_path, \$current_ftpaccess, 1 );
            $allowed_ip     = '';
            $deny_from_all  = 0;
            $allow_from_all = 1;
        }
        elsif ( $main::limit eq 'all' ) {
            $current_ftpaccess = "<Limit ALL>\x0A  DenyAll\x0A</Limit>\x0A"
                unless $current_ftpaccess
                =~ s/<Limit[\x09\x0A\x0C\x0D\x20]+ALL>.*?<\/Limit>\x0A?/<Limit ALL>\x0A  DenyAll\x0A<\/Limit>\x0A/igs;
            $this->write_file( $ftpaccess_path, \$current_ftpaccess, 1 );
            $allowed_ip     = '';
            $deny_from_all  = 1;
            $allow_from_all = 0;
        }
        elsif ( $main::limit eq 'ip' ) {
            $current_ftpaccess
                = "<Limit ALL>\x0A  Order Allow,Deny\x0A  Allow from $ENV{'REMOTE_ADDR'}\x0A  Deny from all\x0A</Limit>\x0A"
                unless $current_ftpaccess
                =~ s/<Limit[\x09\x0A\x0C\x0D\x20]+ALL>.*?<\/Limit>\x0A?/<Limit ALL>\x0A  Order Allow,Deny\x0A  Allow from $ENV{'REMOTE_ADDR'}\x0A  Deny from all\x0A<\/Limit>\x0A/igs;
            $this->write_file( $ftpaccess_path, \$current_ftpaccess, 1 );
            $allowed_ip     = $ENV{'REMOTE_ADDR'};
            $deny_from_all  = 0;
            $allow_from_all = 0;
        }
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>FTPアクセス制限</h1>';
    print '<p class="warning">'
        . ( ($main::root)
        ? '<strong>アクセス可能な最上層</strong>'
        : 'このディレクトリ' )
        . 'への FTP アクセス制限を設定します。「.ftpaccess」による FTP アクセス制限に対応していない FTP サーバでは、アクセス制限ができません。</p>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="root" value="1" />' if $main::root;
    print '<fieldset><legend>現在の設定</legend><p>';

    if ($allowed_ip) {
        print $this->escape($allowed_ip)
            . ' 以外の IP からの FTP アクセスを拒絶しています。';
    }
    elsif ($deny_from_all) {
        print
            'すべての IP からの FTP アクセスを拒絶しています。';
    }
    elsif ($allow_from_all) {
        print
            'すべての IP からの FTP アクセスを明示的に許可しています。';
    }
    else {
        print 'FTP アクセス制限は実施されていません。';
    }
    print '</p></fieldset>';
    print
        '<fieldset><legend>アクセス制限設定</legend><ol class="checkbox">';
    print
        '<li><label><input type="radio" name="limit" value="none" /> 設定ファイルを作成して、すべての IP からの FTP アクセスを明示的に許可する(上位階層で FTP アクセスが制限されている場合など)。</label></li>'
        if !$allow_from_all;
    print
        '<li><label><input type="radio" name="limit" value="remove" /> FTP アクセス制限設定を削除する(可能なら設定ファイルを削除します)。</label></li>'
        if $allow_from_all;
    print
        '<li><label><input type="radio" name="limit" value="remove" /> FTP アクセス制限を解除する(可能なら設定ファイルを削除します)。</label></li>'
        if $allowed_ip || $deny_from_all;
    print '<li><label><input type="radio" name="limit" value="ip" /> '
        . $this->escape( $ENV{'REMOTE_ADDR'} )
        . ' 以外の IP からの FTP アクセスを拒絶する。</label></li>'
        if !$allowed_ip || $allowed_ip ne $ENV{'REMOTE_ADDR'};
    print
        '<li><label><input type="radio" name="limit" value="all" /> すべての IP からの FTP アクセスを拒絶する。</label></li>'
        if !$deny_from_all;
    print '</ol></fieldset>';
    print '<fieldset class="submit">';
    print '<input type="submit" value="変更する" /></fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');

}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if (   $env::ownerpower
        && !$env::subdirectory_disabled
        && !$env::user_site_template_dir )
    {
        no warnings qw(once);

        #クラス登録
        Common::class_register( '00s2', 'FTPAccess' );

        #メニュー登録
        $setting::jump_menu{'00s2'} = 'FTPアクセス制限';

    }
}

1;
