package JavaScriptUpdater;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
use utf8;
######################################################################
# JavaScriptアップデータモジュール
# JavaScriptUpdater.pm ver1.0.7
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-03-08
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->get_setup_env;
    my $updater_enabled
        = ( -d $env::template_dir . '/site/default/htdocs/lib/javascript' )
        ? 1
        : 0;

    #アップデート
    $this->update if $updater_enabled && $main::update;

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>JavaScript アップデート</h1>';
    print '<p>"'
        . $this->get_path_for_log($env::template_dir)
        . '/site/default/htdocs/lib/javascript" 以下のファイルを全てのサイトテンプレートおよび全てのサブディレクトリの javascript フォルダに上書きコピーします。</p>';
    if ( !$updater_enabled ) {
        print
            '<fieldset>アップデートに必要なテンプレートがみつかりません。</fieldset>';
    }
    else {
        print $this->form_start(
            'key'    => 'tools',
            'name'   => 'input',
            'method' => 'post',
            'onsubmit' =>
                'return confirm(\'この操作は取り消せません。本当に変更しますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
            'required' => \@setting::form
        );
        if ( $this->{'update_log'} ) {
            print
                '<fieldset><legend>JavaScript アップデートログ</legend><ol>';
            print $this->{'update_log'};
            print '</ol></fieldset>';
        }
        print
            '<fieldset class="submit"><input type="submit" name="update=1" value="JavaScript をアップデートする" /></fieldset></form>';
    }

    #ページフッタ
    $this->print_page_footer('tools');
}

sub get_path_for_log ($$) {
    my ( $this, $path ) = @_;
    $path =~ s/^(?:\.\.\/)+/~\//;
    return $path;
}

sub update ($) {
    my $this = shift;
    local (*TEMP);
    foreach my $dir ( '', $this->sub_directory_scan($default::cgi_data_root) )
    {
        $this->javascript_update($dir);
        if ($dir
            && opendir( TEMP,
                $default::cgi_data_root . $dir . '/template/site'
            )
            )
        {
            my @template
                = grep( $_ ne 'default'
                    && $_ !~ /\./
                    && -d $default::cgi_data_root
                    . $dir
                    . '/template/site/'
                    . $_,
                readdir(TEMP) );
            closedir(TEMP);
            foreach my $temp_dir (@template) {
                $this->javascript_update( $temp_dir, 1, '',
                    $default::cgi_data_root . $dir . '/template' );
            }
        }
    }
    if ( opendir( TEMP, $env::template_dir . '/site' ) ) {
        my @template
            = grep( $_ ne 'default'
                && $_ !~ /\./
                && -d $env::template_dir . '/site/' . $_,
            readdir(TEMP) );
        closedir(TEMP);
        foreach my $dir (@template) {
            $this->javascript_update( $dir, 1 );
        }
    }
    return $this;
}

sub update_log ($) {
    my $this = shift;
    return $this->{'update_log'};
}

sub javascript_update ($$;$$$) {
    my ( $this, $home_dir, $is_template, $home_rel, $template_dir ) = @_;
    $home_dir =~ s!^/!!;
    $home_rel     = '../../' . $home_dir if !$home_rel;
    $template_dir = $env::template_dir   if !$template_dir;
    my $new_version
        = $env::template_dir . '/site/default/htdocs/lib/javascript';
    my $javascript_dir;
    my $cart_enabled = (
        -f ( ($is_template)
            ? $template_dir
                . '/site/'
                . $home_dir
                . '/htdocs/cgi/order/start.cgi'
            : ( !$home_dir ) ? ($env::checkout)
                    ? $env::checkout
                    : '../order/start.cgi'
                : $home_rel . '/cgi/order/start.cgi'
        )
    ) ? 1 : 0;
    my (@files,                      @directories,
        $entry,                      $f,
        $env_javascript,             $env_home_dir_id,
        $env_checkout_window_type,   $env_checkout_window_width,
        $env_checkout_window_height, $env_checkout_window_top,
        $env_checkout_window_left
    );
    local (*SUBDIR);
    return 0 unless opendir( SUBDIR, $new_version );

    while ( $entry = readdir(SUBDIR) ) {
        next if $entry =~ /^\./;
        my $path = $new_version . '/' . $entry;
        if ( -f $path ) {
            push( @files, $entry );
        }
        elsif ( -d $path ) {
            push( @directories, $entry );
        }
    }
    closedir(SUBDIR);
    if ($is_template) {
        $javascript_dir
            = $template_dir . '/site/' . $home_dir . '/htdocs/lib/javascript';
        return 0 if !-d $javascript_dir;
        $env_home_dir_id = '';
        $env_javascript
            = $this->get_path_for_log($template_dir)
            . '/site/'
            . $home_dir
            . '/htdocs/lib/javascript';
        $this->{'update_log'} .= '<li>' . $env_javascript . '</li>';
        my $env_data = $this->read_file(
            $template_dir . '/site/' . $home_dir . '/env.bak' );
        if ($env_data) {
            if ( $env_data =~ /^checkout_window_type\x09([0-9a-zA-Z_]+)$/m ) {
                $env_checkout_window_type = $1;
            }
            if ( $env_data =~ /^checkout_window_width\x09(\-?[0-9]+)$/m ) {
                $env_checkout_window_width = $1;
            }
            if ( $env_data =~ /^checkout_window_height\x09(\-?[0-9]+)$/m ) {
                $env_checkout_window_height = $1;
            }
            if ( $env_data =~ /^checkout_window_top\x09(\-?[0-9]+)$/m ) {
                $env_checkout_window_top = $1;
            }
            if ( $env_data =~ /^checkout_window_left\x09(\-?[0-9]+)$/m ) {
                $env_checkout_window_left = $1;
            }
        }
    }
    else {
        my $multi_domain;
        if ( $home_dir
            && -f $default::cgi_data_root . '/' . $home_dir . '/lib/env.pl' )
        {
            my $env_data = $this->read_file(
                $default::cgi_data_root . '/' . $home_dir . '/lib/env.pl' );
            if ($env_data) {
                if ( $env_data
                    =~ /^[\x20\x09]*\$home_dir_id[\x20\x09]*=[\x20\x09]*["'](.*?)["'][\x20\x09]*;/m
                    )
                {
                    $env_home_dir_id = $1;
                }
                if (  !$env::multi_domain
                    && $env_data
                    =~ /^[\x20\x09]*\$multi_domain[\x20\x09]*=[\x09\x0A\x0C\x0D\x20]*1/m
                    )
                {
                    $multi_domain = 1;
                }
                if ( $env_data
                    =~ /^[\x20\x09]*\$checkout_window_type[\x20\x09]*=[\x20\x09]*["']([0-9a-zA-Z_]+)["'][\x20\x09]*;/m
                    )
                {
                    $env_checkout_window_type = $1;
                }
                if ( $env_data
                    =~ /^[\x20\x09]*\$checkout_window_width[\x20\x09]*=[\x20\x09]*["']?(\-?[0-9a-zA-Z_]+)["']?[\x20\x09]*;/m
                    )
                {
                    $env_checkout_window_width = $1;
                }
                if ( $env_data
                    =~ /^[\x20\x09]*\$checkout_window_height[\x20\x09]*=[\x20\x09]*["']?(\-?[0-9a-zA-Z_]+)["']?[\x20\x09]*;/m
                    )
                {
                    $env_checkout_window_height = $1;
                }
                if ( $env_data
                    =~ /^[\x20\x09]*\$checkout_window_top[\x20\x09]*=[\x20\x09]*["']?(\-?[0-9a-zA-Z_]+)["']?[\x20\x09]*;/m
                    )
                {
                    $env_checkout_window_top = $1;
                }
                if ( $env_data
                    =~ /^[\x20\x09]*\$checkout_window_left[\x20\x09]*=[\x20\x09]*["']?(\-?[0-9a-zA-Z_]+)["']?[\x20\x09]*;/m
                    )
                {
                    $env_checkout_window_left = $1;
                }
            }
            $javascript_dir = $home_rel . '/lib/javascript';
        }
        else {
            $env_home_dir_id            = '';
            $javascript_dir             = $env::javascript;
            $env_checkout_window_type   = $env::checkout_window_type;
            $env_checkout_window_width  = $env::checkout_window_width;
            $env_checkout_window_height = $env::checkout_window_height;
            $env_checkout_window_top    = $env::checkout_window_top;
            $env_checkout_window_left   = $env::checkout_window_left;
        }
        $env_javascript
            = $this->path_change( $javascript_dir, $ENV{'SCRIPT_NAME'},
            'abs' );
        $this->{'update_log'} .= '<li>' . $env_javascript . '</li>';
        $env_javascript =~ s!^/[^/]+!! if $multi_domain;
    }
    foreach $f (@files) {
        if ( $f eq 'cmonos.js' ) {
            my $old = $this->read_file( $javascript_dir . '/cmonos.js', 1 );
            my $new = $this->read_file( $new_version . '/cmonos.js',    1 );
            my $sync_buttons
                = (
                $old =~ /var sync_button_classes = new Array\(([^\)]*)\);/ )
                ? $1
                : '';
            $new
                =~ s/(var sync_button_classes = new Array\()[^\)]*(\);)/$1$sync_buttons$2/si;
            if ( !$is_template ) {
                $new =~ s!(\.\./\.\./|/)lib/javascript!$env_javascript!g;
                $new =~ s/parent\.main/parent\.${env_home_dir_id}main/g;
                $new =~ s/parent\.navi/parent\.${env_home_dir_id}navi/g;
            }
            if ( $old =~ /mobile_mode_disabled\s*:\s*(false|true)\s*,/s ) {
                my $mobile_mode_disabled = $1;
                $new
                    =~ s/mobile_mode_disabled\s*:\s*(?:false|true)\s*,/mobile_mode_disabled : $mobile_mode_disabled,/sg;
            }
            $new =~ s!^//(cmonos\.init\.loadCartJs\(\);)!$1!m
                if $cart_enabled;
            $this->write_file( $javascript_dir . '/cmonos.js', \$new, 1 );
        }
        elsif ( $f eq 'cart.js' ) {
            my $cart_js = $this->read_file( $new_version . '/cart.js', 1 );
            my $top
                = (    $env_checkout_window_top
                    && $env_checkout_window_top !~ /^\-?[0-9]+/ )
                ? '"' . $env_checkout_window_top . '"'
                : $env_checkout_window_top;
            my $left
                = (    $env_checkout_window_left
                    && $env_checkout_window_left !~ /^\-?[0-9]+/ )
                ? '"' . $env_checkout_window_left . '"'
                : $env_checkout_window_left;
            my $width
                = (    $env_checkout_window_width
                    && $env_checkout_window_width !~ /^\-?[0-9]+/ )
                ? '"' . $env_checkout_window_width . '"'
                : $env_checkout_window_width;
            my $height
                = (    $env_checkout_window_height
                    && $env_checkout_window_height !~ /^\-?[0-9]+/ )
                ? '"' . $env_checkout_window_height . '"'
                : $env_checkout_window_height;
            $cart_js
                =~ s/([\x09\x0A\x0C\x0D\x20]+)type : .*?,/${1}type : "$env_checkout_window_type",/mg
                if defined $env_checkout_window_type
                && $env_checkout_window_type ne '';
            $cart_js
                =~ s/([\x09\x0A\x0C\x0D\x20]+)top : .*?,/${1}top : $top,/mg
                if defined $top && $top ne '';
            $cart_js
                =~ s/([\x09\x0A\x0C\x0D\x20]+)left : .*?,/${1}left : $left,/mg
                if defined $left && $left ne '';
            $cart_js
                =~ s/([\x09\x0A\x0C\x0D\x20]+)width : .*?,/${1}width : $width,/mg
                if defined $width && $width ne '';
            $cart_js
                =~ s/([\x09\x0A\x0C\x0D\x20]+)height : .*?,/${1}height : $height,/mg
                if defined $height && $height ne '';
            $this->write_file( $javascript_dir . '/cart.js', \$cart_js, 1 );
        }
        else {
            $this->file_copy( $new_version . '/' . $f,
                $javascript_dir . '/' . $f );
        }
    }
    if (@directories) {
        my $d;
        foreach $d (@directories) {
            $this->directory_copy( $new_version . '/' . $d,
                $javascript_dir . '/' . $d, 1 );
        }
    }
    return 1;
}

#変更（アップデートで必要な場合利用）
sub text_replace ($$$$;$$) {
    my ( $this, $path, $old, $new, $quote, $log_ref ) = @_;
    my $data = $this->read_file( $path, 1 );
    $old = quotemeta $old if $quote;
    if ( $data =~ s/$old/$new/sg ) {
        $this->write_file( $path, \$data, 1 );
        $log_ref->{$path} = 1 if ref $log_ref;
    }
}

sub sub_directory_scan ($$) {
    my ( $this, $dir, $home_dir ) = @_;
    my ( @directories, @sub_directories, $entry, $d );
    @directories = @sub_directories = ();
    local (*DIR);
    return unless opendir( DIR, $dir );
    $home_dir = '' if !defined $home_dir;
    while ( $entry = readdir(DIR) ) {
        next if $entry =~ /^\./;
        my $path = $dir . '/' . $entry;
        push( @directories, $entry )
            if -d $dir . '/' . $entry
            && -f $dir . '/' . $entry . '/lib/env.pl';
    }
    closedir(DIR);
    foreach $d (@directories) {
        push(
            @sub_directories,
            $home_dir . '/' . $d,
            $this->sub_directory_scan(
                $dir . '/' . $d, $home_dir . '/' . $d
            )
        );
    }
    return @sub_directories;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 's303', 'JavaScriptUpdater' );

    #メニュー登録
    $setting::jump_menu{'s303'} = 'JavaScript アップデート';

}

1;
