package SystemUninstaller;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use File::Path;
use strict;
use utf8;
######################################################################
# システム・アンインストール モジュール
# SystemUninstaller.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-03-10
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->get_setup_env;
    my @directories = ();
    my @files       = ();
    push( @directories, $default::cgi_data_root . '/clipboard' )
        if -d $default::cgi_data_root . '/clipboard';
    push( @directories, $default::cgi_data_root . '/data' )
        if -d $default::cgi_data_root . '/data';
    push( @directories, $default::cgi_data_root . '/default' )
        if -d $default::cgi_data_root . '/default';
    push( @directories, $default::cgi_data_root . '/lib' )
        if -d $default::cgi_data_root . '/lib';
    push( @directories, $default::cgi_data_root . '/preferences' )
        if -d $default::cgi_data_root . '/preferences';
    push( @directories, $default::cgi_data_root . '/template' )
        if -d $default::cgi_data_root . '/template';
    push( @directories, $default::cgi_data_root . '/zipcode' )
        if -d $default::cgi_data_root . '/zipcode';
    push( @files, $default::cgi_data_root . '/.htaccess' )
        if -f $default::cgi_data_root . '/.htaccess';

    if ( $default::cgi_data_root ne $default::shared_cgi_data_root ) {
        push( @directories, $default::shared_cgi_data_root . '/clipboard' )
            if -d $default::shared_cgi_data_root . '/clipboard';
        push( @directories, $default::shared_cgi_data_root . '/data' )
            if -d $default::shared_cgi_data_root . '/data';
        push( @directories, $default::shared_cgi_data_root . '/default' )
            if -d $default::shared_cgi_data_root . '/default';
        push( @directories, $default::shared_cgi_data_root . '/lib' )
            if -d $default::shared_cgi_data_root . '/lib';
        push( @directories, $default::shared_cgi_data_root . '/preferences' )
            if -d $default::shared_cgi_data_root . '/preferences';
        push( @directories, $default::shared_cgi_data_root . '/template' )
            if -d $default::shared_cgi_data_root . '/template';
        push( @directories, $default::shared_cgi_data_root . '/zipcode' )
            if -d $default::shared_cgi_data_root . '/zipcode';
        push( @files, $default::shared_cgi_data_root . '/.htaccess' )
            if -f $default::shared_cgi_data_root . '/.htaccess';
    }
    local (*DIR);
    if ( opendir( DIR, $default::cgi_data_root ) ) {
        my @subdirectories
            = grep( $_ =~ /^[0-9a-zA-Z_]+$/
                && -d $default::cgi_data_root . '/' . $_
                && -f $default::cgi_data_root . '/' . $_ . '/lib/env.pl',
            readdir(DIR) );
        closedir(DIR);
        push( @directories,
            map { ( $default::cgi_data_root . '/' . $_, '../../' . $_ ) }
                @subdirectories )
            if @subdirectories;
    }

    #CGI関連ディレクトリの抽出
    push( @directories, '../' );
    push( @directories, '../../error' ) if -d '../../error';
    push( @directories, $env::icon_dir ) if -d $env::icon_dir;
    push( @directories, $env::image_dir ) if -d $env::image_dir;
    push( @directories, '../../lib' )
        if $env::javascript =~ m!^\.\./\.\./lib/! && -d '../../lib';
    if ( opendir( DIR, '../' ) ) {
        my @cgi
            = grep( $_ !~ /\./
                && -d '../' . $_
                && -f '../' . $_ . '/default.pl',
            readdir(DIR) );
        closedir(DIR);
        foreach my $cgi (@cgi) {
            if (grep( $_ eq $cgi,
                    'accesscounter', 'accestat', 'gatekeeper',
                    'pswd',          'setup',    'station',
                    'yahoosearch',   'zipcode' )
                || -d '../' . $cgi . '/files'
                )
            {
                next;
            }
            else {
                my $default
                    = $this->read_file( '../' . $cgi . '/default.pl', 1 );
                my $lib
                    = ( $default
                        =~ /\$lib[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*'([0-9a-zA-Z_]+)';/s
                    ) ? $1 : '';
                if ( $lib eq 'NaviMaker' ) {
                    if ( $default
                        =~ /\$sitemap_path[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*(.*?);/s
                        )
                    {
                        push( @directories, eval($1) );
                    }
                    if ( $default
                        =~ /\$sitemap_ssi[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*(.*?);/s
                        )
                    {
                        push( @directories, eval($1) );
                    }
                    if ( $default
                        =~ /\$frame_path[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*(.*?);/s
                        )
                    {
                        push( @directories, eval($1) );
                    }
                    if ( $default
                        =~ /\$navi_path[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*(.*?);/s
                        )
                    {
                        push( @directories, eval($1) );
                    }
                    if ( $default
                        =~ /\$top_path[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*(.*?);/s
                        )
                    {
                        push( @directories, eval($1) );
                    }
                }
                elsif ( $lib eq 'HomePageMaker' ) {
                    if ( $default
                        =~ /\$home[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*(.*?);/s
                        )
                    {
                        push( @directories, eval($1) );
                    }
                }
                elsif ( $lib eq 'HomePageMakerLite' ) {
                    my $rel_folder
                        = ( -d '../../' . $cgi ) ? '../../' . $cgi : '';
                    if ( $default
                        =~ /\$home[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*(.*?);/s
                        )
                    {
                        my $home = eval($1);
                        if ( !$rel_folder || $home !~ /^$rel_folder/ ) {
                            push( @files, $home );
                            $home =~ s/\.\w+$/.ssi/;
                            push( @files, $home );
                            $home =~ s/\.ssi$/.js/;
                            push( @files, $home );
                        }
                    }
                    if ( $default
                        =~ /\$file[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*(.*?);/s
                        )
                    {
                        my $file = eval($1);
                        push( @directories, $file )
                            if !$rel_folder || $file !~ /^$rel_folder/;
                    }
                }
            }
        }
    }
    push( @files, '../../.htaccess' )     if -f '../../.htaccess';
    push( @files, '../../index.xml' )     if -f '../../index.xml';
    push( @files, '../../index.kml' )     if -f '../../index.kml';
    push( @files, '../../trackback.xml' ) if -f '../../trackback.xml';
    push( @files, '../../podcast.xml' )   if -f '../../podcast.xml';
    push( @files, '../../comment.xml' )   if -f '../../comment.xml';
    push( @files, '../../m.cgi' )         if -f '../../m.cgi';
    push( @files, '../../qr_mini.png' )   if -f '../../qr_mini.png';
    push( @files, '../../qr.png' )        if -f '../../qr.png';

    #アンインストール
    if ( $this->is_master && $main::uninstall ) {
        my $perl_path          = $^X;
        my @target_directories = map {
            $this->base_change( $_, '../../uninstaller.cgi', 'rel', 1 )
        } @directories;
        my @target_files = map {
            $this->base_change( $_, '../../uninstaller.cgi', 'rel', 1 )
        } @files;
        my $target_directories_list
            = "'" . join( "','", @target_directories ) . "'";
        my $target_files_list = "'" . join( "','", @target_files ) . "'";
        my $remove = $main::remove || 0;
        my $cgi_data_root = $this->base_change( $default::cgi_data_root,
            '../../uninstaller.cgi', 'rel', 1 );
        my $shared_cgi_data_root
            = $this->base_change( $default::shared_cgi_data_root,
            '../../uninstaller.cgi', 'rel', 1 );
        my $uninstaller = <<CGI;
#!$perl_path -w
use File::Find;
use File::Path;
use strict;
use utf8;
my \$remove = $remove;

my \@directories = ($target_directories_list);
my \@files = ($target_files_list);

foreach my \$path (\@files) {
	chmod(0666,\$path);
	unlink \$path if \$remove;
}
my \$log = '';
foreach my \$path (\@directories) {
	find(sub {
		my \$f = \$File::Find::dir . '/' . \$_;
		if (-f \$_) {
			\$log .= '<li>' . \$f . '</li>' if chmod(0666,\$_);
		} elsif (-d \$_) {
			\$log .= '<li>' . \$f . '</li>' if chmod(0777,\$_);
		}
	},\$path);
	rmtree \$path if \$remove;
}
chmod(0777,'$cgi_data_root');
chmod(0777,'$shared_cgi_data_root');
chmod(0777,'./');
my \$msg = (\$remove) ? '関連ファイルをすべて削除しました。' : '関連ファイルのパーミッションを削除しやすいものに変更しました。';
binmode STDOUT, ":utf8";
print <<MSG;
Content-Type: text/html

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<title lang="ja">CMONOS.JP アンインストーラー</title>
<style type="text/css">
<!--
body, table {
  font: 14px 'Lucida Grande','Hiragino Kaku Gothic Pro','ヒラギノ角ゴ Pro W3','HiraKakuProN-W3',Verdana,'メイリオ','Meiryo','ＭＳ Ｐゴシック','MS PGothic',Osaka,arial,helvetica,sans-serif;
}
body {
  margin: 3em 10%;
  background-color: #FFF;
}
-->
</style>
</head>
<body>
<p>\$msg</p>
<ol>\$log</ol>
</body>
</html>
MSG

unlink './uninstaller.cgi';

CGI
        $this->write_file( '../../uninstaller.cgi', $uninstaller, 1 );
        chmod( $env::cgi_file_mode, '../../uninstaller.cgi' );
        $this->jump( $this->full_path('../../uninstaller.cgi') );
        return;
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>システム・アンインストール</h1>';
    if ( $this->is_master ) {
        print
            '<p class="warning">【警告】この作業は取り消しできません。</p>';
        print $this->form_start(
            'key'    => 'tools',
            'name'   => 'input',
            'target' => '_top',
            'method' => 'post',
            'onsubmit' =>
                'return confirm(\'この操作は取り消せません。本当に CMONOS.JP をアンインストールしますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
            'required' => \@setting::form
        );
    }
    else {
        print
            '<p class="warning">この作業を実行するには「マスターパスワード」が必要です。一度ログアウトして「マスターパスワード」でログインしてください。</p>';
        print '<form action="#">';
    }
    my $here = $this->get_cwd . '/start.cgi';
    print '<input type="hidden" name="uninstall" value="1" />';
    print
        '<fieldset><legend>アンインストール対象となるファイルおよびディレクトリ</legend>';
    print '<fieldset><legend>下記ファイル</legend><ol><li>';
    print join( '</li><li>',
        map { $this->path_change( $_, $here, 'abs' ) } @files );
    print '</li></ol></fieldset>';
    print
        '<fieldset><legend>下記ディレクトリ以下のすべてのファイルおよびディレクトリ</legend><ol><li>';
    print join( '</li><li>',
        map { $this->path_change( $_, $here, 'abs' ) } @directories );
    print '</li></ol></fieldset>';
    print '</fieldset>';

    if ( $this->is_master ) {
        print '<fieldset><legend>処理</legend><ol class="checkbox">';
        print
            '<li><label><input type="radio" name="remove" value="0" checked="checked" /> すべての関連ファイルのパーミッションを FTP 等で削除しやすいものに変更する</label></li>';
        print
            '<li><label><input type="radio" name="remove" value="1" /> すべての関連ファイルを削除する</label></li>';
        print '</ol></fieldset>';
        print '<fieldset class="delete">';
        print
            '<input type="submit" value="CMONOS.JP をアンインストールする" />';
        print '</fieldset>';
    }
    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if (   $env::ownerpower
        && ( !defined $env::home_dir_id || $env::home_dir_id eq '' )
        && !$env::multi_domain )
    {
        no warnings qw(once);

        #クラス登録
        Common::class_register( 'yzzz', 'SystemUninstaller' );

        #メニュー登録
        $setting::jump_menu{'yzzz'}
            = 'システム・アンインストール';
    }
}

1;
