package CheckOut;
require CMONOS::TableMaker::InputBase;
@ISA = qw(InputBase);
use strict;
use utf8;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# チェックアウトモジュール
# CheckOut.pm ver1.2.6
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2018-02-21
######################################################################
sub update ($) {
    my $this = shift;
    eval 'use ' . $env::dbm_file . ';';
    $main::n = '';
    require CMONOS::CGI_Lib::Deco;
    $this->{'icon'} =
      Deco->new( $env::image_dir . '/order', $env::image_lib . '/order' );
    $this->import_db( $default::preference_dir . '/terms',
        \%setting::payment, 1 )
      if !%setting::payment;
    $setting::general{'itemname'} = '商品'
      if !$setting::general{'itemname'};
    if ( $field::for{'payment_method'} && $setting::payment{'paypalenabled'} ) {

        if ( eval { require LWP::UserAgent } && eval 'use Crypt::SSLeay;1;' ) {
            $setting::payment{'paypal'}{'button'} =
              'http://www.paypal.com/ja_JP/JP/i/btn/btn_xpressCheckout.gif'
              if !$setting::payment{'paypal'}{'button'};
            $this->{'settings'}{'payment'}{'paypal'}{'banner'} =
'<a href="#" onclick="javascript:window.open(\'https://www.paypal.com/jp/webapps/mpp/logo/about\',\'olcwhatispaypal\',\'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=900, height=700\');"><img src="https://www.paypalobjects.com/digitalassets/c/website/marketing/apac/jp/developer/Logo_203_80.png" border="0" alt="ペイパル｜Mastercard,VISA,American Express,JCB"></a></a>'
              if !$setting::payment{'paypal'}{'banner'};
            if ( $this->is_ssl ) {
                $setting::payment{'paypal'}{'button'} =~ s!^http://!https://!i;
                $setting::payment{'paypal'}{'banner'} =~ s!http://!https://!i;
            }
            else {
                $setting::payment{'paypal'}{'button'} =~ s!^https://!http://!i;
                $setting::payment{'paypal'}{'banner'} =~ s!https://!http://!i;
            }
            $this->{'paypal_only'} = 1
              if $field::for{'payment_method'}
              && @{ $field::obj{ $field::for{'payment_method'} }
                  ->{'payment_methods'} } <= 1;
            if ($main::paypal_cancel) {
                $main::a      = 'w';
                $main::cancel = 1;
                undef $main::token;
                my %checkout = ();
                $cgi::Session->read_by_uri( $session::id,
                    $env::home_dir_id . 'checkout', \%checkout );
                %main::data = %{ $checkout{'data'} } if ref $checkout{'data'};
                $main::clipboard_id = $checkout{'clipboard_id'}
                  if $checkout{'clipboard_id'};
                $main::set_cookie = 1 if $checkout{'set_cookie'};
                $cgi::Session->reset_by_uri( $session::id,
                    $env::home_dir_id . 'checkout' );
            }
            elsif (
                   $main::paypal
                || $main::token
                || (   $main::data{ $field::for{'payment_method'} }{'str'}
                    && $main::data{ $field::for{'payment_method'} }{'str'} eq
                    'paypal' )
              )
            {
                $this->{'use_paypal'} = 1;
                $main::data{ $field::for{'payment_method'} }{'str'} =
                  'paypal';
                require CMONOS::TableMaker::CheckOutAPI::PayPal;
                $this->{'paypal'} = PayPal->new(
                    $setting::payment{'paypal'}{'username'},
                    $setting::payment{'paypal'}{'password'},
                    $setting::payment{'paypal'}{'signature'},
                    'JPY',
                    $setting::payment{'paypal'}{'sandbox'},
                );
                if ($main::token) {
                    $main::a = 'w';
                    my %checkout = ();
                    $cgi::Session->read_by_uri( $session::id,
                        $env::home_dir_id . 'checkout', \%checkout );
                    $main::clipboard_id = $checkout{'clipboard_id'}
                      if $checkout{'clipboard_id'};
                    if (   $checkout{'token'}
                        && $checkout{'token'} eq $main::token )
                    {
                        if ( $checkout{'phase'} eq 'SetExpressCheckout' ) {
                            my $payer_info =
                              $this->{'paypal'}
                              ->get_express_checkout_details(
                                $checkout{'token'} );
                            if ( !ref $payer_info ) {
                                push(
                                    @{ $this->{'dialog'} },
'お客様情報の取得に失敗しました。',
                                    $this->{'paypal'}->errors('all')
                                );
                                undef $main::token;
                                $main::cancel = 1;
                            }
                            elsif (
                                !$checkout{'no_shipping'}
                                && (  !$payer_info->{'Address'}{'Country'}
                                    || $payer_info->{'Address'}{'Country'} ne
                                    'JP' )
                              )
                            {
                                push(
                                    @{ $this->{'dialog'} },
'日本国外への配送は、お問い合わせ下さい。'
                                );
                                undef $main::token;
                                $main::cancel = 1;
                            }
                            else {
                                push(
                                    @{ $this->{'dialog'} },
                                    'お客様情報を取得しました。',
                                    $this->{'paypal'}->errors('all')
                                ) if $setting::payment{'paypal'}{'sandbox'};
                                while ( my ( $id, $field ) = each %field::obj )
                                {
                                    if ( ref $field ) {
                                        if (   $field::for{'name'}
                                            && $field::for{'name'} == $id )
                                        {
                                            my $name = '';
                                            if (
                                                $payer_info->{'Address'}{'Name'}
                                              )
                                            {
                                                $name = $payer_info->{'Address'}
                                                  {'Name'};
                                            }
                                            elsif (
                                                ref $payer_info->{'PayerName'} )
                                            {
                                                $name .=
                                                  $payer_info->{'PayerName'}
                                                  {'LastName'}
                                                  if $payer_info->{'PayerName'}
                                                  {'LastName'};
                                                $name .= ' '
                                                  . $payer_info->{'PayerName'}
                                                  {'MiddleName'}
                                                  if $payer_info->{'PayerName'}
                                                  {'MiddleName'};
                                                $name .= ' '
                                                  . $payer_info->{'PayerName'}
                                                  {'FirstName'}
                                                  if $payer_info->{'PayerName'}
                                                  {'FirstName'};
                                            }
                                            $checkout{'data'}{$id} =
                                              { 'str' => $name }
                                              if $name;
                                        }
                                        elsif ($field::for{'mail'}
                                            && $field::for{'mail'} == $id )
                                        {
                                            $checkout{'data'}{$id} = { 'str' =>
                                                  $payer_info->{'Payer'} };
                                        }
                                        elsif ( $field->{'class'} eq 'addr_j' )
                                        {
                                            if (
                                                (
                                                    !$field::for{
                                                        'shippingaddress'}
                                                    && $field->{'required'}
                                                )
                                                || (
                                                    $field::for{
                                                        'shippingaddress'}
                                                    && $field::for{
                                                        'shippingaddress'} eq
                                                    $id )
                                              )
                                            {
                                                my $pref =
                                                  ( $payer_info->{'Address'}
                                                      {'StateOrProvince'} )
                                                  ? $payer_info->{'Address'}
                                                  {'StateOrProvince'}
                                                  : '';
                                                $pref =~
s/[\x09\x0A\x0C\x0D\x20]*-[\x09\x0A\x0C\x0D\x20]*[0-9a-zA-Z_]+[\x09\x0A\x0C\x0D\x20]*$//;
                                                $checkout{'data'}{$id} = {
                                                    'pref' =>
                                                      ( ($pref) ? $pref : '' ),
                                                    'city' => (
                                                        (
                                                            $payer_info->{
                                                                'Address'}
                                                              {'CityName'}
                                                        )
                                                        ? $payer_info->{
                                                            'Address'}
                                                          {'CityName'}
                                                        : ''
                                                    ),
                                                    'street' => (
                                                        (
                                                            $payer_info->{
                                                                'Address'}
                                                              {'Street1'}
                                                        )
                                                        ? $payer_info->{
                                                            'Address'}
                                                          {'Street1'}
                                                        : ''
                                                    ),
                                                    'building' => (
                                                        (
                                                            $payer_info->{
                                                                'Address'}
                                                              {'Street2'}
                                                        )
                                                        ? $payer_info->{
                                                            'Address'}
                                                          {'Street2'}
                                                        : ''
                                                    ),
                                                };
                                            }
                                        }
                                        elsif (
                                            $field->{'class'} eq 'addr_zipcode'
                                            && $payer_info->{'Address'}
                                            {'PostalCode'}
                                            && $payer_info->{'Address'}
                                            {'PostalCode'} =~
                                            /([0-9]{3})-?([0-9]{4})/ )
                                        {
                                            if (
                                                (
                                                    !$field::for{
                                                        'shippingzipcode'}
                                                    && $field->{'required'}
                                                )
                                                || (
                                                    $field::for{
                                                        'shippingzipcode'}
                                                    && $field::for{
                                                        'shippingzipcode'} eq
                                                    $id )
                                              )
                                            {
                                                $checkout{'data'}{$id} = {
                                                    '3' => $1,
                                                    '4' => $2,
                                                };
                                            }
                                        }
                                    }
                                }
                                $checkout{'phase'} =
                                  'GetExpressCheckoutDetails';
                                $checkout{'payer_id'} =
                                  $payer_info->{'PayerID'};
                                if ($main::clipboard_id) {
                                    $cgi::input->set_clipboard;
                                    $checkout{'clipboard_id'} =
                                      $cgi::input->{'clipboard_id'};
                                }
                                $cgi::Session->save_by_uri( $session::id,
                                    $env::home_dir_id . 'checkout',
                                    \%checkout );
                            }
                        }
                        elsif ($checkout{'payer_id'}
                            && $checkout{'payer_id'} eq $main::PayerID )
                        {
                            $main::a = 'w';
                        }
                        else {
                            push(
                                @{ $this->{'dialog'} },
                                'トークンが一致しません。'
                            );
                            undef $main::token;
                            $main::cancel = 1;
                        }
                    }
                    else {
                        push(
                            @{ $this->{'dialog'} },
                            'トークンが一致しません。'
                        );
                        undef $main::token;
                        $main::cancel = 1;
                    }
                    %main::data =
                      ( ref $checkout{'data'} )
                      ? %{ $checkout{'data'} }
                      : ();
                    $main::set_cookie = 1 if $checkout{'set_cookie'};
                }
                elsif ($main::ok) {
                    my %checkout = ();
                    $cgi::Session->read_by_uri( $session::id,
                        $env::home_dir_id . 'checkout', \%checkout );
                    if (   $checkout{'phase'}
                        && $checkout{'phase'} eq 'GetExpressCheckoutDetails'
                        && $checkout{'token'}
                        && $checkout{'payer_id'} )
                    {
                        %main::data = %{ $checkout{'data'} };
                        $main::set_cookie = 1 if $checkout{'set_cookie'};
                        $this->{'paypal'}->set_parameter(
                            {
                                'Token'         => $checkout{'token'},
                                'PaymentAction' => $checkout{'paymentaction'},
                                'PayerID'       => $checkout{'payer_id'},
                            }
                        );
                    }
                    else {
                        undef $main::ok;
                    }
                    $main::clipboard_id = $checkout{'clipboard_id'}
                      if $checkout{'clipboard_id'};
                }
            }
        }
        else {
            $setting::payment{'paypalenabled'} = 0;
        }
    }
    if ( $main::a eq 'w' ) {
        if ( $field::for{'mail'} ) {
            $field::obj{ $field::for{'mail'} }->{'required'} = 1;
            $field::obj{ $field::for{'mail'} }->{'single'}   = 1
              if $setting::general{'oneEmailToOneRecord'};
        }
        my @order_info     = $this->calculate;
        my $input_is_valid = $this->input_is_valid;

        #EMAILチェック
        if (   ( !$this->{'use_paypal'} || $main::token || $main::ok )
            && $setting::security{'revise'}{'passwordCheck'}
            && $setting::security{'revise'}{'passwordCheck'} eq 'member'
            && $this->is_registered_email
            && !$this->is_staff )
        {
            my (@user_address);
            if ( ref $field::for{'mail_address'}
                && @{ $field::for{'mail_address'} } )
            {
                foreach my $id ( @{ $field::for{'mail_address'} } ) {
                    push( @user_address, $main::data{$id}{'str'} )
                      if $main::data{$id}{'str'};
                }
                @user_address = $this->get_address(@user_address);
            }
            if (   !@user_address
                || !grep( $_ eq $main::email, @user_address ) )
            {
                push(
                    @{ $this->{'dialog'} },
                    '登録メールアドレスがみつかりません。'
                );
                if ( $field::for{'mail'}
                    && ref $field::obj{ $field::for{'mail'} } )
                {
                    $main::data{ $field::for{'mail'} }{'str'} = $main::email;
                    $field::obj{ $field::for{'mail'} }
                      ->{'is_invalid_field'}{'str'} = 1;
                }
                $input_is_valid = 0;
            }
        }

        #名前チェック
        if (   $field::NAMECHECK
            && $field::for{'name'}
            && defined $main::data{ $field::for{'name'} }{'str'}
            && $main::data{ $field::for{'name'} }{'str'} ne '' )
        {
            if ($input_is_valid) {
                my ( $name, $fontcolor );
                $name = $main::data{ $field::for{'name'} }{'str'};
                $fontcolor = $1 if $name =~ s/<>([#0-9a-zA-z]{3,10})\Z//s;
                if ( defined $name && $name ne '' ) {
                    if (
                        $cgi::Register->is_available_name(
                            $main::pswd, $main::email,
                            $name,       $security::registered
                        )
                      )
                    {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->success_dialog
                        );
                    }
                    else {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->error_dialog
                        );
                        $main::data{ $field::for{'name'} }{'str'} = $name
                          . (
                            ( defined $fontcolor && $fontcolor ne '' )
                            ? '<>' . $fontcolor
                            : ''
                          );
                        push(
                            @{ $this->{'dialog'} },
                            'この入力は確定していません。'
                        );
                        $input_is_valid = 0;
                    }
                }
            }
        }

        if ( $input_is_valid && @order_info && !$main::cancel ) {

            #PayPalへリダイレクト
            if (   $this->{'use_paypal'}
                && !$main::token
                && !$main::ok
                && $this->{'estimated_sum'} )
            {
                my $action =
                  (
                    $this->{'noshipping_only'}
                      && ( $this->{'noshipping_only'} eq '2'
                        || $setting::payment{'paypal'}{'noshippingsale'} )
                  ) ? 'Sale'
                  : ( $setting::payment{'paypal'}{'paymentaction'} )
                  ? $setting::payment{'paypal'}{'paymentaction'}
                  : 'Order';
                if (
                    $this->{'paypal'}->set_express_checkout(
                        {
                            'OrderTotal'       => $this->{'estimated_sum'},
                            'OrderDescription' => '最終的な明細を'
                              . (
                                (
                                         $env::title
                                      && $this->str_length($env::title) < 70
                                ) ? '「' . $env::title . '」'
                                : '元のサイト'
                              )
                              . 'でご確認いただいた後、注文を確定します。',
                            'ReturnURL' => $this->my_full_path
                              . '?m=CheckOut'
                              . (
                                (
                                         $setting::general{'skipConfirmation'}
                                      && $main::ok
                                ) ? '&ok=1' : ''
                              ),
                            'CancelURL' => $this->my_full_path
                              . '?m=CheckOut&paypal_cancel=1',
                            'PaymentAction' => $action,
                            'LocaleCode'    => 'JP',
                            'SolutionType'  => 'Sole',
                            'LandingPage'   => 'Billing',
                            'AllowNote'     => '0',
                            'BrandName'     => $env::title,
                            (
                                ( $setting::payment{'paypal'}{'pagestyle'} )
                                ? ( 'PageStyle' =>
                                      $setting::payment{'paypal'}{'pagestyle'} )
                                : ()
                            ),
                            'NoShipping' =>
                              ( ( $this->{'no_shipping'} ) ? 1 : 0 ),
                        }
                    )
                  )
                {
                    my %checkout = (
                        'data'          => \%main::data,
                        'token'         => $this->{'paypal'}->get('Token'),
                        'payer_id'      => $this->{'paypal'}->get('PayerID'),
                        'paymentaction' => $action,
                        'phase'         => 'SetExpressCheckout',
                        (
                            ( $this->{'no_shipping'} ) ? ( 'no_shipping' => 1 )
                            : ()
                        ),
                        ( ($main::set_cookie) ? ( 'set_cookie' => 1 ) : () ),
                        (
                            ( $cgi::input->{'clipboard_id'} )
                            ? ( 'clipboard_id' =>
                                  $cgi::input->{'clipboard_id'} )
                            : ()
                        ),
                    );
                    $cgi::Session->save_by_uri( $session::id,
                        $env::home_dir_id . 'checkout', \%checkout );
                    $this->{'paypal'}->redirect;
                }
                else {
                    push(
                        @{ $this->{'dialog'} },
'チェックアウト情報の送信に失敗しました。',
                        $this->{'paypal'}->errors('all')
                    );
                }
            }
            else {

                #新規登録
                if ($main::ok) {
                    $main::n = $this->new_record_number(1);
                    if ( $this->order_info_is_saved(@order_info) ) {
                        $this->{'new_data'} = 1;
                        $this->dbm;
                        $cgi::CartController->cancel_all;
                        $setting::general{'mail'} = 'master'
                          if !$setting::general{'mail'}
                          && $setting::general{'mailonly'};
                        $this->notice_mail_for_master(
                            '新しい注文が入力されました。',
                            '新しい注文が入力されました。',
                            \%field::obj,
                            (
                                ( $setting::general{'data'} )
                                ? \%main::data
                                : ''
                            )
                        );

                        #メールアドレス自動登録
                        if (
                               $setting::general{'autoRegister'}
                            && $field::for{'mail'}
                            && $main::data{ $field::for{'mail'} }{'str'}
                            && $this->use_register
                            && !$cgi::Register->exist(
                                $main::data{ $field::for{'mail'} }{'str'}
                            )
                          )
                        {
                            if (
                                !$cgi::Register->register(
                                    $main::data{ $field::for{'mail'} }{'str'}
                                )
                              )
                            {
                                push(
                                    @{ $this->{'dialog'} },
                                    $cgi::Register->error_dialog
                                );
                            }
                        }

                        if ( defined $setting::page{'checkout'}{'thanksTitle'}
                            && $setting::page{'checkout'}{'thanksTitle'} ne '' )
                        {
                            $this->push_window_title(
                                $setting::page{'checkout'}{'thanksTitle'} );
                            $setting::page{$setting::key}{'titleText'} =~
s/((<[^>]+>)*)[^<]+/$1$setting::page{'checkout'}{'thanksTitle'}/s
                              if
                              defined $setting::page{$setting::key}{'titleText'}
                              && $setting::page{$setting::key}{'titleText'} ne
                              '';
                            $this->thanks( 1, 1 );
                        }
                        else {
                            $this->thanks(1);
                        }
                    }
                    else {
                        $main::n = '';
                    }
                }

                #注文の確認
                $this->push_window_title(
                    $setting::page{'checkout'}{'confirmationTitle'} )
                  if $setting::page{'checkout'}{'confirmationTitle'};
                $this->print_page_header('checkout');
                my $sheet = $this->estimate_sheet(
                    ( $setting::page{'checkout'}{'confirmationDescription'} )
                    ? ( $setting::page{'checkout'}{'confirmationDescription'}
                          =~ /<[a-zA-Z][^>]*>/s )
                          ? $setting::page{'checkout'}
                          {'confirmationDescription'}
                          : '<p id="confirmation-description">'
                          . $setting::page{'checkout'}
                          {'confirmationDescription'} . '</p>'
                    : ''
                );
                if ($sheet) {
                    print $sheet;
                    $this->print_confirmation_table;
                }
                else {
                    print '<p id="sc-empty-notice">'
                      . ( $setting::page{'emptyCartMsg'}
                          || 'カートに何も入っていません。' )
                      . '</p>';
                }
                $this->print_contents_footer;
                $this->print_page_footer('checkout');
                exit;
            }
        }
        $this->dialog if $main::paypal_cancel;
        undef $main::ok;

    }
    else {
        $this->new_record_number;
    }
    $this->push_window_title( $setting::page{'checkout'}{'checkoutTitle'} )
      if $setting::page{'checkout'}{'checkoutTitle'};
    if (   $field::for{'payment_method'}
        && $setting::payment{'paypalenabled'}
        && !$this->{'paypal_only'} )
    {
        my $nonpaypal_target = "'sc-order-button'";
        my $paypal_target    = "'sc-paypal-button','sc-paypal-solution'";
        while ( my ( $id, $field ) = each %field::obj ) {
            if (   ( $field::for{'name'} && $field::for{'name'} == $id )
                || ( $field::for{'mail'} && $field::for{'mail'} == $id )
                || $this->field_require_shipping($id) )
            {
                $nonpaypal_target .= ",'field-$id'";
            }
        }
        my $javascript = <<JAVA;
cmonos.form.togglePaymentMethod = function (is_paypal) {
	if (!document.getElementById('sc-order-or')) return;
	cmonos.element.item(document.getElementById('sc-order-or')).disappear();
	var nonpaypal_target = new Array($nonpaypal_target);
	var paypal_target = new Array($paypal_target);
	for (var i=0; i<nonpaypal_target.length; i++) {
		var e = document.getElementById(nonpaypal_target[i]);
		if (e) {
			var controller = cmonos.element.getProperty(e,'controller') || [];
			if (is_paypal) {
				if (!cmonos.value.isIncluded(controller,'togglePaymentMethod')) controller.push('togglePaymentMethod');
				cmonos.element.setProperty(e,'controller',controller);
				if (controller.length == 1) {
					cmonos.element.item(e).disappear();
					cmonos.element.item(e).disableAttribute('required');
				}
			} else {
				controller = cmonos.value.deleteFromArray(controller,'togglePaymentMethod');
				if (controller.length == 0) {
					cmonos.element.setProperty(e,'controller',null);
					cmonos.element.item(e).appear();
					cmonos.element.item(e).restoreAttribute('required');
				} else {
					cmonos.element.setProperty(e,'controller',controller);
				}
			}
		}
	}
	for (var i=0; i<paypal_target.length; i++) {
		var e = document.getElementById(paypal_target[i]);
		if (e) {
			var controller = cmonos.element.getProperty(e,'controller') || [];
			if (!is_paypal) {
				if (!cmonos.value.isIncluded(controller,'togglePaymentMethod')) controller.push('togglePaymentMethod');
				cmonos.element.setProperty(e,'controller',controller);
				if (controller.length == 1) {
					cmonos.element.item(e).disappear();
					cmonos.element.item(e).disableAttribute('required');
				}
			} else {
				controller = cmonos.value.deleteFromArray(controller,'togglePaymentMethod');
				if (controller.length == 0) {
					cmonos.element.setProperty(e,'controller',null);
					cmonos.element.item(e).appear();
					cmonos.element.item(e).restoreAttribute('required');
				} else {
					cmonos.element.setProperty(e,'controller',controller);
				}
			}
		}
	}
}
cmonos.form.togglePaymentMethodByMenu = function () {
	this.togglePaymentMethod((cmonos.form.field('data:$field::for{'payment_method'}:str').getValue() == 'paypal') ? true : false);
}
cmonos.form.togglePaymentMethodByButton = function (this_form) {
	var options = cmonos.form.item(this_form).getFieldsByName('data:$field::for{'payment_method'}:str');
	var is_paypal = false;
	for (var i=0; i<options.length; i++) {
		if (options[i].value == 'paypal' && options[i].checked) is_paypal = true;
	}
	this.togglePaymentMethod(is_paypal);
}
JAVA
        $this->set_javascript($javascript);
    }
}

sub input_form_id ($) {
    my $this = shift;
    return 'tm-checkout-form';
}

sub my_full_path ($) {
    my $this = shift;
    my $url  = $this->full_path($cgi::path);
    if ( $ENV{'HTTP_USER_AGENT'} && $ENV{'HTTP_USER_AGENT'} =~ /MCONV/ ) {
        my $base = $this->full_path( '../../', 1 );
        $url =~ s!^$base!$base/m.cgi!;
    }
    return $url;
}

sub my_default_url ($) {
    my $this = shift;
    return
        $this->my_url
      . '?m=TableViewer'
      . ( ( defined $main::c && $main::c ) ? '&c=' . $main::c : '' );
}

#入力チェック
sub input_is_valid ($) {
    my $this = shift;
    my $is_valid = $this->{'no_shipping'} = 1;
    foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$o};
        if (
            ref $field::obj{$id}
            && (
                !$field::obj{$id}->{'protected'}
                || (   defined $main::n
                    && $main::n ne ''
                    && $this->is_secure( 'reviseProtectedFields', 0, 'revise' )
                )
                || ( ( !defined $main::n || $main::n eq '' )
                    && $this->is_secure( 'inputProtectedFields', 0, 'input' ) )
            )
            && (   !$this->{'noshipping_only'}
                || !$this->is_skippable_field( $field::obj{$id} ) )
          )
        {
            delete $this->{'no_shipping'}
              if $this->{'no_shipping'}
              && $this->field_require_shipping($id);
            if (
                (
                       $this->{'use_paypal'}
                    && !$main::token
                    && !$main::ok
                    && (
                        ( $field::for{'name'} && $field::for{'name'} == $id )
                        || (   $field::for{'mail'}
                            && $field::for{'mail'} == $id )
                        || $field::obj{$id}->{'class'} =~ /^addr_/
                    )
                )
              )
            {
                local $field::obj{$id}->{'required'} = 0;
                $is_valid = 0
                  if !$field::obj{$id}->is_valid_data(
                    ( $main::n ne '' )
                    ? "$default::file/$main::c/$main::n"
                    : ''
                  );
            }
            else {
                $is_valid = 0
                  if !$field::obj{$id}->is_valid_data(
                    ( $main::n ne '' )
                    ? "$default::file/$main::c/$main::n"
                    : ''
                  );
            }
        }
    }
    return $is_valid;
}

sub field_require_shipping ($$) {
    my ( $this, $id ) = @_;
    return (
        (
            $field::obj{$id}->{'class'} eq 'addr_zipcode'
              && (
                (
                      !$field::for{'shippingzipcode'}
                    && $field::obj{$id}->{'required'}
                )
                || (   $field::for{'shippingzipcode'}
                    && $field::for{'shippingzipcode'} eq $id )
              )
        )
          || (
            $field::obj{$id}->{'class'} eq 'addr_j'
            && (
                (
                      !$field::for{'shippingaddress'}
                    && $field::obj{$id}->{'required'}
                )
                || (   $field::for{'shippingaddress'}
                    && $field::for{'shippingaddress'} eq $id )
            )
          )
    ) ? 1 : 0;
}

sub has_no_shipping ($) {
    my $this        = shift;
    my $no_shipping = 1;
    while ( my ( $id, $field ) = each %field::obj ) {
        if (
            ref $field
            && (
                !$field->{'protected'}
                || (   defined $main::n
                    && $main::n ne ''
                    && $this->is_secure( 'reviseProtectedFields', 0, 'revise' )
                )
                || ( ( !defined $main::n || $main::n eq '' )
                    && $this->is_secure( 'inputProtectedFields', 0, 'input' ) )
            )
            && !$this->is_skippable_field($field)
            && $this->field_require_shipping($id)
          )
        {
            $no_shipping = 0;
        }
    }
    return $no_shipping;
}

sub top_field ($$) {
    my $this = shift;
    if ( $setting::payment{'paypal'}{'top'} && $field::for{'payment_method'} ) {
        return $field::for{'payment_method'};
    }
    else {
        return;
    }
}

sub is_skip_field ($$) {
    my ( $this, $field ) = @_;
    if (
        (
            $this->{'noshipping_only'} || ( defined $this->{'estimated_sum'}
                && !$this->{'estimated_sum'} )
        )
        && $this->is_skippable_field($field)
      )
    {
        return 1;
    }
    elsif (
           $this->{'paypal_only'}
        && ( !defined $this->{'estimated_sum'} || $this->{'estimated_sum'} )
        && !$main::token
        && !$main::ok
        && (
            ( $field::for{'name'} && $field::for{'name'} == $field->{'id'} )
            || (   $field::for{'mail'}
                && $field::for{'mail'} == $field->{'id'} )
            || $field->{'class'} =~ /^addr_/
        )
      )
    {
        return 1;
    }
    else {
        return 0;
    }
}

sub allocate_category ($) {
    my $this = shift;
    $main::c = 0;
    $main::c++ while defined $setting::category{ ( $main::c + 1 ) };
}

sub print_contents_header ($) {
    my $this  = shift;
    my $sheet = $this->estimate_sheet(
        (
            ( $setting::page{'checkout'}{'checkoutDescription'} )
            ? ( $setting::page{'checkout'}{'checkoutDescription'} =~
                  /<[a-zA-Z][^>]*>/s )
                  ? $setting::page{'checkout'}{'checkoutDescription'}
                  : '<p id="checkout-description">'
                  . $setting::page{'checkout'}{'checkoutDescription'}
                  . '</p>'
            : ''
        ),
          $setting::page{'checkout'}{'estimatedCarriageForbidden'},
          $setting::page{'checkout'}{'estimatedFeeForbidden'}
    );
    $this->print_page_header('checkout');
    if ($sheet) {
        print $sheet;
        if ( $this->{'amount_is_out_of_bounds'} ) {
            print '<div id="sc-error-message">';
            print $this->out_of_bounds_message(1);
            print $cgi::Deco->button(
                'return',
                $setting::page{$setting::key}{'backButton'},
                $cgi::path . '?m=CartViewer&iframe_disabled=1',
                ( $setting::page{$setting::key}{'backButtonName'} || '戻る' )
            );
            print '</div>';
            $this->print_contents_footer;
            $this->print_page_footer($setting::key);
            exit;
        }
    }
    else {
        print '<p id="sc-empty-notice">'
          . ( $setting::page{'emptyCartMsg'}
              || 'カートに何も入っていません。' )
          . '</p>';
        $this->print_contents_footer;
        $this->print_page_footer($setting::key);
        exit;
    }
}

sub print_submit_button ($) {
    my $this = shift;
    $this->print_checkout_button;
}

sub print_confirmation_button ($) {
    my $this = shift;
    print '<input type="hidden" name="m" value="CheckOut" />';
    print '<input type="hidden" name="set_cookie" value="1" />'
      if $main::set_cookie;
    print '<div id="sc-update-box">';
    print '<div id="sc-return-to-checkout">';
    print $cgi::Deco->submit_button(
        'return',
        $setting::page{$setting::key}{'backButton'},
        ( $setting::page{$setting::key}{'backButtonName'} || '戻る' ),
        '',
        { 'cancel' => 1 }
    );
    print '</div>';
    print '<div id="sc-proceed-to-order">';
    print $this->{'icon'}->submit_button(
        'order',
        $setting::page{$setting::key}{'orderButton'},
        (
            ( $setting::page{$setting::key}{'orderButtonName'} )
            ? $setting::page{$setting::key}{'orderButtonName'}
            : '注文を確定する'
        ),
        '',
        { 'a' => 'w', 'ok' => 1 }
    );
    print '</div>';
    print '</div>';
}

sub print_thanks ($$) {
    my ( $this, $msg ) = @_;
    print $this->page_item_replace(
        (
            (
                $setting::page{'checkout'}{'thanksDescription'} =~
                  /<[a-zA-Z][^>]*>/s
            )
            ? $setting::page{'checkout'}{'thanksDescription'}
            : '<p id="thanks-description">'
              . $setting::page{'checkout'}{'thanksDescription'} . '</p>'
        ),
        0, '',
        $setting::page{$setting::key}{'title'}
    ) if $setting::page{'checkout'}{'thanksDescription'};
    $this->print_thanks_content( $msg, 1 );
}

sub print_checkout_button ($) {
    my $this = shift;
    print '<div id="sc-update-box">';
    print '<div id="sc-proceed-to-order">';
    if ( $this->{'cookie_enabled'} ) {
        print
'<label title="同じ内容を入力することが多いいくつかの項目を記憶します。"><input type="checkbox" name="set_cookie" value="1"'
          . (
            ( $cookie::read{$cookie::name} || $main::set_cookie )
            ? ' checked="checked"'
            : ''
          ) . ' />情報を記憶する</label> ';
    }
    elsif ($main::set_cookie) {
        print '<input type="hidden" name="set_cookie" value="1" />';
    }
    if (   !$setting::general{'skipConfirmation'}
        && !$cgi::confirmation_disabled
        && !$cgi::ssl_required
        && !$main::ok )
    {
        if ( !$this->{'paypal_only'} || !$this->{'estimated_sum'} ) {
            print '<span id="sc-order-button">'
              if $setting::payment{'paypalenabled'};
            print $this->{'icon'}->submit_button(
                'confirmation',
                $setting::page{$setting::key}{'confirmationButton'},
                (
                    ( $setting::page{$setting::key}{'confirmationButtonName'} )
                    ? $setting::page{$setting::key}{'confirmationButtonName'}
                    : '注文を確認'
                ),
                '',
                { 'm' => 'CheckOut' }
            );
        }
        if ( $setting::payment{'paypalenabled'} && $this->{'estimated_sum'} ) {
            print
'</span><span id="sc-order-or"> または </span><span id="sc-paypal-button">'
              if !$this->{'paypal_only'};
            print '<input type="image" src="'
              . $setting::payment{'paypal'}{'button'}
              . '" name="m=CheckOut&amp;paypal=1" value="PayPalでのお支払いを承認する" />';
            print '</span>' if !$this->{'paypal_only'};
            print '<div id="sc-paypal-solution">';
            print $setting::payment{'paypal'}{'banner'};
            print '</div>';
        }
        if ( $setting::page{$setting::key}{'estimateButtonEnabled'} ) {
            print '<div id="sc-print-estimate-sheet">';
            print $this->{'icon'}->submit_button(
                'estimate',
                $setting::page{$setting::key}{'estimateButton'},
                (
                    ( $setting::page{$setting::key}{'estimateButtonName'} )
                    ? $setting::page{$setting::key}{'estimateButtonName'}
                    : '見積もりを印刷する'
                ),
                '',
                { 'm' => 'EstimateSheet' }
            );
            print '</div>';
        }
    }
    elsif ( $this->{'use_paypal'} && $this->{'estimated_sum'} ) {
        print '<input type="image" src="'
          . $setting::payment{'paypal'}{'button'}
          . '" name="m=CheckOut&amp;paypal=1&amp;ok=1" value="PayPalでのお支払いを確定する" />';
    }
    else {
        print $this->{'icon'}->submit_button(
            'order',
            $setting::page{$setting::key}{'orderButton'},
            (
                ( $setting::page{$setting::key}{'orderButtonName'} )
                ? $setting::page{$setting::key}{'orderButtonName'}
                : '注文を確定する'
            ),
            '',
            { 'm' => 'CheckOut', 'ok' => 1 }
        );
    }
    print '</div>';
    print '<div id="sc-return-to-cart">';
    print $cgi::Deco->submit_button(
        'return',
        $setting::page{$setting::key}{'backButton'},
        ( $setting::page{$setting::key}{'backButtonName'} || '戻る' ),
        ' formnovalidate="formnovalidate"',
        { 'm' => 'CartViewer', 'iframe_disabled' => 1 }
    );
    print '</div>';
    print '</div>';
}

sub amount_check ($;$$$) {
    my ( $this, $item_data, $item_order ) = @_;
    return 0
      if ( !ref $setting::payment{'discount'}
        || !%{ $setting::payment{'discount'} } )
      && ( !defined $setting::payment{'minimumamount'}
        || $setting::payment{'minimumamount'} eq '' )
      && ( !defined $setting::payment{'maximumamount'}
        || $setting::payment{'maximumamount'} eq '' );
    my $total            = 0;
    my $limited_total    = 0;
    my $discount         = 0;
    my $is_out_of_bounds = 0;
    foreach my $item_id (@$item_order) {
        my $price = (
            ( $item_data->{$item_id}{'optionprice'} )
            ? ( $item_data->{$item_id}{'price'} +
                  $item_data->{$item_id}{'optionprice'} )
            : $item_data->{$item_id}{'price'}
          ) *
          $item_data->{$item_id}{'quantity'};
        $total += $price
          if !$setting::payment{'discountlimited'}
          || $item_data->{$item_id}{'discountable'};
        $limited_total += $price
          if !$setting::payment{'limitlimited'}
          || $item_data->{$item_id}{'limited'};
    }
    if ( ref $setting::payment{'discount'}
        && %{ $setting::payment{'discount'} } )
    {
        foreach my $n (
            sort { $b <=> $a || $b cmp $a }
            keys %{ $setting::payment{'discount'} }
          )
        {
            if ( $n <= $total && $setting::payment{'discount'}{$n} ) {
                $discount =
                  (      $setting::payment{'discount'}{$n} > 0
                      && $setting::payment{'discount'}{$n} < 100 )
                  ? $setting::payment{'discount'}{$n}
                  : 0;
                last;
            }
        }
    }
    if (
        ( $limited_total || !$setting::payment{'pricerequired'} )
        && (
            (
                   defined $setting::payment{'minimumamount'}
                && $setting::payment{'minimumamount'} ne ''
                && $setting::payment{'minimumamount'} > $limited_total
            )
            || (   defined $setting::payment{'maximumamount'}
                && $setting::payment{'maximumamount'} ne ''
                && $setting::payment{'maximumamount'} < $limited_total )
        )
      )
    {
        $is_out_of_bounds = 1;
    }
    return ( $discount, $is_out_of_bounds );
}

sub estimate_sheet ($;$$$) {
    my ( $this, $description, $carriage_forbidden, $fee_forbidden ) = @_;
    my (
        %item_data,    @item_order,        $total,   $count,
        $fee_included, $carriage_included, $dc_only, $noshipping_only,
        $estimated,    $payment_method,    $sheet
    );
    $this->{'estimated_sum'}         = $this->{'weight_lacked'} =
      $this->{'papersize_lacked'}    = $this->{'noshipping_only'} =
      $this->{'noshipping_included'} = 0;
    $total = $carriage_included = 0;
    $fee_included =
      (      !$field::for{'shipping_info'}
          || !$setting::payment{'carriage'}
          || $setting::payment{'carriage'} eq 'disabled' ) ? 1 : 0;
    $dc_only = $noshipping_only = 1;
    require CMONOS::CGI_Lib::CartController;
    $cgi::CartController = CartController->new;

    if (%main::cancel_all) {
        $cgi::CartController->cancel_all;
    }
    elsif (%main::cart) {
        $cgi::CartController->add( \%main::cart, \%item_data, \@item_order, 1 );
    }
    elsif (%main::quantity) {
        $cgi::CartController->change( \%main::quantity, \%item_data,
            \@item_order, 1 );
    }
    else {
        $cgi::CartController->check( '', \%item_data, \@item_order, 1 );
    }
    return '' if !@item_order;
    my ( $discount, $is_out_of_bounds ) =
      $this->amount_check( \%item_data, \@item_order );
    $this->{'amount_is_out_of_bounds'} = 1 if $is_out_of_bounds;
    my $discount_ratio = 1 - ( $discount / 100 );
    $sheet .=
      $this->page_item_replace( $description, 0, '',
        $setting::page{$setting::key}{'title'} )
      if $description;
    $sheet .= '<table id="sc-table">';
    $sheet .= '<thead>';
    $sheet .= '<tr class="odd">';
    $sheet .=
      '<th class="sc-item-name">' . $setting::general{'itemname'} . '</th>';
    $sheet .= '<th class="sc-item-option">オプション</th>';
    $sheet .= '<th class="sc-item-unit-price">単価</th>';
    $sheet .= '<th class="sc-item-quantity">数量</th>';
    $sheet .= '<th class="sc-item-price">価格</th>';
    $sheet .= '</tr>';
    $sheet .= '</thead>';
    $sheet .= '<tbody id="sc-item-tbody">';

    foreach my $item_id (@item_order) {
        $count++;
        my $price = (
            ( $item_data{$item_id}{'optionprice'} )
            ? ( $item_data{$item_id}{'price'} +
                  $item_data{$item_id}{'optionprice'} )
            : $item_data{$item_id}{'price'}
        );
        $this->{'referer_url'} =
          ( $item_data{$item_id}{'referer'} || $item_data{$item_id}{'path'} )
          . (
            ( $item_data{$item_id}{'anchor'} )
            ? $item_data{$item_id}{'anchor'}
            : ''
          );
        $sheet .=
            '<tr class="'
          . ( ( $count % 2 ) ? 'odd' : 'even' )
          . '" id="sc-item-'
          . $item_id . '">';
        $sheet .=
            '<td class="sc-item-name"><a href="'
          . $this->escape( $this->{'referer_url'} )
          . '" target="_blank">'
          . $item_data{$item_id}{'name'}
          . (
            (
                     $item_data{$item_id}{'key'}
                  && $item_data{$item_id}{'key'} ne $item_data{$item_id}{'name'}
            )
            ? '<span class="sc-item-key"> ['
              . $this->escape( $item_data{$item_id}{'key'} )
              . ']</span>'
            : ''
          )
          . '</a>'
          . (
            ( $item_data{$item_id}{'digitalcontent'} )
            ? '<span class="sc-item-filename"> ('
              . $this->escape( $item_data{$item_id}{'digitalcontent'} )
              . ')</span>'
            : ''
          ) . '</td>';
        $sheet .= '<td class="sc-item-option">'
          . $this->escape( $item_data{$item_id}{'option'} ) . '</td>';
        if (
            $discount
            && (  !$setting::payment{'discountlimited'}
                || $item_data{$item_id}{'discountable'} )
          )
        {
            my $proper_price = $price;
            $price = int( $price * $discount_ratio );
            $sheet .=
                '<td class="sc-item-unit-price"><del>&yen;'
              . $this->digit($proper_price)
              . '</del><ins>(-'
              . $this->round_down( $discount,
                $setting::payment{'discountrounddown'}, 'floor' )
              . '%)</ins> &yen;'
              . $this->digit($price) . '</td>';
        }
        else {
            $sheet .= '<td class="sc-item-unit-price">&yen;'
              . $this->digit($price) . '</td>';
        }
        $sheet .= '<td class="sc-item-quantity">'
          . (
            ( defined $item_data{$item_id}{'quantity'} )
            ? $this->digit( $item_data{$item_id}{'quantity'} )
            : '0'
          ) . '</td>';
        $price = (
            ( $price && $item_data{$item_id}{'quantity'} )
            ? $price * $item_data{$item_id}{'quantity'}
            : 0
        );
        $sheet .=
            '<td class="sc-item-price" id="sc-item-'
          . $item_id
          . '-price">&yen;'
          . $this->digit($price) . '</td>';
        $sheet .= '</tr>';
        $total += $price;
        if ( $item_data{$item_id}{'digitalcontent'} ) {
            $this->{'noshipping_included'} = 1;
        }
        else {
            $dc_only = 0;
        }
        if (   $item_data{$item_id}{'digitalcontent'}
            || $item_data{$item_id}{'noshipping'} )
        {
            $this->{'noshipping_included'} = 1;
        }
        else {
            $noshipping_only = 0;
        }
        $this->{'weight_lacked'} = 1
          if ( !defined $item_data{$item_id}{'weight'}
            || $item_data{$item_id}{'weight'} eq '' )
          && !$item_data{$item_id}{'digitalcontent'}
          && !$item_data{$item_id}{'noshipping'};
        $this->{'papersize_lacked'} = 1
          if (!$item_data{$item_id}{'papersize'}
            || $item_data{$item_id}{'papersize'} !~
            /^(?:A[4-6]|B[5-6]|ACCESSORY)$/
            || !$item_data{$item_id}{'thickness'}
            || $item_data{$item_id}{'thickness'} >
            ( 20 - ( $setting::payment{'packagethickness'} || 0 ) ) )
          && !$item_data{$item_id}{'digitalcontent'};
    }
    $sheet .= '</tbody>';
    $sheet .= '<tbody id="sc-total-tbody">';
    my $sc_sub_total = '<tr id="sc-sub-total" class="sc-total-start">';
    $sc_sub_total .= '<td class="sc-name" colspan="4">小計</td>';
    $sc_sub_total .= '<td class="sc-value" id="sc-sub-total-value">&yen;'
      . $this->digit($total) . '</td>';
    $sc_sub_total .= '</tr>';
    my $sc_total = '';
    $estimated = 0;

    if ($noshipping_only) {
        $this->{'noshipping_only'} = 1;
        $noshipping_only = $this->{'noshipping_only'} = 2 if $dc_only;
        $carriage_included = 1;
    }
    elsif (
        !$field::for{'payment_method'}
        || (   $setting::payment{'carriage'}
            && $setting::payment{'carriage'} eq 'disabled' )
      )
    {
        $carriage_included = 1;
    }
    elsif ( !$carriage_forbidden ) {
        my $carriage   = 0;
        my $is_pending = 0;
        if (
            (
                   $setting::payment{'specialcarriage'}{'requirements'}
                && $total >=
                $setting::payment{'specialcarriage'}{'requirements'}
            )
            || $setting::payment{'carriage'} eq 'nation'
            || (
                (
                       $setting::payment{'carriage'} eq 'region'
                    || $setting::payment{'carriage'} eq 'prefecture'
                )
                && $field::for{'shippingaddress'}
                && ref $main::data{ $field::for{'shippingaddress'} }
                && (   $main::data{ $field::for{'shippingaddress'} }{'str'}
                    || $main::data{ $field::for{'shippingaddress'} }{'pref'} )
            )
            || (
                (
                    $setting::payment{'carriage'} eq 'weight'
                    || (   $setting::payment{'yuumail'}
                        && $field::for{'shipping_info'}
                        && ref $main::data{ $field::for{'shipping_info'} }
                        && $main::data{ $field::for{'shipping_info'} }
                        {'service'}
                        && $main::data{ $field::for{'shipping_info'} }
                        {'service'} =~ /ゆうメール/ )
                )
                && !$this->{'weight_lacked'}
            )
            || (
                (
                    $setting::payment{'carriage'} eq 'papersize'
                    || (   $setting::payment{'mailbin'}
                        && $field::for{'shipping_info'}
                        && ref $main::data{ $field::for{'shipping_info'} }
                        && $main::data{ $field::for{'shipping_info'} }
                        {'service'}
                        && $main::data{ $field::for{'shipping_info'} }
                        {'service'} =~ /メール便/ )
                )
                && !$this->{'papersize_lacked'}
            )
          )
        {
            $carriage = $this->order_carriage(
                (
                    (
                             $field::for{'shipping_info'}
                          && ref $main::data{ $field::for{'shipping_info'} }
                          && $main::data{ $field::for{'shipping_info'} }
                          {'service'}
                    )
                    ? $main::data{ $field::for{'shipping_info'} }{'service'}
                    : ''
                ),
                $this->add_tax($total),
                \%item_data
            );
        }
        elsif ( $setting::payment{'estimatedCarriageRequired'} ) {
            $carriage  = $this->get_estimated_carriage;
            $estimated = 1;
        }
        else {
            $is_pending = 1;
            $estimated  = 1;
        }
        $sc_total .= '<tr id="sc-carriage">';
        $sc_total .=
            '<td class="sc-name" colspan="4"><a href="'
          . $default::file
          . '/payment_info.'
          . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' )
          . '#carriage-info-header" target="_blank">配送料'
          . ( ( $estimated && !$is_pending ) ? '(未確定)' : '' )
          . '</a></td>';
        $sc_total .=
            '<td class="sc-value" id="sc-carriage-value">'
          . ( ($is_pending) ? '未確定' : '&yen;' . $this->digit($carriage) )
          . '</td>';
        $sc_total .= '</tr>';
        if ( !$is_pending ) {
            $total += $carriage;
            $carriage_included = 1;
        }
    }
    if ( !$total ) {
        $fee_included = 1 if $carriage_included;
    }
    elsif ( $field::for{'payment_method'}
        && ref $field::obj{ $field::for{'payment_method'} } )
    {
        if ( $main::data{ $field::for{'payment_method'} }{'str'} ) {
            $payment_method =
              $main::data{ $field::for{'payment_method'} }{'str'};
        }
        elsif (
            ref $field::obj{ $field::for{'payment_method'} }->{'payment_method'}
            && @{
                $field::obj{ $field::for{'payment_method'} }->{'payment_method'}
            } == 1
          )
        {
            $payment_method = $field::obj{ $field::for{'payment_method'} }
              ->{'payment_method'}[0]->{'id'};
        }
        if ( !$fee_forbidden ) {
            if ($payment_method) {
                my $fee = $this->order_fee( $payment_method, $total );
                $fee_included = 1;
                if ($fee) {
                    $sc_total .= '<tr id="sc-fee">';
                    $sc_total .=
                        '<td class="sc-name" colspan="4"><a href="'
                      . $default::file
                      . '/payment_info.'
                      . (
                        ( $env::ssi && $env::ssi_ext )
                        ? $env::ssi_ext
                        : 'html'
                      )
                      . '#payment-info-header" target="_blank">手数料'
                      . ( ($estimated) ? '(未確定)' : '' )
                      . '</a></td>';
                    $sc_total .= '<td class="sc-value" id="sc-fee-value">';
                    if ( $fee && $fee =~ /[^0-9]/ ) {
                        $this->{'cod_disabled'} = 1;
                        $fee_included = 0;
                        $sc_total .= '<strong>ERROR</strong>';
                    }
                    else {
                        $sc_total .= $this->{'cod_disabled'}
                          if $this->{'cod_disabled'};
                        $sc_total .= '&yen;' . $this->digit($fee);
                        $total += $fee;
                    }
                    $sc_total .= '</td></tr>';
                }
            }
            elsif ( !$setting::payment{'otherenabled'}
                && ( !$setting::payment{'codenabled'} || $noshipping_only ) )
            {
                $fee_included = 1;
            }
        }
    }
    if ($env::tax_rate) {
        my $tax = $this->get_tax($total);
        $sc_total .= '<tr id="sc-tax">';
        $sc_total .= '<td class="sc-name" colspan="4">消費税</td>';
        $sc_total .= '<td class="sc-value" id="sc-tax-value">&yen;'
          . $this->digit($tax) . '</td>';
        $sc_total .= '</tr>';
        $total += $tax;
    }
    if ($sc_total) {
        $sheet .= $sc_sub_total;
        $sheet .= $sc_total;
        $sheet .= '<tr id="sc-total">';
    }
    else {
        $sheet .= '<tr id="sc-total" class="sc-total-start">';
    }
    $sheet .= '<td class="sc-name" colspan="4">合計'
      . (
          ($estimated) ? '(未確定)'
        : ( $carriage_included && $fee_included ) ? ''
        : '(<a href="'
          . $default::file
          . '/payment_info.'
          . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' )
          . '" target="_blank">'
          . ( ( !$carriage_included ) ? '送料' : '' )
          . (
              ( !$fee_included )
            ? ( ( !$carriage_included ) ? '・' : '' ) . '手数料'
            : ''
          )
          . '</a>別)'
      ) . '</td>';
    $sheet .= '<td class="sc-value" id="sc-total-value">&yen;'
      . $this->digit($total) . '</td>';
    $sheet .= '</tr>';
    $this->{'estimated_sum'} = $total;
    if (   ( $this->is_staff || $setting::payment{'paypal'}{'sandbox'} )
        && $payment_method
        && $payment_method eq 'paypal'
        && $setting::payment{'paypalenabled'}
        && $setting::payment{'paypal'}{'ratio'}
        && $setting::payment{'paypal'}{'fee'} )
    {
        my $paypal_fee = $this->paypal_fee( $total, $noshipping_only );
        $sheet .= '<tr id="sc-paypal">';
        $sheet .= '<td class="sc-name" colspan="4">PayPal 手数料</td>';
        $sheet .= '<td class="sc-value" id="sc-paypal-fee">-&yen;'
          . $this->digit($paypal_fee) . '</td>';
        $sheet .= '</tr>';
        $sheet .= '<tr id="sc-net">';
        $sheet .= '<td class="sc-name" colspan="4">正味金額</td>';
        $sheet .= '<td class="sc-value" id="sc-net-value">&yen;'
          . $this->digit( $total - $paypal_fee ) . '</td>';
        $sheet .= '</tr>';
    }
    $sheet .= '</tbody>';
    $sheet .= '</table>';
    $this->{'paypal_only'} =
      $field::obj{ $field::for{'payment_method'} }
      ->has_paypal_only( $this->{'noshipping_only'},
        $this->{'noshipping_included'} )
      if $field::for{'payment_method'};
    return $sheet;
}

sub out_of_bounds_message ($$) {
    my ( $this, $html ) = @_;
    return (
        ( $html && $setting::payment{'limiterrormsghtml'} )
        ? $this->tag_fix( $setting::payment{'limiterrormsghtml'} )
        : ( $setting::payment{'limiterrormsg'} )
        ? ( ($html) ? '<p class="error-msg">' : '' )
          . $this->escape_except_html_entity(
            $setting::payment{'limiterrormsg'}
          )
          . ( ($html) ? '</p>' : '' )
        : ( ($html) ? '<p class="error-msg">' : '' )
          . (
            ( $setting::payment{'pricerequired'} )
            ? '購入総額制限対象に指定された'
              . $setting::general{'itemname'}
              . 'の総額が'
            : '購入総額が'
          )
          . (
            (
                defined $setting::payment{'minimumamount'}
                  && $setting::payment{'minimumamount'} ne ''
            ) ? $setting::payment{'minimumamount'} . '円以上' : ''
          )
          . (
            (
                defined $setting::payment{'maximumamount'}
                  && $setting::payment{'maximumamount'} ne ''
            ) ? $setting::payment{'maximumamount'} . '円以下' : ''
          )
          . 'となるようお買い求めください。'
          . ( ($html) ? '</p>' : '' )
    );
}

sub calculate ($) {
    my $this = shift;
    my (
        %item_data,      @item_order,      $total,    $tax,
        $total_amount,   $fee,             $carriage, $order_info,
        $carriage_total, @digital_content, $dc_only,  $noshipping_only,
        $changed,        $is_pending
    );
    $this->{'estimated_sum'}         = $this->{'weight_lacked'} =
      $this->{'papersize_lacked'}    = $this->{'noshipping_only'} =
      $this->{'noshipping_included'} = 0;
    $total_amount = $total = $changed = 0;
    $dc_only = $noshipping_only = 1;
    $tax = $fee = $carriage = $order_info = $carriage_total = '';
    require CMONOS::CGI_Lib::CartController;
    $cgi::CartController = CartController->new;

    if (
        !$cgi::CartController->check(
            '', \%item_data, \@item_order, 1, \@digital_content
        )
      )
    {
        $changed = 1;
    }
    if ( !@item_order ) {
        push(
            @{ $this->{'dialog'} },
            (
                $setting::page{'emptyCartMsg'}
                  || 'カートに何も入っていません。'
            )
        );
        return ();
    }
    my ( $discount, $is_out_of_bounds ) =
      $this->amount_check( \%item_data, \@item_order );
    if ($is_out_of_bounds) {
        push( @{ $this->{'dialog'} }, $this->out_of_bounds_message );
        return ();
    }
    my $discount_ratio = 1 - ( $discount / 100 );
    foreach my $item_id (@item_order) {
        my $price =
          ( $item_data{$item_id}{'optionprice'} )
          ? ( $item_data{$item_id}{'price'} +
              $item_data{$item_id}{'optionprice'} )
          : $item_data{$item_id}{'price'};
        $price = int( $price * $discount_ratio )
          if $discount
          && (!$setting::payment{'discountlimited'}
            || $item_data{$item_id}{'discountable'} );
        $item_data{$item_id}{'amount'} = $price;
        my $subtotal = $price * $item_data{$item_id}{'quantity'};
        $total += $subtotal;
        $order_info .= $cgi::Session->data( '', '', $item_data{$item_id}, 1 );
        if ( $item_data{$item_id}{'digitalcontent'} ) {
            $this->{'noshipping_included'} = 1;
        }
        else {
            $dc_only = 0;
        }
        if (   $item_data{$item_id}{'digitalcontent'}
            || $item_data{$item_id}{'noshipping'} )
        {
            $this->{'noshipping_included'} = 1;
        }
        else {
            $noshipping_only = 0;
        }
        $this->{'weight_lacked'} = 1
          if ( !defined $item_data{$item_id}{'weight'}
            || $item_data{$item_id}{'weight'} eq '' )
          && !$item_data{$item_id}{'digitalcontent'}
          && !$item_data{$item_id}{'noshipping'};
        $this->{'papersize_lacked'} = 1
          if (!$item_data{$item_id}{'papersize'}
            || $item_data{$item_id}{'papersize'} !~
            /^(?:A[4-6]|B[5-6]|ACCESSORY)$/
            || !$item_data{$item_id}{'thickness'}
            || $item_data{$item_id}{'thickness'} >
            ( 20 - ( $setting::payment{'packagethickness'} || 0 ) ) )
          && !$item_data{$item_id}{'digitalcontent'};
        if ( $this->{'use_paypal'} && ref $this->{'paypal'} && $price ) {
            $total_amount += $subtotal;
            $this->{'paypal'}->add_payment_details_item(
                {
                    'Name' => $item_data{$item_id}{'name'}
                      . (
                        (
                                 $item_data{$item_id}{'key'}
                              && $item_data{$item_id}{'key'} ne
                              $item_data{$item_id}{'name'}
                        ) ? ' [' . $item_data{$item_id}{'key'} . ']' : ''
                      ),
                    (
                        ( $item_data{$item_id}{'option'} )
                        ? ( 'Description' =>
                              $this->escape( $item_data{$item_id}{'option'} ) )
                        : ()
                    ),
                    'Amount'   => $price,
                    'Quantity' => ( $item_data{$item_id}{'quantity'} || 1 ),
                    (
                        ( $setting::payment{'paypal'}{'incontext'} )
                        ? (
                            'ItemCategory' => (
                                ( $item_data{$item_id}{'digitalcontent'} )
                                ? 'Digital'
                                : 'Physical'
                            )
                          )
                        : ()
                    ),

#				(($setting::payment{'paypal'}{'incontext'}) ? ('ItemCategory'	=>	(($item_data{$item_id}{'digitalcontent'} || ($setting::payment{'paypal'}{'paymentaction'} && $setting::payment{'paypal'}{'paymentaction'} eq 'Sale')) ? 'Digital' : 'Physical')) : ()),
                }
            );
        }
    }
    if (
        (
               $setting::payment{'yuumail'}
            && $field::for{'shipping_info'}
            && ref $main::data{ $field::for{'shipping_info'} }
            && $main::data{ $field::for{'shipping_info'} }{'service'}
            && $main::data{ $field::for{'shipping_info'} }{'service'} =~
            /ゆうメール/
            && $this->{'weight_lacked'}
        )
        || (   $setting::payment{'mailbin'}
            && $field::for{'shipping_info'}
            && ref $main::data{ $field::for{'shipping_info'} }
            && $main::data{ $field::for{'shipping_info'} }{'service'}
            && $main::data{ $field::for{'shipping_info'} }{'service'} =~
            /メール便/
            && $this->{'papersize_lacked'} )
      )
    {
        push(
            @{ $this->{'dialog'} },
            $main::data{ $field::for{'shipping_info'} }{'service'}
              . 'で配送できない'
              . $setting::general{'itemname'}
              . 'が含まれています。'
        );
        return ();
    }
    if (   $setting::payment{'carriage'}
        && $setting::payment{'carriage'} eq 'weight'
        && $this->{'weight_lacked'} )
    {
        push(
            @{ $this->{'dialog'} },
'エラー！ 重量が設定されていない商品があるため、送料を計算できません。'
        );
        return ();
    }
    if (   $setting::payment{'carriage'}
        && $setting::payment{'carriage'} eq 'papersize'
        && $this->{'papersize_lacked'} )
    {
        push(
            @{ $this->{'dialog'} },
'エラー！ サイズが設定されていない商品があるため、送料を計算できません。'
        );
        return ();
    }
    if ($noshipping_only) {
        $this->{'noshipping_only'} = 1;
        $noshipping_only = $this->{'noshipping_only'} = 2 if $dc_only;
    }
    $carriage_total = $this->add_tax($total);
    if (
           $noshipping_only
        || !$field::for{'payment_method'}
        || (   $setting::payment{'carriage'}
            && $setting::payment{'carriage'} eq 'disabled' )
      )
    {
        $carriage = 0;
    }
    elsif (
        (
               $setting::payment{'specialcarriage'}{'requirements'}
            && $total >= $setting::payment{'specialcarriage'}{'requirements'}
        )
        || $setting::payment{'carriage'} eq 'nation'
        || (
            (
                   $setting::payment{'carriage'} eq 'region'
                || $setting::payment{'carriage'} eq 'prefecture'
            )
            && $field::for{'shippingaddress'}
            && ref $main::data{ $field::for{'shippingaddress'} }
            && (   $main::data{ $field::for{'shippingaddress'} }{'str'}
                || $main::data{ $field::for{'shippingaddress'} }{'pref'} )
        )
        || (
            (
                $setting::payment{'carriage'} eq 'weight'
                || (   $setting::payment{'yuumail'}
                    && $field::for{'shipping_info'}
                    && ref $main::data{ $field::for{'shipping_info'} }
                    && $main::data{ $field::for{'shipping_info'} }{'service'}
                    && $main::data{ $field::for{'shipping_info'} }{'service'}
                    =~ /ゆうメール/ )
            )
            && !$this->{'weight_lacked'}
        )
        || (
            (
                $setting::payment{'carriage'} eq 'papersize'
                || (   $setting::payment{'mailbin'}
                    && $field::for{'shipping_info'}
                    && ref $main::data{ $field::for{'shipping_info'} }
                    && $main::data{ $field::for{'shipping_info'} }{'service'}
                    && $main::data{ $field::for{'shipping_info'} }{'service'}
                    =~ /メール便/ )
            )
            && !$this->{'papersize_lacked'}
        )
      )
    {
        $carriage = $this->order_carriage(
            (
                (
                         $field::for{'shipping_info'}
                      && ref $main::data{ $field::for{'shipping_info'} }
                      && $main::data{ $field::for{'shipping_info'} }{'service'}
                )
                ? $main::data{ $field::for{'shipping_info'} }{'service'}
                : ''
            ),
            $carriage_total,
            \%item_data
        );
        $total += $carriage;
    }
    elsif ( $setting::payment{'estimatedCarriageRequired'} ) {
        $carriage = $this->get_estimated_carriage;
        $total += $carriage;
    }
    else {
        $carriage   = 0;
        $is_pending = 1;
    }
    $this->{'estimated_sum'} = $total;
    if (   $total
        && $field::for{'payment_method'}
        && $main::data{ $field::for{'payment_method'} }{'str'} )
    {
        if (
            (
                $noshipping_only || ( $setting::payment{'cod'}{'dcUnavailable'}
                    && $this->{'noshipping_included'} )
            )
            && $main::data{ $field::for{'payment_method'} }{'str'} eq 'cod'
            && $setting::payment{'codenabled'}
          )
        {
            $this->{'cod_disabled'} = 1;
            return ();
        }
        $fee =
          $this->order_fee( $main::data{ $field::for{'payment_method'} }{'str'},
            $total );
        if ( $fee && $fee =~ /[^0-9]/ ) {
            $this->{'cod_disabled'} = 1;
            return ();
        }
        undef $this->{'cod_disabled'};
        $total += $fee;
    }
    if ($env::tax_rate) {
        $tax = $this->get_tax($total);
        $total += $tax;
    }
    $this->{'estimated_sum'} = $total;
    if ( $total && $this->{'use_paypal'} && ref $this->{'paypal'} ) {
        $this->{'paypal'}->set_payment_details(
            {
                'OrderTotal' => $total,
                'ItemTotal'  => $total_amount,
                'TaxTotal'   => $tax,
                (
                    ( ( $carriage || 0 ) + ( $fee || 0 ) == $total ) ? ()
                    : (
                        (
                              ($is_pending) ? ()
                            : ( 'ShippingTotal' => ( $carriage || 0 ) )
                        ),
                        ( 'HandlingTotal' => ( $fee || 0 ) )
                    )
                ),
            }
        );
    }
    return ($changed)
      ? ()
      : (
        $total,
        $noshipping_only,
        $this->{'noshipping_included'},
        $tax, $fee,
        $carriage,
        $order_info,
        $carriage_total,
        \@digital_content,
        \%item_data,
        \@item_order,
        (
            (
                     $field::for{'payment_method'}
                  && ref $main::data{ $field::for{'payment_method'} }
                  && $main::data{ $field::for{'payment_method'} }{'str'}
                  && $main::data{ $field::for{'payment_method'} }{'str'} eq
                  'paypal'
                  && $setting::payment{'paypalenabled'}
                  && $setting::payment{'paypal'}{'ratio'}
                  && $setting::payment{'paypal'}{'fee'}
            ) ? $this->paypal_fee( $total, $noshipping_only ) : 0
        ),
        $discount
      );
}

sub get_tax ($$) {
    my ( $this, $amount ) = @_;
    if ( $env::tax_rate && $amount ) {
        return ( $env::tax_frac && $env::tax_frac eq 'ceil' )
          ? int( ( $amount * $env::tax_rate ) + 0.99999 )
          : ( $env::tax_frac && $env::tax_frac eq 'round' )
          ? int( ( $amount * $env::tax_rate ) + 0.5 )
          : int( $amount * $env::tax_rate );
    }
    else {
        return 0;
    }
}

sub add_tax ($$) {
    my ( $this, $amount ) = @_;
    return ($amount) ? $amount + $this->get_tax($amount) : 0;
}

sub get_estimated_carriage ($) {
    my $this = shift;
    if (   $setting::payment{'carriage'}
        && $setting::payment{'carriage'} eq 'region' )
    {
        return $setting::payment{'region'}
          { $this->maximum( $setting::payment{'region'} ) };
    }
    elsif ($setting::payment{'carriage'}
        && $setting::payment{'carriage'} eq 'prefecture' )
    {
        return $setting::payment{'pref'}
          { $this->maximum( $setting::payment{'pref'} ) };
    }
    return 0;
}

sub order_info_is_saved ($$$$$$$$$$$$;$) {
    my (
        $this,                  $total,          $noshipping_only,
        $noshipping_included,   $tax,            $fee,
        $carriage,              $order_info,     $carriage_total,
        $digital_content_array, $item_data_hash, $item_order_array,
        $expense,               $discount
    ) = @_;
    my ( $ptime, $transaction_id, $status, $download_key );
    return 0 if !defined $total;
    $ptime = $transaction_id = $status = $download_key = '';
    if ( ref $digital_content_array && @$digital_content_array ) {
        $download_key = $this->make_download_folder($digital_content_array);
        if ( !$download_key ) {
            push(
                @{ $this->{'dialog'} },
'ご注文を確定できませんでした。ダウンロードファイルの準備に失敗しました。'
            );
            return 0;
        }
    }
    undef $digital_content_array;
    if ( !$total ) {
        $ptime  = time;
        $status = 'Completed';
    }
    elsif ( ref $this->{'paypal'} ) {
        ( $transaction_id, $ptime ) = $this->{'paypal'}
          ->do_express_checkout_payment( { 'OrderTotal' => $total, } );

#	if (!$transaction_id || (($noshipping_only || ($setting::payment{'paypal'}{'paymentaction'} && $setting::payment{'paypal'}{'paymentaction'} eq 'Sale')) && !$ptime)) {
        if ( !$transaction_id
            || ( $noshipping_only && $noshipping_only eq '2' && !$ptime ) )
        {
            push(
                @{ $this->{'dialog'} },
                'ご注文の確定に失敗しました。',
                $this->{'paypal'}->errors('all')
            );
            return 0;
        }
        $status = ($ptime) ? 'Completed' : 'Pending';
    }
    $cgi::CartController->purchase( $item_data_hash, $item_order_array, 1, 1 );
    undef $item_data_hash;
    undef $item_order_array;
    if ( $setting::general{'mailonly'} ) {
        $main::data{ $field::for{'order_info'} }{'str'} = join( "\x09",
            $total,           $tax,            $fee,
            $carriage,        $carriage_total, $download_key,
            $ptime,           $transaction_id, $status,
            $noshipping_only, $expense,        $noshipping_included,
            $discount )
          . "\x0A"
          . $order_info
          if defined $field::for{'order_info'};
        $main::data{$field::total_price}{'str'} = $total . "\x0A" . $order_info
          if defined $field::total_price;
    }
    else {
        my ( %order, $is_failed );
        tie( %order, $env::dbm_file, "$default::db/$main::c/order",
            O_RDWR | O_CREAT,
            $env::dbm_mode );
        if ( ref tied %order ) {
            $order{ $this->encode_utf8($main::n) } = $this->encode_utf8(
                join( "\x09",
                    $total,          $tax,
                    $fee,            $carriage,
                    $carriage_total, $download_key,
                    $ptime,          $transaction_id,
                    $status,         $noshipping_only,
                    $expense,        $noshipping_included,
                    $discount )
                  . "\x0A"
                  . $order_info
            );
        }
        else {
            $is_failed = 1;
        }
        untie %order;
        if ( !$is_failed ) {
            my %price;
            tie( %price, $env::dbm_file, "$default::db/$main::c/price",
                O_RDWR | O_CREAT,
                $env::dbm_mode );
            if ( ref tied %price ) {
                $price{ $this->encode_utf8($main::n) } =
                  $this->encode_utf8($total);
            }
            else {
                $is_failed = 1;
            }
            untie %price;
            if ( !$is_failed && $ptime && $field::for{'checker'} ) {
                my $addr =
                  (      $main::data{ $field::for{'checker'} }{'str'}
                      && $main::data{ $field::for{'checker'} }{'str'} =~
                      /^(.*?)[,\x0A]/s ) ? $1 : '';
                foreach my $id (
                    @{ $field::obj{ $field::for{'checker'} }->{'order'} } )
                {
                    if (   ref $field::obj{ $field::for{'checker'} }->{'phase'}
                        && ref $field::obj{ $field::for{'checker'} }
                        ->{'phase'}{$id}
                        && $field::obj{ $field::for{'checker'} }
                        ->{'phase'}{$id}{'paid'} )
                    {
                        $main::data{ $field::for{'checker'} }{'str'} .=
                            $id . ':'
                          . $addr . ':'
                          . time
                          . ':お支払い完了('
                          . ( ($total) ? 'PayPal' : '0円' ) . ')';
                        last;
                    }
                }
            }
        }
        if ($is_failed) {
            push(
                @{ $this->{'dialog'} },
                '注文内容の保存に失敗しました。'
            );
            return 0;
        }
    }
    return 1;
}

sub order_carriage ($$$$) {
    my ( $this, $service, $total, $item_data ) = @_;
    $service = $1 if $service =~ /^(.*?)\x09/s;
    my $carriage = 0;
    if (
        (
            (
                   $setting::payment{'carriage'}
                && $setting::payment{'carriage'} eq 'weight'
            )
            || (   $setting::payment{'yuumail'}
                && $service
                && $service =~ /ゆうメール/ )
        )
        && !$this->{'weight_lacked'}
      )
    {
        $carriage = $this->carriage_by_weight($item_data);
    }
    elsif (
        (
            (
                   $setting::payment{'carriage'}
                && $setting::payment{'carriage'} eq 'papersize'
            )
            || (   $setting::payment{'mailbin'}
                && $service
                && $service =~ /メール便/ )
        )
        && !$this->{'papersize_lacked'}
      )
    {
        $carriage = $this->carriage_by_papersize( $service, $item_data );
    }
    elsif ($setting::payment{'carriage'}
        && $setting::payment{'carriage'} eq 'nation' )
    {
        $carriage =
          ( $setting::payment{'nation'} )
          ? $setting::payment{'nation'}
          : 0;
    }
    else {
        require CMONOS::CGI_Lib::JPrefecture;
        $cgi::JPrefecture = JPrefecture->new;
        my $pref =
          ( $main::data{ $field::for{'shippingaddress'} }{'pref'} )
          ? $main::data{ $field::for{'shippingaddress'} }{'pref'}
          : (    $main::data{ $field::for{'shippingaddress'} }{'str'}
              && $main::data{ $field::for{'shippingaddress'} }{'str'} =~
              /^(.*)$/m ) ? $1
          : '';
        return 0 if !$pref;
        my $pref_id = $cgi::JPrefecture->get_prefecture_id_by_name($pref);
        return 0 if !$pref_id;
        if (   $setting::payment{'carriage'}
            && $setting::payment{'carriage'} eq 'region' )
        {
            my $reg_id =
              $cgi::JPrefecture->get_region_id_by_prefecture_id($pref_id);
            return ( $setting::payment{'region'}{$reg_id} )
              ? $setting::payment{'region'}{$reg_id}
              : 0;
        }
        elsif ($setting::payment{'carriage'}
            && $setting::payment{'carriage'} eq 'prefecture' )
        {
            return ( $setting::payment{'pref'}{$pref_id} )
              ? $setting::payment{'pref'}{$pref_id}
              : 0;
        }
    }
    if (   $setting::payment{'specialcarriage'}{'requirements'}
        && $total >= $setting::payment{'specialcarriage'}{'requirements'} )
    {
        $setting::payment{'specialcarriage'}{'cost'} = 0
          if !$setting::payment{'specialcarriage'}{'cost'};
        $carriage = $setting::payment{'specialcarriage'}{'cost'}
          if $carriage > $setting::payment{'specialcarriage'}{'cost'};
    }
    return $carriage;
}

sub carriage_by_weight ($$) {
    my ( $this, $item_data ) = @_;
    my ( $total_weight, $total_carriage, @weight_id, $last );
    $total_weight = $total_carriage = 0;
    @weight_id = sort { $a <=> $b } keys %{ $setting::payment{'weight'} };
    $last = $weight_id[$#weight_id];
    while ( my ( $id, $item ) = each %$item_data ) {
        $total_weight += $item->{'weight'} * $item->{'quantity'}
          if $item->{'weight'} && $item->{'quantity'};
    }
    $total_weight += $setting::payment{'packageweight'}
      if $setting::payment{'packageweight'};
    if (   $setting::payment{'weight'}{$last}{'weight'}
        && $total_weight > $setting::payment{'weight'}{$last}{'weight'} )
    {
        $total_carriage = $setting::payment{'weight'}{$last}{'carriage'} *
          int( $total_weight / $setting::payment{'weight'}{$last}{'weight'} );
        $total_weight =
          $total_weight % $setting::payment{'weight'}{$last}{'weight'};
    }
    return $total_carriage if !$total_weight;
    foreach my $id (@weight_id) {
        return $total_carriage + (
            ( $setting::payment{'weight'}{$id}{'carriage'} )
            ? $setting::payment{'weight'}{$id}{'carriage'}
            : 0
        ) if $total_weight < $setting::payment{'weight'}{$id}{'weight'};
    }
    return $total_carriage;
}

sub carriage_by_papersize ($$$) {
    my ( $this, $service, $item_data ) = @_;
    my ( $total_carriage, $total_thickness, @a4, $max_thickness,
        $accessory_count, $is_express );
    $max_thickness = 20 - ( $setting::payment{'packagethickness'} || 0 );
    $total_thickness = $total_carriage = $accessory_count = 0;
    $is_express =
      (      $setting::payment{'papersize'}{'expressdelivery'}
          && $service
          && $service =~ /速達/ ) ? 1 : 0;
    while ( my ( $id, $item ) = each %$item_data ) {
        if ( $item->{'papersize'} ) {
            if ( $item->{'papersize'} eq 'ACCESSORY' ) {
                $accessory_count += $item->{'quantity'}
                  if $item->{'quantity'};
            }
            elsif ( $item->{'papersize'} =~ /^(?:A[4-6]|B[5-6])$/ ) {
                if (   $item->{'thickness'}
                    && $item->{'thickness'} > 0
                    && $item->{'thickness'} <= $max_thickness
                    && $item->{'quantity'} )
                {
                    for ( my $i = 0 ; $i < $item->{'quantity'} ; $i++ ) {
                        push( @a4, $item->{'thickness'} );
                        $total_thickness += $item->{'thickness'};
                    }
                }
            }
        }
    }
    if ($total_thickness) {
        if ( $total_thickness <= $max_thickness ) {
            if ( $total_thickness <= $max_thickness - 10 ) {
                $total_carriage = $setting::payment{'papersize'}{'1A4'};
            }
            else {
                $total_carriage = $setting::payment{'papersize'}{'2A4'};
            }
            $total_carriage += $setting::payment{'papersize'}{'expressdelivery'}
              if $is_express;
        }
        else {
            $total_thickness = 0;
            @a4 = (@a4) ? sort { $b <=> $a } @a4 : ();
            while ( @a4 > 0 ) {
                my @temp = ();
                @temp = ();
                foreach my $t (@a4) {
                    if ( $total_thickness + $t <= $max_thickness ) {
                        $total_thickness += $t;
                    }
                    else {
                        push( @temp, $t );
                    }
                }
                @a4 = @temp;
                $total_carriage +=
                  ( $total_thickness <= $max_thickness - 10 )
                  ? $setting::payment{'papersize'}{'1A4'}
                  : $setting::payment{'papersize'}{'2A4'};
                $total_carriage +=
                  $setting::payment{'papersize'}{'expressdelivery'}
                  if $is_express;
                $total_thickness = 0;
            }
        }
    }
    if ($accessory_count) {
        if (   $setting::payment{'papersize'}{'accessory2'}
            && $setting::payment{'papersize'}{'accessory2'} < $accessory_count )
        {
            my $c = int(
                $accessory_count / $setting::payment{'papersize'}{'accessory2'}
            );
            $total_carriage += (
                $setting::payment{'papersize'}{'2A4'} + (
                    ($is_express)
                    ? $setting::payment{'papersize'}{'expressdelivery'}
                    : 0
                )
              ) *
              $c;
            $accessory_count -=
              $setting::payment{'papersize'}{'accessory2'} * $c;
        }
        if (   $setting::payment{'papersize'}{'accessory1'}
            && $setting::payment{'papersize'}{'accessory2'}
            && $accessory_count > $setting::payment{'papersize'}{'accessory1'}
            && $accessory_count <=
            $setting::payment{'papersize'}{'accessory2'} )
        {
            $total_carriage += $setting::payment{'papersize'}{'2A4'} + (
                ($is_express)
                ? $setting::payment{'papersize'}{'expressdelivery'}
                : 0
            );
        }
        else {
            if (   $setting::payment{'papersize'}{'accessory1'}
                && $setting::payment{'papersize'}{'accessory1'} <
                $accessory_count )
            {
                my $c = int( $accessory_count /
                      $setting::payment{'papersize'}{'accessory1'} );
                $total_carriage += (
                    $setting::payment{'papersize'}{'1A4'} + (
                        ($is_express)
                        ? $setting::payment{'papersize'}{'expressdelivery'}
                        : 0
                    )
                  ) *
                  $c;
                $accessory_count -=
                  $setting::payment{'papersize'}{'accessory1'} * $c;
            }
            if ($accessory_count) {
                $total_carriage += $setting::payment{'papersize'}{'1A4'} + (
                    ($is_express)
                    ? $setting::payment{'papersize'}{'expressdelivery'}
                    : 0
                );
            }
        }
    }
    return $total_carriage;
}

sub order_fee ($$$) {
    my ( $this, $type, $price ) = @_;
    my ($id);
    return 0 if !$type;
    $price = 0 if !$price;
    ( $type, $id ) = ( $type =~ /^(.*?):(.*)$/ ) ? ( $1, $2 ) : ( $type, '' );
    if ( $type eq 'cod' && $setting::payment{'codenabled'} ) {
        $price = $this->add_tax($price);
        return ( $price < 10000 )
          ? $setting::payment{'cod'}{'fee1'}
          : ( $price < 30000 ) ? (
            ( $setting::payment{'cod'}{'fee2'} ne '' )
            ? $setting::payment{'cod'}{'fee2'}
            : '1万円'
          )
          : ( $price < 100000 ) ? (
            ( $setting::payment{'cod'}{'fee3'} ne '' )
            ? $setting::payment{'cod'}{'fee3'}
            : '3万円'
          )
          : ( $price < 300000 ) ? (
            ( $setting::payment{'cod'}{'fee4'} ne '' )
            ? $setting::payment{'cod'}{'fee4'}
            : '10万円'
          )
          : '30万円';
    }
    elsif ( $type eq 'paypal' && $setting::payment{'paypalenabled'} ) {
        return 0;
    }
    elsif ($type eq 'other'
        && $setting::payment{'otherenabled'}
        && $id
        && defined $setting::payment{'other'}{$id}{'name'}
        && defined $setting::payment{'other'}{$id}{'name'} ne '' )
    {
        my $formula = $setting::payment{'other'}{$id}{'formula'};
        return 0 if !$formula;
        $formula =~ s/x/$price/g;
        my $frac = $setting::payment{'other'}{$id}{'frac'};
        my $fee  = eval $formula;
        return
            ( !$fee ) ? 0
          : ( $frac && $frac eq 'ceil' )  ? int( $fee + 0.99999 )
          : ( $frac && $frac eq 'round' ) ? int( $fee + 0.5 )
          :                                 int($fee);
    }
    return 0;
}

sub paypal_fee ($$;$) {
    my ( $this, $price, $noshipping_only ) = @_;
    my $ratio =
      ( $setting::payment{'paypal'}{'ratio'} )
      ? $setting::payment{'paypal'}{'ratio'} / 100
      : 0;
    my $fee =
      ( $setting::payment{'paypal'}{'fee'} )
      ? $setting::payment{'paypal'}{'fee'}
      : 0;
    my $order_fee = int( ( $price * $ratio + $fee ) + 0.5 );

#if ($setting::payment{'paypal'}{'incontext'} && ($noshipping_only || ($setting::payment{'paypal'}{'paymentaction'} && $setting::payment{'paypal'}{'paymentaction'} eq 'Sale'))) {
    if (   $setting::payment{'paypal'}{'incontext'}
        && $noshipping_only
        && $noshipping_only eq '2' )
    {
        my $mratio =
          ( $setting::payment{'paypal'}{'mratio'} )
          ? $setting::payment{'paypal'}{'mratio'} / 100
          : 0;
        my $mfee =
          ( $setting::payment{'paypal'}{'mfee'} )
          ? $setting::payment{'paypal'}{'mfee'}
          : 0;
        my $m_order_fee = int( ( $price * $mratio + $mfee ) + 0.5 );
        $order_fee = $m_order_fee if $m_order_fee < $order_fee;
    }
    return $order_fee;
}

sub make_download_folder ($$) {
    my ( $this, $digital_content_array ) = @_;
    my $download_folder = $default::file . '/download';
    my $download_key;
    my @temp_files = ();
    my %list       = ();
    my $is_success = 0;
    my $zip_enabled =
      ( eval 'use Archive::Zip;1;' && $setting::general{'dcArchiveEnabled'} )
      ? 1
      : 0;
    $download_key = $this->rand_char(24)
      while ( !$download_key || -d $download_folder . '/' . $download_key );
    $download_folder .= '/' . $download_key;
    $this->set_dir($download_folder);
    my $htaccess = <<'HTA';
Satisfy all
Order allow,deny
Deny from all

HTA
    $this->write_file( $download_folder . '/.htaccess', $htaccess, 1 );
    $this->write_file(
        $download_folder . '/index.html',
"<html><head><title>404 Not Found</title></head><body><h1>Not Found</h1> The requested object does not exist on this server.</body></html>\x0A",
        1
    );
    $this->write_file( $download_folder . '/checkout.dat', '', 1 );

    foreach my $path (@$digital_content_array) {
        if ( $path =~ /([^\/]+)$/ ) {
            my $file_name = $1;
            $file_name =~ s/^[0-9]+\.// if $file_name =~ s/\.dat$//;
            $file_name .= '.txt' if $file_name !~ /\.[0-9a-zA-Z_]+$/;
            $file_name = 'download' . $file_name
              if $file_name =~ /^\.[0-9a-zA-Z_]+$/;
            my $n = 1;
            if ( $setting::general{'dcUnmaintainable'} ) {
                while ( $list{$file_name} ) {
                    $n++;
                    $file_name =~ s/(?:-[0-9]+)?(\.[0-9a-zA-Z_]+)$/-$n$1/;
                }
                $list{$file_name} = $path;
            }
            else {
                while ( -f $download_folder . '/' . $file_name ) {
                    $n++;
                    $file_name =~ s/(?:-[0-9]+)?(\.[0-9a-zA-Z_]+)$/-$n$1/;
                }
                my $file_path = $download_folder . '/' . $file_name;
                if ( $this->file_copy( $path, $file_path ) ) {
                    if ($zip_enabled) {
                        push( @temp_files, $file_name );
                    }
                    else {
                        $this->write_file( $file_path . '.dat', '', 1 );
                        $is_success = 1
                          if -f $download_folder . '/' . $file_name;
                    }
                }
            }
        }
    }
    if ( $setting::general{'dcUnmaintainable'} ) {
        local (*LIST);
        my $path = $download_folder . '/list.dat';
        if ( open( LIST, ">>$path" ) ) {
            binmode LIST, ":utf8";
            flock( LIST, LOCK_EX );
            truncate( LIST, 0 );
            seek( LIST, 0, 0 );
            foreach my $file_name ( sort keys %list ) {
                print LIST $file_name . "\x09"
                  . $list{$file_name}
                  . "\x090\x0A";
                $is_success = 1;
            }
            close(LIST);
        }
    }
    elsif (@temp_files) {
        if ( @temp_files == 1 && $temp_files[0] =~ /\.zip$/i ) {
            $this->write_file( $download_folder . '/' . $temp_files[0] . '.dat',
                '', 1 );
            $is_success = 1 if -f $download_folder . '/' . $temp_files[0];
        }
        else {
            my $zip_folder = $download_folder . '/download';
            $this->set_dir($zip_folder);
            my $download_file = $download_folder . '/download.zip';
            foreach my $file (@temp_files) {
                rename(
                    $download_folder . '/' . $file,
                    $zip_folder . '/' . $file
                );
            }
            my $zip = Archive::Zip->new;
            $zip->addTree( $zip_folder, '.' );
            $zip->writeToFileNamed($download_file);
            use File::Path;
            rmtree $zip_folder;
            $this->write_file( $download_file . '.dat', '', 1 );
            $is_success = 1 if -f $download_file;
        }
    }
    return ($is_success) ? $download_key : '';
}

sub print_contents_footer ($;$) {
    my ( $this, $closebutton_only ) = @_;
    print '<div id="close-button">'
      . $this->close_button(
        $this->{'referer_url'},       $setting::page{'closeButton'},
        $setting::page{'backButton'}, $closebutton_only
      )
      . '</div>'
      if !$setting::page{$setting::key}{'closeButtonDisabled'};
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if (   $default::type
        && $default::type eq 'order'
        && ( !$main::k || $main::k eq 'checkout' ) )
    {
        no warnings qw(once);

        #設定種キー設定
        $setting::security_key =
          'checkout';    #デフォルトセキュリティキー
        $setting::key = 'checkout';    #ページ設定キー

        #イメージCSS
        $setting::image_css = 'order-image.css';

        #クッキー
        $cookie::id_enabled = 1;       #ID情報クッキー読み込み

        #デフォルトキー
        $main::k = 'checkout' if !defined $main::k || !$main::k;

        #必須フォーム
        @setting::form = ('c');

        $setting::page{'checkout'}{'title'} = 'ご注文';

        #クラス登録
        Common::class_register( 'checkout', 'CheckOut' );
    }
}

1;
