package SCOrderTotalPrice;
require CMONOS::TableMaker::Field::SCNumericalData;
@ISA = qw(SCNumericalData);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（支払い額）
# SCOrderTotalPrice.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'price';
}

sub __set ($$) {
    my ( $this, $setting ) = @_;
    $field::total_price = $this->{'id'};
    return;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    my $num = $str;
    $str
        = ( $this->{'numtype'} )
        ? $this->kansuuji( $this->{'numtype'}, $str )
        : $this->digit($str);
    $str = (
        ( $this->{'monetaryunit'} !~ /[^\x20-\x7F]/ )
        ? '<span class="unit">'
            . (
            ( $this->{'monetaryunit'} eq '&yen;' )
            ? '￥'
            : $this->{'monetaryunit'}
            )
            . '</span>'
        : ''
        )
        . $str
        . ( ( $this->{'monetaryunit'} =~ /[^\x20-\x7F]/ )
        ? '<span class="unit">' . $this->{'monetaryunit'} . '</span>'
        : '' )
        if $this->{'monetaryunit'};
    return ( defined $str && $str ne '' )
        ? $this->style( $str, $this->{'style'}, $this->{'fontsize'},
        $this->{'fontcolor'}, $this->{'fontface'} )
        : '';
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return ( $this->{'mailDisabled'} ) ? 0 : 1;
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    my $num = $str;
    $str
        = ( $this->{'numtype'} )
        ? $this->kansuuji( $this->{'numtype'}, $str )
        : $this->digit($str);
    $str
        = ( ( $this->{'monetaryunit'} !~ /[^\x20-\x7F]/ )
        ? ( $this->{'monetaryunit'} eq '&yen;' )
                ? '￥'
                : $this->{'monetaryunit'}
        : '' )
        . $str
        . ( ( $this->{'monetaryunit'} =~ /[^\x20-\x7F]/ )
        ? $this->{'monetaryunit'}
        : '' )
        if $this->{'monetaryunit'};
    return '[' . $this->name . "]\x0A" . $str . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( defined $str && $str ne '' ) ? $str : '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;
    my $name = 'data:' . $this->{'id'};
    $this->print_field_info_form($name);

    print
        '<fieldset><legend>支払い額の定義</legend>税込み合計（小計+手数料+送料+消費税）</fieldset>';

    print '<fieldset><legend><label for="' . $name
        . '_monetaryunit">価格単位</label></legend>';
    print $this->mk_select_menu(
        $name . '_monetaryunit', '', '', $this->{'monetaryunit'},
        '円'   => '円',
        '&yen;' => '&yen;'
    );
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>検索設定</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_searchOption" value="1"'
        . ( ( defined $this->{'searchOption'} && $this->{'searchOption'} )
        ? ' checked="checked"'
        : '' )
        . ' /> より詳しい検索</label>';
    print '</fieldset>';
    $this->print_font_setting_form($name);
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };

    $main::data{ $this->{'id'} . '_searchOption' } = ''
        if !defined $main::data{ $this->{'id'} . '_searchOption' }
        || $main::data{ $this->{'id'} . '_searchOption' } eq '';
    return $this->is_valid_font_setting;
}

######################################################################
#sub import {
BEGIN {
    if (   defined $default::type
        && $default::type eq 'order'
        && defined $env::checkout
        && $env::checkout
        && !$setting::field_for_mail )
    {
        Field::class_register( 'yorder_price', 'SCOrderTotalPrice',
            '支払い額' );
    }
}

1;
