package InputBase;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
use utf8;
######################################################################
# データ入力基本モジュール
# InputBase.pm ver1.1.5
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-02-05
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    $this->gc_download_directory
        if $default::type && $default::type eq 'order';
    $main::a = '' if !defined $main::a;
    if ( defined $main::record_id && $main::record_id ) {
        ( $main::c, $main::n )
            = $this->get_category_and_number_from_permanent_id(
            $main::record_id);
    }
    $main::c = '' if !defined $main::c || $main::c =~ /[^0-9]/;
    $main::n = '' if !defined $main::n || $main::n =~ /[^0-9]/;
    if ($main::rewind) {
        $main::rewind =~ s/[^0-9]//g;
        undef $main::rewind
            if !defined $main::n
            || $main::n eq ''
            || $main::a eq 'w'
            || !$main::rewind
            || !
            -d "$default::file/$main::c/$main::n/archives.pending/$main::rewind";
    }
    $field::obj{ $field::for{'mail'} }->{'required'} = 1
        if $default::type
        && $default::type eq 'order'
        && $field::for{'mail'}
        && ref $field::obj{ $field::for{'mail'} };
    use Fcntl qw(:DEFAULT :flock);
    eval 'use ' . $env::dbm_file . ';';

    #カテゴリー設定読み込み
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 );
    $setting::category{'LIMIT'} = 2000
        if !defined $setting::category{'LIMIT'}
        || !$setting::category{'LIMIT'};

    #カテゴリー作成
    if (( !defined $main::c || $main::c eq '' )
        && (   !ref $setting::category{'ORDER'}
            || !%{ $setting::category{'ORDER'} }
            || ( keys %{ $setting::category{'ORDER'} } ) <= 1 )
        )
    {
        $main::c = 1;
        if (   !ref $setting::category{$main::c}
            || !%{ $setting::category{$main::c} } )
        {
            $this->mk_category($main::c);
        }
        else {
            $this->set_dir("$default::db/1");
            $this->set_dir("$default::file/1");
        }
    }

    #オーダー情報
    $this->get_order_info
        if $default::type
        && $default::type eq 'order'
        && defined $main::c
        && $main::c ne ''
        && defined $main::n
        && $main::n ne '';

    $this->allocate_category
        if $main::c eq '' || !ref $setting::category{$main::c};
    $this->update;

    #ページヘッダ
    $this->print_contents_header;

    #フォーム
    print $this->form_start(
        'key'      => $setting::key,
        'id'       => $this->input_form_id,
        'name'     => 'input',
        'multi'    => $cgi::enctype_multipart,
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="w" />';

    #ファイル格納ディレクトリ
    my $path = "$default::file/$main::c/$main::n";

    print '<table class="field-table"><tbody>';
    $this->{'cookie_enabled'} = 0;
    my $top_field = $this->top_field;
    if ( $top_field && ref $field::obj{$top_field} ) {
        print $field::obj{$top_field}->form( $main::n, '', $path );
        $this->{'cookie_enabled'} = 1
            if $field::obj{$top_field}->cookie_enabled
            && $field::obj{$top_field}->{'cookie'};
        print '</tbody><tbody>';
    }
    foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$o};
        next if $top_field && $top_field == $id;
        if ( ref $field::obj{$id} ) {
            my $field = $field::obj{$id};
            if (( defined $main::n && $main::n ne '' )
                || (   $field->{'class'} ne 'user_xtime'
                    && $field->{'class'} ne 'xtm_checker' )
                )
            {
                if ($field->{'protected'}
                    && ((      defined $main::n
                            && $main::n ne ''
                            && !$this->is_secure(
                                'reviseProtectedFields', 0, 'revise'
                            )
                        )
                        || (( !defined $main::n || $main::n eq '' )
                            && !$this->is_secure(
                                'inputProtectedFields', 0, 'input'
                            )
                        )
                    )
                    )
                {
                    next;
                }
                elsif (
                    (      !defined $main::n
                        || $main::n eq ''
                        || !$field->has_content( $main::data{$id} )
                    )
                    && $this->is_skip_field($field)
                    )
                {
                    next;
                }
                elsif ( $this->is_reserved_field($field) ) {
                    $field->print_confirmation_form_table_row( $path,
                        $main::c, $main::n );
                }
                else {
                    $this->{'cookie_enabled'} = 1
                        if $field->cookie_enabled && $field->{'cookie'};
                    print $field->form( $main::n, '', $path );
                }
            }
        }
    }
    print '</tbody>';
    $this->print_submit_button_in_table;
    print '</table>';
    $this->print_submit_button;
    print '</form>';
    $this->print_contents_footer;
    $this->print_page_footer($setting::key);
}

sub input_form_id ($) {
    my $this = shift;
    return 'tm-input-form';
}

sub top_field ($$) {
    my $this = shift;
}

sub get_order_info ($) {
    my $this = shift;
}

sub is_skip_field ($$) {
    my $this = shift;
    return 0;
}

sub is_skippable_field ($$) {
    my ( $this, $field ) = @_;
    return (
               $default::type
            && $default::type eq 'order'
            && $field->{'skippable'}
            && $field->input_enabled
            && $field->{'class'} !~ /^(?:ug|xtm|yorder)_/
            && ( !$field->{'field_for'}{'mail'}
            || $field->{'field_for'}{'mail'} ne $field->{'id'} )
    ) ? 1 : 0;
}

sub is_reserved_field ($$) {
    my $this = shift;
    return 0;
}

sub allocate_category ($) {
    my $this = shift;
}

sub update ($) {
    my $this = shift;
}

sub print_contents_header ($) {
    my $this = shift;
    $this->print_page_header($setting::key);
}

sub print_submit_button_in_table ($) {
    my $this = shift;
}

sub print_submit_button ($) {
    my $this = shift;
}

sub input_is_valid ($) {
    my $this     = shift;
    my $is_valid = 1;

    #入力チェック
    foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$o};
        if (ref $field::obj{$id}
            && (!$field::obj{$id}->{'protected'}
                || (   defined $main::n
                    && $main::n ne ''
                    && $this->is_secure( 'reviseProtectedFields', 0,
                        'revise' ) )
                || ( ( !defined $main::n || $main::n eq '' )
                    && $this->is_secure( 'inputProtectedFields', 0, 'input' )
                )
            )
            && ((      defined $main::n
                    && $main::n ne ''
                    && $field::obj{$id}->has_content( $main::data{$id} )
                )
                || !$this->{'noshipping_only'}
                || !$this->is_skippable_field( $field::obj{$id} )
            )
            )
        {
            $is_valid = 0
                if !$field::obj{$id}->is_valid_data( ( $main::n ne '' )
                ? "$default::file/$main::c/$main::n"
                : '' );
        }
    }

    #連続チェック
    if (   $main::n eq ''
        && $setting::general{'ipStopper'}
        && $setting::general{'latest'} )
    {
        my ( $mtime, $ip ) = split( /:/, $setting::general{'latest'} );
        if (   $ip
            && $mtime
            && $ip eq
            ( $ENV{'REMOTE_HOST'} || $this->to_host( $ENV{'REMOTE_ADDR'} ) )
            && time - $mtime <= $setting::general{'ipStopper'} )
        {
            push(
                @{ $this->{'dialog'} },
                '送信が連続しました。安全のため連続送信は制限されています。送信に問題がない場合は、しばらくしてからもう一度送信しなおしてください。'
            );
            $is_valid = 0;
        }
    }
    return $is_valid;
}

sub print_confirmation_table ($$) {
    my ( $this, $button_required ) = @_;
    print $this->form_start(
        'key'      => $setting::key,
        'name'     => 'input',
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="w" />';
    print '<table class="field-table"><tbody>';
    my $path           = "$default::file/$main::c/$main::n";
    my $cookie_enabled = 0;
    foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$o};
        if (   ref $field::obj{$id}
            && defined $main::data{$id}{'str'}
            && ( ( defined $main::n && $main::n ne '' )
                || $field::obj{$id}->{'class'} ne 'user_xtime' )
            && (!$field::obj{$id}->{'protected'}
                || (   defined $main::n
                    && $main::n ne ''
                    && $this->is_secure( 'reviseProtectedFields', 0,
                        'revise' ) )
                || ( ( !defined $main::n || $main::n eq '' )
                    && $this->is_secure( 'inputProtectedFields', 0, 'input' )
                )
            )
            )
        {
            $cookie_enabled = 1
                if $field::obj{$id}->cookie_enabled
                && $field::obj{$id}->{'cookie'};
            $field::obj{$id}
                ->print_confirmation_form_table_row( $path, $main::c,
                $main::n );
        }
    }
    print '</tbody>';
    if ($button_required) {
        print
            '<tbody><tr class="tbody-start"><td class="submit-box" colspan="2">';
        print '<input type="hidden" name="set_cookie" value="1" />'
            if $cookie_enabled && $main::set_cookie;
        print '<input type="submit" name="cancel=1" value="'
            . ( ($default::english) ? 'Cancel' : 'キャンセル' )
            . '" class="cancel" />';
        print '<input type="submit" name="ok=1" value="'
            . ( ($default::english) ? 'OK' : '送信' )
            . '" class="save" /></td></tr></tbody>';
    }
    print '</table>';
    $this->print_confirmation_button;
    print '</form>';
}

sub print_confirmation_button ($) {
    my $this = shift;
}

sub print_checkout_button ($) {
    my $this = shift;
}

sub thanks ($;$$) {
    my ( $this, $closebutton_only, $title_pushed ) = @_;
    my ($list,         $record, $url, $script_name, $input,
        $register_url, %thanks, $key, $name,        $title
    );

    #入力お礼設定読み込み
    $this->import_db( $default::preference_dir . '/thanks', \%thanks );

    #自動返信メール
    $script_name = $this->my_url;
    ( $url, $record ) = $this->permalink_of_detailview( $main::c, $main::n );
    $register_url
        = $this->http_my_domain
        . $this->path_change( $env::register_cgi, $ENV{'SCRIPT_NAME'},
        'abs' );
    $input = $script_name . '?m=Input&c=' . $main::c . '&n=' . $main::n;

    if (   $thanks{'resmsg'}
        && $field::for{'mail'}
        && ref $field::obj{ $field::for{'mail'} }
        && $field::obj{ $field::for{'mail'} }->{'e-mail'}
        && $field::obj{ $field::for{'mail'} }->{'class'} =~ /email/
        && $main::data{ $field::for{'mail'} }{'str'} )
    {
        my ( $key, $name, $title );
        if (   $field::for{'name'}
            && defined $main::data{ $field::for{'name'} }{'str'}
            && $main::data{ $field::for{'name'} }{'str'} ne '' )
        {
            $name = $field::obj{ $field::for{'name'} }->format_for_text(
                $main::data{ $field::for{'name'} }{'str'} );
        }
        else {
            $name = '';
        }
        if (   $field::for{'key'}
            && defined $main::data{ $field::for{'key'} }{'str'}
            && $main::data{ $field::for{'key'} }{'str'} ne '' )
        {
            $key = $field::obj{ $field::for{'key'} }
                ->format_for_text( $main::data{ $field::for{'key'} }{'str'} );
        }
        else {
            $key = '';
        }
        if (   $field::for{'title'}
            && defined $main::data{ $field::for{'title'} }{'str'}
            && $main::data{ $field::for{'title'} }{'str'} ne '' )
        {
            $title = $field::obj{ $field::for{'title'} }->format_for_text(
                $main::data{ $field::for{'title'} }{'str'} );
        }
        else {
            $title = '';
        }
        $thanks{'resmsg'} =~ s/<name>/$name/igs;
        $thanks{'ressubject'} =~ s/<name>/$name/igs;
        $thanks{'resmsg'} =~ s/<key>/$key/igs;
        $thanks{'ressubject'} =~ s/<key>/$key/igs;
        $thanks{'resmsg'} =~ s/<title>/$title/igs;
        $thanks{'ressubject'} =~ s/<title>/$title/igs;
        if ( $thanks{'resmsg'} =~ /<data>/i ) {
            local $setting::shortpaymentinfo = $thanks{'shortpaymentinfo'};
            $list = $this->data_for_notice_mail( \%field::obj, \%main::data );
            $thanks{'resmsg'} =~ s/<data>/$list/igs;
        }
        $thanks{'ressubject'} =~ s/<record>/$record/igs;
        $thanks{'resmsg'} =~ s/<record>/$record/igs;
        $thanks{'resmsg'} =~ s/<url>/$url/igs;
        $thanks{'resmsg'} =~ s/<input>/$input/igs;
        $thanks{'resmsg'} =~ s/<register>/$register_url/igs;
        unless ( ref $cgi::SendMail ) {
            require CMONOS::CGI_Lib::SendMail;
            $cgi::SendMail
                = SendMail->new( $env::sendmail, $env::master_email, '',
                $cgi::input, 1 );
        }
        $cgi::SendMail->send_mail(
            'To' => (
                ( $main::data{ $field::for{'name'} }{'str'} )
                ? $main::data{ $field::for{'name'} }{'str'} . ' <'
                    . $main::data{ $field::for{'mail'} }{'str'} . '>'
                : $main::data{ $field::for{'mail'} }{'str'}
            ),
            'From' => (
                ( $setting::general{'master'} )
                ? ( ( $setting::general{'mastername'} )
                    ? $setting::general{'mastername'} . ' <'
                        . $setting::general{'master'} . '>'
                    : $setting::general{'master'} )
                : $env::master_email
            ),
            'Subject' => $thanks{'ressubject'},
            'message' => $thanks{'resmsg'} . "\x0A\x0A",
            'info'    => 0
        );
        undef $thanks{'resmsg'};
        undef $thanks{'ressubject'};
    }

    if (   $field::for{'name'}
        && defined $main::data{ $field::for{'name'} }{'str'}
        && $main::data{ $field::for{'name'} }{'str'} ne '' )
    {
        $name = $this->detag_text( $field::obj{ $field::for{'name'} }
                ->usual_format( $main::data{ $field::for{'name'} }{'str'} ) );
    }
    else {
        $name = '';
    }
    if (   $field::for{'key'}
        && defined $main::data{ $field::for{'key'} }{'str'}
        && $main::data{ $field::for{'key'} }{'str'} ne '' )
    {
        $key = $this->detag_text( $field::obj{ $field::for{'key'} }
                ->usual_format( $main::data{ $field::for{'key'} }{'str'} ) );
    }
    else {
        $key = '';
    }
    if (   $field::for{'title'}
        && defined $main::data{ $field::for{'title'} }{'str'}
        && $main::data{ $field::for{'title'} }{'str'} ne '' )
    {
        $title
            = $this->detag_text( $field::obj{ $field::for{'title'} }
                ->usual_format( $main::data{ $field::for{'title'} }{'str'} )
            );
    }
    else {
        $title = '';
    }

    #書き込みお礼
    $thanks{'thankstitle'} =~ s/<name>/$name/igs;
    $thanks{'thanks'} =~ s/<name>/$name/igs;
    $thanks{'thankstitle'} =~ s/<key>/$key/igs;
    $thanks{'thanks'} =~ s/<key>/$key/igs;
    $thanks{'thankstitle'} =~ s/<title>/$title/igs;
    $thanks{'thanks'} =~ s/<title>/$title/igs;
    if ( defined $thanks{'thanks'} && $thanks{'thanks'} =~ /<data>/i ) {
        $list = $this->data_for_notice_mail( \%field::obj, \%main::data )
            if !defined $list || !$list;
        $this->escape( \$list );
        $thanks{'thanks'} =~ s/<data>/$list/igs;
    }
    $thanks{'thankstitle'} =~ s/<record>/$record/igs;
    $thanks{'thanks'} =~ s/<record>/$record/igs;
    $thanks{'thanks'} =~ s/<url>/$url/igs;
    $thanks{'thanks'} =~ s/<input>/$input/igs;
    $thanks{'thanks'} =~ s/<register>/$register_url/igs;
    if (   !$title_pushed
        && defined $thanks{'thankstitle'}
        && $thanks{'thankstitle'} ne '' )
    {
        $this->push_window_title( $thanks{'thankstitle'} );
        $setting::page{$setting::key}{'titleText'}
            =~ s/((<[^>]+>)*)[^<]+/$1$thanks{'thankstitle'}/s
            if defined $setting::page{$setting::key}{'titleText'}
            && $setting::page{$setting::key}{'titleText'} ne '';
    }
    $this->print_page_header($setting::key);
    $this->print_thanks( $thanks{'thanks'} );
    $this->print_contents_footer($closebutton_only);
    $this->print_page_footer($setting::key);
    exit;
}

sub print_thanks ($$) {
    my ( $this, $msg ) = @_;
    $this->print_thanks_content($msg);
}

sub print_thanks_content ($$;$) {
    my ( $this, $msg, $alt_disabled ) = @_;
    if ( defined $msg && $msg ne '' ) {
        $this->tag_fix( \$msg, 2, 0, 0, 1 );
        $this->autolink( \$msg );
        print $msg;
    }
    elsif ( !$alt_disabled ) {
        print '<p>登録されました。</p>';
    }
}

sub print_contents_footer ($;$) {
    my ( $this, $closebutton_only ) = @_;
    print '<div id="close-button">'
        . $this->close_button(
        $this->{'referer_url'},       $setting::page{'closeButton'},
        $setting::page{'backButton'}, $closebutton_only
        ) . '</div>';
}

######################################################################
# 削除予約レコードの削除
sub gc ($) {
    my $this = shift;
    my ( %expire, %pending, @delete, $nocount );
    $nocount = 0;
    tie( %expire, $env::dbm_file, "$default::db/$main::c/expire",
        O_RDONLY, $env::dbm_mode );
    tie( %pending, $env::dbm_file, "$default::db/$main::c/pending",
        O_RDONLY, $env::dbm_mode );
    if ( ref tied %expire ) {
        my $t = time;
        while ( my ( $n, $v ) = each %expire ) {
            if ( $v < $t ) {
                push( @delete, $n );
                $nocount++
                    if !ref tied %pending
                    || !$pending{ $this->encode_utf8($n) }
                    || $this->decode_utf8(
                    $pending{ $this->encode_utf8($n) } ) !~ /^1/;
            }
        }
    }
    untie %pending;
    untie %expire;
    if (@delete) {
        foreach my $n (@delete) {
            $this->delete_record( $main::c, $n );
        }
    }
    if ($nocount) {
        my (%category);
        tie(%category, $env::dbm_file,
            $default::preference_dir . '/category',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %category ) {
            $category{ $this->encode_utf8( $main::c . '_total' ) } -= @delete
                if $category{ $this->encode_utf8( $main::c . '_total' ) };
            $category{ $this->encode_utf8( $main::c . '_count' ) } -= $nocount
                if $category{ $this->encode_utf8( $main::c . '_count' ) };
            $setting::category{$main::c}{'total'}
                = $category{ $this->encode_utf8( $main::c . '_total' ) } || 0;
            $setting::category{$main::c}{'count'}
                = $category{ $this->encode_utf8( $main::c . '_count' ) } || 0;
        }
        untie %category;
        $this->write_category_list
            if !defined $default::type || $default::type ne 'order';
    }
}

######################################################################
# 新規カテゴリー
sub mk_category ($$;$$) {
    my ( $this, $id, $name, $order ) = @_;
    my ( %new, $category_count );
    $this->set_dir("$default::db/$id");
    $this->set_dir("$default::file/$id");
    $category_count = keys %{ $setting::category{'ORDER'} };
    if ( $order && $order <= $category_count ) {
        my %order = %{ $setting::category{'ORDER'} };
        foreach ( sort { $a <=> $b } keys %order ) {
            if ( $_ == $order ) {
                $setting::category{$id}{'ORDER'} = $new{ $id . '_ORDER' }
                    = $order;
                $setting::category{'ORDER'}{$order}
                    = $new{ 'ORDER_' . $order } = $id;
                $setting::category{$id}{'name'} = $new{ $id . '_name' }
                    = ( defined $name && $name ) ? $name : $order;
            }
            if ( $new{ 'ORDER_' . $_ } ) {
                my $o = $_ + 1;
                my $i = $order{$_};
                $setting::category{$i}{'ORDER'} = $new{ $i . '_ORDER' } = $o;
                $setting::category{'ORDER'}{$o} = $new{ 'ORDER_' . $o } = $i;
            }
        }
    }
    else {
        $setting::category{$id}{'ORDER'} = $new{ $id . '_ORDER' }
            = $category_count + 1;
        $setting::category{'ORDER'}{ $new{ $id . '_ORDER' } }
            = $new{ 'ORDER_' . $new{ $id . '_ORDER' } } = $id;
        $setting::category{$id}{'name'} = $new{ $id . '_name' }
            = ( defined $name && $name ) ? $name : $new{ $id . '_ORDER' };
    }
    $this->write_db( $default::preference_dir . '/category', \%new );
}

######################################################################
#データベース読み書き
sub dbm ($;$) {
    my ( $this, $read_only ) = @_;
    my ( $flags, $dir, $filedir, $user_info );
    return 1 if $setting::general{'mailonly'};

    #ディレクトリ
    $dir = "$default::db/$main::c";
    if ( !$this->set_dir($dir) ) {
        push(
            @{ $this->{'dialog'} },
            'データベース書き込みに失敗しました。保存用ディレクトリが存在しません。'
        );
        return;
    }
    $filedir = "$default::file/$main::c/$main::n";

    if ( ( !$read_only && $main::a eq 'w' ) || $main::rewind ) {

        #更新時刻の書き込み
        my ( %mtime, %ctime, %ip, %agent, %general, $this_ip, $time, $last );
        $time = time;

        tie(%mtime,           $env::dbm_file, $dir . '/mtime',
            O_RDWR | O_CREAT, $env::dbm_mode
        );
        if ( ref tied %mtime ) {
            $last = $this->decode_utf8(
                $mtime{ $this->encode_utf8($main::n) } );
            $mtime{ $this->encode_utf8($main::n) } = $time;
        }
        untie %mtime;

        $this->{'new_record'} = 1
            if $this->{'new_data'} || $time - $last > 10800;

        #作成時刻の書き込み
        tie(%ctime,           $env::dbm_file, $dir . '/ctime',
            O_RDWR | O_CREAT, $env::dbm_mode
        );
        if ( ref tied %ctime ) {
            $ctime{ $this->encode_utf8($main::n) } = $time
                if !$ctime{ $this->encode_utf8($main::n) }
                || $this->{'new_data'};
        }
        untie %ctime;

        $this_ip
            = $ENV{'REMOTE_HOST'} || $this->to_host( $ENV{'REMOTE_ADDR'} );
        $user_info
            = $this_ip . "\x0A"
            . $ENV{'HTTP_USER_AGENT'} . "\x0A"
            . ( ($main::email) ? $main::email : '' );
        if ( !$this->{'keep_original_user_info'} ) {

            #投稿者IPの書き込み
            tie(%ip, $env::dbm_file,
                $dir . '/ip',
                O_RDWR | O_CREAT,
                $env::dbm_mode
            );
            if ( ref tied %ip ) {
                $ip{ $this->encode_utf8($main::n) }
                    = $this->encode_utf8($this_ip);
            }
            untie %ip;

            #投稿者環境の書き込み
            tie(%agent,           $env::dbm_file, $dir . '/agent',
                O_RDWR | O_CREAT, $env::dbm_mode
            );
            if ( ref tied %agent ) {
                $agent{ $this->encode_utf8($main::n) }
                    = $this->encode_utf8( $ENV{'HTTP_USER_AGENT'} );
            }
            untie %agent;
        }

        #名前登録
        if (   $field::NAMEREGISTER
            && $field::for{'name'}
            && defined $main::data{ $field::for{'name'} }{'str'}
            && $main::data{ $field::for{'name'} }{'str'} ne ''
            && $this->use_register )
        {
            my $user_name = $main::data{ $field::for{'name'} }{'str'};
            if ( defined $user_name && $user_name ne '' ) {
                $user_name =~ s/<>([#0-9a-zA-z]{3,10})\Z//s;
                $user_info .= "\x0A" . $user_name;
                $cgi::Register->user_name_register(
                    $main::pswd, $main::email,
                    $user_name,  $security::registered
                );
            }
        }

        #レコード番号
        if (   $field::for{'serialno'}
            && ref $field::obj{ $field::for{'serialno'} }
            && $field::obj{ $field::for{'serialno'} }->{'class'} eq
            'xtm_serialno' )
        {
            $field::obj{ $field::for{'serialno'} }
                ->save_serial_no( $main::c, $main::n );
        }

        #一般情報更新
        tie(%general, $env::dbm_file,
            $default::preference_dir . '/general',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %general ) {
            $general{'latest'} = $this->encode_utf8( $time . ':' . $this_ip );
            $general{'mtime'}  = $this->encode_utf8($time);
        }
        untie %general;
        $setting::general{'mtime'} = $time;

        #カテゴリーレコード数カウント/番号記録
        if ( $this->{'new_data'} ) {
            my ( %category, %record_id );
            tie(%category, $env::dbm_file,
                $default::preference_dir . '/category',
                O_RDWR | O_CREAT,
                $env::dbm_mode
            );
            if ( ref tied %category ) {
                $category{ $this->encode_utf8( $main::c . '_total' ) }++;
                $category{ $this->encode_utf8( $main::c . '_count' ) }++;
                $setting::category{$main::c}{'total'}
                    = $this->decode_utf8(
                    $category{ $this->encode_utf8( $main::c . '_total' ) } )
                    || 0;
                $setting::category{$main::c}{'count'}
                    = $this->decode_utf8(
                    $category{ $this->encode_utf8( $main::c . '_count' ) } )
                    || 0;
            }
            untie %category;
            $this->write_category_list
                if !defined $default::type || $default::type ne 'order';
            $this->save_record_id( $main::c, $main::n );
        }

        if ( !$main::rewind ) {

            #ファイル保存
            $cgi::input->fix_all_files($filedir);

            if ( ref $cgi::input->{'dialog'} && @{ $cgi::input->{'dialog'} } )
            {
                push( @{ $this->{'dialog'} }, @{ $cgi::input->{'dialog'} } );
            }
        }

        #アンテナ対策
        local (*OUT);
        if ( open( OUT, ">>$default::file/index.html" ) ) {
            binmode OUT, ":utf8";
            flock( OUT, LOCK_EX );
            truncate( OUT, 0 );
            seek( OUT, 0, 0 );
            print OUT
                '<html><head><meta http-equiv="Refresh" content="0; URL='
                . $cgi::path . '?c='
                . $main::c
                . '" /></head><body></body></html>';
            close(OUT);
        }

        if ($main::rewind) {
            $flags = O_RDONLY;
        }
        else {
            $flags = O_RDWR | O_CREAT;
        }
    }
    else {
        $flags = O_RDONLY;
    }

    while ( my ( $id, $field ) = each %field::obj ) {
        my $db = $field->db;
        if (   defined $db
            && $db
            && (!$read_only
                || (   $main::a eq 'w'
                    && $field->input_enabled
                    && !$this->is_reserved_field($field) )
                || !$field->input_enabled
                || $this->is_reserved_field($field)
            )
            )
        {
            my %db;
            tie( %db, $env::dbm_file, $dir . '/' . $db,
                $flags, $env::dbm_mode );
            if ( ref tied %db ) {

                #書き込み
                if (   $main::a eq 'w'
                    && $field->input_enabled
                    && !$this->is_reserved_field($field) )
                {
                    if (!$field->{'protected'}
                        || (!$this->{'new_data'}
                            && $this->is_secure(
                                'reviseProtectedFields', 0, 'revise'
                            )
                        )
                        || ($this->{'new_data'}
                            && $this->is_secure(
                                'inputProtectedFields', 0, 'input'
                            )
                        )
                        )
                    {
                        eval
                            '$db{$this->encode_utf8($main::n)} = $this->encode_utf8($main::data{$id}{\'str\'})';
                        if ( defined $@ && $@ ) {
                            push(
                                @{ $this->{'dialog'} },
                                '書き込みに失敗しました。('
                                    . $field->{'name'} . ')'
                            );
                        }
                        else {
                            $field->settle_up($filedir);
                        }
                    }

                    #読み込み
                }
                elsif ( $this->is_reserved_field($field) ) {
                    my $str = $this->decode_utf8(
                        $db{ $this->encode_utf8($main::n) } );
                    %{ $main::data{$id} } = $field->elements($str);
                    $main::data{$id}{'str'} = $str;
                }
                elsif ( !$read_only || !$field->input_enabled ) {
                    %{ $main::data{$id} } = $field->elements(
                        $this->decode_utf8(
                            $db{ $this->encode_utf8($main::n) }
                        )
                    );
                }
            }
            elsif ( $main::a && $main::a eq 'w' && !$read_only ) {
                push(
                    @{ $this->{'dialog'} },
                    'データベースに接続できませんでした。('
                        . $field->{'name'} . ')'
                );
            }
            untie %db;
        }
    }
    $this->feed_db_rss( $main::c, $main::n, \%main::data )
        if ( ( !$read_only && defined $main::a && $main::a eq 'w' )
        || $main::rewind )
        && ( !$field::for{'pending'}
        || !$main::data{ $field::for{'pending'} }{'str'}
        || $main::data{ $field::for{'pending'} }{'str'} !~ /^1/ );

    if ( $setting::general{'rewindable'} ) {
        my $archives_dir = $filedir . '/archives.pending';
        if ( !$read_only && $main::a eq 'w' ) {
            my $current_dir = $archives_dir . '/' . $this->time_id;
            use File::Path;
            if ( $this->set_dir($archives_dir) ) {
                $this->write_file(
                    $archives_dir . '/.htaccess',
                    'Satisfy all' . "\x0A"
                        . 'order deny,allow' . "\x0A"
                        . 'deny from all' . "\x0A",
                    1
                );
                rmtree $current_dir if -d $current_dir;
                if ( $this->set_dir($current_dir) ) {
                    $this->write_file(
                        $current_dir . '/.htaccess',
                        'Satisfy all' . "\x0A"
                            . 'order deny,allow' . "\x0A"
                            . 'deny from all' . "\x0A",
                        1
                    );
                    $this->directory_copy( $filedir, $current_dir, 0,
                        [ '^\\.', '\\.(?:js|ssi|dat)$' ] );
                    if ( $this->set_dir( $current_dir . '/data' ) ) {
                        $this->write_file(
                            $current_dir . '/data/.htaccess',
                            'Satisfy all' . "\x0A"
                                . 'order deny,allow' . "\x0A"
                                . 'deny from all' . "\x0A",
                            1
                        );
                        $this->write_file( $current_dir . '/data/author',
                            $user_info, 1 );
                        while ( my ( $id, $field ) = each %field::obj ) {
                            my $db = $field->db;
                            if (   defined $db
                                && $db
                                && $db ne 'pending'
                                && $field->input_enabled
                                && !$field->update_enabled
                                && !$this->is_reserved_field($field) )
                            {
                                my ( %db, $data );
                                tie( %db, $env::dbm_file, $dir . '/' . $db,
                                    O_RDONLY, $env::dbm_mode );
                                $data
                                    = $this->decode_utf8(
                                    $db{ $this->encode_utf8($main::n) } )
                                    if ref tied %db;
                                untie %db;
                                if ( defined $data ) {
                                    $this->write_file(
                                        $current_dir . '/data/' . $db,
                                        \$data, 1 );
                                }
                            }
                        }
                    }
                }
            }
            $this->archives_gc($archives_dir);
        }
        elsif ( $main::rewind && $this->is_secure('rewind') ) {
            my $current_dir = $archives_dir . '/' . $main::rewind;
            if ( -d $current_dir ) {
                my $new_dir = $archives_dir . '/' . $this->time_id;
                $this->directory_copy( $current_dir, $filedir, 0,
                    [ '^\\.', '\\.(?:js|ssi|dat)$' ] );
                $this->directory_copy( $current_dir, $new_dir, 1 );
                $this->write_file( $new_dir . '/data/author', \$user_info,
                    1 );
                while ( my ( $id, $field ) = each %field::obj ) {
                    my $db = $field->db;
                    if (   defined $db
                        && $db
                        && $db ne 'pending'
                        && $field->input_enabled
                        && !$field->update_enabled
                        && !$this->is_reserved_field($field) )
                    {
                        my ($data);
                        $data
                            = $this->read_file( $current_dir . '/data/' . $db,
                            1 )
                            if -f $current_dir . '/data/' . $db;
                        if ( defined $data ) {
                            my (%db);
                            tie( %db, $env::dbm_file, $dir . '/' . $db,
                                O_RDWR, $env::dbm_mode );
                            $db{ $this->encode_utf8($main::n) }
                                = $this->encode_utf8($data)
                                if ref tied %db;
                            untie %db;
                            %{ $main::data{$id} } = $field->elements($data);
                        }
                    }
                }
            }
            $this->archives_gc($archives_dir);
        }
    }
}

sub archives_gc ($$) {
    my ( $this, $archives_dir ) = @_;
    if ( opendir( DIR, $archives_dir ) ) {
        my @dir = sort { $this->sort_by( \$a, \$b, 'descend' ) }
            grep( $_ !~ /^\./ && -d $archives_dir . '/' . $_, readdir(DIR) );
        closedir(DIR);
        if ( ( $setting::general{'rewindable'} + 1 ) < @dir ) {
            foreach my $n (
                ( $setting::general{'rewindable'} + 1 ) .. ( @dir - 1 ) )
            {
                rmtree $archives_dir . '/' . $dir[$n];
            }
        }
    }
}

sub new_record_number ($;$) {
    my ( $this, $count_flag ) = @_;
    my ( %ctime, $count, $nocount, $first_record, $n );
    $this->gc;

    #レコード数カウント
    $count = $nocount = 0;
    tie( %ctime, $env::dbm_file, "$default::db/$main::c/ctime", O_RDONLY,
        $env::dbm_mode );
    if ( ref tied %ctime ) {
        my %pending;
        tie( %pending, $env::dbm_file, "$default::db/$main::c/pending",
            O_RDONLY, $env::dbm_mode );
        my $first_record_ctime = 0;
        while ( my ( $n, $t ) = each %ctime ) {
            if ( !$first_record_ctime || $first_record_ctime > $t ) {
                $first_record       = $n;
                $first_record_ctime = $t;
            }
            $count++;
            $nocount++
                if ref tied %pending
                && $pending{ $this->encode_utf8($n) }
                && $this->decode_utf8( $pending{ $this->encode_utf8($n) } )
                =~ /^1/;
        }
        untie %pending;
    }
    untie %ctime;

    #レコード数制限オーバー
    if ( $count >= $setting::category{'LIMIT'} ) {

        #特殊なDB
        if ( defined $default::type && $default::type eq 'order' ) {
            my ( @categories, $name, $d );
            @categories = sort {
                $setting::category{$a}{'ORDER'}
                    <=> $setting::category{$b}{'ORDER'}
                    || $a <=> $b
                } grep( defined $_ && $_ !~ /[^0-9]/,
                keys %setting::category );
            $name = $setting::category{ $categories[$#categories] }{'name'};
            $main::c = $categories[$#categories] + 1;
            $d       = $1 if $name =~ s/([0-9]+)$//;
            $d       = 1 if $d == 0;
            $this->mk_category( $main::c, $name . $d );

  #最も古いレコードを消去して新しいレコードを追加する
        }
        elsif ( $setting::category{'ADD'} eq 'add' ) {

            #データ削除
            $this->delete_record( $main::c, $first_record );

            #レコード数減数
            $count--;

  #新しいカテゴリーを作成して新しいレコードを追加する
        }
        elsif ( $setting::category{'ADD'} eq 'newcategory' ) {
            my ( $oname, $name, $d, $new_name, $new_c, @categories );
            $name = $oname = $setting::category{$main::c}{'name'};
            $d = $1 if $name =~ s/([0-9]+)$//;
            $d = 1  if !$d;
            @categories = sort {
                $setting::category{$a}{'ORDER'}
                    <=> $setting::category{$b}{'ORDER'}
                    || $a <=> $b
                } grep( defined $_ && $_ !~ /[^0-9]/,
                keys %setting::category );
        COUNT:
            while ( $count >= $setting::category{'LIMIT'} ) {
                $count = $nocount = 0;
                $d++;
                $new_name = $name . $d;
                $new_c    = '';
                foreach my $c (@categories) {
                    if (   ref $setting::category{$c}
                        && defined $setting::category{$c}{'name'}
                        && $setting::category{$c}{'name'} eq $new_name )
                    {
                        my (%ctime);
                        tie( %ctime, $env::dbm_file, "$default::db/$c/ctime",
                            O_RDONLY, $env::dbm_mode );
                        if ( ref tied %ctime ) {
                            my %pending;
                            tie( %pending, $env::dbm_file,
                                "$default::db/$c/pending", O_RDONLY,
                                $env::dbm_mode );
                            while ( my ($n) = each %ctime ) {
                                $count++;
                                $nocount++
                                    if ref tied %pending
                                    && $pending{ $this->encode_utf8($n) }
                                    && $this->decode_utf8(
                                    $pending{ $this->encode_utf8($n) } )
                                    =~ /^1/;
                            }
                            untie %pending;
                        }
                        untie %ctime;
                        if ( !$count || $count < $setting::category{'LIMIT'} )
                        {
                            $new_c = $c;
                            last COUNT;
                        }
                        $main::c = $c;
                        next COUNT;
                    }
                }
            }
            if ( defined $new_c && $new_c ) {
                $main::c = $new_c;
            }
            else {
                my $order = $setting::category{$main::c}{'ORDER'} + 1;
                $main::c = $this->new_number( \%setting::category, 1 );
                $this->mk_category( $main::c, $new_name, $order );
                $count = 0;
            }
            push(
                @{ $this->{'dialog'} },
                'レコード数が '
                    . $setting::category{'LIMIT'}
                    . ' 件以内に制限されているため、'
                    . $oname
                    . ' には書き込めません。'
                    . $new_name
                    . ' に書き込みます。'
            );

            #新しいレコードの書き込みを拒絶する
        }
        else {
            push(
                @{ $this->{'dialog'} },
                'このカテゴリーには書き込めません。レコード数が '
                    . $setting::category{'LIMIT'}
                    . ' 件以内に制限されています。'
            );
            $this->allocate_category;

        }

    }

    #レコードID
    $n = $this->new_record_id;
    $n = $this->make_record_id_db if !$n;

    #カウント記録
    if ( defined $count_flag && $count_flag ) {
        my (%category);
        tie(%category, $env::dbm_file,
            $default::preference_dir . '/category',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %category ) {
            $category{ $this->encode_utf8( $main::c . '_total' ) } = $count;
            $category{ $this->encode_utf8( $main::c . '_count' ) }
                = $count - $nocount;
            $setting::category{$main::c}{'total'}
                = $this->decode_utf8(
                $category{ $this->encode_utf8( $main::c . '_total' ) } )
                || 0;
            $setting::category{$main::c}{'count'}
                = $this->decode_utf8(
                $category{ $this->encode_utf8( $main::c . '_count' ) } )
                || 0;
        }
        untie %category;
    }
    return $n;
}

sub new_record_id ($) {
    my $this = shift;
    my ( $n, %record_id );
    tie( %record_id, $env::dbm_file, $default::db . '/record_id',
        O_RDONLY, $env::dbm_mode );
    if (   ref tied %record_id
        && defined $record_id{'last'}
        && $record_id{'last'} ne '' )
    {
        $n = $record_id{'last'} + 1;
    }
    untie %record_id;
    return $n;
}

sub save_record_id ($$$) {
    my ( $this, $c, $n ) = @_;
    my (%record_id);
    tie( %record_id, $env::dbm_file, $default::db . '/record_id',
        O_RDWR, $env::dbm_mode );
    if ( ref tied %record_id ) {
        $record_id{$n} = $c;
        $record_id{'last'} = $n
            if !defined $record_id{'last'} || $record_id{'last'} < $n;
    }
    untie %record_id;
}

sub make_record_id_db ($) {
    my $this = shift;
    my $n    = 0;
    my @categories
        = grep( defined $_ && $_ !~ /[^0-9]/, keys %setting::category );
    if ( @categories == 1 ) {
        my ( %ctime, %record_id, $c );
        $c = $categories[0];
        tie( %ctime, $env::dbm_file, "$default::db/$c/ctime", O_RDONLY,
            $env::dbm_mode );
        tie(%record_id, $env::dbm_file,
            $default::db . '/record_id',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %ctime && ref tied %record_id ) {
            while ( my ($num) = each %ctime ) {
                $n = $num if $n < $num;
                $record_id{$n} = $c;
            }
            $record_id{'last'} = $n;
        }
        untie %record_id;
        untie %ctime;
    }
    else {
        my (%record_id);
        foreach my $c (@categories) {
            my (%ctime);
            tie( %ctime, $env::dbm_file, "$default::db/$c/ctime", O_RDONLY,
                $env::dbm_mode );
            if ( ref tied %ctime ) {
                while ( my ($num) = each %ctime ) {
                    $n = $num if $n < $num;
                }
            }
            untie %ctime;
        }
        tie(%record_id, $env::dbm_file,
            $default::db . '/record_id',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        $record_id{'last'} = $n if ref tied %record_id;
        untie %record_id;
    }
    $n++;
    $this->write_file( $default::file . '/record_id_alias.dat',
        $default::db . '/record_id', 1 );
    return $n;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::table    = 1;    #テーブル設定読み込み
    $setting::page     = 1;    #ページ設定読み込み

    $setting::field_db_name = 'inputfield';    #フィールド設定DB
    $setting::field         = 2
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 2
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled
        = 'no'; #tag=タグのみ/all=全ての設定/no=タグをつけない

    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み
    $cookie::default_enabled
        = 1;    #ユーザー設定情報クッキー読み込み
    $cookie::name = 'INPUT';
    $cookie::path = $ENV{'SCRIPT_NAME'};

    #イメージCSS
    $setting::image_css = 'order-image.css'
        if $default::type && $default::type eq 'order';

    if ( $ENV{'QUERY_STRING'} ) {
        undef $main::a;
        undef $main::delete
            if $main::delete && !$cgi::input->referer_is_me(1);
    }
    elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' && !$cgi::input->referer_is_me )
    {
        undef $main::a;
        undef $main::delete;
    }
}

1;
