package SalesViewer;
require CMONOS::TableMaker::Viewer;
@ISA = qw(Viewer);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# 売り上げビューワモジュール
# SalesViewer.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-01-21
######################################################################
# ペンディング情報を非表示
sub set_pending_item_alert ($) {
    my $this = shift;
}

sub set_viewer ($) {
    my $this = shift;
    $setting::key = $setting::subkey
        if !ref $setting::page{$setting::key}
        && ref $setting::page{$setting::subkey};
}

######################################################################
# 表示フィールド取得
sub get_required_fields ($) {
    my $this = shift;
    $this->{'required_fields'}
        = ( $field::for{'order_info'} ) ? [ $field::for{'order_info'} ] : [];
}

######################################################################
# コンテンツタイプ
sub print_viewer_header ($) {
    my $this = shift;
    if ($main::type) {
        binmode STDOUT;
        $this->print_http_header(
            (   ( $main::type && $main::type eq 'tsv' )
                ? 'text/tab-separated-values'
                : 'text/comma-separated-values'
            ),
            0, 1
        );
    }
    else {
        $this->SUPER::print_viewer_header;
    }
    $this->{'u'} = $main::u;
    $main::u = 0;
}

# フッタ
sub print_viewer_footer ($) {
    my $this = shift;
    if ( !$main::type ) {
        $this->SUPER::print_viewer_footer;
    }
}

######################################################################
# コンテンツヘッダ
sub print_contents_header ($) {
    my $this = shift;
    $this->{'order_items'} = {};
}

######################################################################
# コンテンツフッタ
sub print_contents_footer ($) {
    my $this = shift;
    my (@order_items);
    $main::u = $this->{'u'};
    $main::ss
        = ( $main::ss
            && grep( $main::ss eq $_, 'name', 'total', 'price', 'quantity' ) )
        ? $main::ss
        : 'name';
    $main::sw = ( $main::sw && $main::sw eq 'ascend' ) ? 'ascend' : 'descend';

    if ( %{ $this->{'order_items'} } ) {
        @order_items = sort {
            $this->sort_by( \$this->{'order_items'}{$a}{$main::ss},
                \$this->{'order_items'}{$b}{$main::ss}, $main::sw )
                || $this->sort_by( \$a, \$b, $main::sw )
        } keys %{ $this->{'order_items'} };
    }
    $this->{'mcount'} = @order_items || 0;

    if ( !$main::type ) {

        #ツールボックス
        $this->print_toolbox_top;

        #前後ページへのジャンプ
        $this->print_page_jump_form;

        if ( $this->{'mcount'} ) {
            $this->{'Table'} = Table->new;
            if ( defined $setting::page{$setting::key}{'table'} ) {
                if (ref $table::obj{ $setting::page{$setting::key}{'table'} }
                    )
                {
                    %{ $this->{'Table'} }
                        = %{ $table::obj{ $setting::page{$setting::key}
                                {'table'} } };
                }
                elsif (
                    defined
                    $setting::table{ $setting::page{$setting::key}{'table'} }
                    {'setting'}
                    && $setting::table{ $setting::page{$setting::key}{'table'}
                    }{'setting'} )
                {
                    $this->{'Table'}->set(
                        $setting::table{ $setting::page{$setting::key}
                                {'table'} }{'setting'} );
                    $this->{'Table'}->{'name'}
                        = $setting::table{ $setting::page{$setting::key}
                            {'table'} }{'name'};
                }
            }

            $this->{'Table'}->set(
                'align0'  => 'left,left,right,right,right',
                'alignH'  => 'center',
                'valign0' => $this->{'cellValign'},
                'valignH' => 'middle',
                'tableid' => 'table-viewer'
            );

            #テーブル開始
            print '<div id="table-viewer-box">';
            print $this->{'Table'}->table;

            #テーブルヘッダ
            my $url = $cgi::path
                . $this->set_query( 'url',
                [ grep( $_ ne 'sw' && $_ ne 'ss', @setting::form ) ] );
            print $this->{'Table'}->tr;
            print $this->table_header_link( 'name',
                ( $setting::general{'itemname'} || '商品' ), $url );
            print $this->{'Table'}->th('オプション');
            print $this->table_header_link( 'price',    '価格', $url );
            print $this->table_header_link( 'quantity', '総数', $url );
            print $this->table_header_link( 'total',    '総額', $url );
            print $this->{'Table'}->_tr;
        }
    }
    else {
        $this->{'Table'} = Table->new;
        $this->{'Table'}->set_encoding;
    }
    my $total = 0;
    if ( $this->{'mcount'} ) {
        my $from  = ( $main::p || 0 ) * $main::u;
        my $to    = $from + $main::u;
        my $count = 0;
        foreach my $id (@order_items) {
            $total += $this->{'order_items'}{$id}{'total'};
            if ( $main::type
                || ( $main::u && $count >= $from && $count < $to ) )
            {
                my ( $url, $option )
                    = ( $id =~ /^(.*?)\x0b(.*)\Z/s )
                    ? ( $1, $2 )
                    : ( $id, '' );
                if ($main::type) {
                    print $this->{'Table'}->array_to_sv(
                        $main::type,
                        $this->{'order_items'}{$id}{'name'},
                        $this->full_path($url),
                        $option,
                        $this->{'order_items'}{$id}{'price'},
                        $this->{'order_items'}{$id}{'quantity'},
                        $this->{'order_items'}{$id}{'total'},
                    );
                }
                else {
                    print $this->{'Table'}->tr;
                    print $this->{'Table'}->td( '<a href="'
                            . $this->escape($url)
                            . '" target="_blank">'
                            . $this->{'order_items'}{$id}{'name'}
                            . '</a>' );
                    print $this->{'Table'}->td($option);
                    print $this->{'Table'}->td(
                        '&yen;'
                            . $this->digit(
                            $this->{'order_items'}{$id}{'price'}
                            )
                    );
                    print $this->{'Table'}->td(
                        $this->digit(
                            $this->{'order_items'}{$id}{'quantity'}
                        )
                    );
                    print $this->{'Table'}->td(
                        '&yen;'
                            . $this->digit(
                            $this->{'order_items'}{$id}{'total'}
                            )
                    );
                    print $this->{'Table'}->_tr;
                }
            }
        }
        continue {
            $count++;
        }
    }
    if ( !$main::type ) {

        if ( $this->{'mcount'} ) {

            #テーブル終了
            print $this->{'Table'}->_table;
            print '<p class="panel">合計: &yen;'
                . $this->digit($total) . '</p>';
            print '</div>';
            print join( '<br />', $this->dialog );

            #前後ページへのジャンプ
            $this->print_page_jump_form;
        }

        $this->print_toolbox_bottom;
        $this->print_download_form;
        $this->print_page_return_form;
    }
}

sub table_header_link ($$$$) {
    my ( $this, $id, $name, $url ) = @_;
    return $this->{'Table'}->th(
        '<a href="'
            . $this->escape(
            $url
                . $this->add_query(
                'url',
                {   'ss' => $id,
                    'sw' => (
                          ( $main::ss eq $id )
                        ? ( $main::sw eq 'descend' )
                                ? 'ascend'
                                : 'descend'
                        : $main::sw
                    )
                }
                )
            )
            . '" title="'
            . (
            ($default::english)
            ? 'sort this column in '
                . (
                  ( $main::ss eq $id )
                ? ( $main::sw eq 'descend' )
                        ? 'ascending'
                        : 'descending'
                : ( $main::sw eq 'descend' ) ? 'descending'
                :                              'ascending'
                )
                . ' order.'
            : 'この項目で'
                . ( ( $main::ss eq $id )
                ? ( $main::sw eq 'descend' )
                        ? '昇順▲'
                        : '降順▼'
                : ( $main::sw eq 'descend' ) ? '降順▼'
                :                              '昇順▲' )
                . 'にソートする'
            )
            . '">'
            . $name . '</a>'
            . ( ($default::english)
            ? ( $main::ss eq $id )
                    ? ( $main::sw eq 'descend' )
                        ? ' <span class="sort-mark">&uarr;</span>'
                        : ' <span class="sort-mark">&darr;</span>'
                    : ''
            : ( $main::ss eq $id ) ? ( $main::sw eq 'descend' )
                    ? ' <span class="sort-mark">▼</span>'
                    : ' <span class="sort-mark">▲</span>'
                : '' ),
            ( ( $main::ss eq $id ) ? { 'class' => 'sorted' } : {} )
    );
}

######################################################################
# レコード
sub print_record ($$$) {
    my ( $this, $c, $n ) = @_;
    if ( !ref tied %{ $this->{'DB'}{$c}{'order'} } ) {
        tie( %{ $this->{'DB'}{$c}{'order'} },
            $env::dbm_file, "$default::db/$c/order", O_RDONLY,
            $env::dbm_mode );
    }
    my $data = $this->{'DB'}{$c}{'order'}{$n};
    if ($data) {
        $data =~ s/^(.*?)\x0A//;
        while ( $data =~ /^(.*)$/mg ) {
            next if !$1;
            my %item_data = ();
            $cgi::Session->read_data( \%item_data, $1 );
            my $id
                = $this->item_path_fix( $item_data{'path'} )
                . ( ( $item_data{'anchor'} ) ? $item_data{'anchor'} : '' )
                . (
                (   defined $item_data{'option'}
                        && $item_data{'option'} ne ''
                ) ? "\x0b" . $item_data{'option'} : ''
                );
            my $price
                = ( $item_data{'amount'} ) ? $item_data{'amount'}
                : ( $item_data{'optionprice'} )
                ? ( $item_data{'price'} + $item_data{'optionprice'} )
                : $item_data{'price'};
            $this->{'order_items'}{$id}{'price'} = $price || 0;
            $this->{'order_items'}{$id}{'total'}
                += ( $price || 0 ) * ( $item_data{'quantity'} || 1 );
            $this->{'order_items'}{$id}{'quantity'}
                += $item_data{'quantity'} || 0;
            $this->{'order_items'}{$id}{'name'} = $item_data{'name'}
                . (
                (          $item_data{'key'}
                        && $item_data{'key'} ne $item_data{'name'}
                ) ? ' [' . $item_data{'key'} . ']' : ''
                )
                . ( ( $item_data{'digitalcontent'} )
                ? ' (' . $item_data{'digitalcontent'} . ')'
                : '' );
        }
    }
}

sub item_path_fix ($$) {
    my ( $this, $path ) = @_;
    if ( $path =~ m!/start\.cgi! ) {
        $path
            =~ s/(&|\?)m=(?:TableViewer|TileViewer|Gate|DetailGate|GMapViewer|KMLViewer)(&|$)/$1m=DetailViewer$2/s;
    }
    return $path;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( $default::type && $default::type eq 'order' ) {
        no warnings qw(once);

        $setting::field_style_disabled = 2
            ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
        $setting::field_tag_enabled = 'no'
            ;   #tag=タグのみ/all=全ての設定/no=タグをつけない

        #設定種キー設定
        $setting::key    = 'sales';     #ページ設定キー
        $setting::subkey = 'viewer';    #ページ設定キー

        #デフォルトキー
        $main::k = 'sales' if !defined $main::k || !$main::k;

        #設定種キー設定
        $setting::security_key
            = 'tools';    #デフォルトセキュリティキー

        #必須フォーム
        @setting::form = (
            'm',      'c',   'type', 'ss', 'sw', 's',
            'w',      'f',   'u',    'fv', 'q',  'and',
            'search', 'mod', 'uni'
        );

        #クラス登録
        Common::class_register( 'sales', 'SalesViewer' );
    }
}

1;
