package DetailVariation;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
use Fcntl qw(:flock);
######################################################################
# 詳細表示バリエーション数変更モジュール
# DetailVariation.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my ( $valid_flag, $error_flag );
    $default::detail_variation = 1 if !$default::detail_variation;

    #入力チェック
    if ($main::variation) {
        if ( $this->is_nan($main::variation) ) {
            push( @{ $this->{'dialog'} }, '不正な入力です。' );
            $error_flag = 1;
        }
        elsif ( $main::variation != $default::detail_variation ) {
            $valid_flag = 1;
        }
    }

    #detail.pl書き換え
    if ( $valid_flag && !$error_flag ) {
        local (*FILE);
        my ( $data, $default_path );
        $default_path = './default.pl';
        $data = $this->read_file( $default_path, 1 );
        unless ( $data
            =~ s/^[\x20\x09]*\$detail_variation[\x20\x09]*=[^;]*;/\$detail_variation = $main::variation;/gm
            )
        {
            $data =~ s/^1;/\$detail_variation = $main::variation;\x0A\x0A1;/m;
        }
        if ( $this->write_file( $default_path, \$data, 1 ) ) {
            push(
                @{ $this->{'dialog'} },
                '詳細表示バリエーション数を更新しました。'
            );
            $default::detail_variation = $main::variation;
            undef $main::variation;
        }
        else {
            push(
                @{ $this->{'dialog'} },
                '詳細表示バリエーション数の更新に失敗しました。'
            );
        }
    }
    elsif ( defined $error_flag && $error_flag ) {
        push(
            @{ $this->{'dialog'} },
            '詳細表示バリエーション数の更新に失敗しました。'
        );
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>詳細表示バリエーション数変更</h1>';

    print $this->form_start(
        'key'    => 'tools',
        'name'   => 'input',
        'method' => 'post',
        'onsubmit' =>
            'return confirm(\'この操作は取り消せません。本当に変更しますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
        'required' => \@setting::form
    );
    print '<fieldset class="submit"><select name="variation">';
    foreach ( 1 .. 10 ) {
        print '<option value="'
            . $_ . '"'
            . ( ( $default::detail_variation == $_ )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $_
            . '</option>';
    }
    print '</select>';
    print '<input type="submit" value="変更" />';
    print '</fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( '00t1', 'DetailVariation' );

    #メニュー登録
    $setting::jump_menu{'00t1'} = '詳細表示バリエーション数';

}

1;
