package HmlPreferenceShare;
require CMONOS::CGI_Lib::Tools::PreferenceShare;
@ISA = qw(PreferenceShare);
use strict;
use utf8;
######################################################################
# HomePageMakerLite 設定の共有モジュール
# HmPreferenceShare.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-11-14
######################################################################
sub get_shareable_db_info ($$) {
    my ( $this, $shareable_db ) = @_;
    my $default_path
        = ( $env::user_default_dir || $env::default_dir )
        . ( ( $default::type && $default::type eq 'order' )
        ? '/order'
        : '/tablemaker' );
    $this->set_dir( $default_path . '/field' );
    %$shareable_db = (
        'general' => {
            'pref_path' => $default::preference_dir . '/general',
            'bak_path'  => $default_path . '/general',
            'pref_type' => '一般設定',
            'pref_id'   => '0000'
        },
        'security' => {
            'pref_path' => $default::preference_dir . '/security',
            'bak_path'  => $default_path . '/security',
            'pref_type' => 'アクセス権設定',
            'pref_id'   => '0001'
        },
        'category' => {
            'pref_path' => $default::preference_dir . '/category',
            'bak_path'  => $default_path . '/category',
            'pref_type' => 'カテゴリー設定',
            'pref_id'   => '00t0'
        },
        'page' => {
            'pref_path' => $default::preference_dir . '/page',
            'bak_path'  => $default_path . '/page',
            'pref_type' => 'ページレイアウト設定',
            'pref_id'   => 't001'
        },
        'inputfield' => {
            'pref_path' => $default::field_pref_dir . '/inputfield',
            'bak_path'  => $default_path . '/field/inputfield',
            'pref_type' => '入力フィールド設定',
            'pref_id'   => 't100'
        },
        'inquiryfield' => {
            'pref_path' => $default::field_pref_dir . '/inquiryfield',
            'bak_path'  => $default_path . '/field/inquiryfield',
            'pref_type' => '問い合わせフィールド設定',
            'pref_id'   => 't101'
        },
        'thanks' => {
            'pref_path' => $default::preference_dir . '/thanks',
            'bak_path'  => $default_path . '/thanks',
            'pref_type' => '入力お礼設定',
            'pref_id'   => 't200'
        },
        'mail' => {
            'pref_path' => $default::preference_dir . '/mail',
            'bak_path'  => $default_path . '/mail',
            'pref_type' => 'メール配信設定',
            'pref_id'   => 't201'
        }
    );
    if ( $default::type && $default::type eq 'order' ) {
        $shareable_db->{'terms'} = {
            'pref_path' => $default::preference_dir . '/terms',
            'bak_path'  => $default_path . '/terms',
            'pref_type' => '支払い方法・送料設定',
            'pref_id'   => 'c210'
        };
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ($env::default_dir) {

        #クラス登録
        Common::class_register( 'xxbs', 'HmlPreferenceShare' );

        #メニュー登録
        $setting::jump_menu{'xxbs'}              = '設定の共有';
        $setting::sub_jump_menu{'share'}{'xxbs'} = '設定の共有';
        $setting::selected_jump_menu{'xxbs'}     = 'xxbs';
    }
}

1;
