package TsvViewer;
require CMONOS::TableMaker::Viewer;
@ISA = qw(Viewer);
use strict;
use utf8;
######################################################################
# tsvダウンロードモジュール
# TsvViewer.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-08-17
######################################################################
# コンテンツタイプ
sub print_viewer_header ($) {
    my $this = shift;
    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';
    my ($agent);
    $agent = ( $ENV{'HTTP_USER_AGENT'} ) ? $ENV{'HTTP_USER_AGENT'} : '';
    if ( $agent =~ /win/i ) {
        $this->{'jcode'} = 'sjis';
        $this->{'\n'}    = "\x0D\x0A";
    }
    elsif ( $agent =~ /mac/i ) {
        $this->{'jcode'} = 'sjis';
        $this->{'\n'}    = "\x0D";
    }
    else {
        $this->{'jcode'} = '';
        $this->{'\n'}    = "\x0A";
    }

    $main::u = 0;
    binmode STDOUT;

    #$this->print_http_header('text/tab-separated-values');
    $this->print_http_header('application/tab-separated-values');
}

######################################################################
# ページフッタ
sub print_viewer_footer ($) {
    my $this = shift;
}

######################################################################
# レコード
sub print_record ($$$) {
    my ( $this, $c, $n ) = @_;
    my ( $col, $jcode );
    $jcode = $this->{'jcode'} if $this->{'jcode'};
    $col = 0;
    foreach ( @{ $this->{'required_fields'} } ) {
        next
            unless ref $field::obj{$_}
            && $field::obj{$_}->format_for_text_enabled;
        my ( $db, $v );
        $db = $field::obj{$_}->db;
        if ( defined $db && $db ) {
            unless ( ref tied %{ $this->{'DB'}{$c}{$db} } ) {
                tie( %{ $this->{'DB'}{$c}{$db} },
                    $env::dbm_file, "$default::db/$c/$db", O_RDONLY,
                    $env::dbm_mode );
            }
            $v = $field::obj{$_}->format_for_text(
                $this->decode_utf8(
                    $this->{'DB'}{$c}{$db}{ $this->encode_utf8($n) }
                ),
                "$default::file/$c/$n",
                $c, $n
            );
        }
        else {
            $v = $field::obj{$_}->format_for_text('');
        }
        $v =~ s/\t/   /gs;
        $v =~ s/(\x0D\x0A|\x0D|\x0A|<br \/>)/\x0B/gs;
        $this->jcode_convert( \$v, $jcode, 'utf8' ) if $jcode;
        utf8::encode($v) if utf8::is_utf8($v);
        print "\x09" if defined $col && $col;
        print $v;
        undef $v;
        $col++;
    }

    print $this->{'\n'};
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定種キー設定
    $setting::key = 'none';    #ページ設定キー

    #デフォルトキー
    $main::k = 'tsv' if !defined $main::k || !$main::k;

    #クラス登録
    Common::class_register( 'tsv', 'TsvViewer' );
}

1;
