package Viewer;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
use utf8;
######################################################################
# ビューワモジュール
# Viewer.pm ver1.2.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2016-06-27
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';
    if ( $default::type && $default::type eq 'order' ) {
        $this->gc_download_directory;
        push( @setting::form, 'order_item' );
    }
    $this->reset_access_counter( $setting::general{'counterReset'} );

    #---------------------------------------------------------------------
    #承認待ち項目警告
    $this->set_pending_item_alert
        if !defined $main::c && $this->is_secure('tools');

    #---------------------------------------------------------------------
    #特殊フィールド処理
    if (   defined $main::c
        && $main::c ne ''
        && defined $main::n
        && $main::n ne ''
        && -d $default::db . '/' . $main::c
        && defined $main::id
        && $main::id ne ''
        && ref $field::obj{$main::id}
        && $field::obj{$main::id}->update_enabled
        && $field::obj{$main::id}->is_secure_user_for_update )
    {
        $field::obj{$main::id}->update;
        @main::c
            = (@main::ct)
            ? @main::ct
            : ($main::c)
            ;    #特殊フィールド用の条件から元の条件を復元
        undef $main::c;
    }

    #---------------------------------------------------------------------
    #条件の調整
    push( @main::f, $main::f ) if !@main::f && defined $main::f && $main::f;
    push( @main::c, $main::c ) if !@main::c && defined $main::c && $main::c;
    undef $main::f;
    undef $main::c;

    $main::mod = $main::m;

    #特別な前処理
    $this->set_viewer;
    $this->open_filehandle;

    #カテゴリー設定読み込み
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;

    #カテゴリー指定がない場合、最後のカテゴリーを指定
    if ( !@main::c ) {
        if ( $setting::category{'DEFAULT'} ) {
            push(
                @main::c,
                (   ( ref $setting::category{'DEFAULT'} )
                    ? @{ $setting::category{'DEFAULT'} }
                    : $setting::category{'DEFAULT'}
                )
            );
        }
        else {
            my @g_order
                = sort { $a <=> $b } keys %{ $setting::category{'ORDER'} };
            my $c
                = (@g_order)
                ? $setting::category{'ORDER'}{ $g_order[$#g_order] }
                : 1;
            push( @main::c, ( ($c) ? $c : 1 ) );
        }
    }

    $main::p = $main::pnum - 1 if $main::pnum && !$this->is_nan($main::pnum);
    $main::p = 0
        if !defined $main::p || $this->is_nan($main::p) || $main::p < 0;

    #---------------------------------------------------------------------
    #検索
    $this->sort_and_search;

    #---------------------------------------------------------------------
    #書き出し
    #表示件数＆ソート調整
    $setting::page{'u'} = 20 if !$setting::page{'u'};
    $main::u = $main::uni if $main::uni;
    if ( $setting::page{'uStatic'} || $this->is_nan($main::u) ) {
        $main::u = $setting::page{'u'};
    }
    elsif ($setting::page{'uLimit'}
        && $main::u
        && $main::u > $setting::page{'uLimit'} )
    {
        $main::u = $setting::page{'uLimit'};
    }
    $main::u = $setting::page{'u'} if !$main::u;
    $main::w = $field::SORTORDER || 'ascend'
        if !defined $main::w || $main::w eq '';

    #フィールド
    $this->get_required_fields;

    #デフォルトか
    $this->query_optimize;

    #前後ページ登録
    $this->set_related_links;

    #ページヘッダ
    $this->set_last_modified( $setting::general{'mtime'} )
        if $setting::general{'lastModifiedHeaderEnabled'};
    $this->print_viewer_header;

    #コンテンツヘッダ
    $this->print_contents_header;

    no warnings qw(numeric);
    my ( $no, $count, $from, $to );
    $from  = $main::p * $main::u;
    $to    = $from + $main::u;
    $count = 0;
    foreach $no (
        sort {
            $this->sort_by( \$this->{'match'}{$b}, \$this->{'match'}{$a} )
                || $this->sort_by( \$this->{'sort'}{$a},
                \$this->{'sort'}{$b}, $main::w )
                || $a <=> $b
                || $a cmp $b
        } keys %{ $this->{'sort'} }
        )
    {
        next if $main::u && $count < $from;
        last if $main::u && $count >= $to;

        my ( $n, $c ) = split( /\@/, $no );
        $this->print_record( $c, $n );

    }
    continue {
        $count++;
    }

    #DBM接続解除
    $this->untie_all_dbm;

    #コンテンツフッタ
    $this->print_contents_footer;

    #ページフッタ
    $this->print_viewer_footer;

    $this->close_filehandle;
}

sub set_viewer ($) {
    my $this = shift;
    return;
}

sub open_filehandle ($) {
    my $this = shift;
    $this->{'filehandle'} = \*STDOUT;
    return;
}

sub close_filehandle ($) {
    my $this = shift;
    return;
}

######################################################################
# 表示フィールド取得
sub get_required_fields ($) {
    my $this = shift;
    return if ref $this->{'required_fields'} eq 'ARRAY';
    $this->{'required_fields'} = [];
    $this->{'revForm'}         = 1
        if ( !@main::f || grep( $_ eq 'r', @main::f ) || $main::rev_mode )
        && $this->is_secure('revise');
    @main::f = grep( ref $field::obj{$_}, @main::f );
    if ( @main::f && !$main::all_fields ) {
        foreach my $id (
            sort { $field::obj{$a}->{'ORDER'} <=> $field::obj{$b}->{'ORDER'} }
            @main::f
            )
        {
            if ( !$field::obj{$id}->{'Hidden'}
                && (   $field::obj{$id}->{'Open'}
                    || $this->is_secure('secret') )
                && !grep( $_ eq $id, @{ $this->{'required_fields'} } ) )
            {
                push( @{ $this->{'required_fields'} }, $id );
                $this->set_field_setting($id);
            }
        }
    }
    else {
        foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
            my $id = $field::ORDER{$i};
            if (   ref $field::obj{$id}
                && !$field::obj{$id}->{'Hidden'}
                && ( $field::obj{$id}->{'Default'} || $main::all_fields )
                && (   $field::obj{$id}->{'Open'}
                    || $this->is_secure('secret') )
                && !grep( $_ eq $id, @{ $this->{'required_fields'} } ) )
            {
                push( @{ $this->{'required_fields'} }, $id );
                $this->set_field_setting($id);
            }
        }
    }
    @main::f = @{ $this->{'required_fields'} };
    push( @main::f, 'r' ) if defined $this->{'revForm'} && $this->{'revForm'};
}

sub get_required_fields_for_template ($) {
    my $this = shift;
    return
        if ref $this->{'required_fields'} && @{ $this->{'required_fields'} };
    $this->{'required_fields'} = [];

    #テンプレートの読み込み
    if ( defined $setting::page{$setting::key}{'template'}
        && $setting::page{$setting::key}{'template'} ne '' )
    {
        if ( !ref $this->{'template'} ) {
            require CMONOS::CGI_Lib::Template;
            $this->{'template'} = Template->new;
        }
        $this->{'template'}->set(
            'field_style_disabled' => $setting::field_style_disabled,
            'field_tag_enabled'    => $setting::field_tag_enabled
        );
        my @fields = $this->{'template'}
            ->template_parser( \$setting::page{$setting::key}{'template'} );
        if (@fields) {
            foreach my $id (@fields) {
                if ( ref $field::obj{$id} ) {
                    if (!$field::obj{$id}->{'Hidden'}
                        && (   $field::obj{$id}->{'Open'}
                            || $this->is_secure('secret') )
                        )
                    {
                        push( @{ $this->{'required_fields'} }, $id );
                    }
                    else {
                        $field::obj{$id}->disabled;
                    }
                }
            }
            $setting::page{$setting::key}{'template'} = $this->{'template'}
                ->deco( $setting::page{$setting::key}{'template'} );
            $this->{'has_template'} = 1;
        }
    }

    #デフォルト項目のみ表示
    if ( !$this->{'has_template'} ) {
        foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
            my $id = $field::ORDER{$i};
            push( @{ $this->{'required_fields'} }, $id )
                if ref $field::obj{$id}
                && !$field::obj{$id}->{'Hidden'}
                && $field::obj{$id}->{'Default'}
                && ( $field::obj{$id}->{'Open'}
                || $this->is_secure('secret') )
                && !grep( $_ eq $id, @{ $this->{'required_fields'} } );
        }
    }

    return $this;
}

######################################################################
# フィールド設定
sub set_field_setting ($$) {
    my ( $this, $id ) = @_;
}

######################################################################
# コンテンツヘッダ
sub print_contents_header ($) {
    my $this = shift;
}

######################################################################
# コンテンツフッタ
sub print_contents_footer ($) {
    my $this = shift;
}

######################################################################
# 新着アイコン取得
sub new_item_icon ($$$) {
    my ( $this, $c, $n ) = @_;
    $n = $this->encode_utf8($n);
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    if ( $setting::page{'newIconLimit'} ) {
        unless ( ref tied %{ $this->{'DB'}{$c}{'ctime'} } ) {
            tie( %{ $this->{'DB'}{$c}{'ctime'} },
                $env::dbm_file, "$default::db/$c/ctime", O_RDONLY,
                $env::dbm_mode );
        }
        my $ctime = $this->{'DB'}{$c}{'ctime'}{$n};
        if ( $ctime
            && time - $ctime < 86400 * $setting::page{'newIconLimit'} )
        {
            my $title
                = ( $setting::page{'newIconAlt'} )
                ? $setting::page{'newIconAlt'}
                : (
                $setting::deco{'new'}{ $setting::page{'newIcon'} }{'alt'} )
                ? $setting::deco{'new'}{ $setting::page{'newIcon'} }{'alt'}
                : 'NEW!';
            if (   $setting::page{'newIcon'}
                && $setting::deco{'new'}{ $setting::page{'newIcon'} }{'width'}
                )
            {
                return ' '
                    . $cgi::Image->image_tag(
                    $env::image_dir . '/new/'
                        . $setting::deco{'new'}{ $setting::page{'newIcon'} }
                        {'name'},
                    $setting::deco{'new'}{ $setting::page{'newIcon'} }
                        {'width'},
                    $setting::deco{'new'}{ $setting::page{'newIcon'} }
                        {'height'},
                    0,
                    $title,
                    'class="new-item-icon"',
                    '',
                    '',
                    $cgi::output,
                    $cgi::output_option
                    );
            }
            else {
                return ' <span class="new-item-icon">' . $title . '</span>';
            }
        }
    }
    if ( $setting::page{'upIconLimit'} ) {
        unless ( ref tied %{ $this->{'DB'}{$c}{'mtime'} } ) {
            tie( %{ $this->{'DB'}{$c}{'mtime'} },
                $env::dbm_file, "$default::db/$c/mtime", O_RDONLY,
                $env::dbm_mode );
        }
        my $mtime = $this->{'DB'}{$c}{'mtime'}{$n};
        if ( $mtime && time - $mtime < 86400 * $setting::page{'upIconLimit'} )
        {
            my $title
                = ( $setting::page{'upIconAlt'} )
                ? $setting::page{'upIconAlt'}
                : ( $setting::deco{'new'}{ $setting::page{'upIcon'} }{'alt'} )
                ? $setting::deco{'new'}{ $setting::page{'upIcon'} }{'alt'}
                : 'UP!';
            if (   $setting::page{'upIcon'}
                && $setting::deco{'new'}{ $setting::page{'upIcon'} }{'width'}
                )
            {
                return ' '
                    . $cgi::Image->image_tag(
                    $env::image_dir . '/new/'
                        . $setting::deco{'new'}{ $setting::page{'upIcon'} }
                        {'name'},
                    $setting::deco{'new'}{ $setting::page{'upIcon'} }
                        {'width'},
                    $setting::deco{'new'}{ $setting::page{'upIcon'} }
                        {'height'},
                    0,
                    $title,
                    'class="up-item-icon"',
                    '',
                    '',
                    $cgi::output,
                    $cgi::output_option
                    );
            }
            else {
                return ' <span class="up-item-icon">' . $title . '</span>';
            }
        }
    }
    return '';
}

######################################################################
# 前後ページへのリンク
sub set_related_links ($) {
    my $this = shift;
    $this->set_link_rel( { 'index' => { 'href' => $cgi::path } } );
    return if $main::u > $this->{'mcount'};
    my $url = $cgi::path
        . $this->set_query( 'url', [ grep( $_ ne 'mod', @setting::form ) ] );
    if ($main::p) {
        $this->set_link_rel( { 'start' => { 'href' => $url } } );
        $this->set_link_rel(
            {   'prev' => {
                    'href' => $url
                        . $this->amp_escape(
                        $this->add_query(
                            'url', { 'p' => ( $main::p - 1 ) }
                        )
                        )
                }
            }
        );
    }
    if (   $this->{'mcount'}
        && $this->{'mcount'} > $main::u * ( $main::p + 1 ) )
    {
        $this->set_link_rel(
            {   'next' => {
                    'href' => $url
                        . $this->amp_escape(
                        $this->add_query(
                            'url', { 'p' => ( $main::p + 1 ) }
                        )
                        )
                }
            }
        );
    }
}

sub print_page_jump_form ($) {
    my $this = shift;
    if ( defined $this->{'PageJumpForm'} && $this->{'PageJumpForm'} ) {
        print $this->{'PageJumpForm'};
        return;
    }

    my ( $prev, $next, $to, $form_flag, @queries );
    $prev = $main::p - 1;
    $next = $main::p + 1;
    $this->{'mcount'} = 0 if !$this->{'mcount'};

    #return if !$setting::page{'pageinfo'} && $this->{'mcount'} <= $main::u;

    @queries = grep( $_ ne 'mod', @setting::form );
    if ( $setting::general{'postMethod'} ) {
        $this->{'PageJumpForm'} = $this->form_start(
            'key'      => $setting::security_key,
            'name'     => 'jump',
            'required' => \@queries
        );
        $form_flag = 1;
    }
    else {
        $form_flag = 0;
    }

    $this->{'PageJumpForm'} .= '<ul class="pager">';

    if ( $prev >= 0 ) {
        $this->{'PageJumpForm'} .= '<li class="prev">';
        if ($form_flag) {
            $this->{'PageJumpForm'} .= $cgi::Deco->submit_button(
                'prev',
                $setting::page{'prevButton'},
                ( ($default::english) ? 'Prev' : '前のページ' ),
                '',
                ( ($prev) ? { 'p' => $prev } : {} )
            );
        }
        else {
            $this->{'PageJumpForm'} .= $cgi::Deco->button(
                'prev',
                $setting::page{'prevButton'},
                $cgi::path
                    . $this->set_query( 'url', \@queries )
                    . (
                    ($prev)
                    ? $this->add_query( 'url', { 'p' => $prev } )
                    : ''
                    ),
                ( ($default::english) ? 'Prev' : '前のページ' )
            );
        }
        $this->{'PageJumpForm'} .= '</li>';
    }

    $to = $main::u * $next;
    $to = $this->{'mcount'} if $to > $this->{'mcount'};
    if (   $form_flag
        || $setting::page{'pageinfo'}
        || $this->{'mcount'} <= $main::u )
    {
        my $from = $main::u * $main::p;
        $from += 1 if $this->{'mcount'};
        $this->{'PageJumpForm'}
            .= '<li class="info">'
            . $from . ' - '
            . $to . ' / '
            . $this->{'mcount'} . '</li>';
    }
    else {
        my $p = $main::p + 1;
        my $max
            = ( $setting::page{'pagelistmax'} )
            ? $setting::page{'pagelistmax'}
            : 12;
        my $margin
            = ( $setting::page{'pagelistmargin'} )
            ? $setting::page{'pagelistmargin'}
            : 2;
        my $total = int( $this->{'mcount'} / $main::u + 0.9999 );
        $max = 7 if $max && $max < 7;
        $margin = int( ( $max - 5 ) / 2 ) if $max - $margin * 2 - 5 < 0;
        $margin = 1 if $margin < 1;
        my $start_page
            = ( $p - $margin <= $total - $max + 3 )
            ? ( $p - $margin > 3 )
                ? $p - $margin
                : 3
            : $total - $max + 3;
        my $end_page = $start_page + $max - 5;
        my $omission = 0;

        foreach my $page ( 1 .. $total ) {
            if (( $max && $max < $total && $page > 1 && $page < $total )
                && (   ( $p > $margin + 3 && $page < $start_page )
                    || ( $end_page < $page && $end_page < $total - 2 ) )
                )
            {
                $omission = 1;
                next;
            }
            if ($omission) {
                $this->{'PageJumpForm'} .= '<li class="omission">...</li>';
                $omission = 0;
            }
            if ( $page == $p ) {
                $this->{'PageJumpForm'}
                    .= '<li class="here">' . $page . '</li>';
            }
            else {
                $this->{'PageJumpForm'}
                    .= '<li><a href="./start.cgi'
                    . $this->set_query( 'url', \@queries )
                    . ( ( $page && $page > 1 )
                    ? $this->add_query( 'url', { 'p' => ( $page - 1 ) } )
                    : '' )
                    . '">'
                    . $page
                    . '</a></li>';
            }
        }
        $this->{'PageJumpForm'} .= '<li class="manual">'
            . $this->form_start(
            'key'      => $setting::security_key,
            'name'     => 'jump',
            'required' => \@queries
            );
        $this->{'PageJumpForm'}
            .= '<input type="text" size="2" name="pnum" title="'
            . ( ($default::english)
            ? 'Type return key'
            : 'ページ番号を入力しリターンキーで移動します。'
            ) . '" />';
        $this->{'PageJumpForm'} .= '</form></li>';
    }

    unless ( !$this->{'mcount'} || $this->{'mcount'} <= $to ) {
        $this->{'PageJumpForm'} .= '<li class="next">';
        if ($form_flag) {
            $this->{'PageJumpForm'} .= $cgi::Deco->submit_button(
                'next',
                $setting::page{'nextButton'},
                ( ($default::english) ? 'Next' : '次のページ' ),
                '', { 'p' => $next }
            );
        }
        else {
            $this->{'PageJumpForm'} .= $cgi::Deco->button(
                'next',
                $setting::page{'nextButton'},
                $cgi::path
                    . $this->set_query( 'url', \@queries )
                    . $this->add_query( 'url', { 'p' => $next } ),
                ( ($default::english) ? 'Next' : '次のページ' )
            );
        }
        $this->{'PageJumpForm'} .= '</li>';
    }

    $this->{'PageJumpForm'} .= '</ul>';
    $this->{'PageJumpForm'} .= '</form>' if $form_flag;
    print $this->{'PageJumpForm'};
}

######################################################################
# ダウンロードフォーム
sub print_download_form ($) {
    my $this = shift;
    return if !$this->{'mcount'};
    my $filename = $default::id || 'exported';
    $filename =~ s/^_//;
    my @form = grep( $_ ne 'k' && $_ ne 'm' && $_ ne 'type', @setting::form );

    if (   $default::type
        && $default::type eq 'order'
        && $this->is_secure('tools') )
    {
        print $this->form_start(
            'key'      => $setting::security_key,
            'name'     => 'order-itemlist-form',
            'id'       => 'order-itemlist-form',
            'class'    => 'panel',
            'required' => \@form
        );
        print '<input type="hidden" name="m" value="SalesViewer" />';
        print
            '<select name="type" id="type" onchange="cmonos.form.item(this.form).field(this).appendDownloadPathByValue({\'csv\':\''
            . $filename
            . '_items.csv\',\'tsv\':\''
            . $filename
            . '_items.tsv\'})">';
        print '<option value="">このウィンドウに</option>';
        print
            '<option value="csv">カンマ区切りテキスト(csv) で</option>';
        print '<option value="tsv">タブ区切りテキスト で</option>';
        print '</select><input type="submit" value="'
            . ( $setting::general{'itemname'} || '商品' )
            . 'ごとの売り上げを表示する" /></form>';
    }
    return if !$setting::page{'download'};

    $filename .= '_data';
    print $this->form_start(
        'key'      => $setting::security_key,
        'name'     => 'tm-download-form',
        'id'       => 'tm-download-form',
        'class'    => 'panel',
        'path'     => '/.dl/' . $filename . '.csv',
        'required' => \@form
    );
    print
        '<select name="m" id="m" onchange="cmonos.form.item(this.form).field(this).appendDownloadPathByValue({\'CsvViewer\':\''
        . $filename
        . '.csv\',\'TsvViewer\':\''
        . $filename
        . '.tsv\',\'VCardViewer\':\''
        . $filename
        . '.vcf\',\'VCard2Viewer\':\''
        . $filename
        . '.vcf\'})">';
    print '<option value="CsvViewer"'
        . ( ( defined $main::m && $main::m eq 'CsvViewer' )
        ? ' selected="selected"'
        : '' )
        . '>'
        . ( ($default::english) ? 'Comma-Separated-Values (csv)'
        : 'カンマ区切りテキスト(csv)' )
        . '</option>';
    print '<option value="TsvViewer"'
        . ( ( defined $main::m && $main::m eq 'TsvViewer' )
        ? ' selected="selected"'
        : '' )
        . '>'
        . ( ($default::english) ? 'Tab-Separated-Values'
        : 'タブ区切りテキスト' )
        . '</option>';
    if ( defined $setting::page{'vcard'} && $setting::page{'vcard'} ) {
        print '<option value="VCardViewer"'
            . ( ( defined $main::m && $main::m eq 'VCardViewer' )
            ? ' selected="selected"'
            : '' )
            . '>'
            . ( ($default::english) ? 'vCard (vcf)' : 'vCard 形式(vcf)' )
            . '</option>';
        print '<option value="VCard2Viewer"'
            . ( ( defined $main::m && $main::m eq 'VCard2Viewer' )
            ? ' selected="selected"'
            : '' )
            . '>'
            . (
            ($default::english) ? 'vCard2.1 (vcf)' : 'vCard2.1 形式(vcf)' )
            . '</option>';
    }
    print '</select><input type="submit" name="download" value="'
        . ( ($default::english) ? 'Download' : 'ダウンロード' )
        . '" />';
    print
        ' <label><input type="checkbox" name="all_fields" value="1" checked="checked" />'
        . ( ($default::english) ? 'All fields.' : '全項目' )
        . '</label></form>';
}

sub set_title_link ($$$) {
    my ( $this, $c, $n ) = @_;
    return
           if !$setting::page{'linkedTitle'}
        || !$field::for{'title'}
        || !ref $field::obj{ $field::for{'title'} };
    my ($ct);
    if ( @main::c && ( @main::c > 1 || $main::c[0] =~ /,/ ) ) {
        foreach (@main::c) {
            $ct .= '&ct=' . $_;
        }
    }
    $field::obj{ $field::for{'title'} }->set_link(
        {   'href' => $cgi::path
                . '?m=DetailViewer'
                . (
                ( $setting::page{'detailViewerNo'} )
                ? '&dn=' . $setting::page{'detailViewerNo'}
                : ''
                )
                . ( ( defined $c ) ? '&c=' . $c : '' )
                . ( ( defined $n ) ? '&n=' . $n : '' )
                . ( ($ct)          ? $ct        : '' )
                . $this->set_query(
                'url+',
                [   grep( $_ ne 'm'
                            && $_ ne 'k'
                            && $_ ne 'c'
                            && $_ ne 'n'
                            && $_ ne 'ct'
                            && $_ ne 'dn'
                            && $_ ne 'uni',
                        @setting::form )
                ]
                ),
            (   ( !$setting::page{'sameWindowDetailViewer'} )
                ? ( 'target' => 'detailViewer'
                        . (
                        (          $setting::page{'detailViewerNo'}
                                && $setting::page{'detailViewerNo'} > 1
                        ) ? '-' . $setting::page{'detailViewerNo'} : ''
                        ),
                    'onclick' =>
                        'if(typeof cmonos == \'object\'){cmonos.window.open(\'detailViewer'
                        . (
                        (          $setting::page{'detailViewerNo'}
                                && $setting::page{'detailViewerNo'} > 1
                        ) ? '-' . $setting::page{'detailViewerNo'} : ''
                        )
                        . '\','
                        . (
                        ( $setting::page{'detailViewerWidth'} )
                        ? $setting::page{'detailViewerWidth'}
                        : '640'
                        )
                        . ','
                        . (
                        ( $setting::page{'detailViewerHeight'} )
                        ? $setting::page{'detailViewerHeight'}
                        : '480'
                        )
                        . ')}else{window.open(\'\',\'detailViewer'
                        . (
                        (          $setting::page{'detailViewerNo'}
                                && $setting::page{'detailViewerNo'} > 1
                        ) ? '-' . $setting::page{'detailViewerNo'} : ''
                        )
                        . '\',\'width='
                        . (
                        ( $setting::page{'detailViewerWidth'} )
                        ? $setting::page{'detailViewerWidth'}
                        : '640'
                        )
                        . ',height='
                        . (
                        ( $setting::page{'detailViewerHeight'} )
                        ? $setting::page{'detailViewerHeight'}
                        : '480'
                        )
                        . ',scrollbars=yes,resizable=yes\')} return true',
                    )
                : ()
            ),
        }
    );
}

sub clear_title_link ($) {
    my $this = shift;
    $field::obj{ $field::for{'title'} }->set_link
        if $setting::page{'linkedTitle'}
        && $field::for{'title'}
        && ref $field::obj{ $field::for{'title'} };
}

######################################################################
sub set_rss_link ($;$) {
    my ( $this, $output ) = @_;
    $this->_set_rss_link(
        $default::file . '/' . $main::c[0],
        (   (          ref $setting::category{ $main::c[0] }
                    && defined $setting::category{ $main::c[0] }{'name'}
                    && $setting::category{ $main::c[0] }{'name'} ne ''
            ) ? $setting::category{ $main::c[0] }{'name'} : ''
        )
    ) if @main::c == 1;
    $this->_set_rss_link(
        $default::file,
        (   (   defined $setting::general{'cginame'}
                    && $setting::general{'cginame'} ne ''
            ) ? $setting::general{'cginame'} : ''
        )
    );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::table    = 1;    #テーブル設定読み込み
    $setting::page     = 1;    #ページ設定読み込み

    $setting::field_db_name = 'inputfield';    #フィールド設定DB
    $setting::field         = 2
        ; #フィールド設定読み込み（2=オリジナルも読み込む）

    $setting::pending_check = 1;    #非公開レコードチェック

    #設定種キー設定
    $setting::security_key = 'browse'
        if !defined $setting::security_key
        || !$setting::security_key;   #デフォルトセキュリティキー

    #クッキー
    $cookie::id_enabled = 1;          #ID情報クッキー読み込み

    #必須フォーム
    @setting::form = (
        'm',  'c', 's',   'w',      'f',   'u',
        'fv', 'q', 'and', 'search', 'mod', 'uni'
    ) if !@setting::form;
    $main::mod = $main::m;

    #イメージCSS
    $setting::image_css = 'tablemaker-image.css';
}

1;
