package ZipCodeSearch;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 郵便番号検索モジュール
# ZipCodeSearch.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    $this->set_og_url( $this->my_url );
    $this->print_dialog( 'search',
        '設定エラー！ : パスワード管理データベースディレクトリのパスが設定されていません。'
    ) if !defined $env::zipcode || !$env::zipcode;

    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';

    #---------------------------------------------------------------------
    #検索
    $this->fill( \$main::zip3, \$main::zip4, \$main::zip );
    $main::zip3 = $this->z_to_h($main::zip3) if $main::zip3 =~ /[^0-9]/;
    $main::zip4 = $this->z_to_h($main::zip4) if $main::zip4 =~ /[^0-9]/;
    $main::zip  = $this->z_to_h($main::zip)  if $main::zip =~ /[^0-9]/;
    $main::zip =~ s/[^0-9]//g;
    $main::zip3 =~ s/[^0-9]//g;
    $main::zip4 =~ s/[^0-9]//g;
    $main::zip = $main::zip3 . $main::zip4
        if $main::zip eq '' && $main::zip3 ne '' && $main::zip4 ne '';
    my @addr_list = ();
    my $search_check;

    if ( $main::zip =~ /^[0-9]{5,7}$/ ) {
        my @zip = ();
        if ( length $main::zip == 7 ) {
            push( @zip, $main::zip );
        }
        elsif ( length $main::zip == 6 ) {
            foreach ( 0 .. 9 ) { push( @zip, ( $main::zip . $_ ) ) }
        }
        else {
            foreach ( 0 .. 99 ) {
                push( @zip, ( $main::zip . sprintf( "%.2d", $_ ) ) );
            }
        }
        my %zipcode;
        tie( %zipcode, $env::dbm_file, $env::zipcode . '/zipcode',
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %zipcode ) {
            foreach my $zip (@zip) {
                next if !$zipcode{ $this->encode_utf8($zip) };
                $this->mk_address_list(
                    $zip . ' '
                        . $this->decode_utf8(
                        $zipcode{ $this->encode_utf8($zip) }
                        ),
                    \@addr_list
                );
            }
        }
        else {
            push(
                @{ $this->{'dialog'} },
                '郵便番号データベースに接続できませんでした。'
            );
        }
        untie(%zipcode);
        $search_check = 1;
    }

    #---------------------------------------------------------------------
    #検索条件
    if ( !@addr_list ) {
        if ( defined $search_check && $search_check ) {
            push(
                @{ $this->{'dialog'} },
                '郵便番号に該当する住所がみつかりませんでした。'
            );
        }
        elsif ( $main::zip ne '' || $main::zip3 ne '' || $main::zip4 ne '' ) {
            push(
                @{ $this->{'dialog'} },
                '5〜7桁の郵便番号を半角数字で入力してください。'
            );
        }

        #ページヘッダ
        if ( defined $setting::page{'search'}{'title'} ) {
            $setting::page{'search'}{'title'}
                =~ s/(郵便(番号|)|番号|)検索結果/郵便番号入力/g;
            $setting::page{'search'}{'title'} =~ s/結果//g;
        }
        else {
            $setting::page{'search'}{'title'} = '郵便番号入力';
        }
        if ( defined $setting::page{'search'}{'titleText'} ) {
            $setting::page{'search'}{'titleText'}
                =~ s/(郵便(番号|)|番号|)検索結果/郵便番号入力/g;
            $setting::page{'search'}{'titleText'} =~ s/結果//g;
        }
        $this->print_page_header('search');

        print $this->form_start(
            'key'      => 'search',
            'name'     => 'input',
            'required' => \@setting::form
        );

        print '<input type="text" name="zip3" size="3" maxlength="3" value="'
            . $main::zip3
            . '" /> - ';
        print '<input type="text" name="zip4" size="4" maxlength="4" value="'
            . $main::zip4 . '" /> ';
        print '<input type="submit" value="検索" /></form>';

        #ページフッタ
        $this->print_page_footer('search');
        return;
    }

    #---------------------------------------------------------------------
    #書き出し

    #JavaScript;
    $this->set_javascript(
        <<JAVASCRIPT
window.focus();
cmonos.form.zipCodeExport = function () {
	if (this.currentField.selectedIndex < 0) {
		alert('住所を選択してください。');
		return;
	}
	var addr = this.currentField.options[this.currentField.selectedIndex].value;
	var addr_list = addr.split(" ",6);
	if (opener) {
		if (opener.cmonos.form.zip3_field && opener.cmonos.form.zip4_field) {
			if (addr_list[0] == null) {
				addr_list[0] = '';
			}
			if (opener.cmonos.form.zip3_field == opener.cmonos.form.zip4_field) {
				opener.cmonos.form.zip3_field.value = addr_list[0];
			} else {
				opener.cmonos.form.zip3_field.value = addr_list[0].substr(0,3);
				opener.cmonos.form.zip4_field.value = addr_list[0].substr(3,4);
			}
		}
		if (opener.cmonos.form.pref_field && opener.cmonos.form.city_field && opener.cmonos.form.street_field && opener.cmonos.form.building_field) {
			if (addr_list[1] == null) {
				addr_list[1] = '';
			}
			if (addr_list[2] == null) {
				addr_list[2] = '';
			}
			if (addr_list[3] == null) {
				addr_list[3] = '';
			}
			if (addr_list[4] == null) {
				addr_list[4] = '';
			}
			if (addr_list[5] == null) {
				addr_list[5] = '';
			}
			if (opener.cmonos.form.pref_field.type == 'select-one') {
				cmonos.form.field(opener.cmonos.form.pref_field).getOptionByValue(addr_list[1]).selected = true;
			} else {
				opener.cmonos.form.pref_field.value = addr_list[1];
			}
			if (opener.cmonos.form.pref_field.className) {opener.cmonos.form.pref_field.className = opener.cmonos.form.pref_field.className.replace(/invalid-field/,'');}
			if (opener.cmonos.form.city_field == opener.cmonos.form.pref_field) {
				opener.cmonos.form.city_field.value += addr_list[2];
			} else {
				opener.cmonos.form.city_field.value = addr_list[2];
				if (opener.cmonos.form.city_field.className) {opener.cmonos.form.city_field.className = opener.cmonos.form.city_field.className.replace(/invalid-field/,'');}
			}
			if (opener.cmonos.form.street_field == opener.cmonos.form.city_field) {
				opener.cmonos.form.street_field.value += addr_list[3] + addr_list[4];
			} else {
				opener.cmonos.form.street_field.value = addr_list[3] + addr_list[4];
				if (opener.cmonos.form.street_field.className) {opener.cmonos.form.street_field.className = opener.cmonos.form.street_field.className.replace(/invalid-field/,'');}
			}
			if (opener.cmonos.form.building_field == opener.cmonos.form.street_field) {
				opener.cmonos.form.building_field.value += addr_list[5];
			} else {
				opener.cmonos.form.building_field.value = addr_list[5];
				if (opener.cmonos.form.building_field.className) {opener.cmonos.form.building_field.className = opener.cmonos.form.building_field.className.replace(/invalid-field/,'');}
			}
		}
		window.close();
	} else {
		this.writeAddressSample(true);
		alert('サンプルをコピーしてご利用下さい。');
	}
};
cmonos.form.writeAddressSample = function (select_all) {
	var selected_addr_num = this.currentField.selectedIndex;
	var sample_box = cmonos.element.form(this.currentForm).fieldname('sample').shift();
	if (selected_addr_num < 0) {
		sample_box.value = '住所サンプル表示欄';
	} else {
		var sample_addr = this.currentField.options[selected_addr_num].value;
		sample_addr = sample_addr.replace(/ /g,"\\n");
		sample_box.value = sample_addr;
		if (select_all) sample_box.select();
	}
};
JAVASCRIPT
    );

    #ページヘッダ
    $this->print_page_header('search');
    my $size = @addr_list;
    $size = 2  if $size == 1;
    $size = 12 if $size > 12;
    print '<form action="#" name="input">';
    print '<table id="address-table"><tbody><tr><td colspan="2">';
    print '<select name="zipcode" id="zipcode" size="' . $size
        . '" onchange="cmonos.form.item(this.form).field(this).writeAddressSample(\'sample\')">';

    foreach (@addr_list) {
        print '<option value="' . $_ . '">' . $_ . '</option>';
    }
    print '</select>';
    print '</td></tr><tr><td class="close-box">'
        . $this->close_button(
        '',
        $setting::page{'closeButton'},
        $setting::page{'backButton'}
        ) . '</td>';
    print
        '<td class="submit-box"><input type="button" value="OK" onclick="cmonos.form.item(this.form).field(\'zipcode\').zipCodeExport()" class="save" /></td></tr></tbody></table>';
    print
        '<textarea name="sample" cols="40" rows="4" wrap="off">住所サンプル表示欄</textarea>';
    print '</form>';

    #ページフッタ
    $this->print_page_footer('search');
}

######################################################################
#検索にマッチした住所リスト作成
sub mk_address_list ($$$) {
    my ( $this, $addr, $addr_list ) = @_;
    $addr = '' if !defined $addr;
    if ( $addr =~ /^(.*?)\(([^\(\)]+)\)(.*)$/ ) {
        my $addr1 = $1;
        my $addr3 = $3;
        my @addr  = split( /\|/, $2, -1 );
        my ($addr2);
        foreach $addr2 (@addr) {
            $this->mk_address_list( $addr1 . $addr2 . $addr3, $addr_list );
        }
    }
    elsif ( $addr =~ /\|/ ) {
        my ( $base, @addr, $addr1 );
        $addr =~ s/[\(\)]//g;
        ( $base, $addr ) = ( $1, $2 )
            if $addr =~ /^(.*\x20)([^\x09\x0A\x0C\x0D\x20]+)$/;
        @addr = split( /\|/, $addr, -1 );
        foreach $addr1 (@addr) {
            $this->mk_address_list( $base . $addr1, $addr_list );
        }
    }
    elsif ( $addr =~ /^(.*?)\[([0-9]+)\-([0-9]+)\](.*)$/ ) {
        my $addr1 = $1;
        my $d1    = $2;
        my $d2    = $3;
        my $addr2 = $4;
        if ( $d2 - $d1 > 50 ) {
            $this->mk_address_list( $addr1, $addr_list );
        }
        else {
            my $d;
            foreach $d ( $d1 .. $d2 ) {
                $this->mk_address_list( $addr1 . $d . $addr2, $addr_list );
            }
        }
    }
    else {
        $addr =~ s/[\x0A\x0D]//g;
        push( @$addr_list, $addr ) unless grep( $_ eq $addr, @$addr_list );
    }
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::page     = 1;    #ページ設定読み込み

    #設定種キー設定
    $setting::security_key
        = 'search';            #デフォルトセキュリティキー
    $setting::key = 'search';  #ページ設定キー

    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    #デフォルトキー
    $main::k = 'search' if !defined $main::k || !$main::k;

    #必須フォーム
    @setting::form = ( 'm', 'k' );

    #クラス登録
    Common::class_register( 'search', 'ZipCodeSearch' );
}

1;
