package env;
use utf8;
######################################################################
# CGI環境設定 env.pl ver2.0
# Copyright (C) 1999-2014 CMONOS
######################################################################

# 時間帯設定（日本時間）
$ENV{'TZ'} = 'JST-9';

# locale
$locale = 'ja_JP';

# サイト全体のタイトル
$title = 'My Web Site';

# サイト全体の著作権者
$copyright = '';

# サイト全体の説明
$description = '';

# og:type
$og_type = 'website';

# 管理人パスワード
$master_password = 'master';

# 1=管理人パスワードは暗号化済み
$master_password_encrypted = 0;

# 1=管理人パスワードを確認する際、管理人メールアドレスを要求する
$master_email_required = 0;

# 管理人メールアドレス
$master_email = '';

# sendmailの位置（絶対パス）
$sendmail = '/usr/sbin/sendmail';

#$sendmail = '/usr/lib/sendmail';

# ファイルアップロード最大容量
$post_max_size = 100000000;

# サブドメインなしでも、サブドメイン名 www でも同じ（yes=1/no=0）
$doublename = 0;

# 検索サイトへの登録を拒否する（yes=1/no=0）
$noindex = 0;

# RSS 最大記事数
$rss_maxitem = 15;

# RSS 説明項目の最大字数（半角）
$rss_description_maxlength = 128;

# RSS からのアクセスを検出する（yes=1/no=0）
$rss_marker = 1;

# データベースの種類
#$dbm_file = 'AnyDBM_File';
$dbm_file = 'DB_File';

# データベースのパーミッション
$dbm_mode = 0644;

# データベース1レコード容量
$db_maxlength = 4000;

# ユーザー権限で CGI が動作するかどうか（yes=1/no=0）
#$ownerpower = 1;

# パーミッション
$file_mode     = 0604;    # ファイルのパーミッション
$dir_mode      = 0705;    # ディレクトリのパーミッション
$cgi_file_mode = 0705;    # CGI ファイルのパーミッション

# 所有者権限で動かない場合
#$file_mode = 0644;				# ファイルのパーミッション
#$dir_mode = 0755;				# ディレクトリのパーミッション
#$cgi_file_mode = 0755;			# CGI ファイルのパーミッション

# サーバネーム（空欄で自動取得）
$server_name = '';

# CGI作動サーバーネーム（"/"で終わらないこと）
$cgi_server = '';

# 通常ファイルサーバーネーム（"/"で終わらないこと）
$file_server = '';

# SSLサーバ（yes=1/no=0/''=自動判定）
$ssl = '';

# SSIが使用可能（yes=1/no=0）
$ssi = 1;

# SSI拡張子設定
$ssi_ext = 'shtml';

# Location ヘッダが禁止されている（yes=1/no=0）
$location_header_disabled = 0;

# DOCTYPE宣言
$doctype
    = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';

# 共通 HTML ヘッダ
$html_header = '';

# 埋め込み型ナビゲーション（フレーム型=0/埋め込み型=1）
$inline_navi = 1;

# ウィンドウタイトルフォーマット
# [サイトタイトルの区切り文字],[中間層の区切り文字],[上層→下層=0/下層→上層=1]
$window_title_format = ':,:';

# 会員登録CGIの位置
$register_cgi = '../pswd/start.cgi';

# 会員登録情報データベースディレクトリの位置（CGIから見た相対パス）
# インターネットから見えない位置にするか、
# ユニークなディレクトリ名（'register'の部分）にしてください
$register_db = '../../../cgi-data/preferences/register';

# 会員登録CGIを同じウィンドウで開く
$register_in_same_window = 0;

# 会員登録時のパスワード重複チェック設定
# 1=重複チェックを行う(※ 0を推奨)
$register_check = 0;

# セッション管理を可能にする
# 個人認証によって外部に公開されない個人情報を扱う場合はセッション管理を推奨
# 1=ID情報のみセッション管理/2=ユーザー情報を全てセッション管理
$session_enabled = 1;

# セッション情報格納ディレクトリ
$session_store = '../../../cgi-data/data/session_store';

# セッションハイジャック防止
# ip=前回認証時と同一IPでない場合パスワードを再確認する
# agent=前回認証時と同一エージェントでない場合パスワードを再確認する
$session_security = 'agent';

# OpenID による認証を許可する（yes=1/no=0）
$openid_enabled = 0;

# 許容するパスワード認証失敗回数
$password_threshold = 5;

# 許容するパスワード認証失敗回数を超えて認証に失敗したときの待ち時間(分)
$password_latency = 5;

# 未読の承認待ちアイテム情報を保管するDBのパス
$pending_db = '../../../cgi-data/preferences/station/pending';

# Google API キー
$google_api_key = '';

# Google カスタム検索 cx
$google_custom_search_cx = '';

# Google Analytics のユーザーアカウント
$google_analytics_uacct = '';

# Google Analytics をデフォルト状態で埋め込む（1/0）
$google_analytics_embedded = 1;

# Amazon アクセスキー
$amazon_access_key = '';

# Amazon 秘密のアクセスキー
$amazon_secret_access_key = '';

# デフォルトの Amazon アソシエイト ID
$amazon_associates_id = '';

# Facebook Platform アプリケーションID
$fb_appid = '';

# ショッピングカートCGIの位置
$checkout = '';

# ショッピングカートツールCGIを開くウィンドウ（self|new|iframe|modal）
$checkout_window_type = 'iframe';

# ショッピングカートツールウィンドウ幅
$checkout_window_width = 'auto';

# ショッピングカートツールウィンドウ高さ
$checkout_window_height = 'auto';

# iframe で開くときのショッピングカートツールの垂直表示位置
$checkout_window_top = 'top';

# iframe で開くときのショッピングカートツールの水平表示位置
$checkout_window_left = -300;

# 消費税率
$tax_rate = 0;

# 端数処理(切り上げ=ceil/四捨五入=round/切り下げ=floor)
$tax_frac = 'ceil';

# 内税方式で表示する(yes=1/no=0)
$tax_included = 1;

# ポイント有効期限（月）
#$point_lifetime = 24;

# クッキーの保存期間（日数）
$cookie_lifetime = '1000';

# クッキーの有効範囲（URL絶対パス）
$cookie_path = '/';

# ページヘッダファイルの位置（CGIから見た相対パス）
$page_header_path = '';

# ページフッタファイルの位置（CGIから見た相対パス）
$page_footer_path = '';

# スペーサーGIFの位置（CGIから見た相対パス）
$spacer = '../../image/spacer.gif';

# 共通画像素材ライブラリの位置（CGIから見た相対パス）
$image_lib = '../imageLib';

# 共通画像ディレクトリの位置（CGIから見た相対パス）
$image_dir = '../../image';

# テーブル設定DB、装飾設定DB 等共通設定を保存するディレクトリのパス（CGIから見た相対パス）
$preference_dir = '../../../cgi-data/preferences/common';

# デフォルト設定の位置（CGIから見た相対パス）
$default_dir = '../../../cgi-data/default';

# CGI テンプレートの位置（CGIから見た相対パス）
$template_dir = '../../../cgi-data/template';

# 一時保存ファイルディレクトリの位置（CGIから見た相対パス）
$clipboard = '../../../cgi-data/clipboard';

# ブラウザからアクセス可能な一時保存ファイルディレクトリの位置（CGIから見た相対パス）
$public_clipboard = '../../lib/clipboard';

# ファイルアイコンディレクトリの位置（CGIから見た相対パス）
$icon_dir = '../../icon';

# CSSファイルディレクトリの位置（CGIから見た相対パス）
$css = '../../lib/css';

# JavaScriptディレクトリのパス（CGIからみた相対パス）
$javascript = '../../lib/javascript';

# 外部ファイルディレクトリの位置（CGIから見た相対パス）
$externalfiles = '../../lib/xfiles';

# 郵便番号データベースディレクトリの位置（CGIから見た相対パス）
$zipcode = '../../../cgi-data/zipcode';

# 郵便番号検索CGIの位置（CGIから見た相対パス）
$zipcode_search = '../zipcodesearch/start.cgi';

# ダウンロードダミーページの位置（CGIから見た相対パス）
$download_window = '../dummy.html';

# リンクダミーページの位置（CGIから見た相対パス）
$dummy_window = '../dummy4href.html';

# ジェネレータをメタ情報に含めない
$no_generator = 0;

# ホームディレクトリ識別ID（最上層は必ず空欄にします）
$home_dir_id = '';

# 最上層ディレクトリのパス
$top_dir = '';

1;
