// CMONOS.JP JavaScript Library cal.js
// Copyright (C) 2007-2018 CMONOS Co. Ltd.

// 最終更新日：2016-05-22

//	カテゴリー表示切り替えパネル
cmonos.togglePanel = function () {};
cmonos.togglePanel.prototype = {
	id				:	"category-toggle-panel",
	className		:	"view-control-panel",
	categories		:	[],
	calendarCategory	:	'',
	opacity			:	{},
	callerId		:	null,
	draggableOptions :	{},
	defaultX		:	null,
	defaultY		:	null,
	positionFixed	:	false,
	cookieName		:	'TOGGLEPANEL_COORDINATE',
	prefix			:	'',
	targetTags		:	['div','a'],
	trackLength		:	158,
	handleLength	:	4,
	targetPrefix	:	'event-category-',
	appear			:	function (c) {
							if (c != null) {
								if (c == this.callerId && !this._disappeared) {
									this.disappear();
									return;
								} else {
									this.callerId = c;
								}
							}
							this._disappeared = false;
							var panel = this;
							var new_panel = false;
							if (!this._panel) {
								new_panel = true;
								this._sliderHandles = [];
								this._panel = document.createElement('div');
								document.getElementsByTagName('body')[0].appendChild(this._panel);
								this._panel.style.visibility = "hidden";
								if (document.compatMode) this._panel.style.cursor = "move";

								var header = document.createElement('div');
								this._panel.appendChild(header);
								header.className = "cltgl-header";
								var closebox = document.createElement('a');
								header.appendChild(closebox);
								closebox.className = "cltgl-closebox";
								closebox.title = '閉じる';
								closebox.innerHTML = "&times;";
								cmonos.element.item(closebox).addEventListener('click',function (e) {
									cmonos.document.deleteCookie(panel.cookieName);
									panel.disappear();
									cmonos.element.stopPropagation(e);
									cmonos.element.preventDefault(e);
								});
								for (var i = 0; i < this.categories.length; i++) {
									if (this.categories[i].id != null) {
										this._appendController(this.categories[i].id,this.categories[i].name);
									}
								}
							}
							this._panel.id = this.id;
							this._panel.className = this.className;
							if (this.positionFixed) {
								this._panel.style.position = (navigator.userAgent.indexOf("MSIE") != -1 && typeof document.documentElement.style.msInterpolationMode == "undefined") ? "absolute" : "fixed";
							} else {
								this._panel.style.position = "absolute";
							}
							this._panel.style.left = (this.defaultX != null) ? this.defaultX+'px' : (cmonos.document.mousedown.x != null) ? (cmonos.document.mousedown.x+5-((this._panel.style.position == "absolute") ? 0 : cmonos.window.getPageXOffset()))+'px' : "50px";
							this._panel.style.top = (this.defaultY != null) ? this.defaultY+'px' : (cmonos.document.mousedown.y != null) ? (cmonos.document.mousedown.y+5-((this._panel.style.position == "absolute") ? 0 : cmonos.window.getPageYOffset()))+'px' : "50px";
							if (new_panel) {
								cmonos.element.item(this._panel).draggable(
									{
										endeffect	:	function (element) {
															if (element.style.position != null && element.style.position == "fixed") {
																panel.defaultX = parseInt(element.style.left);
																panel.defaultY = parseInt(element.style.top);
															} else {
																panel.defaultX = parseInt(element.style.left) - cmonos.window.getPageXOffset();
																panel.defaultY = parseInt(element.style.top) - cmonos.window.getPageYOffset();
																element.style.position = (navigator.userAgent.indexOf("MSIE") != -1 && typeof document.documentElement.style.msInterpolationMode == "undefined") ? "absolute" : "fixed";
															}
															panel.positionFixed = true;
															cmonos.document.setCookie(panel.cookieName,panel.defaultX + ',' + panel.defaultY);
														}
									}
								);
							}
							cmonos.element.item(this._panel).moveToFront();

							//表示
							if (this._panel.style.visibility == "hidden" || this._panel.style.display == "none") {
								cmonos.element.item(this._panel).fadeIn();
							}
						},
	_appendController :	function (id, name) {
							if (this.opacity[id] == null) this.opacity[id] = 1;
							var panel = this;
							var view_controller = document.createElement('div');
							view_controller.className = "cltgl-category-box";
							this._panel.appendChild(view_controller);

							var color_sample = document.createElement('div');
							view_controller.appendChild(color_sample);
							color_sample.className = "cltgl-color-sample";
							color_sample.id = this.prefix + 'cltgl-color-sample-' + id;
							color_sample.title = 'クリックでこのカテゴリーのみを表示／ダブルクリックで全てのカテゴリーを表示';
							if (document.compatMode) color_sample.style.cursor = 'pointer';

							view_controller.appendChild(document.createTextNode(name));

							var slider_box = document.createElement('div');
							view_controller.appendChild(slider_box);
							slider_box.className = 'cltgl-slider-box';

							var slider_track = document.createElement('div');
							slider_box.appendChild(slider_track);
							slider_track.className = 'cltgl-slider-track';
							slider_track.style.width = this.trackLength + 'px';

							var slider_handle = document.createElement('div');
							slider_track.appendChild(slider_handle);
							slider_handle.className = 'cltgl-slider-handle';
							slider_handle.style.width = this.handleLength + 'px';
							this._sliderHandles[id] = slider_handle;
							this.changeOpacity(id,parseFloat(cmonos.document.getCookie('CATEGORY_OPACITY_'+((this.calendarCategory) ? this.calendarCategory+'_' : '')+id) || 1),false);

							cmonos.element.item(color_sample).addEventListener('click',function (e) {
								for (var i in panel._sliderHandles) {
									if (i == id) {
										panel._sliderHandles[i].style.left = parseInt(slider_track.clientWidth - slider_handle.offsetWidth) + 'px';
										panel.changeOpacity(i,1,true)
									} else {
										panel._sliderHandles[i].style.left = '0px';
										panel.changeOpacity(i,0,true)
									}
								}
							});
							cmonos.element.item(color_sample).addEventListener('dblclick',function (e) {
								for (var i in panel._sliderHandles) {
									panel._sliderHandles[i].style.left = parseInt(slider_track.clientWidth - slider_handle.offsetWidth) + 'px';
									panel.changeOpacity(i,1,true)
								}
							});

							setTimeout(
								function () {
									cmonos.control.slider(
										slider_handle,
										slider_track,
										{
											onSlide		:	function (v) { panel.changeOpacity(id,v,false) },
											onChange	:	function (v) { panel.changeOpacity(id,v,false) },
											sliderValue	:	panel.opacity[id]
										}
									);
								},100
							);
						},
	changeOpacity	:	function (id,op,fade) {
							this.opacity[id] = op;
							cmonos.document.setCookie('CATEGORY_OPACITY_'+((this.calendarCategory) ? this.calendarCategory+'_' : '')+id,op);
							var target_class = this.targetPrefix + id;
							for (var t = 0; t < this.targetTags.length; t++) {
								var elements = document.getElementsByTagName(this.targetTags[t]);
								for (var i = 0; i < elements.length; i++) {
									if (cmonos.element.item(elements[i]).hasClassName(target_class)) {
										if (fade) {
											if (op == 1) {
												cmonos.element.item(elements[i]).fadeIn();
											} else {
												cmonos.element.item(elements[i]).fadeOut();
											}
										} else {
											cmonos.element.item(elements[i]).setOpacity(op);
										}
									}
								}
							}
						},
	_disappeared	:	true,
	disappear		:	function () {
							if (this._panel != null) {
								this.callerId = null;
								cmonos.element.item(this._panel).fadeOut();
								clearTimeout(this._timer);
							}
							this._disappeared = true;
						},
	isDisappeared	:	function () { return this._disappeared }
};

//	イベントカレンダーパレット
cmonos.tool.calendar = {
	calendarPalette : {
		palette : null,
		open : function (cgi_path,defaultX,defaultY) {
			if (this.palette == null) {
				this.palette = new cmonos.calendar();
				this.palette.id = 'event-calendar-palette';
				if (defaultX != null && defaultY != null) {
					this.palette.defaultX = defaultX;
					this.palette.defaultY = defaultY;
				}
				this.palette.positionFixed = true;
				this.palette.view = (cmonos.tool.calendar.current.view != null) ? cmonos.tool.calendar.current.view : 'w';
				this.palette.fixed = (cmonos.tool.calendar.current.fixed != null) ? cmonos.tool.calendar.current.fixed : false;
				this.palette.option = (cmonos.tool.calendar.current.option != null) ? cmonos.tool.calendar.current.option : '';
				this.palette.bodyClassName = (cmonos.tool.calendar.current.view == 'm') ? 'clplt-monthly' : (cmonos.tool.calendar.current.view == 'd') ? 'clplt-daily' : 'clplt-weekly';
				this.palette.func = function (year,mon,mday) {
					document.location.href = cgi_path + '&v=' + this_palette.view + '&date=' + year + ((mon < 10) ? '0' + mon : mon) + ((mday < 10) ? '0' + mday : mday) + this_palette.option;
				};
				this.palette.autoClosable = false;
				this.palette.draggable = true;
				var this_palette = this.palette;
				this.palette.draggableOptions = {
					endeffect	:	function (element) {
										if (element.style.position != null && element.style.position == "fixed") {
											this_palette.defaultX = parseInt(element.style.left);
											this_palette.defaultY = parseInt(element.style.top);
										} else {
											this_palette.defaultX = parseInt(element.style.left) - cmonos.window.getPageXOffset();
											this_palette.defaultY = parseInt(element.style.top) - cmonos.window.getPageYOffset();
											element.style.position = (navigator.userAgent.indexOf("MSIE") != -1 && typeof document.documentElement.style.msInterpolationMode == "undefined") ? "absolute" : "fixed";
										}
										this_palette.positionFixed = true;
										cmonos.document.setCookie("CALENDAR_COORDINATE",this_palette.defaultX + ',' + this_palette.defaultY);
									}
				};
				var header = document.createElement('div');
				header.className = "clplt-header";
				var closebox = document.createElement('a');
				header.appendChild(closebox);
				closebox.className = "clplt-closebox";
				closebox.title = '閉じる';
				closebox.innerHTML = "&times;";
				cmonos.element.item(closebox).addEventListener('click',function (e) {
					cmonos.document.deleteCookie("CALENDAR_COORDINATE");
					this_palette.disappear();
					cmonos.element.stopPropagation(e);
					cmonos.element.preventDefault(e);
				});
				if (!this.palette.fixed) {
					var view_selector = document.createElement('div');
					header.appendChild(view_selector);
					view_selector.className = (cmonos.tool.calendar.current.view == 'm') ? 'clplt-m-selected' : (cmonos.tool.calendar.current.view == 'd') ? 'clplt-d-selected' : 'clplt-w-selected';
					var daybox = document.createElement('a');
					view_selector.appendChild(daybox);
					daybox.className = "clplt-daybox";
					daybox.innerHTML = '日';
					cmonos.element.item(daybox).addEventListener('click',function (e) {
						this_palette.view = 'd';
						this_palette.bodyClassName = 'clplt-daily';
						this_palette._calBody.className = 'clplt-daily';
						this_palette._viewSelector.className = 'clplt-d-selected';
						cmonos.element.stopPropagation(e);
						cmonos.element.preventDefault(e);
					});
					var weekbox = document.createElement('a');
					view_selector.appendChild(weekbox);
					weekbox.className = "clplt-weekbox";
					weekbox.innerHTML = '週';
					cmonos.element.item(weekbox).addEventListener('click',function (e) {
						this_palette.view = 'w';
						this_palette.bodyClassName = 'clplt-weekly';
						this_palette._calBody.className = 'clplt-weekly';
						this_palette._viewSelector.className = 'clplt-w-selected';
						cmonos.element.stopPropagation(e);
						cmonos.element.preventDefault(e);
					});
					var monthbox = document.createElement('a');
					view_selector.appendChild(monthbox);
					monthbox.className = "clplt-monthbox";
					monthbox.innerHTML = '月';
					cmonos.element.item(monthbox).addEventListener('click',function (e) {
						this_palette.view = 'm';
						this_palette.bodyClassName = 'clplt-monthly';
						this_palette._calBody.className = 'clplt-monthly';
						this_palette._viewSelector.className = 'clplt-m-selected';
						cmonos.element.stopPropagation(e);
						cmonos.element.preventDefault(e);
					});
					this.palette._viewSelector = view_selector;
				}
				this.palette.header = header;
			}
			this.palette.appear(cmonos.tool.calendar.current.year,cmonos.tool.calendar.current.mon,'event-calendar-palette');
			if (this.palette.isDisappeared()) {
				cmonos.document.deleteCookie("CALENDAR_COORDINATE");
				this.palette.defaultX = null;
				this.palette.defaultY = null;
			}
		}
	},

	restore : function (cgi_path) {
		var cal_cookie = cmonos.document.getCookie("CALENDAR_COORDINATE");
		if (cal_cookie != '') {
			var cal_info = cal_cookie.split(/,/);
			this.calendarPalette.open(cgi_path,cal_info[0],cal_info[1]);
		}
		var panel_cookie = cmonos.document.getCookie("TOGGLEPANEL_COORDINATE");
		if (panel_cookie != '') {
			var panel_info = panel_cookie.split(/,/);
			this.togglePanel.open(panel_info[0],panel_info[1]);
		}
	},

	togglePanel : {
		panel : null,
		open : function (defaultX,defaultY) {
			if (this.panel == null) this.panel = new cmonos.togglePanel();
			if (defaultX != null && defaultY != null) {
				this.panel.defaultX = defaultX;
				this.panel.defaultY = defaultY;
			}
			this.panel.positionFixed = true;
			this.panel.categories = cmonos.tool.calendar.current.category || [];
			this.panel.calendarCategory = cmonos.tool.calendar.current.calendarCategory || '';
			this.panel.appear('category-toggle-panel');
			if (this.panel.isDisappeared()) {
				cmonos.document.deleteCookie(this.panel.cookieName);
				this.panel.defaultX = null;
				this.panel.defaultY = null;
			}
		}
	},

	event_ribons : new Array(),
	setUp : function (h) {
		var scroll_top = ((h != null) ? parseInt(h) : (new Date()).getHours()) * 60;
		document.getElementById('timetable-box').scrollTop = (scroll_top > 840) ? 840 : scroll_top;
		var divs = document.getElementsByTagName('div');
		var n = 0;
		for (var i = 0; i < divs.length; i++) {
			if (divs[i].className != null && divs[i].className.search(/ event-id-\d+/) != -1) this.event_ribons[n++] = divs[i];
		}
	},

	z_index_top : 10,
	moveToFront : function (element) {
		if (element.style.zIndex != null && element.style.zIndex <= this.z_index_top) element.style.zIndex = this.z_index_top++;
		var event_id = element.className.match(/ event-id-\d+/);
		for (var i = 0; i < this.event_ribons.length; i++) {
			if (this.event_ribons[i].className != null && this.event_ribons[i].className.search(event_id) != -1) this.event_ribons[i].style.zIndex = this.z_index_top;
		}
		element.style.zIndex = this.z_index_top;
	}
};